<?php
class BuildLetterActivity extends SplickitActivity
{
	
	function BuildLetterActivity($resource)
	{
		parent::SplickitActivity($resource);
	}

	function doit() {
		if (isset($this->data['test']) && (strtolower($this->data['test']) == 'true' || strtolower($this->data['test']) == 'false'))
			; // all is good
		else
		{ 
			myerror_log("ERROR! no test value set in build letter activity.  a true or false value must be set");
			$this->error_text = "No test value set in build letter activity.  a true or false value must be set";
			return false;	
		}
		
		if (strtolower($this->data['object']) == 'merchant')
			$adapter = new MerchantAdapter(null);
		else if (strtolower($this->data['object']) == 'user')
			$adapter = new UserAdapter(null);
			
		if ($data_table_name = $this->data['data_table_name'])	
			myerror_log("about to get the data from the submitted table: ".$data_table_name);
		else
		{
			myerror_log("ERROR!  no table name specified in build letter activity record: ".$this->activity_history_resource->activity_id);
			$this->error_text = "No table name specified in build letter activity";
			return false;	
		}
		
//object=merchant;destination=file;template_path=accounting/spl_merchant_email_welcome2.html;name=welcome;data_table_name=adm_AS_welcome_letter		

		$sql = "SELECT * FROM $data_table_name WHERE 1 = 1";
		$options[TONIC_FIND_BY_SQL] = $sql;
	
		if ($table_data = $adapter->select('',$options))
		{
			foreach ($table_data as $record)
			{
				if ($resource = Resource::find($adapter,$record['object_id']))
				{
					// all is good
					$resource_data = $resource->getDataFieldsReally(); 
					foreach ($resource_data as $name=>$value)
					{
						myerror_logging(5,"adding to the record array  $name=$value");
						$record[$name] = $value;
					}
				}
				else
				{
					myerror_log("ERROR! we have a bad ".$this->data['object']." id in build letter activity.  ".$this->data['object']."_id: ".$record['object_id']);
					recordError("ACTIVITY ERROR", "BAD ".$this->data['object']." ID IN BUILD LETTER ACTIVITY", $this->data['object']."_id: ".$record['object_id']);
					//MailIt::sendErrorEmail("BAD ".$this->data['object']." ID IN BUILD LETTER ACTIVITY", $this->data['object']."_id: ".$record['object_id']);
					continue;
				}
				/*
				myerror_log("**********complete record array is********");
				foreach ($record as $name=>$value)
					myerror_log("$name=$value");				
				*/
				$resource->set("data",$record);
				$today = date('Y-m-d');
				$resource->set("today",$today);
			
				//$resource->_representation = $resource->_representation = '/utility_templates/accounting/spl_merchant_email_welcome2.html';
				$resource->_representation = $resource->_representation = '/utility_templates/'.$this->data['template_path'];
				$representation =& $resource->loadRepresentation($this->file_adapter);
				if ($resource && $representation)
					$response =& $representation->get($request);
					
				$body = $response->getOutputAsText();
//				$body = $representation->_getContent();
				myerror_logging(1,"build letter body: $body");
				$info = '';
				foreach ($this->data as $name=>$value)
				{
					myerror_logging(1, "$name = $value");
					//commented out, too much extra stuff
					//$info .= "$name=$value;";
				}
				if (strtolower($this->data['destination']) == 'file')
				{
					$file_string = "/usr/local/splickit/httpd/htdocs/prod/app2/letterfiles/".$resource->data['object_id']."_".$this->data['name']."_letter.html";
					if (isLaptop())
						$file_string = $resource->data['object_id']."_".$this->data['name']."_letter.html";
						
					myerror_log("now write to the file");
					$file_handle = fopen($file_string, 'w+') or die("DEATH! can't open file");
					fwrite($file_handle, $body);
					//fwrite($file_handle, $message_body);
					fclose($file_handle);
				
				} else if (strtolower($this->data['destination']) == 'email') {

					$subject = 'letter';
					if (isset($this->data['email_subject']))
						$subject = $this->data['email_subject'];
						
					if (isTest() || isLaptop() || strtolower($this->data['test']) == 'true')
						$address = array('adam@order140.com','tarek@order140.com');
					else if (strtolower($this->data['test']) == 'false') 
					{
						if (isset($record['destination_email']) && $record['destination_email'] != null && trim($record['destination_email']) != '')
						{
							$add = $record['destination_email'];
							$address = explode(";", $add);
												
						}
						else if ($address = $resource->email)
							;// its a user
						else
							$address = $resource->shop_email;
					} else {
						myerror_log("ERROR! NO TEST VALUE SET IN FOR BUILD LETTER ACIVITIY! activity_id: ".$this->activity_history_resource->activity_id);
						throw new Exception("ERROR! NO TEST VALUE SET IN FOR BUILD LETTER ACIVITIY! activity_id: ".$this->activity_history_resource->activity_id);
					}

					$time1 = microtime(true);
					$error_string = null;
					$mmh_adapter = new MerchantMessageHistoryAdapter(getM());
					foreach ($address as $address_to_send)
					{
						try {
							//if (MailIt::sendUserEmailMandrill($address_to_send, $subject, $body, 'Order140 Support', $bcc))
							$support_name = getProperty('support_sender_name');
                            $info = "subject=$subject;from=$support_name;";
							if ($this->data['attachment'])
								$info .= "attachment=".$this->data['attachment'].";";
							if ($mmh_adapter->createMessage(null, null, 'E', $address_to_send, time(), 'I', $info, $body))
								myerror_logging(2, "email staged for: ".$address_to_send);
							else
								throw new Exception("ERROR!  Couldn't stage email in BuildLetterActivity");	
						} catch (Exception $e) {
							myerror_log("ERROR!  cant send build letter to: ".$address_to_send);
							$error_string = "   Cant send build letter to: ".$address_to_send;
							MailIt::sendErrorEmail("ERROR sending build letter",$error_string);
						}
					}
					$time2 = microtime(true);
					$elapsed = $time2-$time1;
					myerror_log("elapsed time for send build letter call is: ".$elapsed);
								
				} // end if email
			}					
		} else if ($adapter->getLastErrorNo() > 0) {
			$this->error_text = $adapter->getLastErrorText();
			return false;
		}
		return true;
	}

}
?>