<?php

class BustCacheActivity extends SplickitActivity
{
    function __construct($activity_history_resource)
    {
        parent::SplickitActivity($activity_history_resource);
    }

    function doit()
    {
        $user_resource = UserAdapter::doesUserExist('store_tester@order140.com');
        $user = $user_resource->getDataFieldsReally();
        $_SERVER['AUTHENTICATED_USER'] = $user;
        $_SERVER['AUTHENTICATED_USER_ID'] = $user['user_id'];
        $_SERVER['USER_IS_STORE_TESTER_OR_BETTER'] = true;
        if ($merchant_id = $this->data['merchant_id']) {
            if ($merchant_resource = Resource::find(new MerchantAdapter(getM()),"$merchant_id")) {
                $complete_merchant = new CompleteMerchant($merchant_id);
                $complete_merchant_data_resource = $complete_merchant->getTheMerchantData('pickup');
                $menu = CompleteMenu::getCompleteMenu($complete_merchant_data_resource->menu_id, 'Y', $merchant_id, 2, 'pickup'); //we need reload menu in APIv2 format to correct process favorites and last orders
                $hour_adapter = new HourAdapter(getM());
                $hour_adapter->getAllMerchantHoursHumanReadableV2($merchant_id);
            } else {
                myerror_log('ERROR!!!!!!  no merchant matching that merchant_id: '.$this->data['merchant_id']);
                return false;
            }
        } else if ($menu_id = $this->data['menu_id']) {
            if ($menu_resource = Resource::find(new MenuAdapter(getM()),"$menu_id")) {
                $menu_resource->last_menu_change = time();
                $menu_resource->save();
            }  else {
                myerror_log('ERROR!!!!!!  no menu matching that menu_id: '.$this->data['merchant_id']);
                return false;
            }

        } else if ($value = $this->data['bust_entire_cache']) {
            $splickit_cache = new SplickitCache();
            $resource = $splickit_cache->instanceFlushAll();
        }
        return true;
    }


}
?>