<?php

class CheckDeviceCallInActivity extends SplickitActivity
{
    function doIt()
    {
        $call_in_gap_threshold_for_late_in_minutes = getProperty("call_in_gap_threshold_for_late");
        if ($call_in_gap_threshold_for_late_in_minutes == null || $call_in_gap_threshold_for_late_in_minutes < 4) {
            $call_in_gap_threshold_for_late_in_minutes = 4;
        }

        $dciha = new DeviceCallInHistoryAdapter(getM());
        if ($non_recently_called_in_devices_by_type = $dciha->getNonRecentlyCalledInDevicesOtherThanGPRS($call_in_gap_threshold_for_late_in_minutes)) {
            $merchant_adapter = new MerchantAdapter(getM());
            $auto_turned_off_infos = [];
            foreach ($non_recently_called_in_devices_by_type as $key=>$late_devices) {
                myerror_log("starting auto turn off deivces for $key. Number of offline devices: ".sizeof($late_devices));
                foreach ($late_devices as $late_device) {
                    $merchant_resource_for_send_message = $dciha->deactivateMerchantDueToNoCallInByDeviceCallInResource($late_device);
                    if ($merchant_resource_for_send_message) {
                        $call_in_gap_threshold_for_late_in_minutes = getProperty("call_in_gap_threshold_for_late");
                        $body = "Alert for ".$merchant_resource_for_send_message->name." at ".$merchant_resource_for_send_message->address1." - ".$merchant_resource_for_send_message->phone_no."\n\nYour order receiving device is off line, and has not called in for over $call_in_gap_threshold_for_late_in_minutes minutes. Please check your connection.";
                        $subject = 'Your Order Receiving Device Is Has Not Called in Recently!';
                        if ($key == 'Compris') {
                            $subject = $subject.' siteID: '.$merchant_resource_for_send_message->merchant_external_id;
                        } else {
                            $subject = $subject.' merchant_id: '.$merchant_resource_for_send_message->merchant_id;
                        }
                        MailIt::stageEmail($merchant_resource_for_send_message->shop_email,$subject,$body,getProperty('support_sender_name'),null,['merchant_id'=>$merchant_resource_for_send_message->merchant_id]);
                    }
                }
            }
            if (sizeof($auto_turned_off_infos) > 0) {
                $email_body = "These merchant devices have not called in for at least $call_in_gap_threshold_for_late_in_minutes minutes. They have been auto turned off: \r\n \r\n";
                foreach ($auto_turned_off_infos as $auto_turned_off_info) {
                    $email_body .= "$auto_turned_off_info \r\n";
                }
                myerror_log("Auto Turnoff Email:    $email_body");
                MailIt::sendErrorEmailSupport("Merchant Device Off Line Report. Merchants Auto Turned Off.",$email_body);
            }
        }
    }
}
