<?php

class SendMerchantStatementActivity extends SplickitActivity
{

	function SendMerchantStatementActivity($resource)
	{
		parent::SplickitActivity($resource);
	}

	function doit() {

		$entity_name = 'Order140';
		if (strtolower($this->data['period']) == 'week')
			$sql = "SELECT * FROM adm_statement";
		else if (strtolower($this->data['period']) == 'month')
			$sql = "SELECT * FROM adm_statement_month";
		if ($this->data['entity'] == 'rrt') {
			$use_rrt = true;
			$entity_name = 'RRT';
		}
		$adapter = new MySQLAdapter($this->mimetypes);
		$options[TONIC_FIND_BY_SQL] = $sql;
		if ($merchant_records = $adapter->select('',$options))
		{
			// ok we've gotten the generic merchant records.  now loop through them and generate the details

			foreach ($merchant_records as $merchant_record)
			{
				if (strtolower($this->data['period']) == 'week')
				{
					$sql = "SELECT * FROM adm_statement_detail WHERE merchant_id = ".$merchant_record['merchant_id']." AND x < 99999999";
					$options[TONIC_FIND_BY_SQL] = $sql;
					if ($merchant_detail_records = $adapter->select('',$options))
					{
						$merchant_record['weekly_details'] = $merchant_detail_records;
						$merchant_record['statement_date'] = date('M j, Y');
						$sql = "SELECT * FROM adm_statement WHERE merchant_id = ".$merchant_record['merchant_id'];
						$options[TONIC_FIND_BY_SQL] = $sql;
						$merchant_weekly_total_record_array = $adapter->select('',$options);
						$merchant_record['merchant_weekly_total_record'] = array_pop($merchant_weekly_total_record_array);
						$resource = Resource::dummyFactory($merchant_record);
						if ($use_rrt) {
							$resource->_representation = '/utility_templates/accounting/rrt_weekly_merchant_statement.html';
						} else {
							$resource->_representation = '/utility_templates/accounting/weekly_merchant_statement.html';
						}

					} else {
						myerror_log("query resulted in NO matching detail record");
						$this->error_text = "query resulted in NO matching adm_statemnt_detail record for merchant id: ".$merchant_record['merchant_id'];
						return false;
					}
				} else if (strtolower($this->data['period']) == 'month') {
					// all data is in the adm_statement_month table
					$resource = Resource::dummyFactory($merchant_record);
					if ($use_rrt) {
						$resource->_representation = '/utility_templates/accounting/rrt_monthly_merchant_statement.html';
					} else {
						$resource->_representation = '/utility_templates/accounting/monthly_merchant_statement.html';
					}

				} else {
					myerror_log("no period type matching submission of: ".$this->data['period']);
					$this->error_text = "no period type matching submission of: ".$this->data['period'];
					return false;
				}

				$representation =& $resource->loadRepresentation($this->file_adapter);
				if ($resource && $representation)
					$response =& $representation->get($request);

				$email_body = $response->getOutputAsText();
				//myerror_log("$email_body");

				if ($this->data['destination'] == 'file')
				{

					if ($_SERVER['SERVER_NAME'] == 'test')
						$server_name = 'prod';
					else
						$server_name = 'prod';

					$file_string = "/usr/local/splickit/httpd/htdocs/".$server_name."/app2/letterfiles/".$resource->merchant_id."_merchant_statement_".$this->data['period'].".html";
					myerror_log("now write to the file");
					myerror_log("file: ".$file_string);
					$file_handle = fopen($file_string, 'w+') or die("DEATH! can't open file");
					fwrite($file_handle, $email_body);
					fclose($file_handle);

				} else if ($this->data['destination'] == 'email') {

					$subject = "$entity_name Statement   ID#: ".$merchant_record['merchant_id']."   ".$merchant_record['name']."    ".$merchant_record['address1'];
					$mail_string = $merchant_record['destination_emails'];

					if (strtolower($this->data['test']) == 'true' || $_SERVER['GLOBAL_PROPERTIES']['server'] == 'test') {
						// this is in the Property Table
						$mail_string = getProperty('statement_test_emails');
						myerror_log("the statement_test_emails: $mail_string",3);
					} else {
						// this is in the Configuration_By_Environment_Variables Table
						$bcc = getProperty('statement_catch_all_email');
						myerror_log("the statement_catch_all_email: $mail_string",3);
					}


					myerror_log("the mail string is: ".$mail_string);

					if (MailIt::sendEmailMandrill($mail_string, $subject, $email_body, $entity_name.' Support', $bcc, null)) {
						myerror_logging(1,"succesful send of statement to merchant: ".$merchant_record['merchant_id']);
					} else {
						myerror_log("*********ERRROR************* sending ".$this->data['period']." statement to the merchant");
					}
				}
				set_time_limit(30);
			}
		}
		return true;
	}

}
?>
