<?php

class SendMerchantStatusActivity extends SplickitActivity
{
	private $table = "adm_AS_merchant_status";
	private $temp_table = "adm_temp_merchant_status";
	private $adapter;
	
	function SendMerchantStatusActivity($resource)
	{
		parent::SplickitActivity($resource);
		$this->adapter = new MerchantAdapter(Null);
	}

	function doit() 
	{
		
		$merchant_adapter = $this->adapter;
		
		// get all the merchant id's from the table
		myerror_log("about to get the merchant ids from the status table");
		$sql = "SELECT distinct merchant_id FROM adm_AS_merchant_status";
		if (isset($this->data['merchant_id']))
			$sql .= " WHERE merchant_id = ".$this->data['merchant_id'];
		$options[TONIC_FIND_BY_SQL] = $sql;
		$merchants_to_run = $merchant_adapter->select('',$options);

		foreach ($merchants_to_run as $merchant_to_run)
		{		
			$merchant_id = $merchant_to_run['merchant_id'];
			$result = $this->runMerchantStatus($merchant_id,false);
			set_time_limit(30);
		}
		return true;
	}

	function getTempMerchantStatus($merchant_id)
	{
		$merchant_adapter = $this->adapter;
		$merchant_options[TONIC_FIND_BY_METADATA]['numeric_id'] = $merchant_id;
		if ($merchant_resource = Resource::findExact($merchant_adapter,'',$merchant_options))
		{
			$merchant_id = $merchant_resource->merchant_id;
		} else {
			myerror_log("SERIOUS ERROR IN sendmerchantstatusactivity!  no matching merchant for submitted numeric_id: ".$merchant_id);
			MailIt::sendErrorMail('arosenthal@order140.com', 'no matching id in sendmerchantstatusactivity', 'no matching id: '.$merchant_id);
			return false;
		}
		
		$sql = "call SMAWSP_adm_MerchantStatus($merchant_id)";
		myerror_log($sql);
		$merchant_adapter->_query($sql);
		return $this->runMerchantStatus($merchant_id,true);

	}
	
	private function runMerchantStatus($merchant_id,$use_temp = false)
	{			
		$merchant_adapter = $this->adapter;
		$resource = Resource::find($merchant_adapter,''.$merchant_id);
		
		if ($use_temp)
			$sql = "SELECT * FROM adm_temp_merchant_status WHERE merchant_id = $merchant_id ORDER BY section ASC";
		else
			$sql = "SELECT * FROM adm_AS_merchant_status WHERE merchant_id = $merchant_id ORDER BY section ASC";
			
		$options[TONIC_FIND_BY_SQL] = $sql;
	
		if ($merchant_status_data = $merchant_adapter->select('',$options))
		{
			$section_data = array();
			foreach ($merchant_status_data as $record)
			{
				$section_data[$record['section']][] = $record;
			}
			
			$resource->set('merchant_status_data',$section_data);
			$resource->_representation = $resource->_representation = '/utility_templates/accounting/merchant_status.html';
			
			// now return the resoruce if we are displaying in a browser
			if ($this->data['destination'] == 'browser')
				return $resource;

			// if not then its email or file	
			$representation =& $resource->loadRepresentation($this->file_adapter);
			if ($resource && $representation)
				$response =& $representation->get($request);
	
			$email_body = $response->getOutputAsText();
			//myerror_log("$email_body");
			
			$headers  = "MIME-Version: 1.0" . "\n";
			$headers .= "Content-Type: text/html; charset=UTF-8" . "\n";
			$headers .= "From: support@order140.com\n";
			
			$subject = "Splickit Merchant Status   ID#: ".$resource->merchant_id."   ".$resource->name."    ".$resource->address1;

			if ($this->data['destination'] == 'file')
			{
				
				if ($_SERVER['SERVER_NAME'] == 'test')
					$server_name = 'test';
				else
					$server_name = 'prod';
			
				$file_string = "/usr/local/splickit/httpd/htdocs/".$server_name."/app2/statusfiles/".$resource->merchant_id."_merchantstatus.html";
				$html = $email_body;
				myerror_log("now write to the file");
				$file_handle = fopen($file_string, 'w+') or die("DEATH! can't open file");
				fwrite($file_handle, $html);
				fclose($file_handle);
				
			} else if ($this->data['destination'] == 'email') {
				$mail_string = $resource->shop_email;
				if (strtolower($this->data['test']) == 'true')
					$mail_string = 'tarek@order140.com;arosenthal@order140.com';
				else if ($_SERVER['GLOBAL_PROPERTIES']['server'] == 'test')
					$mail_string = 'arosenthal@order140.com;tarek@order140.com';
				else
					$bcc = "splickit.letters.all@gmail.com";

				myerror_log("the mail string is: ".$mail_string);
					
				if (MailIt::sendUserEmailMandrill($mail_string, $subject, $email_body, 'Order140 Support', $bcc)) {	
					myerror_logging(1,"successful send of statment to merchant");
				} else {
					myerror_log("*********ERRROR************* sending email statement to the merchant");
				}
			}			
			return true;	
		}
	}	
	
}
?>