<?php

class VioDataImportActivity extends SplickitActivity
{
    function __construct($activity_history_resource)
    {
        $this->activity_history_resource = $activity_history_resource;
        parent::SplickitActivity($activity_history_resource);
    }

    function doit()
    {
        logData($this->data,"ACTIVITY DATA");
        if (isset($this->data['file'])) {
            return $this->saveFile();
        }
        if (isset($this->data['date'])) {
            $date = $this->data['date'];
            myerror_log("*******VIOREPORT**********  WE HAVE A DATE SET: $date");
        } else {
            $ts = time() - (24 * 3600);
            if ('deposit_detail' == $this->data['action']) {
                $date = date("Y-m-d", $ts);
            } else {
                $date = date("n/j/Y", $ts);
            }


            myerror_log("*******VIOREPORT**********  NO date set so we default to: $date");
        }
        if (isset($this->data['account_number'])) {
            $account_number = $this->data['account_number'];
        }
        myerror_log("**********  $date  **********");
        $transactions = false;
        $deposit_detail = false;
        if ('transactions' == $this->data['action']) {
            $transactions = true;
            $report = 'propay_comprehensive_transaction_detail';
            $search_date = urlencode("TransactionDate=$date");
        } else if ('deposit_detail' == $this->data['action']) {
            $deposit_detail = true;
            $report = 'propay_deposit_detail';
            $search_date = urlencode("TransactionDateTime=$date");
        } else if ('daily_deposit' == $this->data['action']) {
            $report = 'propay_merchant_bank_deposit';
            $search_date = urlencode("TransactionDateTime=$date");
        } else {
            myerror_log("ERROR!!! Unrecognized action in VioDataImportActivity: ".$this->data['action']);
            return false;
        }

        //$url = 'https://reports.value.io/reports.json?filter_report_type='.$report.'&page=1&search=' . urlencode($date);
        $url = 'https://reports.value.io/reports.json?search='.$search_date.'&filter_report_type='.$report;

        $response = $this->curlIt($url);
        if ($response == '{"data":[]}') {
            myerror_log("ERROR!!!! NO DATA RETURNED FOR VIO REPORT REQUEST: $response");
            MailIt::sendErrorEmail("NO DATA RETURNED FOR VIO REPORT REQUEST","For $url  There was no data returned");
            return false;
        } else if ($this->info['http_code'] == 504) {
            myerror_log("VIO GATEWAY TIMEOUT!!!!!");
            MailIt::sendErrorEmail("VIO REPORTS GATEWAY TIMEOUT","For $url");
            return false;
        }
        if ($transactions) {
            $daily_transactions = json_decode($response, true);
            if (json_last_error() != JSON_ERROR_NONE) {
                myerror_log("ERROR!!!!!  reponse was NOT valid JSON: $response");
                MailIt::sendErrorEmail("VIO REPORTING IMPORT ERROR IN ACTIVITY", "error: $response");
                return false;
            }
            myerror_log("VIO REPORTING IMPORT for $url, there were ".sizeof($daily_transactions)." records returned");
            $this->saveDailyTransactionData($daily_transactions, $account_number);

        } else if ($deposit_detail) {
            $deposit_deails = json_decode($response, true);
            if (json_last_error() != JSON_ERROR_NONE) {
                myerror_log("ERROR!!!!!  reponse was NOT valid JSON: $response");
                MailIt::sendErrorEmail("VIO REPORTING IMPORT ERROR IN ACTIVITY", "error: $response");
                return false;
            }
            myerror_log("VIO REPORTING IMPORT for $url, there were ".sizeof($deposit_deails)." records returned");
            $this->saveDepositDetailData($deposit_deails, $account_number);

        } else {
            $merchant_daily_deposits = json_decode($response);
            if (json_last_error() != JSON_ERROR_NONE) {
                myerror_log("ERROR!!!!!  reponse was NOT valid JSON: $response");
                MailIt::sendErrorEmail("VIO REPORTING IMPORT ERROR IN ACTIVITY","error: $response");
                return false;
            }
            myerror_log("VIO REPORTING IMPORT for $url, there were ".sizeof($merchant_daily_deposits)." records returned");
            $this->saveDailyDepositData($merchant_daily_deposits,$account_number);
        }

    }

    function saveFile()
    {
            $viodda = new VioDepositDetailAdapter(getM());
            $cwd = getcwd();
            myerror_log("the current working directory is:  $cwd");
            $file_path = 'lib/activities/resources/reports.json';
            if ($file = fopen($file_path,"r")) {
                while(! feof($file))
                {
                    $json_row = fgets($file);
                    $single_transaction = json_decode($json_row,true);
                    if (json_last_error() != JSON_ERROR_NONE) {
                        myerror_log("ERROR!!!!!  this row was NOT valid JSON: $json_row");
                        continue;
                    }

                    if (strtotime($single_transaction['TransactionDateTime']) < strtotime('11/29/2019')) {
                        continue;
                    }
                    foreach ($single_transaction as $name => &$value) {
                        myerror_log("$name = $value",6);
                        $value = str_replace('$','',$value);
                        if ($name == 'TransactionDateTime') {
                            $value = strtotime($value);
                        }
                    }
                    $newTransaction = new Resource($viodda, $single_transaction);
                    if (! $newTransaction->save()) {
                        myerror_log("*******VIOREPORT********** UNABLE TO SAVE VIO REPORT DATA!!! $json_row");
                        myerror_log("*******VIOREPORT**********  error: ".$newTransaction->_adapter->getLastErrorText());
                    }
                }

                fclose($file);
            } else {
                myerror_log("Couldnt open file. current workign directory is: $cwd");
                return false;
            }
            return true;
    }

    function saveDepositDetailData($deposit_details,$account_number)
    {
        $viodda = new VioDepositDetailAdapter(getM());
        foreach ($deposit_details as $single_transaction) {
            $detail_account_number = $single_transaction['account_num'];
            if ($account_number == $detail_account_number ){
                myerror_log("*******VIOREPORT********** SELECTIVELY importing data for ".$detail_account_number,5);
            } else if ($account_number) {
                myerror_log("*******VIOREPORT**********  skipping daily summary for account number: ".$detail_account_number,5);
                continue;
            } else {
                myerror_log("*******VIOREPORT**********  importing data for ".$detail_account_number,5);
            }
            foreach ($single_transaction as $name => &$value) {
                myerror_log("$name = $value",6);
                $value = str_replace('$','',$value);
                if ($name == 'TransactionDateTime') {
                    $value = strtotime($value);
                }
            }
            $newTransaction = new Resource($viodda, $single_transaction);
            if (! $newTransaction->save()) {
                myerror_log("*******VIOREPORT********** UNABLE TO SAVE VIO REPORT DATA!!! transaction_id: ".$newTransaction->TransactionInfoId);
                myerror_log("*******VIOREPORT**********  error: ".$newTransaction->_adapter->getLastErrorText());
            }
        }
        myerror_log("done saving deposit detail",5);
    }

    function saveDailyTransactionData($daily_transactions,$account_number)
    {
        $viodta = new VioDailyTransactionsAdapter(getM());
        foreach ($daily_transactions as $single_transaction) {
            $transaction_account_number = $single_transaction['AccountNum'];
            if ($account_number == $transaction_account_number ){
                myerror_log("*******VIOREPORT********** SELECTIVELY importing data for ".$transaction_account_number,5);
            } else if ($account_number) {
                myerror_log("*******VIOREPORT**********  skipping daily summary for account number: ".$transaction_account_number,5);
                continue;
            } else {
                myerror_log("*******VIOREPORT**********  importing data for ".$transaction_account_number,5);
            }
            foreach ($single_transaction as $name => &$value) {
                myerror_log("$name = $value",6);
                $value = str_replace('$','',$value);
                if ($name == 'TransactionDate' || $name == 'SettleDate' || $name == 'FundDate') {
                    $value = strtotime($value);
                }
            }
            $newTransaction = new Resource($viodta, $single_transaction);
            if (! $newTransaction->save()) {
                myerror_log("*******VIOREPORT********** UNABLE TO SAVE VIO REPORT DATA!!! transaction_id: ".$newTransaction->TransactionInfoId);
                myerror_log("*******VIOREPORT**********  error: ".$newTransaction->_adapter->getLastErrorText());
            }
            myerror_log("done saving transaction data",5);

        }
    }

    function saveDailyDepositData($resources,$account_number)
    {
        $viodsa = new VioDailyDepositSummariesAdapter(getM());
        foreach ($resources as $dailySummary) {
            $transaction_account_number = $dailySummary->account_num;
            if ($account_number == $transaction_account_number ){
                myerror_log("*******VIOREPORT********** SELECTIVELY importing data for ".$transaction_account_number,5);
            } else if ($account_number) {
                myerror_log("*******VIOREPORT**********  skipping daily summary for account number: ".$transaction_account_number,5);
                continue;
            } else {
                myerror_log("*******VIOREPORT**********  importing data for ".$transaction_account_number,5);
            }
            {
                $newDailySummary = new Resource($viodsa, []);
                $newDailySummary->fees = preg_replace("/[^0-9.]/", "", $dailySummary->Fees);
                $newDailySummary->amount = preg_replace("/[^0-9.]/", "", $dailySummary->Amount);
                $newDailySummary->details = $dailySummary->Details;
                $newDailySummary->sweep_id = $dailySummary->SweepId;
                $newDailySummary->attn_number = $dailySummary->att_num;
                $newDailySummary->inv_number = $dailySummary->inv_num;
                $newDailySummary->trans_id = $dailySummary->Trans_Id;
                $newDailySummary->identifier = $dailySummary->Identifier;
                $newDailySummary->report_date = $dailySummary->ReportDate;
                $newDailySummary->gross_amount = preg_replace("/[^0-9.]/", "", $dailySummary->GrossAmount);
                $newDailySummary->vio_account_number = $dailySummary->account_num;
                $newDailySummary->ach_return_code = $dailySummary->AchReturnCode;
                $newDailySummary->transaction_type = $dailySummary->TransactionType;
                $newDailySummary->transaction_date_time = date('Y-m-d H:m', strtotime($dailySummary->TransactionDateTime));
                $newDailySummary->charge_back_response_code = $dailySummary->ChargeBackResponeCode;
                $newDailySummary->return_code_description = $dailySummary->ReturnCodeDescription;
                $newDailySummary->response_code_description = $dailySummary->ResponeCodeDescription;
                $newDailySummary->created_at = getMySqlFormattedDateTimeFromTimeStampAndTimeZone(time());
                if (! $newDailySummary->save()) {
                    myerror_log("*******VIOREPORT********** UNABLE TO SAVE VIO REPORT DATA!!! transaction_id: ".$dailySummary->Trans_Id);
                    myerror_log("*******VIOREPORT**********  error: ".$newDailySummary->_adapter->getLastErrorText());
                }
            }

        }
    }

    function curlIt($url)
    {
        unset($this->info);
        $method = strtoupper('GET');
        $curl = curl_init($url);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
//        curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 5);
//        curl_setopt($curl, CURLOPT_TIMEOUT, 5);
        curl_setopt($curl, CURLOPT_VERBOSE, true);
        $api_token = getProperty('vio_api_key');
        $headers = ["X-Api-Token: $api_token"];
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        logCurl($url,$method,null,$headers,null);
        $result = curl_exec($curl);
        $this->info = curl_getinfo($curl);
        curl_close($curl);
//        myerror_log("VIO HTTP CODE: ".$this->info['http_code']);
//        myerror_log("VIO RESPONSE: $result");
//        logData($this->info,"VIO INFO");
        return $result;
    }

}
?>