<?php

class ConfigurationByEnvironmentVariablesAdapter extends MySQLAdapter
{

	function ConfigurationByEnvironmentVariablesAdapter($mimetypes)
	{
		parent::MysqlAdapter(
			$mimetypes,
			'Configuration_By_Environment_Variables',
			'%([0-9]{1,8})%',
			'%d',
			array('id'),
			null,
			array('created','modified')
		);
		
		$this->allow_full_table_scan = true;
	}

    function &select($url, $options = NULL)
    {
        $options[TONIC_FIND_BY_METADATA]['logical_delete'] = 'N';
        return parent::select($url, $options);
    }

    function getDefaultEnvironmentVariables()
    {
        return $this->getEnvironmentVariablesByEnvironmentName('default');
    }

    function getEnvironmentVariablesByEnvironmentName($environment_name)
    {
        if ($environment_name == null || trim($environment_name) == '') {
            throw new Exception("ERROR LOADING CONFIGURATION VARIABLES FROM Configuration_By_Environment_Variables TABLE");
        }
        return $this->getRecords(['environment'=>$environment_name]);
    }

}
?>