<?php

class GroupListsAdapter extends MySQLAdapter
{
    function __construct($mimetypes)
    {
        parent::MysqlAdapter(
            $mimetypes,
            'Group_Lists',
            '%([0-9]{4,15})%',
            '%d',
            array('id'),
            null,
            array('created','modified')
        );

        $this->allow_full_table_scan = true;

    }

    function &select($url, $options = NULL)
    {
        $options[TONIC_FIND_BY_METADATA]['logical_delete'] = 'N';
        return parent::select($url,$options);
    }

    function getAllListsAndMembersForUserId($user_id)
    {
        if ($user_id > 1) {
            $group_list_email_adapter = new GroupListEmailsAdapter(getM());
            if ($records = $this->getRecords(['user_id'=>$user_id])) {
                $data = [];
                foreach ($records as $list) {
                    $list_id = $list['id'];
                    $list_name = $list['name'];
                    foreach ($group_list_email_adapter->getRecords(['group_list_id' => $list_id]) as $email_record) {
                        $data[$list_name][] = $email_record['email'];
                    }
                }
                return $data;
            }
        }
    }
}
?>