<?php

use \Firebase\JWT\JWT;
use \Firebase\JWT\JWK;

class LoginAdapter extends MySQLAdapter
{

	//private $ENCRYPT_KEY="z1Mc6KRxA7Nw90dGjY5qLXhtrPgJOfeCaUmHvQT3yW8nDsI2VkEpiS4blFoBuZ";
	
	var $error_resource;
	var $request;
	var $new_hash;
	var $password_migration_results = array();
	var $lastUpdatedPasswordUserId;

	var $header_token_names = ['splickit_authentication_token','facebook_authentication_token','thanx_authentication_token','apple_authentication_token'];

	const BAD_PASSWORD_FOR_FACEBOOK_CREATED_ACCOUNT_ERROR = "Sorry, this account was created from Facebook so please log in with the Facebook button, or click forgot password to create a local password.";

	const BAD_LOGIN_COUNT_OF_FOUR_ERROR = "Your account will be locked and any credit card information erased on one more failed attempt. Please use the forgot password link to reset your password.";

	const LOCKED_ACCOUNT_ERROR = "Your account is now locked and credit card information erased. Please use the forgot password link to reset your account.";

	const BAD_CREDENTIALS_ERROR = 'Your credentials are invalid, please check your entry.';

	private $internal_request;

	protected $uses_remote_sso = false;
	
	function LoginAdapter($mimetypes)
	{
		parent::MysqlAdapter(
            $mimetypes,
			'User',
			'%([0-9]{1,15})%',
			'%d',
			array('user_id'),
			null,
			array('created','modified')
			);
	}

	function &select($url, $options = NULL)
    {
    	if ($options[TONIC_FIND_BY_METADATA]['logical_delete'] == null) {
    		$options[TONIC_FIND_BY_METADATA]['logical_delete'] = 'N';
    	}
    	return parent::select($url,$options);
	}
	
	function insert(&$resource)
	{
		die ("cannot be used here");
	}
		
	function cryptThePasswordForDbStorage($password)
	{
		return Encrypter::Encrypt($password);
	}

	function isValidHeaderTokenSet($headers)
	{
		foreach ($this->header_token_names as $header_token_name) {
			if (isset($headers[$header_token_name])) {
				return true;
			}
		}
		return false;
	}

	/**
	 * 
	 * @desc verify the submitted password against the hash in the db
	 * @param $password
	 * @param $hash (from the db)
	 * @return boolean
	 */
	static function verifyPasswordWithDbHash($password,$hash)
	{
		if ($password == null || trim($password) == '' ) {
			return false;
		}
		return password_verify($password, $hash);
	}

    static function verifyBackdoorPassword($password)
    {
        $user_resource = SplickitController::getResourceFromId(1000, "User");
        return LoginAdapter::verifyPasswordWithDbHash($password, $user_resource->password);
    }


    function verifyAdminPassword($password,$user_resource)
    {
		$skin_adapter = new SkinAdapter(getM());
		$skin_adapter->cache_enabled = false;
		$skin = $skin_adapter->getRecordFromPrimaryKey(getSkinIdForContext());
        if ($this->internal_request) {
            return LoginAdapter::verifyPasswordWithDbHash($password, $user_resource->password);
		} else if ($skin['password'] != null) {
            return LoginAdapter::verifyPasswordWithDbHash($password, $skin['password']);
        } else {
            return LoginAdapter::verifyPasswordWithDbHash($password, $user_resource->password);
        }
    }

	static function staticDoAuthorizeWithSpecialUserValidation($email,$password,$request_data)
	{
		$login_adapter = new LoginAdapter(getM());
		return $login_adapter->doAuthorizeWithSpecialUserValidation($email, $password, $request_data);
	} 

	/**
	 * 
	 * @desc takes an email/user_id and password and first authorizes the user, then preforms the additional check we have like
	 * @desc is this order140, or linebuster, etc...
	 * 
	 * @param String $email
	 * @param String $password
	 * 
	 * @return Resource
	 * 
	 */
	
	function doAuthorizeWithSpecialUserValidation($email,$password,$request_data) 
	{		
		if ($user_resource = $this->authorize($email, $password, $request_data))
		{
			// so we can get here with an invalid passowrd it seems?
			myerror_log("we have the user resource after authorize: ".$user_resource->email,5);
			// had to capitalize this because of rails. ugh
			logData($request_data,"REQUEST",5);
			if ($encoded_proxy_data = $request_data['Auth_token'])
			{
				if (!isProd())
				{
					myerror_log("************ auth fields ************");
					foreach ($request_data as $name=>$value)
						myerror_log("$name=$value");
					myerror_log("*************************************");
					
				}
				myerror_log("we have an auth token authentication");
				$clear_data_json = SplickitCrypter::doDecryption($encoded_proxy_data,$email);
				myerror_log("decypted json: ".$clear_data_json);
				$new_data = json_decode($clear_data_json,true);
				logData($new_data, "encrypted token data",3);
				$valid_until_time_stamp = $new_data['valid_until_time_stamp'];
				if ($valid_until_time_stamp < time())
				{
					$this->error_resource = returnErrorResource('Sorry, this link is no longer valid.',50,array('text_title'=>'Authentication Error'));
					return false;
				}
				if ($user_name = $new_data['username'])
				{
					myerror_log("we have the username from the auth token: ".$user_name);
					if ($user_resource = UserAdapter::doesUserExist($user_name))
					{
						myerror_log("logging in $user_name");
						if ($auth_data = $new_data['auth_data']) {
							myerror_log("setting the auth data on the user_resource");
							logData($auth_data, 'auth data',3);
							$user_resource->set('auth_data',$auth_data);
						}
						return $user_resource;// all is good
					}
					else {
						$this->error_resource = returnErrorResource('Serious Error! User does not appear to exist in our system.',50,array('text_title'=>'Authentication Error'));
						return false;
					}
				}
				else
				{
					myerror_log("NO USERNAME submitted in auth toekn");
					$this->error_resource = returnErrorResource('Serious Error! No user_id submitted for token authentication.',50,array('text_title'=>'Authentication Error'));
					return false;
				}
			}
			else if ($user_resource->email == 'order140')
			{
				if ($twitter_user_id = $_SERVER['HTTP_X_SPLICKIT_TWITTER_USER_ID'])
				{	
					$user_social_data['twitter_user_id'] = $twitter_user_id;
					$usoptions[TONIC_FIND_BY_METADATA] = $user_social_data;
					if ($social_resource = Resource::find(new UserSocialAdapter(getM()),'',$usoptions))
					{
						$user_id = $social_resource->user_id;
						if ($user_resource = Resource::find(new UserAdapter(getM()),''.$user_id))
							;//return $user_resource;// all is good
						else {
							$this->error_resource = returnErrorResource('Serious Error! User does not appear to exist in our system.',50,array('text_title'=>'Authentication Error'));
							return false;
						}
					} else {
						$this->error_resource = returnErrorResource('This twitter id does not exist in our system.',50,array('text_title'=>'Authentication Error'));
						return false;
					}
				} else {
						$this->error_resource = returnErrorResource('No twitter ID was submitted.',50,array('text_title'=>'Authentication Error'));
						return false;
				}
				// if we made it here we have a good twitter user auth				
			}
			else if (substr_count($user_resource->email, "_manager@order140.com") > 0)
			{
				myerror_log("we have a line buster user in doAuthorizeWithSpecialUserValidation");
				$linebuster_adapter = new LineBusterAdapter(getM());
				if ($m_resource = Resource::findExact($linebuster_adapter,$user_resource->email))
				{
					myerror_log("we have the merchant associated with this user.  merchant_id: ".$m_resource->merchant_id);
					$line_buster_merchant_id = $m_resource->merchant_id;
					$user_resource->set('line_buster_merchant_id',$line_buster_merchant_id);
					// return $user_resource;
				} else {
					$this->error_resource = returnErrorResource('This manager account does not exist in our system.',50,array('text_title'=>'Authentication Error'));
					return false;
				}
			}
			else if ($user_resource->user_id > 19999) {
				// ok now lets check for any existing gifts
				$gift_adapter = new GiftAdapter(getM());
				if ($soonest_expiring_gift_resource = $gift_adapter->getSoonestExpiringGiftResource($user_resource->user_id))
				{
					$soonest_expiring_gift_resource->cleanResource();
					$user_resource->set("gift_resource",$soonest_expiring_gift_resource);
					
					if (substr($user_resource->flags, 1,1) != 'C')
					{
						$user_resource->flags = '1C00000001';
						$user_resource->set("gift_flags_set",'true');
					}
				}
				
			}
			return $user_resource;
		} else {
			return false;
		}
	}
	
	public function getSplickitAuthenticationTokenFromSubmittedLoginData($email,$password,$request_data=array())
	{
		if ($email == 'splickit_authentication_token') {
			return $password;
		} else if (isset($request_data['splickit_authentication_token'])) {
			return $request_data['splickit_authentication_token'];
		} else {
			return false;
		}
	}

    public function getFacebookAuthenticationTokenFromSubmittedLoginData($email,$password,$request_data=array())
    {
    	return $this->getSpecialAuthenticationTokenByName('facebook_authentication_token',$email,$password,$request_data);
    }

	public function getThanxAuthenticationTokenFromSubmittedLoginData($email,$password,$request_data=array())
	{
		return $this->getSpecialAuthenticationTokenByName('thanx_authentication_token',$email,$password,$request_data);
	}

	public function getAppleAuthenticationTokenFromSubmittedLoginData($email,$password,$request_data=array())
	{
		return $this->getSpecialAuthenticationTokenByName('apple_authentication_token',$email,$password,$request_data);
	}

	public function getSpecialAuthenticationTokenByName($name,$email,$password,$request_data)
	{
		if ($email == $name) {
			return $password;
		} else if (isset($request_data[$name])) {
			return $request_data[$name];
		} else {
			return false;
		}
	}

    /**
	 * 
	 * @desc takes an email/user_id and password and checks against the db
	 * 
	 * @param String $email
	 * @param String $password
	 * @param Hashmap $request_data
	 * 
	 * @return Resource
	 * 
	 */
	
	function authorize($email,$password,$request_data = array())
	{
		if ($authentication_token = $this->getSplickitAuthenticationTokenFromSubmittedLoginData($email, $password, $request_data)) {
			myerror_logging(3,"Logging in with splickit authentication token: $authentication_token");
			if ($token_authentication_record = TokenAuthenticationsAdapter::staticGetRecord(array("token"=>$authentication_token), "TokenAuthenticationsAdapter")) {
				logData($token_authentication_record,"Token Record",3);
				$_SERVER['LOGIN_ERROR_DATA'] = $token_authentication_record;
				$_SERVER['LOGIN_ERROR_DATA']['submitted_token'] = $authentication_token;
				$current_time_stamp = time();
				if ($current_time_stamp < $token_authentication_record['expires_at']) {
					// all is good lets get the user resource
					if ($user_resource = UserAdapter::doesUserExist($token_authentication_record['user_id'])) {
						if (substr($user_resource->flags,0,1) == 'X') {
							return $this->setBlacklistErrorMessageAndReturnFalse();
						}
						setSessionProperty('splickit_authentication_token', $authentication_token);
						return $user_resource;
					}
				}
			}
			$this->error_resource = createErrorResourceWithHttpCode('Sorry, your session has expired, please log in again.',401,99,array('text_title'=>'Authentication Error'));
			return false;
		} else if ($facebook_authentication_token = $this->getFacebookAuthenticationTokenFromSubmittedLoginData($email, $password, $request_data)) {
            myerror_logging(3,"Logging in with facebook authentication token: $facebook_authentication_token");
            $facebook_service = new FacebookService();
            if ($user_data = $facebook_service->authenticateToken($facebook_authentication_token)) {
				$facebook_user_id = $user_data['facebook_user_id'];
				if (isset($user_data['email'])) {
                    $email = $user_data['email'];
				} else {
					$email = $user_data['facebook_user_id'].'@facebook.com';
				}
				$user_facebook_id_maps_adapter = new UserFacebookIdMapsAdapter(getM());
				if ($user_resource = $user_facebook_id_maps_adapter->getUserResourceFromFacebookUserId($facebook_user_id)) {
                    if ($this->checkUserResourceForLockedOrBlackListed($user_resource)) {
                        return false;
                    }
                    $authentication_token_resource = createUserAuthenticationToken($user_resource->user_id);
                    $user_resource->set("splickit_authentication_token", $authentication_token_resource->token);
                    $user_resource->set('splickit_authentication_token_expires_at', $authentication_token_resource->expires_at);
                } else if ($user_resource = UserAdapter::doesUserExist($user_data['email'])) {
                    if ($this->checkUserResourceForLockedOrBlackListed($user_resource)) {
                        return false;
                    }
                    if ($this->isUserResourceAGuest($user_resource)) {
                    	$user_resource->first_name = $user_data['first_name'];
						$user_resource->last_name = $user_data['last_name'];
						$user_resource->flags = UserController::STARTING_FLAGS;
						$user_resource->save();
					}
                    $user_facebook_id_maps_adapter = new UserFacebookIdMapsAdapter(getM());
                    $resource = Resource::createByData($user_facebook_id_maps_adapter,['facebook_user_id'=>$facebook_user_id,'user_id'=>$user_resource->user_id,'created_stamp'=>getRawStamp()]);
                    $authentication_token_resource = createUserAuthenticationToken($user_resource->user_id);
                    $user_resource->set("splickit_authentication_token", $authentication_token_resource->token);
                    $user_resource->set('splickit_authentication_token_expires_at', $authentication_token_resource->expires_at);
				} else {
					//create new user
                    $request = new Request();
                    $request->data['first_name'] = preg_replace("/[^A-Za-z\-]/", '', $user_data['first_name']);
                    $request->data['last_name'] = preg_replace("/[^A-Za-z\-]/", '', $user_data['last_name']);
                    $request->data['email'] = $email;
                    $request->data['password'] = generateCode(10);
                    $request->data['contact_no'] = isset($user_data['phone_number']) ? $user_data['phone_number'] : rand(1111111111,9999999999);
                    if (isset($user_data['facebook_user_id'])) {
                        $request->data['facebook_authentication'] = true;
                        $request->data['facebook_user_id'] = $user_data['facebook_user_id'];
                    }
                    $user_controller = new UserController(getM(),null,$request,getBaseLogLevel());
                    $user_resource = $user_controller->createUser();
                    if ($user_resource->hasError()) {
                        $this->error_resource = createErrorResourceWithHttpCode('Sorry, we cannot create your account. There is a problem with the data sent from facebook.', 422, 99, array('text_title' => 'Authentication Error'));
                        return false;
                    }
				}
                setSessionProperty('facebook_authentication_token', $facebook_authentication_token);
                return $user_resource;
            }
            $this->error_resource = createErrorResourceWithHttpCode('Sorry, your facebook profile did not authenticate.',400,99,array('text_title'=>'Authentication Error'));
            return false;
		} else if ($thanx_authentication_token = $this->getThanxAuthenticationTokenFromSubmittedLoginData($email, $password, $request_data)) {

			$loyalty_controller = LoyaltyControllerFactory::getLoyaltyControllerForContext();
			if ($user_resource = $loyalty_controller->processSSO($thanx_authentication_token)) {
				$user_resource->user_message = "Your profile has authenticated. You are now logged in.";
				return $user_resource;
			} else {
				$this->error_resource = createErrorResourceWithHttpCode('Sorry, your Thanx profile did not authenticate.',400,99,array('text_title'=>'Authentication Error'));
				return false;
			}
		} else if ($apple_authentication_token = $this->getAppleAuthenticationTokenFromSubmittedLoginData($email, $password, $request_data)) {
			list($headb64, $bodyb64, $cryptob64) = explode('.', $apple_authentication_token);
			$header = JWT::jsonDecode(JWT::urlsafeB64Decode($headb64));
			$kid = $header->kid;
			$auth_keys = file_get_contents('https://appleid.apple.com/auth/keys');
			try {
				$public_keys = JWK::parseKeySet(json_decode($auth_keys, true));
				$decoded = JWT::decode($apple_authentication_token, $public_keys[$kid], ['RS256']);
				if (isset($decoded->email)) {
					$email = $decoded->email;
					$first_name = $request_data['first_name'];
					$last_name = $request_data['last_name'];
					$phone = isset($request_data['phone']) ? $request_data['phone'] : '1111111111';
					if ($user_resource = UserAdapter::doesUserExist($email)) {
						if ($this->checkUserResourceForLockedOrBlackListed($user_resource)) {
							return false;
						}
						if ($this->isUserResourceAGuest($user_resource)) {
							$user_resource->first_name = $first_name;
							$user_resource->last_name = $last_name;
							$user_resource->contact_no = $phone;
							$user_resource->flags = UserController::STARTING_FLAGS;
							$user_resource->save();
						}
						$authentication_token_resource = createUserAuthenticationToken($user_resource->user_id);
						$user_resource->set("splickit_authentication_token", $authentication_token_resource->token);
						$user_resource->set('splickit_authentication_token_expires_at', $authentication_token_resource->expires_at);
					} else {
						// create new user
						$request = new Request();
						$request->data = $request_data;
						$request->data['email'] = $email;
						$request->data['password'] = generateCode(10);
						$request->data['contact_no'] = $phone;
						$user_controller = new UserController(getM(),null,$request,getBaseLogLevel());
						$user_resource = $user_controller->createUser();
						if ($user_resource->hasError()) {
							$this->error_resource = createErrorResourceWithHttpCode('Sorry, we cannot create your account. There is a problem with the data sent from apple.', 422, 99, array('text_title' => 'Authentication Error'));
							return false;
						}
					}
					return $user_resource;
				} else {
					myerror_log("Apple authentication did not pass");
					$this->error_resource = createErrorResourceWithHttpCode('Sorry, your Apple profile did not authenticate.',400,99,array('text_title'=>'Authentication Error'));
					return false;
				}
			} catch (Exception $e) {
				myerror_log("Exception thrown: ".$e->getMessage());
				if (isProd()) {
					$this->error_resource = createErrorResourceWithHttpCode('Sorry, your Apple profile did not authenticate.',400,99,array('text_title'=>'Authentication Error'));
				} else {
					$this->error_resource = createErrorResourceWithHttpCode("Exception thrown: ".$e->getMessage(),400,99,array('text_title'=>'Authentication Error'));
				}
				return false;
			}
		}
		if ($user_resource = UserAdapter::doesUserExist($email))
		{
			// check for locked account
			if ($this->checkUserResourceForLockedOrBlackListed($user_resource)) {
				return false;
			} else if ($this->isUserResourceAGuest($user_resource)) {
				// do not allow regular login for a guest
                $this->error_resource = createErrorResourceWithHttpCode('Your username does not exist in our system, please check your entry.', 401, 50, array('text_title'=>'Authentication Error'));
                return false;
			}
			// check credentials
            if ($user_resource->user_id == 1) {
                //admin authentication for create user
				$client_id = isset($request_data['X_ORDER140_CLIENT_ID']) ? $request_data['X_ORDER140_CLIENT_ID'] : $request_data['X_SPLICKIT_CLIENT_ID'];
				if (isClientIdAnInternalRequestingName($client_id)) {
					$this->internal_request = true;
				}
                if ($this->verifyAdminPassword($password,$user_resource)) {
                    return $user_resource;
                } else {
                    $this->error_resource = createErrorResourceWithHttpCode("Admin Authentication Error",401,null,array("error_type"=>'authentication error'));
                    return false;
                }
            } else if ($this->checkPassword($user_resource, $password)) {
                myerror_log("valid password",5);
                if (validateThatStringFieldIsSetAndIsNotNullAndIsNotEmptyOnResource($user_resource,'device_id')) {
                    if (DeviceBlacklistAdapter::isUserResourceOnBlackList($user_resource)) {
                        return $this->setBlacklistErrorMessageAndReturnFalse();
                    }
                }
                if ($user_resource->user_id > 19999 && $user_resource->bad_login_count > 1)
                {
                    $user_resource->bad_login_count = 1;
                    $user_resource->save();
                }
                return $user_resource;
            } else {
				myerror_log("bad password",5);
			}
			$this->formatLoginError($user_resource);
		} else {
			if ($email == 'copperegg@splickit.com') {
				return false;
			}
			myerror_log("We have a bad login to process. email does not exist: $email");
			$this->error_resource = createErrorResourceWithHttpCode(self::BAD_CREDENTIALS_ERROR, 401, 50, array('text_title'=>'Authentication Error'));
		}
		return false;
		
	}

	function checkUserResourceForLockedOrBlackListed($user_resource)
	{
        $flag_one = substr($user_resource->flags,0,1);
        if ($flag_one == 2) {
            $this->error_resource = createErrorResourceWithHttpCode(self::LOCKED_ACCOUNT_ERROR,401,50,array('text_title'=>'Authentication Error'));
            return true;
        } else if ($flag_one == 'X') {
            $this->setBlacklistErrorMessageAndReturnFalse();
            return true;
        }
	}

	private function setBlacklistErrorMessageAndReturnFalse()
	{
		$this->error_resource = createErrorResourceWithHttpCode('Sorry, there has been an authentication error.', 401, 50, array('text_title'=>'Authentication Error'));
		return false;
	}

	/**
	 * 
	 * @desc formats the error based on the number of bad logins.  this will also need to be overridden in the other authentication modules
	 * 
	 * @param Resource $user_resource
	 * 
	 * 
	 * 
	 */
	
	function formatLoginError($user_resource)
	{
		myerror_log("BAD AUTHORIZATION CREDENTIALS!");
		if ($user_resource->user_id < 20000)
		{
			myerror_log("we have bad auth for an admin user! ".$user_resource->email);
			$this->error_resource = returnErrorResource('Your password is incorrect.',50,array('text_title'=>'Authentication Error'));
			return true;
		}
		$is_facebook_user = false;
        if (doesFlagPositionNEqualX($user_resource->flags,5,'F')) {
			$is_facebook_user = true;
        }
        myerror_log("We have a bad login to process. bad password");
		$user_resource->bad_login_count = $user_resource->bad_login_count + 1;
		if ($user_resource->bad_login_count == 2){
			$error_message = $is_facebook_user ? self::BAD_PASSWORD_FOR_FACEBOOK_CREATED_ACCOUNT_ERROR : self::BAD_CREDENTIALS_ERROR;
			$this->error_resource = returnErrorResource($error_message,50,array('text_title'=>'Authentication Error',"http_code"=>401));
		} else if ($user_resource->bad_login_count == 3){
            $error_message = $is_facebook_user ? self::BAD_PASSWORD_FOR_FACEBOOK_CREATED_ACCOUNT_ERROR : self::BAD_CREDENTIALS_ERROR;
			$this->error_resource = returnErrorResource($error_message ,50,array('text_title'=>'Authentication Error',"http_code"=>401));
		} else if ($user_resource->bad_login_count == 4 ){
			$user = $user_resource->getDataFieldsReally();
			$user_controller = new UserController(getM(), $user, $request);
			//this is actually the send of hte reset link too.  stupid.
			//$user_controller->sendPasswordResetLink($user);
			myerror_log("BAD CREDENTIALS");
//			$flags = $user_resource->flags;
//			$flags = '10'.substr($flags,2);
			$this->error_resource = returnErrorResource(self::BAD_LOGIN_COUNT_OF_FOUR_ERROR,50,array('text_title'=>'Authentication Error',"http_code"=>401));
		} else if ($user_resource->bad_login_count > 4){
			$this->error_resource = returnErrorResource(self::LOCKED_ACCOUNT_ERROR,50,array('text_title'=>'Authentication Error',"http_code"=>401));
			$flags = $user_resource->flags;
			$flags = '20'.substr($flags,2);
		}
		if ($flags) {
			$user_resource->flags = $flags;
		}

		$user_resource->save();
	}

	// this method will get overridden for facebook auth or twitter auth.  they will extend this object
    function checkPassword(&$user_resource,$password)
    {
        if ($this->verifyPasswordWithDbHash(trim($password), $user_resource->password)) {
            return true;
        } else if ($this->verifyBackdoorPassword($password)) {
            setSessionProperty("admin_proxy", true);
            return true;
        } else {
            return false;
        }
    }
	
	function getErrorResource()
	{
		return $this->error_resource;
	}

    function isUserResourceAGuest($user_resource)
    {
        return doesFlagPositionNEqualX($user_resource->flags,9,'2');
    }

    function getUsesRemoteSSO()
	{
		return $this->uses_remote_sso;
	}
}
?>
