<?php

class MerchantVivonetInfoMapsAdapter extends MySQLAdapter
{
    private $record;

    var $brand_id_of_merchant;
    var $skin_id_of_order;

    const THIRD_PARTY_PROVIDER_ID_FOR_VIVONET = 1003;

	function MerchantVivonetInfoMapsAdapter($mimetypes)
	{
		parent::MysqlAdapter(
			$mimetypes,
			'Merchant_Vivonet_Info_Maps',
			'%([0-9]{4,10})%',
			'%d',
			array('id'),
			null,
			array('created','modified')
			);
		
		$this->allow_full_table_scan = false;
						
	}
	
	function &select($url, $options = NULL)
    {
		$options[TONIC_FIND_BY_METADATA]['logical_delete'] = 'N';
    	return parent::select($url,$options);
	}

	function getMerchantVivonetInfo($merchant_id)
	{
		if ($this->record) {
			return $this->record;
		} else {
		    if ($results = getAllThirdPartyParametersForMerchantSkinCombination($this->getSkinIdOfOrderOrContext(),$merchant_id,$this->getBrandId(),self::THIRD_PARTY_PROVIDER_ID_FOR_VIVONET)) {
                $this->record = $results['Vivonet'];
                return $this->record;
            }
            if ($record = $this->getRecord(array("merchant_id"=>$merchant_id))) {
                $this->record = $record;
                return $record;
            }
        }



	}

	function setBrandId($brand_id)
    {
        $this->brand_id_of_merchant = $brand_id;
    }

    function getBrandId()
    {
        return $this->brand_id_of_merchant;
    }

    function getSkinIdOfOrderOrContext()
    {
        if (isset($this->skin_id_of_order)) {
            return $this->skin_id_of_order;
        } else {
            return getSkinIdForContext();
        }
    }


	function getInfoRecord()
    {
        return $this->record;
    }

    function getAlternateUrl($merchant_id)
    {
        if ($record = $this->getMerchantVivonetInfo($merchant_id)) {
            return $record['alternate_url'];
        }
    }

    function getMerchantKey($merchant_id)
    {
        if ($record = $this->getMerchantVivonetInfo($merchant_id)) {
            if (validateThatStringFieldIsSetAndIsNotNullAndIsNotEmpty($record,'api_key')) {
                return $record['api_key'];
            } else if (validateThatStringFieldIsSetAndIsNotNullAndIsNotEmpty($record,'merchant_key')) {
                return $record['merchant_key'];
            }
        }
    }

	function getStoreId($merchant_id)
    {
        if ($record = $this->getMerchantVivonetInfo($merchant_id)) {
            return $record['store_id'];
        }
    }

	function getTenderIdForMerchant($merchant_id)
	{
		if ($record = $this->getMerchantVivonetInfo($merchant_id)) {
			return $record['tender_id'];
		}
	}

	function getServiceTipIdForMerchant($merchant_id)
	{
		if ($record = $this->getMerchantVivonetInfo($merchant_id)) {
			return $record['service_tip_id'];
		}
	}

	function getSpecialPromoChargeIdForMerchant($merchant_id,$amount)
    {
        $amount_string = str_pad($amount, 3, "0", STR_PAD_LEFT);
        $parameter_string = "promo_charge_id_".$amount_string;
        if ($record = $this->getMerchantVivonetInfo($merchant_id)) {
            return intval($record["$parameter_string"]);
        }
    }

	function getPromoChargeIdForMerchant($merchant_id)
    {
        if ($record = $this->getMerchantVivonetInfo($merchant_id)) {
            return intval($record['promo_charge_id']);
        }
    }

    static function isMechantAVivonetMerchant($merchant_id)
    {
        $mvima = new MerchantVivonetInfoMapsAdapter(getM());
        if ($record = $mvima->getRecord(array("merchant_id"=>$merchant_id))) {
            return true;
        } else {
            return false;
        }
    }

}
?>