<?php

class MessageControllerTemplateInfosAdapter extends MySQLAdapter
{
    private $controller_record;
    private $all_controller_records;

    function __construct($mimetypes)
    {
        parent::MysqlAdapter(
            $mimetypes,
            'Message_Controller_Template_Infos',
            '%([0-9]{4,15})%',
            '%d',
            array('id'),
            null,
            array('created', 'modified')
        );

        $this->allow_full_table_scan = true;

    }

    function &select($url, $options = NULL)
    {
        $options[TONIC_FIND_BY_METADATA]['logical_delete'] = 'N';
        return parent::select($url, $options);
    }

    function getPulledMessageFormats()
    {
        if ($records = $this->getRecords(['is_pulled_message_type'=>1])) {
            $hash = createHashmapFromArrayOfArraysByFieldName($records,'base_format');
            return $hash;
        } else {
            return [];
        }
    }

    function getAllFormatsAndControllers()
    {
        $this->all_controller_records = $this->getRecords([]);
        return $this->all_controller_records;
    }

    function getAllFormatsAndControllersHashedByUrlName()
    {
        $records = $this->getAllFormatsAndControllers();
        return createHashmapFromArrayOfArraysByFieldName($records,'url_name');
    }

    function getControllerNameFromUrlName($url_name)
    {
        if ($record = $this->getRecord(['url_name'=>$url_name])) {
            $this->controller_record = $record;
            return $record['controller_name'];
        }
    }

    function getControllerNameFromFormatBase($base_format)
    {
        if ($record = $this->getRecord(['base_format'=>$base_format])) {
            $this->controller_record = $record;
            return $record['controller_name'];
        }
    }

    function getControllerRecord()
    {
        return $this->controller_record;
    }



}
?>