<?php

class MessageManagerRequestsAdapter extends MySQLAdapter
{

	function MessageManagerRequestsAdapter($mimetypes)
	{
		parent::MysqlAdapter(
			$mimetypes,
			'message_manager_requests',
			'%([0-9]{4,10})%',
			'%d',
			array('id'),
			null,
			array('modified','created')
			);
        $this->log_level = 0;
	}

	function recordMessageManangerRequest($identifier,$request_url,$request_method)
    {
        $data = [];
        if ($identifier == null) {
            $identifier = 'NOID-'.time();
        }
        $data['identifier'] = $identifier;
        $data['date_of_request'] = date("Y-m-d");
        $data['request_method'] = $request_method;
        $resource = Resource::findOrCreateIfNotExistsByData($this,$data);
        if (! isset($resource->insert_id)) {
            if ($resource->request_url != $request_url) {
                myerror_log("WE HAVE MULTIPLE URLS FOR MESSAGE MANAGER REQUESTS WITH THE SAME IDENTIFIER");
                myerror_log("Existing $resource->request_url  --  Submitted: $request_url");
            }
        } else {
            $resource->request_url = $request_url;
        }
        $resource->count = $resource->count + 1;
        $resource->save();
    }
}
?>