<?php

class ThirdPartyProviderParameterBrandMapsAdapter extends MySQLAdapter
{

	function ThirdPartyProviderParameterBrandMapsAdapter($mimetypes)
	{
		parent::MysqlAdapter(
			$mimetypes,
			'Third_Party_Provider_Parameter_Brand_Maps',
			'%([0-9]{4,10})%',
			'%d',
			array('id'),
			null,
			array('created','modified')
			);
		
		$this->allow_full_table_scan = true;
						
	}

    function &select($url, $options = NULL)
    {
        $options[TONIC_FIND_BY_METADATA]['logical_delete'] = 'N';
        return parent::select($url,$options);
    }

    function getBrandParameters($brand_id,$third_party_provider_id = 0)
    {
        if ($brand_id < 2) {
            myerror_log("ERROR!!!!! brand_id: $brand_id.  Is INVALID for getBrandParameters");
            throw new Exception("No valid brand_id sent for ThirdPartyProviderParameterBrandMapsAdapter.getBrandParameters");
        }
        $sql = "SELECT c.name AS 'provider_name', b.name AS 'parameter_name' ,a.value ".
            "FROM Third_Party_Provider_Parameter_Brand_Maps a JOIN Third_Party_Provider_Parameters b ON a.third_party_provider_parameter_id = b.id ".
            "JOIN Third_Party_Providers c ON b.third_party_provider_id = c.id ".
            "WHERE a.brand_id = $brand_id and a.logical_delete = 'N' AND b.logical_delete = 'N' AND c.logical_delete = 'N'";
        if ($third_party_provider_id > 0) {
            $sql = $sql." AND c.id = $third_party_provider_id";
        }
        $options[TONIC_FIND_BY_SQL] = $sql;
        $third_party_fields = [];
        if ($parameters = Resource::findAll($this,null,$options)) {
            foreach ($parameters as $parameter_row) {
                $third_party_fields[$parameter_row->provider_name][$parameter_row->parameter_name] = $parameter_row->value;
            }
        }
        return $third_party_fields;
    }

    function setBrandParameterByName($parameter_name,$provider_id,$brand_id,$value)
    {
        $third_party_provider_parameters_adapter = new ThirdPartyProviderParametersAdapter(getM());
        $options[TONIC_FIND_BY_METADATA] = ["name"=>$parameter_name,'third_party_provider_id'=>$provider_id];
        if ($resource = Resource::find($third_party_provider_parameters_adapter,null,$options)) {
            $third_party_provider_parameter_id = $resource->id;
            return Resource::createByData($this,["brand_id"=>$brand_id,"third_party_provider_parameter_id"=>$third_party_provider_parameter_id,"value"=>$value]);
        }
    }


}
?>