<?php

class ThirdPartyProviderParameterMerchantMapsAdapter extends MySQLAdapter
{

	function ThirdPartyProviderParameterMerchantMapsAdapter($mimetypes)
	{
		parent::MysqlAdapter(
			$mimetypes,
			'Third_Party_Provider_Parameter_Merchant_Maps',
			'%([0-9]{4,15})%',
			'%d',
			array('id'),
			null,
			array('created','modified')
			);
		
		$this->allow_full_table_scan = true;
						
	}

    function &select($url, $options = NULL)
    {
        $options[TONIC_FIND_BY_METADATA]['logical_delete'] = 'N';
        return parent::select($url,$options);
    }

    function getMerchantParameters($merchant_id,$third_party_provider_id = 0)
    {
        if ($merchant_id < 1000) {
            myerror_log("ERROR!!!!! merchant_id: $merchant_id.  Is INVALID for getMerchantParameters");
            throw new Exception("No valid merchant_id sent for ThirdPartyProviderParameterMerchantMapsAdapter.getMerchantParameters");
        }
        $sql = "SELECT c.name AS 'provider_name', b.name AS 'parameter_name' ,a.value ".
            "FROM Third_Party_Provider_Parameter_Merchant_Maps a JOIN Third_Party_Provider_Parameters b ON a.third_party_provider_parameter_id = b.id ".
            "JOIN Third_Party_Providers c ON b.third_party_provider_id = c.id ".
            "WHERE a.merchant_id = $merchant_id and a.logical_delete = 'N' AND b.logical_delete = 'N' AND c.logical_delete = 'N'";
        if ($third_party_provider_id > 0) {
            $sql = $sql." AND c.id = $third_party_provider_id";
        }
        $options[TONIC_FIND_BY_SQL] = $sql;
        $third_party_fields = [];
        if ($parameters = Resource::findAll($this,null,$options)) {
            foreach ($parameters as $parameter_row) {
                $third_party_fields[$parameter_row->provider_name][$parameter_row->parameter_name] = $parameter_row->value;
            }
        }
        return $third_party_fields;
    }

    function getMerchantThirdPartyParameterMapByThirdpartyProviderIdAndParameterNameAsResource($parameter_name,$third_party_provider_id,$merchant_id)
    {
        if ($third_party_merchant_fields = $this->getAllThirdPartyParameterMerchantMapsByThirdPartyProviderId($third_party_provider_id,$merchant_id)) {
            if ($resource = $third_party_merchant_fields[$parameter_name]) {
                return $resource;
            }
        }
    }

    function getAllThirdPartyParameterMerchantMapsByThirdPartyProviderId($third_party_provider_id,$merchant_id)
    {
        $sql = "SELECT b.name,a.* FROM Third_Party_Provider_Parameter_Merchant_Maps a JOIN Third_Party_Provider_Parameters b ON a.third_party_provider_parameter_id = b.id ".
            " WHERE a.merchant_id = $merchant_id and a.logical_delete = 'N' AND b.logical_delete = 'N' AND b.third_party_provider_id = $third_party_provider_id";
        $options[TONIC_FIND_BY_SQL] = $sql;
        $third_party_merchant_fields = [];
        if ($parameters = Resource::findAll($this,null,$options)) {
            foreach ($parameters as $parameter_row) {
                $third_party_merchant_fields[$parameter_row->name] = $parameter_row;
            }
        }
        return $third_party_merchant_fields;

    }

    function setThirdPartyParameterFieldByNameProviderMerchantId($provider_name,$parameter_name,$merchant_id,$value)
    {
        if ($provider_name) {
            $tppa = new ThirdPartyProvidersAdapter(getM());
            if ($provider_record = $tppa->getRecord(['name'=>$provider_name])) {
                if ($parameter_name) {
                    $tpppa = new ThirdPartyProviderParametersAdapter(getM());
                    if ($parameter_record = $tpppa->getRecord(["third_party_provider_id"=>$provider_record['id'],'name'=>$parameter_name])) {
                        if ($merchant_id > 1000) {
                            $data = ['third_party_provider_parameter_id'=>$parameter_record['id'],'merchant_id'=>$merchant_id,'value'=>$value];
                            $resource = Resource::factory($this,$data);
                            if ($resource->save()) {
                                return $resource->getRefreshedResource();
                            }
                        }

                    }
                }
            }
        }
    }

}
?>