<?php

class ThirdPartyProviderParametersAdapter extends MySQLAdapter
{

	function ThirdPartyProviderParametersAdapter($mimetypes)
	{
		parent::MysqlAdapter(
			$mimetypes,
			'Third_Party_Provider_Parameters',
			'%([0-9]{4,10})%',
			'%d',
			array('id'),
			null,
			array('created','modified')
			);
		
		$this->allow_full_table_scan = true;
						
	}

	function getParametersFromProviderId($provider_id)
    {
        $parameters = [];
        if ($records = $this->getRecords(['third_party_provider_id'=>$provider_id])) {
            foreach ($records as $record) {
                $parameters[] = ['name'=>$record['name'],'third_party_provider_parameter_id'=>$record['id']];
            }
        }
        return $parameters;
    }

    function &select($url, $options = NULL)
    {
        $options[TONIC_FIND_BY_METADATA]['logical_delete'] = 'N';
        return parent::select($url,$options);
    }


}
?>