<?php

class ThirdPartyProvidersAdapter extends MySQLAdapter
{

	function ThirdPartyProvidersAdapter($mimetypes)
	{
		parent::MysqlAdapter(
			$mimetypes,
			'Third_Party_Providers',
			'%([0-9]{4,10})%',
			'%d',
			array('id'),
			null,
			array('created','modified')
			);
		
		$this->allow_full_table_scan = true;
						
	}

    function &select($url, $options = NULL)
    {
        $options[TONIC_FIND_BY_METADATA]['logical_delete'] = 'N';
        return parent::select($url,$options);
    }


    function getThirdPartyProviderWithParametersById($id)
    {
        if ($provider_record = $this->getRecordFromPrimaryKey($id)) {
            // get parameters
            $third_party_provider_parameters_adapter = new ThirdPartyProviderParametersAdapter(getM());
            $provider_record['parameters'] = $third_party_provider_parameters_adapter->getParametersFromProviderId($id);
            return $provider_record;
        } else {
            myerror_log("No matching third party provider with id: $id");
            throw new Exception("No matching third party provider with id: $id");
        }
    }

}
?>