<?php 
/*
 * @desc This is actually ONLY the MessagerControllerFactory.  it was named incorrectly.
 * @author radamnyc
 */
final Class ControllerFactory {

    private $id;
    private $action;
    private $controller_record;

    /**
     * @desc will instantiate the correct controller based on the request
     *
     * @param $request Request
     * @return MessageController
     */
    public static function getMessageControllerFromRequest($request)
    {
        $controller_factory = new ControllerFactory();
        $url = $request->url;
        if ($url_name = $controller_factory->getUrlNameFromUrlString($url)) {
            $message_controller_template_infos_adapter = new MessageControllerTemplateInfosAdapter(getM());
            if ($controller_class_name = $message_controller_template_infos_adapter->getControllerNameFromUrlName($url_name)) {
                $request->data['submitted_identifier'] = $controller_factory->getSubmittedId();
                $request->data['action'] = $controller_factory->getAction();
                if ($class = new $controller_class_name(getM(), null, $request, $_SERVER['log_level'])) {
                    $class->setControllerRecord($message_controller_template_infos_adapter->getControllerRecord());
                    $fixed_url = str_replace('/','-',$url);
                    myerror_log("controller generated from requets url: ".$fixed_url,3);
                    return $class;
                }
            }
        }
        return null;
    }

    /*
     *  this is the format of the current call backs.  both of these will be going away soon
     *
     * CHINAIP:  /app2/messagemanager/71274406/chinaipprinter/callback.txt
     * PHAXIO FAX:  /app2/messagemanager/413wmm86q1b7/map_id.42429570/service.Phaxio/fax/callback.txt
     */


    public function getUrlNameFromUrlString($url_string)
    {

        if (preg_match('%/messagemanager/(getnextmessagebymerchantid)/([0-9]{1,2}[0-9a-zA-Z]{9,11})/([a-z]+)%', $url_string, $matches)) {
            $this->action = $matches[1];
            $this->id = $matches[2];
            return $matches[3];
        } else if (preg_match('%/messagemanager/(getnextmessagebymerchantid)/([0-9]{8})/([a-z]+)%', $url_string, $matches)) {
            $this->action = $matches[1];
            $this->id = $matches[2];
            return $matches[3];
        } else if (preg_match( '%/messagemanager/foundry/(getnextmessagebymerchantid)%', $url_string, $matches)) {
            $this->action = $matches[1];
            return 'foundry';
        } else if (preg_match('%/messagemanager/(getorderbyid)/([0-9]{8,15})/([a-z]+)%', $url_string, $matches)) {
            $this->action = $matches[1];
            $this->id = $matches[2];
            return $matches[3];
        } else if (preg_match('%/messagemanager/([0-9]{2}[0-9a-zA-Z]{10})/[0-9a-zA-Z._/]+/([a-z]+)/callback.txt%', $url_string, $matches)) {
            $this->action = "callback";
            $this->id = $matches[1];
            return $matches[2];
        } else if (preg_match('%/messagemanager/([0-9]{8}|[0-9]{1,2}[0-9a-zA-Z]{10,11})/([a-z]+)/callback.txt%', $url_string, $matches)) {
            $this->action = "callback";
            $this->id = $matches[1];
            return $matches[2];
        } else {
            return false;
        }
    }

    function getSubmittedId()
    {
        return $this->id;
    }

    function getAction()
    {
        return $this->action;
    }



	/**
	 * 
	 * Enter description here ...
	 * @param $string
	 * @param $mimetypes
	 * @param $user
	 * @param $request
	 * @param $log_level
	 * 
	 * @return MessageController
	 */
	public static function generateFromUrl($string, $mimetypes, $user, $request, $log_level) 
	{
	    return ControllerFactory::getMessageControllerFromRequest($request);

	}
	
	/**
	 * 
	 * Enter factory method to obtain the correct controller for message sending.  will return boolean false if no controller matching type is found.
	 * 
	 * @param Resource $message_resource
	 * @param Mimetypes $mimetypes
	 * @param Array $user
	 * @param Request $request
	 * @param int $log_level
	 * 
	 * @return MessageController
	 */

	public static function generateFromMessageResource($message_resource, $mimetypes, $user, $request, $log_level) 
	{
	    $controller_factory = new ControllerFactory();
		if ($class_name = $controller_factory->getControllerNameFromMessageResource($message_resource))
		{
			$class = new $class_name($mimetypes, $user, $request, $log_level);
            $class->setControllerRecord($controller_factory->getControllerRecord());
			$class->message_resource = $message_resource;
			return $class;
		}
		myerror_log('FATAL ERROR in smaw_message_dispatch! FORMAT NOT RECOGNIZED!  No controller matching type: '.substr($message_resource->message_format, 0,1));
		return false;
	}
	
	public function getControllerNameFromMessageResource($message_resource)
	{
        $format = substr($message_resource->message_format, 0,1);
        myerror_log("the format in controller factory is: ".$format,3);
        $message_controller_template_infos_adapter = new MessageControllerTemplateInfosAdapter(getM());
        if ($controller_class_name = $message_controller_template_infos_adapter->getControllerNameFromFormatBase($format)) {
            $this->controller_record = $message_controller_template_infos_adapter->getControllerRecord();
            return $controller_class_name;
        } else {
            myerror_log("No controller name registered for passed in type: ".$message_resource->message_format);
            return false;
        }
	}

	public function getControllerRecord()
    {
        return $this->controller_record;
    }

}
?>