<?php

/**
 * Created by PhpStorm.
 * User: Elvis
 * Date: 8/18/16
 * Time: 11:32 AM
 */
class EnterpriseController extends CurlController
{
    var $format_name = 'enterprise';
    var $enterprise_service;
    var $third_party_info;

    const Enterprise_THIRD_PARTY_PROVIDER_ID = 1019;

    function EnterpriseController($mt, $u, &$r, $l = 0)
    {
        parent::MessageController($mt, $u, $r, $l);
    }

    function setEnterpriseCheckoutInfoOnOrderObject($order)
    {
        $starting_order_resource = $order->getOrderResource();
        $order_resource = $this->setEnterpriseCheckoutInfoOnOrderResource($starting_order_resource);

        if($order_resource->http_code == 500){
            throw new Exception($order_resource->error);
        }else{
            $order_resource->save();
            $new_order = new Order($order_resource->order_id);
            Order::setRawResult($order_resource->raw_result);
            return $new_order;
        }
    }

    public function setEnterpriseCheckoutInfoOnOrderResource(&$order_resource)
    {
        $isNativeSkin = $this->isNativeSkinOrder($order_resource);
        if ($checkout_info_as_array = $this->getEnterpriseCheckoutInfo($order_resource->order_id)) {

            if ($checkout_info_as_array['http_code'] == 200) {
                $response = json_decode($checkout_info_as_array['raw_result']);

                if(!$response->success && !$isNativeSkin){
                    return createErrorResourceWithHttpCode(PlaceOrderController::REMOTE_SYSTEM_CHECKOUT_INFO_ERROR_MESSAGE,500);
                }
                $order_resource->total_tax_amt = $response->tax;
                $order_resource->order_amt = $response->subtotal;
                $order_resource->grand_total = $response->total;
                $order_resource->raw_result = $checkout_info_as_array['raw_result'];

                // TODO: Determine if we need to set anything else back from the quote
                //$delivery_amount = 0.00;
                //$order_resource->grand_total_to_merchant = $checkout_info_as_array['Total']+$order_resource->tip_amt;
            } else {
                mysqli_query('Error returned from EnterpriseQuoteService.');
                return createErrorResourceWithHttpCode(PlaceOrderController::REMOTE_SYSTEM_CHECKOUT_INFO_ERROR_MESSAGE,500);
            }
        }
        return $order_resource;
    }
    private function isNativeSkinOrder($order_resource){
        $skinAdapter = new SkinAdapter(getM());
        $sql = "SELECT count(*) as result FROM Skin s WHERE s.skin_id = ".$order_resource->skin_id." AND s.skin_type = 'NV'";
        $skin_options[TONIC_FIND_BY_SQL] = $sql;
        $skin_select_resource = Resource::find($skinAdapter, null, $skin_options);
        $counter = (int)$skin_select_resource->result;
        if($counter > 0){
            return true;
        }
        return false;
    }

    public function getEnterpriseCheckoutInfo($order_id)
    {
        $full_order = CompleteOrder::staticGetCompleteOrder($order_id, getM());

        $create_messages_controller = new CreateMessagesController(null);
        $portal_order_array = $create_messages_controller->createOrderDataForPortalDisplayFromCompleteOrder($full_order);
        // Populate a merchant_id on the message before we send it
        $portal_order_array['merchant_id'] = $full_order['merchant_id'];
        $portal_order_json = json_encode($portal_order_array);
        $enterprise_service = new EnterpriseService();
        $quote_response = $enterprise_service->getEnterpriseOrderQuote($portal_order_json);

        return $quote_response;
    }

    public function populateMessageData($message_resource)
    {
        return parent::populateMessageData($message_resource);
    }

    function send($message_text)
    {

        $enterpriseQueueProperty = getProperty("enterprise_order_queue");
        if ($enterpriseQueueProperty == null || $enterpriseQueueProperty == "") {
            $enterpriseQueueProperty = 'https://sqs.us-east-1.amazonaws.com/619629683428/submit_order_queue';
        }
        $service = new AWSService();
        $order_json = $this->message_resource->portal_order_json;

        $order_object = json_decode($this->message_resource->portal_order_json, true);
        $order_object['merchant_id'] = $this->message_resource->merchant_id;

        $order_json = json_encode($order_object);
        try {
            $service->sendToQueue($enterpriseQueueProperty, $order_json);
            return true;
        } catch (AwsException $e) {
            // output error message if fails
            $error = $e->getMessage();
            //printf($error);
            myerror_log("Error Sending json to AWS queue: $error");
            throw new Exception("Error Sending json to AWS queue: $error", 500);
        }
    }
}
