<?php

Class FoundryController extends MessageController
{

    var $importer;
    var $merchant_resource;
    var $merchant_foundry_info;
    var $get_string_data;
    var $foundry_info;

    protected $format = 'U';
    protected $format_name = 'foundry';



    const FOUNDRY_THIRD_PARTY_PROVIDER_ID = 1005;

    function FoundryController($mt,$u,&$r,$l = 0)
    {
        parent::MessageController($mt,$u,$r,$l);
        if (strtoupper($this->request->method) == 'POST') {
            $this->get_string_data = $this->request->_parseGETString();
            $this->data['siteid'] = $this->get_string_data['siteid'];
        } else if (strtoupper($this->request->method) == 'PUT') {
            if (preg_match( '%/getnextmessagebymerchantid/([0-9]{2}[0-9a-zA-Z]{10})%', $this->request->url, $matches)) {
                $this->data['siteid'] = $matches[1];
            }
        }
        if ($this->data['siteid']) {
            $this->data['submitted_identifier'] = $this->data['siteid'];
            myerror_log("we have the submitted identifier: ".$this->data['siteid']);
        } else {
            //throw new NoMerchantFoundryLocationException('NONE SUBMITTED');
        }
    }

    private function processCheckForMessagesRequest($merchant_id)
    {
        if ($message_resources = $this->getAvailablePuledMessageResourcesArrayByMerchantId($merchant_id)) {
            $response_body = "<SVRRESPONSE>2</SVRRESPONSE>";
        } else {
            // check for menu
            if ($this->foundry_info['get_menu'] == 1) {
                //$response_body = '<SVRRESPONSE REQTYPE="01" SITEID="'.$this->merchant_resource->alphanumeric_id.'" SVRREQ="1" PARM6="MENU EXTRACTOR FILTER PARAMETERS" >1</SVRRESPONSE>';
                $response_body = '<SVRRESPONSE REQTYPE="01" SITEID="'.$this->merchant_resource->alphanumeric_id.'" SVRREQ="1"  >1</SVRRESPONSE>';
                // now reset the flag
                if ($this->foundry_info['data_in_third_party_table']) {
                    $tpppmma = new ThirdPartyProviderParameterMerchantMapsAdapter(getM());
                    if ($tpppmm_resource = $tpppmma->getMerchantThirdPartyParameterMapByThirdpartyProviderIdAndParameterNameAsResource('get_menu',self::FOUNDRY_THIRD_PARTY_PROVIDER_ID,$merchant_id)) {
                        $tpppmm_resource->value = 0;
                        $tpppmm_resource->save();
                    } else {
                        myerror_log("UNABLE TO RESET FLAG IN THIRD PARTY TABLE FOR FOUNDRY IMPORT IN FOUNDRY CONTROLLER");
                        MailIt::sendErrorEmail("UNABLE TO RESET FLAG IN THIRD PARTY TABLE FOR FOUNDRY IMPORT IN FOUNDRY CONTROLLER","stamp: ".getRawStamp());
                    }
                } else {
                    $sql = "UPDATE Merchant_Foundry_Info_Maps SET get_menu = FALSE WHERE merchant_id = $merchant_id LIMIT 1";
                    $mfima = new MerchantFoundryInfoMapsAdapter(getM());
                    $mfima->_query($sql);
                }


            } else {
                $response_body = "<SVRRESPONSE>1</SVRRESPONSE>";
            }
        }
        return $response_body;
    }

    static function sortByModifierItemPriorityDescending($a,$b) {
        return $a['modifier_item_priority']<$b['modifier_item_priority'];
    }


    public function populateMessageData($message_resource)
    {
        if ($message_resource->message_format == 'UEX') {

         /*  TENDER ID's for EPL.  ONLY using VISA (201) for now
            7   201 Visa
            8   202 Mastercard
            9   203 Amex
            10  204 Discover
         */

            try {
                $full_order = $this->getOrderInfoForMessage($message_resource);
                // ****  this is for when we start doing promo per item for EPL **** //
//                if ($full_order['promo_amt'] < 0.00) {
//                    // we have a promo
//                    //$promo_controller = new PromoController($m,$this->user,$this->request,$this->log_level);
//                    $promo_id = $full_order['promo_id'];
//                    $promo = PromoAdapter::staticGetRecordByPrimaryKey($promo_id,'PromoAdapter');
//                    $promo_type = $promo['promo_type'];
//                    if ($promo_type == 1) {
//                        $type_one = true;
//                    } else if ($promo_type == 2) {
//                        $promo_items = PromoType2ItemMapAdapter::staticGetRecord(array("promo_id"=>$promo_id),'PromoType2ItemMapAdapter');
//                    } else if ($promo_type == 4) {
//                        $promo_items = PromoType4ItemAmountMapsAdapter::staticGetRecord(array("promo_id"=>$promo_id),'PromoType4ItemAmountMapsAdapter');
//                    } else if ($promo_type == self::FREE_DELIVERY_TYPE_ID) {
//                       // not doing this yet
//                    }
//                }
                $full_order['tender_id'] = "201"; // forced visa
                $year_plus_one = date('y',time()) + 1;
                $full_order['fake_expration_date'] = "12".$year_plus_one;
                $full_order['order_details_foundry_epl'] = array();
                $full_order['epl_pickup_time_string'] = date('H:i A',$full_order['pickup_dt_tm']);
                foreach($full_order['order_details'] as $order_item) {
                    $order_item['exception_tag'] = 'MODITEM';
                    $use_combo = false;
                    $epl_modifiers = array();
                    $hold_modifiers = array();
                    $external_id = $order_item['external_id'];
                    $e = explode(':',$external_id);
                    $order_item['external_id'] = $e[0];
                    if (isset($e[2]) && strtoupper($e[2]) == 'FC') {
                        $use_combo = true;
                        array_pop($e);
                    } else if (sizeof($e) == 3) {
                        // so there are 3 id's associated with this item. we at least have a forced Meal. it may get overridden by a combo though
                        $forced_meal = true;
                    }
                    // a '+' indicates this item has an forced modifier
                    $i = explode('+',$order_item['external_id']);
                    $order_item['external_id'] = $i[0];
                    if ($i[1]) {
                        // we have an item that has a forced modifier
                        $epl_modifiers[] = array("external_id"=>$i[1],"mod_quantity"=>'1',"use_as_sub"=>'NO',"role"=>'none');
                    }
                    foreach ($order_item['order_detail_hold_it_modifiers'] as $hold_modifier) {
                        if ($hold_modifier['modifier_type'] != 'T') {
                            // only show removes for toppings
                            continue;
                        }
                        $h = explode(":",$hold_modifier['external_id']);
                        $hold_modifier['external_id'] = $h[0];
                        $hold_modifier['use_as_sub'] = 'NO';
                        $hold_modifier['role'] = 'none';
                        $epl_modifiers[] = $hold_modifier;
                    }
                    foreach ($order_item['order_detail_complete_modifier_list_no_holds'] as $modifier) {
                        if ($modifier['modifier_type'] == 'T' && $modifier['comes_with'] == 'Y') {
                            // do not add this modifier. toppings that are included are NOT sent
                            continue;
                        }
                        $modifier_external_id = $modifier['external_id'];
                        $m = explode(':',$modifier_external_id);
                        $modifier['use_as_sub'] = 'NO';
                        if ($m[1] == 'C') {
                            $use_combo = true;
                        } else if ($m[1] == 'SUB') {
                            $modifier['use_as_sub'] = 'YES';
                        }
                        $modifier_externals = explode("-",$m[0]);
                        $modifier['external_id'] = $modifier_externals[0];
                        $modifier['role'] = 'none';
                        $quantity = $modifier['mod_quantity'];
                        $modifier['mod_quantity'] = 1;
                        if (isset($modifier_externals[1])) {
                            $modifier['role'] = 'parent';
                            for ($ii=0;$ii<$quantity;$ii++) {
                                $epl_modifiers[] = $modifier;
                                $epl_modifiers[] = array("external_id"=>$modifier_externals[1],"mod_quantity"=>'1',"use_as_sub"=>'MOD',"role"=>'child');
                            }
                        } else {
                            for ($ii=0;$ii<$quantity;$ii++) {
                                $epl_modifiers[] = $modifier;
                            }
                        }
                    }
                    if ($use_combo) {
                        // get last item off the item external string
                        $this->setComboMealItemForTemplate($order_item,array_pop($e),$e[0]);
                    } else if ($forced_meal) {
                        $this->setComboMealItemForTemplate($order_item,$e[1],$e[0]);
                    }
                    $clean_epl_modifiers = $this->doExceptions($epl_modifiers);

                    usort($clean_epl_modifiers, "FoundryController::sortByModifierItemPriorityDescending");

                    $order_item['foundry_epl_modifiers'] = $clean_epl_modifiers;
                    $full_order['order_details_foundry_epl'][] = $order_item;
                }

                $this->full_order = $full_order;
                $this->merchant = $full_order['merchant'];
                $this->order_user = $full_order['user'];
                if ($full_order['cash'] == 'Y') {
                    $full_order['tender_id'] = 406;
                } else {
                    $full_order['tender_id'] = 208;
                }
                $resource = Resource::dummyFactory($full_order);
            } catch (Exception $oe) {
                throw new Exception($oe->getMessage(), 50);
            }
            $resource->set('message_id',$message_resource->map_id);
        } else {
            $resource = parent::populateMessageData($message_resource); // TODO: Change the autogenerated stub
            if ($resource->order_date != $resource->pickup_date) {
                $resource->pickup_time_ampm = $resource->pickup_date3;
            }
            // $this->merchant_foundry_info = MerchantFoundryInfoMapsAdapter::getMerchantFoundryInfoMap($message_resource->merchant_id);
            $this->foundry_info = getThirdPartyParametersForMerchantSkinCombination(self::FOUNDRY_THIRD_PARTY_PROVIDER_ID,0,$this->merchant['merchant_id'],$this->merchant['brand_id']);
            foreach ($this->foundry_info as $name=>$value) {
                if ($name == 'promo_id') {
                    // needed this to avoid name collision with Order.promo_id
                    $foundry_name = "foundry_$name";
                } else {
                    $foundry_name = $name;
                }
                $resource->set($foundry_name,$value);
            }

            foreach ($resource->order_details as &$order_detail) {
                // get item modifier group maps
                $imgma = new ItemModifierGroupMapAdapter(getM());
                $imgm_records = $imgma->getRecords(['item_id'=>$order_detail['item_id'],'merchant_id'=>0]);
                $imgm_hash = createHashmapFromArrayOfArraysByFieldName($imgm_records,'modifier_group_id');
                $foundry_modifiers = [];
                if ($message_resource->message_format == 'UE') {
                    //exceptions
                    $modifiers = array_merge($order_detail['order_detail_hold_it_modifiers'],$order_detail['order_detail_added_modifiers'],$order_detail['order_detail_sides']);
                } else {
                    $modifiers = $order_detail['order_detail_complete_modifier_list_no_holds'];
                }
                foreach ($modifiers as &$modifier) {

                    $s = explode('-',$modifier['external_id']);
                    $has_parent = false;
                    $parent_modifier = [];
                    if ($s[1]) {
                        $modifier['external_id'] = $s[1];
                        $e = explode(':',$s[0]);
                        $parent_modifier['external_modifier_group_id'] = $e[0];
                        $parent_modifier['external_id'] = $e[1];
                        $has_parent = true;
                    }
                    $e = explode(':',$modifier['external_id']);
                    if (isset($e[1])) {
                        $modifier['external_modifier_group_id'] = $e[0];
                        $modifier['external_id'] = $e[1];
                    } else {
                        $modifier['external_modifier_group_id'] = '';
                    }
                    $modifier_group_priority = $imgm_hash[$modifier['modifier_group_id']]['priority'];
                    $modifier['modifier_group_priority'] = $modifier_group_priority;
                    if ($modifier['comes_with'] == 'H') {
                        // we have a hold it
                        $modifier['modecode'] = isset($this->foundry_info['modecode_holds']) ? $this->foundry_info['modecode_holds'] : 2 ;
                        $modifier['mod_quantity'] = 1;
                    } else {
                        $modifier['modecode'] = isset($this->foundry_info['modecode']) ? $this->foundry_info['modecode'] : 1 ;  // $this->foundry_info['modecode'];
                    }
                    $quantity = $modifier['mod_quantity'];
                    if ($has_parent) {
                        $parent_modifier['has_child'] = true;
                        $parent_modifier['modecode'] = $modifier['modecode'];
                        $parent_modifier['modifier_group_priority'] = $modifier_group_priority;
                        $parent_modifier['modifier_item_priority'] = $modifier['modifier_item_priority']+1;
                        for($i=0;$i<$quantity;$i++) {
                            $parent_modifier['child'] = $modifier;
                            $foundry_modifiers[] = $parent_modifier;
                        }
                    } else {
                        for($i=0;$i<$quantity;$i++) {
                            $foundry_modifiers[] = $modifier;
                        }
                    }
                }
                array_multisort(array_column($foundry_modifiers, 'modifier_group_priority'), SORT_DESC,
                                array_column($foundry_modifiers, 'modifier_item_priority'),SORT_DESC, $foundry_modifiers);
                $order_detail['foundry_modifiers'] = $foundry_modifiers;
            }
            // cc info for tender_id
            $bc_adapter = new BalanceChangeAdapter(getM());
            $resource->set('tender_id',215); // default
            if ($bc_record = $bc_adapter->getAuthorizeRow($resource->order_id)) {
                $card_info = $bc_record['card_info'];
                myerror_log("card info retrieved from balance chance: ".$card_info,5);
                $s = explode('-',$card_info);
                $card_type = $s[0];
                $last_four = $s[1];
                $resource->set('last_four',$last_four);
                // now set tender_id from brand card type combination
                $this->setTenderIdOnResource($card_type,$resource);
            } else if (isUserStoreTesterLevelOrBetter($resource->user_id)) {
                $resource->set('last_four','1111');
                $this->setTenderIdOnResource('visa',$resource);
            }
            $resource->set('EXTCHECKID',$resource->first_name.$resource->last_name.$resource->order_id);
            if ($resource->skin_id == 199) {
                if (substr_count($resource->note,'XXX DINE IN XXX') > 0) {
                    $resource->note = str_replace("DINE IN","COUNTER PICKUP",$resource->note);
                    $resource->last_name = 'COUNTER PICKUP';
                }
            }
            if ($resource->catering == 'Y') {
                $ppl = $resource->catering_info['number_of_people'].' ppl';
                $ready_time = $resource->catering_info['better_date_time_of_event'];
                $info = $resource->catering_info['contact_info'];
                $catering_notes = $resource->catering_info['notes'];
                $note_string = "$ppl, $ready_time, $info, $catering_notes. ";
                $resource->note = $note_string.$resource->note;
            }

        }

        if ($this->is_doordash_order) {
            $resource->order_type = 'R';
        }
        if ($resource->order_type == 'R') {
            $resource->set('brand_order_mode',$this->foundry_info['brand_order_mode_pickup']);
        } else {
            $resource->set('brand_order_mode',$this->foundry_info['brand_order_mode_delivery']);
        }
        return $resource;
    }

    function cleanMessageForSending(&$message_resource) {
        $message_resource->note = htmlspecialchars($message_resource->note);
        return $message_resource;
    }

    private function setTenderIdOnResource($card_type,&$resource)
    {
        $parameter_name = 'tender_id_'.$card_type;
        if ($tender_id = $this->foundry_info["$parameter_name"]) {
            $resource->tender_id = $tender_id;
        }
    }

    public function doExceptions($epl_modifiers)
    {
        $clean_epl_modifiers = array();
        foreach ($epl_modifiers as $modifier) {
            if ($modifier['external_id'] == '8026307') {
                $remove_308 = true;
            }
        }
        foreach ($epl_modifiers as $modifier) {
            if ($modifier['external_id'] == '8026308' && $remove_308) {
                continue;
            }
            $clean_epl_modifiers[] = $modifier;
        }
        return $clean_epl_modifiers;
    }

    public function setComboMealItemForTemplate(&$order_item,$external_id,$main_item_id)
    {
        $r = explode('-',$external_id);
        $order_item['external_id'] = $r[0];
        if ($r[1]) {
            $order_item['group_id'] = $r[1];
            $order_item['main_item_id'] = $main_item_id;
            $order_item['exception_tag'] = 'COMBOMODITEM';
        }
    }

    public function getOrderIdFromFoundryResponsePayload()
    {
        if ($submitted_order_id = $this->request->data['CHECKRESPONSES']['ADDCHECK']['@attributes']['ORDERID'][0]) {
            return $submitted_order_id;
        } else {
            myerror_log("could not extract order id from foundry post payload");
            logData($this->request->data,"foundry payload data");
            return 888888888888;
        }
    }

    public function isCallBackSuccessfull($request_data)
    {
        $add_check_error_report = $request_data['CHECKRESPONSES']['ADDCHECK']['@attributes'];
        if (substr_count($request_data['ERRORS']['LOG']['@attributes']['TEXT'][0],'PRINTED DELIVERY TICKET' ) > 0) {
            return true;
        } else if ($request_data['ERRORS']['@attributes']['COUNT'][0] > 0) {
            myerror_log("we had a main error thrown on Foundry callback");
            return false;
        } else if ($add_check_error_report['SYSTEMERRORS'][0] > 0) {
            myerror_log("we had a SYSTEMERRORS thrown on Foundry callback");
            return false;
        } else if ($add_check_error_report['ITEMERRORS'][0] > 0) {
            myerror_log("we had a ITEMERRORS thrown on Foundry callback");
            return false;
        } else if ($add_check_error_report['TENDERERRORS'][0] > 0) {
            myerror_log("we had a TENDERERRORS thrown on Foundry callback");
            return false;
        } else if ($request_data['ERRORS']['@attributes']['COUNT'][0] == 0) {
            return true;
        } else {
            myerror_log("ERROR!!!  could not confirm Foundry call back success.");
            return false;
        }
    }

    function setViewed(&$message_resource)
    {
        $message_resource->viewed = 'N';
        return true;
    }

    public function pullNextMessageResourceByMerchant($alphanumeric_id)
    {
        myerror_log("starting foundry pull with request method: ".strtoupper($this->request->method),5);
        if (strtoupper($this->request->method) == 'POST') {
            myerror_log("OK we have a foundry post");
            //first determine if this is a call back or a menu post
            $get_string_data = $this->get_string_data;
            myerror_log("the get data string: ".json_encode($get_string_data));
            if ($get_string_data['reqtype'] == '04') {
                // its a call back
                $order_id = $this->getOrderIdFromFoundryResponsePayload();
                $options[TONIC_FIND_BY_METADATA]['order_id'] = $order_id;
                $options[TONIC_FIND_BY_METADATA]['message_format'] = array("LIKE"=>'U%');
                if ($order_message_resource = Resource::find(new MerchantMessageHistoryAdapter($m),NULL,$options)) {
                    if ($this->isCallBackSuccessfull($this->request->data)) {
                        $viewed = 'V';
                        $order_status = 'E';
                    } else {
                        $viewed = 'F';
                        $order_status = 'O';
                        $this->message_resource = $order_message_resource;
                        $this->full_order = $this->getOrderInfoForMessage($order_message_resource);
                        $this->emailorderexecutionerror("Foundry Failure on callback");
                    }
                    $order_message_resource->response = $this->request->body;
                    $order_message_resource->viewed = $viewed;
                    $order_message_resource->save();
                    $this->updateOrderStatus($order_status,$order_id);
                } else {
                    myerror_log("COULD NOT FIND ORDER MESSAGE MATCHING ORDER ID: ".$order_id);
                    $this->has_messaging_error = true;
                    $this->error_code = 422;
                    $this->error_message = "Order call back not processed. NO matching order id";
                }
            } else if (isset($get_string_data['reqtype'])) {
                myerror_log("Unrecognized POST reqtype=".$get_string_data['reqtype']);
                $this->has_messaging_error = true;
                $this->error_code = 422;
                $this->error_message = "Unrecognized POST reqtype=".$get_string_data['reqtype'];
            }
            return null;
        }  else if (strtoupper($this->request->method) == 'PUT') {
                myerror_log("WE HAVE A MENU UPLOAD!!!");
                $external_id = $this->data['@attributes']['LOCATIONID'];
                if ($merchant_resource = MerchantAdapter::getMerchantResourceFromAlphaNumeric($alphanumeric_id)) {
                    $fi = new FoundryImporter($merchant_resource);
                    myerror_log("we have the importer");
                    $fi->importMenuFromRequest($this->request);
                    $this->importer = $fi;
                    $resource = new Resource();
                    if (isProd()) {
                        $resource->message_text = 'success';
                    } else {
                        $resource->message_text = $fi->getMessage();
                    }
                    $resource->_representation = '/utility_templates/static_message_no_new_line_at_end.txt';
                    return $resource;
                } else {
                    myerror_log("FOUNDRY ERROR!!! No merchant_id matching alphanumeric: $alphanumeric_id");
                    throw new Exception("No Matching merchant");
                }
                //logData($merchant_resource->getDataFieldsReally(),"MERCHANT");

        }
        if ($alphanumeric_id == 0 || $alphanumeric_id == null) {
            $alphanumeric_id = $this->data['siteid'];
        }
        if ($merchant_resource = MerchantAdapter::getMerchantResourceFromAlphaNumeric($alphanumeric_id)) {
            $this->merchant_resource = $merchant_resource;
            DeviceCallInHistoryAdapter::recordPullCallIn($merchant_resource->merchant_id,$this->format);
            if ($this->data['reqtype'] == '01') {
                // we are checking for ready messages only
                // first get the foundry 3rd party data
                $this->foundry_info = $this->getFoundryInfo($merchant_resource);
                $response_body = $this->processCheckForMessagesRequest($merchant_resource->merchant_id);
                $resource = new Resource();
                $resource->message_text = $response_body;
                $resource->_representation = '/utility_templates/static_message_no_new_line_at_end.txt';
                return $resource;
            }
            if ($message_resource = parent::pullNextMessageResourceByMerchant($merchant_resource->merchant_id)) {
                $resource = $this->prepMessageForSending($message_resource);
                $this->message_resource->message_text = cleanUpDoubleSpacesCRLFTFromString($resource->message_text);
                return $resource;
            }
        } else {
            myerror_log("SERIOUS ERROR IN FOUNDRY CONTROLLER!  no matching merchant for submitted alphanumeric id: ".$alphanumeric_id);
            $this->error_message = "No matching merchant for: $alphanumeric_id";
            $this->error_code = 422;
            $this->has_messaging_error = true;
        }
        return false;
    }

    function getFoundryInfo($merchant_resource,$skin_id = 0)
    {
        if ($this->foundry_info = MerchantFoundryInfoMapsAdapter::getMerchantFoundryInfoMap($merchant_resource->merchant_id)) {
            $this->foundry_info['data_in_third_party_table'] = false;
            return $this->foundry_info;
        } else if ($this->foundry_info = getThirdPartyParametersForMerchantSkinCombination(self::FOUNDRY_THIRD_PARTY_PROVIDER_ID,$skin_id,$merchant_resource->merchant_id,$merchant_resource->brand_id)) {
            $this->foundry_info['data_in_third_party_table'] = true;
            return $this->foundry_info;
        } else {
            throw new NoMerchantFoundryLocationException($merchant_resource->merchant_id);
        }
    }

    function getMainMessageSuccessOrderStatus()
    {
        return 'O';
    }

    protected function send($message_body)
    {
        myerror_log("foundry sending with body: ".cleanUpCRLFTFromString($message_body));

//must build how to send with foundry the below code is an example
//        $foundry_service = new FoundryService();
//        if ($response = $foundry_service->send($message_body)) {
//            $this->message_resource->message_text = $message_body;
//            $this->message_resource->response = $response['raw_result'];
//            return $response;
//        }
        return true;
    }

}

class NoMerchantFoundryLocationException extends Exception
{
    public function __construct($merchant_id) {
        parent::__construct("No Foundry location data for merchant_id: $merchant_id", 100);
    }
}

?>