<?php

class PitapitLoyaltyController extends HeartlandLoyaltyController
{
	const DOMAIN = 'pitapit';
	const TERMINAL = '0001';
	const TERMINAL_ORDER = '0001';
	const TERMINAL_VERSION = 'v17';

    var $loyalty_history_headings = array(
        "transaction_date" => "DATE",
        "description" => "Points Earned/Spent",
        "amount" => "Balance"
    );

    function __construct($mimetypes, $user, $request,$log_level = 0)
	{
		parent::__construct($mimetypes, $user, $request,$log_level);
		$this->service = $this->loyaltyServiceFactory();
	}

	static function loyaltyServiceFactory()
	{
		return new HeartlandLoyaltyService(getProperty('heartland_api_key'),PitapitLoyaltyController::DOMAIN,PitapitLoyaltyController::TERMINAL,PitapitLoyaltyController::TERMINAL_ORDER,PitapitLoyaltyController::TERMINAL_VERSION);

	}


	/**
	 * 
	 * @desc used to link an existing external loyalty account to a splickit user account
	 * @param unknown_type $user_id
	 * @param unknown_type $points
	 * 
	 * @return Resource
	 */
	function linkAccount($user_id,$points)
	{
        if ($this->pin == null || trim($this->pin) == "" || $this->loyalty_number == null || trim($this->loyalty_number == "")) {
            $this->service_response = array("error"=>"Sorry you must enter both loyalty number and pin in order to link to an existing loyalty account.","error_code"=>401);
            return false;
        }
		return parent::linkAccount($user_id,$points);
	}
	
	static function useNewPitaPitLoyalty()
	{
        return strtolower(getProperty('use_new_pita_pit_loyalty')) == 'true';
	}

	static function useOldPitaPitLoyalty()
	{
        return ! PitapitLoyaltyController::useNewPitaPitLoyalty();
	}
	
	function getPointsAndSendIfApplicable($complete_order)
	{
		return parent::getPointsAndSendIfApplicable($complete_order);
	}

	function getPointsEarnedFromCompleteOrder($complete_order)
	{
		//pitapit is 1 point per $1 spent including tax
		$points = $this->getRewardedPurchaseAmountFromCompleteOrder($complete_order);
		$this->points_earned = $points;
		return round($points);
	}


	function validateLoyaltyNumber($loyalty_number)
	{
		return parent::validateLoyaltyNumber($loyalty_number);
	}

	function getLoyaltyHistory()
	{
    $hls = $this->service;
    $history_response = $hls->getHistory($this->loyalty_number, $this->pin, $email);
    if ($history = $history_response['history']) {
      return $history;
    }
    return array();
	}

	function getBadLoyaltyNumberMessage()
	{
		return "We're sorry, the pit card number you entered, ".$this->getLoyaltyNumber().":".$this->getPin().", appears to be invalid, please check your entry.";
	}	
	
	function getBrandPointsList($brand_id)
	{
		if ($this->useNewPitaPitLoyalty()) {
			return parent::getBrandPointsList($brand_id);
		}
	}
}
?>