<?php
Class TextController extends MessageController
{
	protected $representation = '/utility_templates/blank.txt';
		
	protected $format_array = array('T'=>'/utility_templates/blank.txt','TS'=>'/utility_templates/blank.txt','TTM'=>'/order_templates/telegram/execute_order_telegram_mjm.txt');
	protected $format = 'T';
	protected $format_name = 'text';
	protected $max_retries = 3;
	protected $retry_delay = 1;
	protected $use_primary_sms;
	var $sob_activity_id;
		
	function TextController($mt,$u,&$r,$l = 0)
	{
		parent::MessageController($mt,$u,$r,$l);
		$this->use_primary_sms = $this->global_properties['use_primary_sms'];		
	}
	
	public function sendThisMessage($message_resource)
	{
	    if (substr($message_resource->message_format,0,1) != 'T') {
	        throw new Exception("Something other than T passed into TextController");
        }
	    $this->format = $message_resource->message_format;
        return parent::sendThisMessage($message_resource);
	}
	
	function send($body)
	{
		$number = $this->deliver_to_addr;
		if ($number == NULL || trim($number) == '')
		{
			myerror_log("we have no delivery to address in text controller!");
			if ($this->message_resource->order_id < 1000)
			{
				myerror_log("this is a non order related message so just bypass");
			} else {
				throw new Exception("Error sending Text message in TextController: message has no sms number listed! ",100);
			}
			
		}
		
		$message = $body;


        if (substr($this->format,0,2) == 'TT') {
            // telegram message
            $data = ['skin_id'=>$this->full_order['skin_id'],'merchant_id'=>$this->merchant['merchant_id'],'brand_id'=>$this->merchant['brand_id']];
            $telegram_service = new TelegramService($data);
            $response = $telegram_service->send($number,$body);
            if ($response['status'] == 'success') {
                $this->message_resource->response = $response['result']['raw_return'];
                return true;
            } else {
                return false;
            }
        } else if ($results = SmsSender2::send_sms($number, $message, $this->use_primary_sms)) {
			return true;	
		} else {
            throw new Exception("Error sending Text message in TextController: ",100);
        }
	}

	/**
	 * 
	 * @desc will switch SMS providers.  returns a string stating what it was switched to, primary or secondary.
	 * @return String
	 */
	static function switchProviders()
	{
		$use_primary_sms = getProperty('use_primary_sms');
		myerror_log("currently the use_primary_sms is: ".$use_primary_sms);
		if ($use_primary_sms == 'true')
			$value = 'false';
		else
			$value = 'true';
		
		myerror_log("resetting use_primary_sms to ".$value);
		setProperty('use_primary_sms', $value);
		$string = "setting use_primary_sms=$value";
		return $string;
	} 

	static function checkRecentProviderResetWithinThisManySeconds($seconds)
    {
    	$property_adapter = new PropertyAdapter($mimetypes);
    	$resource = $property_adapter->getExactResourceFromData(array("name"=>"use_primary_sms"));
		if ($resource->modified < time()-$seconds)
			return false;
		else
			return true;			    	
    }

}