<?php
class GrubhubCurl extends SplickitCurl
{
    static function curlIt($url,$auth_header,$data)
    {
        $service_name = 'Grubhub';
        if ($ch = curl_init($url))
        {
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
            curl_setopt($ch, CURLOPT_VERBOSE,0);
            $grubhub_key = getProperty('grubhub_partner_key');
            $headers = [];
            if ($data) {
                $method = 'PUT';
                $json_data = json_encode($data);
                curl_setopt($ch, CURLOPT_POSTFIELDS, $json_data);
                $headers[] = 'Content-Type: application/json';
                $headers[] = 'Accept: application/json';
                $headers[] = "X-GH-PARTNER-KEY: $grubhub_key";

            } else if (substr_count($url,'cancel') > 0) {
                $method = 'PUT';
                curl_setopt($ch, CURLOPT_PUT, 1);
            } else {
                $method = 'GET';
            }

            $headers[] = "Authorization: $auth_header";
            curl_setopt($ch, CURLOPT_HTTPHEADER,$headers);
            logCurl($url,$method,null,$headers,$json_data);
            $response = parent::curlIt($ch);
            curl_close($ch);
        } else {
            $response['error'] = "FAILURE. Could not connect to ".$service_name;
            myerror_log("ERROR!  could not connect to ".$service_name);
        }
        return $response;
    }
}
?>