<?php
class FoundryImporter extends SplickitImporter
{
    var $imported_prices = array();

//    const MENU_ID = 102711;
//    const BRAND_ID = 307;

    var $merchant_resource;
    var $raw_menu_payload;

    var $item_price_records_imported;
    var $modifier_price_records_imported;

//    var $upcharges_by_item = array();
//    var $large_drink_combo_upcharge = 0.00;

    var $item_group_hash_of_zero_prices = array();

    const FOUNDRY_THIRD_PARTY_PROVIDER_ID = 1005;

    function __construct($merchant_mixed)
    {
        parent::__construct($merchant_mixed);
        $this->create_zero_records = false;
        $this->merchant_mixed = "/portal/import/foundry/".$this->merchant_resource->alphanumeric_id;
    }

    function setMenuId($menu_id)
    {
        if ($menu_id == null) {
            $merchant_id = $this->merchant_resource->merchant_id;
            $merchant_menu_maps = MerchantMenuMapAdapter::staticGetRecords(['merchant_id'=>$merchant_id],'MerchantMenuMapAdapter');
            $menu_id = $merchant_menu_maps[0]['menu_id'];
        }
        $this->menu_id = $menu_id;
    }

    function loadMerchantFromExternalIdBrandIdCombination($merchant_alphanumeric)
    {
        if ($merchant_alphanumeric == null || $merchant_alphanumeric == '') {
            throw new NoMerchantIdSetForImportException();
        }
        $merchant_adapter = new MerchantAdapter(getM());
        $options[TONIC_FIND_BY_METADATA]['alphanumeric_id'] = $merchant_alphanumeric;
        if ($merchant_resource = Resource::find($merchant_adapter,null,$options)) {
            $this->brand_id = $merchant_resource->brand_id;
            $this->assignMerchantResource($merchant_resource);
        } else {
            throw new NoMatchingMerchantException($merchant_alphanumeric);
        }

    }


    function setBrandId($brand_id)
    {
        $this->brand_id = $brand_id;
    }

    function stageImport()
    {
        $tpppmma = new ThirdPartyProviderParameterMerchantMapsAdapter(getM());
        if ($tpppmm_resource = $tpppmma->getMerchantThirdPartyParameterMapByThirdpartyProviderIdAndParameterNameAsResource('get_menu',self::FOUNDRY_THIRD_PARTY_PROVIDER_ID,$this->merchant_resource->merchant_id)) {
           $tpppmm_resource->value = 1;
           $tpppmm_resource->save();
           // the calling fuction is expecting an activity ID so we give it a time stamp.  Foundry pushes to us we dont call to them.
           return time();
        } else {
            $merchant_id = $this->merchant_resource->merchant_id;
            $sql = "UPDATE Merchant_Foundry_Info_Maps SET get_menu = 1 WHERE merchant_id = $merchant_id LIMIT 1";
            $mfima = new MerchantFoundryInfoMapsAdapter(getM());
            $mfima->_query($sql);
            return time();
        }
        return false;
    }

    function setBrandRegExForMerchantExternalIds()
    {
        $this->brand_regex_for_merchant_external_ids = '[0-9a-zA-Z]+';
    }

    function importMenuFromRequest($request)
    {
        myerror_log("FOUDNRY IMPORT:  starting import menu from request in foundry importer");
        myerror_log("FOUNDRY IMPORT body: ".$request->body,5);
        $this->raw_menu_payload = $request->body;
        $merchant_id = $this->merchant_resource->merchant_id;
        if (getProperty("write_foundry_import_file") == 'true') {
            $file_name = "./menus/foundry_menu_$merchant_id.xml";
            MailIt::sendErrorEmail("foundry_menu_$merchant_id.xml",$request->body);
            if ($myfile = fopen($file_name, "w")) {
                fwrite($myfile, $request->body);
                fclose($myfile);
            } else {
                myerror_log("FOUNDRY IMPORT:  ******************** COULDNT WRITE XML DUMP TO FILE ***********************");
            }
        }
        $this->getPriceData();
        return $this->importRemoteData($this->merchant_resource);
    }

    function getRemoteData($merchant_resource)
    {
        if ($this->imported_prices == null || !is_array($this->imported_prices)) {
            myerror_log("FOUNDRY IMPORT:  Import Exception!!! No data has been loaded for FOUNDRY import");
            throw new UnsuccessfulFOUNDRYImportException($merchant_resource->merchant_external_id);
        }
    }

    function callCustomMethodsOnData()
    {
        return; // not used anymore. was for EPL
        // this really should be a method list but since only 1 thing to do i punted
        $menu_id = $this->menu_id;
        $sql = "SELECT a.*,b.modifier_item_id,b.modifier_item_name FROM Modifier_Group a JOIN Modifier_Item b ON a.modifier_group_id = b.modifier_group_id WHERE a.menu_id = $menu_id";
        $mga = new ModifierGroupAdapter($m);
        $records = $mga->select(null,array(TONIC_FIND_BY_SQL=>$sql));
        foreach ($records as $record) {
            if (strtolower($record['external_modifier_group_id']) == 'zero_prices') {
                $name = $record['modifier_item_name'];
                $id = $record['modifier_item_id'];
                myerror_log("FOUNDRY IMPORT:  this modifier is being set to zero_price: $name - $id",3);
                $this->item_group_hash_of_zero_prices[$record['modifier_item_id']] = 1;
            }
        }
    }

    function importRemoteData($merchant_resource)
    {
        parent::importRemoteData($merchant_resource);
        $this->message = "There were ".$this->getNumberOfItemPricesImported()." item prices imported, and ".$this->getNumberOfModifierPricesImported()." modifier prices imported.";
        myerror_log("FOUNDRY IMPORT RESULTS: ".$this->message);
    }

    function doCustomImgmLogic($imgm_resource)
    {
        if ($upcharges_for_item = $this->upcharges_by_item[$imgm_resource->item_id]) {
            $modifier_group = ModifierGroupAdapter::staticGetRecordByPrimaryKey($imgm_resource->modifier_group_id,'ModifierGroupAdapter');
            $short_modifier_group_name = strtolower(substr($modifier_group['modifier_group_name'],0,9));
            if ($short_modifier_group_name == 'combo 621') {
                // we need to adjust the prices of these items in the group
                $modifier_item_records_for_group = ModifierItemAdapter::staticGetRecords(array("modifier_group_id"=>$imgm_resource->modifier_group_id),'ModifierItemAdapter');
                foreach ($modifier_item_records_for_group as $modifier_item_record) {
                    foreach ($upcharges_for_item as $size_id=>$price) {
                        $msma = new ModifierSizeMapAdapter($m);
                        $default_price_record = $msma->getRecord(array("modifier_item_id"=>$modifier_item_record['modifier_item_id'],"size_id"=>"0","merchant_id"=>"0"));
                        $price_resource = Resource::findOrCreateIfNotExistsByData($msma,array("modifier_item_id"=>$modifier_item_record['modifier_item_id'],"size_id"=>$size_id,"merchant_id"=>$this->merchant_resource->merchant_id));
                        $price_resource->modifier_price = $default_price_record['external_id'] == '8019002-8019300:C' ? $price + $this->large_drink_combo_upcharge : $price;
                        $price_resource->external_id = $default_price_record['external_id'];
                        $price_resource->save();
                    }
                }
            }
        }
    }

    function getNumberOfItemPricesImported()
    {
        return $this->number_of_item_price_records_imported;
    }

    function getNumberOfModifierPricesImported()
    {
        return $this->number_of_modifier_price_records_imported;
    }

    function savePricesForPriceResources(&$splickit_price_resources)
    {
        $total_price_records_imported = 0;
        myerror_log("FOUNDRY IMPORT:  about to import FOUNDRY prices for ".count($splickit_price_resources)." splickit price resources");
        foreach ($splickit_price_resources as $splickit_price_resource) {
            if ($this->processPriceResource($splickit_price_resource)) {
                $total_price_records_imported++;
            }
        }
        return $total_price_records_imported;
    }

    function getObjectPriceFromItemData($item_data)
    {
        return $item_data['PRICE'];
    }

    function getTaxableFromImportedPriceHashByPluRecord($record,$secondary_plu)
    {
        return $record['TAXID1'];
    }

    function processPriceResource(&$splickit_price_resource)
    {

        if ($this->merchant_resource->brand_id == 480) {
            // for OSF prices set to innactive at the merchant level, stay innactive.  must be manually activated with the portal
            if ($splickit_price_resource->merchant_id == $this->merchant_resource->merchant_id) {
                if ($splickit_price_resource->active == 'N') {
                    myerror_log("FOUNDRY IMPORT:  we have an innactive price at the merchant level so we will skip price sych for this item: ".$splickit_price_resource->item_id,3);
                    $this->addToRunningImport("we have an innactive price at the merchant level so we will skip price sych for this item_id: ".$splickit_price_resource->item_id."  size_id: ".$splickit_price_resource->size_id);
                    return false;
                }
            }
        }

        myerror_log("FOUNDRY IMPORT:  about to update price resource: ".$splickit_price_resource->external_id,3);
        $merchant_id = $this->merchant_resource->merchant_id;
        $imported_price_hash_by_plu = $this->imported_prices;
        $raw_plu_on_splickt_price_record = $splickit_price_resource->external_id;
//        $p = explode(":",$raw_plu_on_splickt_price_record);
//        $plu = $p[0];
//        if (isset($splickit_price_resource->modifier_price)) {
//            if ($this->item_group_hash_of_zero_prices[$splickit_price_resource->modifier_item_id]) {
//                myerror_log("FOUNDRY IMPORT:  this modifier is being set to zero_price: foundry_mod_id: ".$splickit_price_resource->modifier_item_id,3);
//                $splickit_price_resource->modifier_price = 0.00;
//                $splickit_price_resource->merchant_id = $this->merchant_resource->merchant_id;
//                return $splickit_price_resource->save();
//            } else {
//                myerror_log("FOUNDRY IMPORT:  this modifier is being set to a PRICE: founcty_mod_id: ".$splickit_price_resource->modifier_item_id,3);
////                if ($p[1] == 'C') {
////                    $exploded_array = explode('-',$secondary_plu);
////                    if ($secondary_plu = $exploded_array[1]) {
////                        $forced_combo = true;
////                    }
////                }
//            }
//        } else {
//            if ($secondary_plu = isset($p[1]) ? $p[1] : null) {
//                $exploded_array = explode('-',$secondary_plu);
//                $secondary_plu = $exploded_array[0];
//            }
//        }

        myerror_log("FOUNDRY IMPORT:  about to get price for: $raw_plu_on_splickt_price_record");
        $plu = $this->getPrimaryPlu($raw_plu_on_splickt_price_record);
        if (isset($imported_price_hash_by_plu[$plu])) {
            $imported_price_record = $imported_price_hash_by_plu[$plu];
            $splickit_price_resource->active = 'Y';
            $price = $this->getObjectPriceFromItemData($imported_price_record);
            myerror_log("FOUNDRY IMPORT:  price from import is: ".$price);
            $splickit_price_resource->price = $price;
            $splickit_price_resource->modifier_price = $price;
            //$splickit_price_resource->tax_group = $this->getTaxableFromImportedPriceHashByPluRecord($imported_price_record) == '1' ?  1  : 0;
            $price_recorded = true;
        } else {
            // there was no price returned so create an innactive price record
            myerror_log("FOUNDRY IMPORT:  there was no price returned so create an innactive price record",3);
            $splickit_price_resource->active = 'N';
            $price_recorded = false;
        }
        $splickit_price_resource->merchant_id = $merchant_id; // in case this is a default record
        if ($splickit_price_resource->save()) {
            myerror_log("FOUNDRY IMPORT:  we have saved the price for $plu as: $price");
            $this->addToRunningImport("we have saved the price for $plu as: $price");
            return $price_recorded;
        }
    }

    function getPrimaryPlu($plu)
    {
        $p = explode(':',$plu);
        if (sizeof($p) > 1) {
            return array_pop($p);
        } else {
            return $plu;
        }
    }

    function getPriceData()
    {
        if ($this->imported_prices) {
            return true;
        }
        $raw_data = $this->raw_menu_payload;
        $this->processRawExport($raw_data);
    }

    function processRawExport($raw_export)
    {
        if ($start = strpos($raw_export, "<MENUITEMS")) {
            $end_string = "</MENUITEMS>";


            $end = strpos($raw_export, $end_string) + strlen($end_string);
            $payload = substr($raw_export, $start, $end - $start);
            $xml = simplexml_load_string($payload) or die("error: cannot create object");
            $hashmap = $this->myXMLToArray($xml);

            $plu_list = array();
            foreach ($hashmap['MENUITEM'] as $plu_node) {
                $price_node = array();
                foreach ($plu_node['@attributes'] as $attribute=>$value_as_subarray) {
                    $price_node[$attribute] = $value_as_subarray[0];
                }
                $plu_list[$plu_node['@attributes']['ITEMID'][0]] = $price_node;
            }
            ksort($plu_list);
            if (getProperty("write_foundry_import_file") == 'true') {
                $merchant_id = $this->merchant_resource->merchant_id;
                $file_name = "./menus/imported_foundry_plus_and_prices_$merchant_id.txt";
                if ($myfile = fopen($file_name, "w")) {
                    foreach($plu_list as $plu_record) {
                        fwrite($myfile, json_encode($plu_record)."\r\n");
                    }
                    fclose($myfile);
                    if ($payload) {
                        $attachments = [];
                        $attachment = [];
                        $file_data = chunk_split(base64_encode($payload));
                        $attachment['type'] = "text/plain";
                        $attachment['name'] = $file_name;
                        $attachment['content'] = $file_data;
                        $attachments[] = $attachment;
                        MailIt::sendEmailMandrill(getProperty('email_string_error'), "foundry_menu_$merchant_id-plu_list.xml", 'imported file attached', 'splickit api', null, $attachments);
                        //MailIt::sendErrorEmail("foundry_menu_$merchant_id-plu_list.xml",$file_txt);
                    }

                }
            }
            $this->imported_prices = $plu_list;
        } else {
            throw new UnsuccessfulFOUNDRYImportException($this->merchant_resource->merchant_id . " - " . $this->merchant_resource->alphanumeric_id);
        }
        if ($start = strpos($raw_export, "<MODIFIERGROUPS")) {
            $end_string = "</MODIFIERGROUPS>";
            $end = strpos($raw_export, $end_string) + strlen($end_string);
            $payload = substr($raw_export, $start, $end - $start);
            $xml = simplexml_load_string($payload) or die("error: cannot create object");
            $hashmap = $this->myXMLToArray($xml);
            foreach ($hashmap['MODIFIERGROUP'] as $mod_plu_node) {
                if ($mod_plu_node['@attributes']['MODGRPID'][0] == "990011") {
                    // get the price
                    foreach ($mod_plu_node['MODIFIERS']['MODIFIER'] as $mod_price_node) {
                        if ($mod_price_node['@attributes']['ITEMID'][0] == '8019002') {
                            $this->large_drink_combo_upcharge = $mod_price_node['@attributes']['PRICE'][0];
                            return;
                        }
                    }
                }
            }
        }
    }

    function myXMLToArray($xml) {
        $array = (array)$xml;

        foreach ( array_slice($array, 0) as $key => $value )
        {
            if ( $value instanceof SimpleXMLElement )
            {
                if ($key == "@attributes") {
                    continue;
                }
                $array[$key] = empty($value) ? NULL : $this->myXMLToArray($value);
            } else if (is_array($value)) {
                foreach ($value as $sub_key => $sub_value) {
                    $array[$key][$sub_key] = $this->myXMLToArray($sub_value);
                }
            }
        }
        return $array;
    }

    function getMerchant()
    {
        return $this->merchant_resource->getDataFieldsReally();
    }

    // need these to make sure not abstract. we're not useing them because we're only importing prices for ElPolloLoco

    function getItemDescriptionFromItemData($item_data) {}

    function getModifierGroupMinForThisIntegration($modifier_group_data) {}

    function getModifierGroupMaxForThisIntegration($modifier_group_data) {}

    function getActiveFlagSetting($data) {}

    function getMenuTypeCatId($menu_type_data) {}

}
class UnsuccessfulFoundryImportException extends Exception
{
    public function __construct($merchant_ids) {
        parent::__construct("We could not import the prices for this FOUNDRY merchant: $merchant_ids", 100);
    }
}
?>