<?php

class NuorderImporter extends SplickitImporter
{
    var $data;
    var $raw_menu_from_nuorder_as_array;

    protected $menu_id;
    protected $filename;
    protected $nuorder_menu_type;
    protected $merchant_name;

    function __construct($data)
    {
        $this->$data = $data;
        $this->nuorder_menu_type = $data['nuorder_menu_type'];
        $this->filename = $data['filename'];
    }

    function loadMenuArrayFromJsonFile($filename)
    {
        if ($filename == null) {
            $filename = $this->filename;
        }
        $txt = file_get_contents($filename);
        if ($menudata_array = json_decode($txt,true)) {
            $this->raw_menu_from_nuorder_as_array = $menudata_array;
            $this->merchant_name = $this->getMerchantNameFromFilePathName($filename);
            $this->menu_name = $this->merchant_name;
            $this->raw_menu_from_nuorder_as_array['name'] = $this->merchant_name;
        } else {
            throw new Exception("NuOrder file is not JSON");
        }



//        if (isLaptop()) {
//            $rand = rand(1111,9999);
//            $menudata_array['location']['menu']['id'] = $rand;
//        }

    }

    function getMerchantNameFromFilePathName($full_path)
    {
        $s = explode('/',$full_path);
        $file_name = array_pop($s);
        return str_replace('_',' ',str_replace('.json','',$file_name));
    }

    function createMenuResource($menudata_array)
    {
        $menu = $menudata_array['location']['menu'];
        $data['external_menu_id'] = "NuOrder: ".$menu['id'];
        $data['version'] = 2.0;
        $data['name'] = $menudata_array['name'];
        $menu_resource = $this->getOrCreateMenuObjectResource($data, new MenuAdapter(getM()));
        $this->menu_id = $menu_resource->menu_id;
        return $menu_resource;
    }

    function createNewMerchant($menu_id)
    {
        $merchant_controller = new MerchantController(getM(),null,null,0);
        $merchant_resource = $merchant_controller->createNewTestMerchant($menu_id);
        $merchant_resource->name = $this->merchant_name;
        $merchant_resource->display_name = $this->merchant_name;
        $merchant_resource->save();
    }

    function importMenuData($filename)
    {
        $this->loadMenuArrayFromJsonFile($filename);
        $menu_resource = $this->createMenuResource($this->raw_menu_from_nuorder_as_array);
        $menu_id = $menu_resource->menu_id;

        $imported_menu_structure = $this->raw_menu_from_nuorder_as_array;
        $menu_type_priority = 200;

        $menu_types = $imported_menu_structure['location']['menu']['sub_menus'];
        $nuo_menu_types_hash = createHashmapFromArrayOfArraysByFieldName($menu_types,'desc');
//        foreach ($menu_types_hash as $menu_type_name=>$menu_type) {
//            myerror_log("********************  starting $menu_type_name  ********************");
//            $menu_items = $menu_type['sub_menu_items'];
//            $menu_items_hash = createHashmapFromArrayOfArraysByFieldName($menu_items,'short_desc');
//            foreach ($menu_items_hash as $name=>$menu_item) {
//                myerror_log("$name : ".$menu_item['long_desc']);
//            }
//        }

        foreach ($nuo_menu_types_hash as $nuo_menu_type_name=>$nuo_menu_type) {
            $has_sizes = false;
            myerror_log("********************  starting $nuo_menu_type_name  ********************");
            $lower_nuo_menu_type_name = strtolower($nuo_menu_type_name);
//            if (substr_count($lower_nuo_menu_type_name,'salads & soups') < 1) {
//            if (substr_count($lower_nuo_menu_type_name,'pizza') < 1) {
//                continue;
//            }
            $menu_type_resource = $this->getMenuTypeResource($menu_id, $nuo_menu_type['submenu_id']);
            $menu_type_resource->menu_type_name = trim($nuo_menu_type['desc']);
            $menu_type_resource->priority = $menu_type_priority;
            $menu_type_resource->save();
            $menu_type_id = $menu_type_resource->menu_type_id;

            // now create the One Size if pizza
//            if ($this->nuorder_menu_type > 1 || ($this->nuorder_menu_type == 1 && substr_count($lower_nuo_menu_type_name,'pizza') > 0)) {
//                $size_resource = $this->getSizeForMenuTypeId($menu_type_resource->menu_type_id, 'One Size');
//
//            }


            if (sizeof($nuo_menu_type['sub_menu_items']) > 0 ) {
                $nuo_items = $nuo_menu_type['sub_menu_items'];
            } else if (sizeof($nuo_menu_type['child_sub_menus']) > 0 ) {
                $has_sizes = true;
                $nuo_items = $nuo_menu_type['child_sub_menus'];
            } else {
                myerror_log("THERE WERE NO ITEMS ASSOCIATED WITH MENU TYPE $nuo_menu_type_name ON THE NuOrder IMPORT");
                continue;
            }


            $item_priority = 200;
            foreach ($nuo_items as $nuo_item) {
                $item_name = isset($nuo_item['short_desc']) ? $nuo_item['short_desc'] : $nuo_item['desc'];
                myerror_log("********************  starting $item_name  *******************");
                $external_item_id = isset($nuo_item['itemid']) ? $nuo_item['itemid'] : $menu_type_id.'-'.$item_name;

                $item_resource = $this->getItemResource($menu_type_resource->menu_type_id,$external_item_id);
                $item_id = $item_resource->item_id;
                $item_resource->priority = $item_priority;

                $item_resource->item_name = $item_name;
                $item_resource->active = $nuo_item['active'] ? 'Y' : 'N';
                $item_resource->item_print_name = $item_name;
                $item_resource->description = $nuo_item['long_desc'];
                $item_resource->save();



                /******  if we're doing sizes here is where i would do the loop through the sub items  ****/
                if ($has_sizes) {
                    $nuo_item_sizes = $nuo_item['sub_menu_items'];
                } else {
                    $nuo_item_sizes = [$nuo_item];
                }


                    myerror_log("lod logig");
                    foreach ($nuo_item_sizes as $nuo_item_size) {
                        $item_id_for_size = $nuo_item_size['itemid'];
                        $s = explode(':',$nuo_item_size['short_desc']);
                        if (sizeof($s) == 2) {
                            $size_name = trim(array_pop($s));
                            if ($this->nuorder_menu_type == 3) {
                                $size_resource = $this->getSizeForMenuTypeId($menu_type_resource->menu_type_id, $size_name,$menu_type_id.'-'.$size_name);
                            } else {
                                $size_resource = $this->getSizeForMenuTypeId($menu_type_resource->menu_type_id, $size_name,$item_id_for_size.'-'.$size_name);
                            }
                        } else if ($this->nuorder_menu_type == 3) {
                            $size_resource = $this->getSizeForMenuTypeId($menu_type_resource->menu_type_id, 'One Size','mt-'.$menu_type_resource->menu_type_id.'-onesize');
                        } else {
                            $size_resource = $this->getSizeForMenuTypeId($menu_type_resource->menu_type_id, 'One Size',$item_id_for_size.'-onesize');
                        }

                        try {
                            $item_size_resource = $this->getItemSizePriceResource($item_resource->item_id, $size_resource->size_id,$nuo_item_size['itemid']);
                        } catch (Exception $e) {
                            //myerror_log("ITEM-SIZE ERROR: ".$e->getMessage());
                            myerror_log("ITEM-SIZE ERROR FOR: ".$nuo_item_size['short_desc']."      menu type: ".$lower_nuo_menu_type_name);
                            continue;
                        }


                        $item_size_resource->price = $nuo_item_size['price'];
                        $item_size_resource->active = $item_resource->active;
                        $item_size_resource->save();


                        /*****  now do modifiers here ******/

                        if ($nuo_modifier_groups = $nuo_item_size['modifiergroups']) {
                            $modifier_group_priority = 2000;
                            foreach ($nuo_modifier_groups as $nuo_modifier_group) {
                                $modifier_group_name = $nuo_modifier_group['short_desc'];
                                myerror_log("********************  starting $modifier_group_name  *******************");

                                //*****  CANT USE THE $nuo_modifier_group['modgrpid'], NEED TO DO NAME AND MENU-ID  *****//
                                //$modifier_group_resource = $this->getModifierGroupResource($menu_id, $nuo_modifier_group['modgrpid']);
                                $modifier_group_resource = $this->getModifierGroupResource($menu_id, $menu_id.'-'.$modifier_group_name);
                                if (isset($modifier_group_resource->insert_id)) {
                                    $modifier_group_resource->priority = $modifier_group_priority;
                                    $modifier_group_resource->modifier_group_name = $nuo_modifier_group['short_desc'];
                                    $modifier_group_resource->modifier_description = $nuo_modifier_group['long_desc'];
                                    $modifier_group_resource->save();
                                }
                                $modifier_group_id = $modifier_group_resource->modifier_group_id;
                                $nuo_modifier_items = $nuo_modifier_group['menu_item_modifiers'];
                                $nuo_modifier_items_json = json_encode($nuo_modifier_items);
                                $modifier_item_priority = $modifier_group_priority;
                                foreach ($nuo_modifier_items as $nuo_modifier_item) {
                                    if ($nuo_modifier_item['use_as_spacer']) {
                                        continue;
                                    }
                                    if (sizeof($nuo_modifier_item['modifiergroups']) > 0) {
                                        $subgroup_modifiers = $nuo_modifier_item['modifiergroups'][0]['menu_item_modifiers'];
                                    } else {
                                        $subgroup_modifiers = ['dummy'];
                                    }
                                    foreach ($subgroup_modifiers as $sub_modifier) {

                                        if (is_array($sub_modifier)) {
                                            $modifier_item_name = $nuo_modifier_item['description'].'='.$sub_modifier['description'];
                                            $modifier_item_id = $nuo_modifier_item['itemid'].':'.$sub_modifier['itemid'];
                                            $sub_modifier_price = $sub_modifier['price'] == null ? 0.00 : $sub_modifier['price'];
                                        } else {
                                            $modifier_item_name = $nuo_modifier_item['description'];
                                            $modifier_item_id = $nuo_modifier_item['itemid'];
                                            $sub_modifier_price = 0.00;
                                        }

                                        $mod_code_value = validateThatStringFieldIsSetAndIsNotNullAndIsNotEmptyOnArray($nuo_modifier_item,'modifier_mod_code_value') ? $nuo_modifier_item['modifier_mod_code_value'] : 0;
                                        //$mod_code_description = $nuo_modifier_item['modifier_mod_code_desc'];
                                        $ingredient = $nuo_modifier_item['ingredient'] || ($nuo_modifier_item['modifier_mod_code_desc'] == 'No');
                                        $nuo_modifier_price = $nuo_modifier_item['price'] == null ? 0.00 : $nuo_modifier_item['price'];
                                        if ($sub_modifier_price > $nuo_modifier_price) {
                                            $nuo_modifier_price = $sub_modifier_price;
                                        }

                                        // *********  CANT USE modifier_item_id  SINCE SMALL AND LARGE GIVE DIFFERENT ID'S    NEED TO USE   group id and name?
                                        $modifier_item_resource = $this->getModifierItemResource($modifier_group_id, $modifier_group_id.'-'.$modifier_item_name);
                                        if (isset($modifier_item_resource->insert_id)) {
                                            if ($nuo_modifier_item['display_position'] > 0) {
                                                $display_position = $nuo_modifier_item['display_position']*10;
                                            } else {
                                                $display_position = 0;
                                            }

                                            $modifier_item_resource->modifier_item_name = $modifier_item_name;
                                            if (substr($modifier_item_resource->modifier_item_name) == 'No ') {
                                                // have to do this since sometimes the names have the 'no' alrady as part of it without the code
                                                $modifier_item_resource->priority = $modifier_item_priority+500-$display_position;
                                            } else {
                                                $modifier_item_resource->priority = $modifier_item_priority-$display_position;
                                            }
                                            $modifier_item_resource->modifier_item_print_name = $modifier_item_name;
                                            $modifier_item_resource->modifier_item_max = 1;
                                            $modifier_item_resource->save();
                                        }
                                        $modifier_item_id = $modifier_item_resource->modifier_item_id;



                                        // now do modifier size maps
                                        try {
                                            $modifier_size_resource = $this->getModifierSizeResource($modifier_item_id, $size_resource->size_id, $nuo_modifier_group['modgrpid'].':'.$nuo_modifier_item['itemid']);
                                        } catch (Exception $e) {
                                            myerror_log("WE HAVE A POSSIBLE DUPLICATE MODIFIER SIZE MAP FROM NUORDER: ".$modifier_item_name);
                                            $modifier_size_resource = $this->getModifierSizeResource($modifier_item_id, $size_resource->size_id, null);
                                        }


                                        if (isset($modifier_size_resource->insert_id)) {
                                            $modifier_size_resource->modifier_price = $nuo_modifier_price;
                                            $modifier_size_resource->save();
                                        } else {
                                            if ($modifier_size_resource->external_id != $nuo_modifier_item['itemid']) {
                                                myerror_log("WE HAVE A DUPLICATE MODIFIER SIZE MAP FROM NUORDER: ".$modifier_item_name);
                                            }
                                            if ($nuo_modifier_price != $modifier_size_resource->modifier_price) {
                                                if ($mod_code_value == 20 || $ingredient) {
                                                    myerror_log("IGNORE price mismatch, its due to a comes with");
                                                } else if ($modifier_size_resource->modifier_price == 0.00) {
                                                    myerror_log("existing price is 0 which means it may have been a comes with originally so lets just make it what it is now");
                                                    $modifier_size_resource->modifier_price = $nuo_modifier_price;
                                                    $modifier_size_resource->save();
                                                } else {
                                                    myerror_log("WE HAVE PRICE MISMATCH PROBLEM ON NuOrder Import. imported price: $nuo_modifier_price,   existing price from previous record: ".$modifier_size_resource->modifier_price);
                                                }
                                            }
                                        }

                                        // now do the comes with
                                        if ($ingredient) {
                                            $item_modifier_item_adapter = new ItemModifierItemMapAdapter(getM());
                                            $imi_data = ['item_id'=>$item_id,'modifier_item_id'=>$modifier_item_id];
                                            if ($imi_resource = Resource::createByData($item_modifier_item_adapter,$imi_data)) {
                                                myerror_log("Item Modifier Item Map created for $item_name  and   ".$modifier_item_name);
                                            }
                                        }

                                        $modifier_item_priority = $modifier_item_priority - 10;
                                    }

                                }

                                $nuo_modifier_group['default_max'] = sizeof($nuo_modifier_items);

                                // now do Item Modifier Group Map
                                $item_modifier_group_map_resource = $this->getItemModifierGroupMap($item_id, $modifier_group_id);
                                $item_modifier_group_map_resource->display_name = $nuo_modifier_group['short_desc'];
                                $min = $this->getModifierGroupMinForThisIntegration($nuo_modifier_group);
                                $max = $this->getModifierGroupMaxForThisIntegration($nuo_modifier_group);
                                $item_modifier_group_map_resource->min = $min;
                                $item_modifier_group_map_resource->max = $max;
                                $item_modifier_group_map_resource->priority = $modifier_group_priority;
                                $item_modifier_group_map_resource->save();

                                $modifier_group_priority = $modifier_group_priority - 200;
                            }
                        }

                    }


                $item_priority = $item_priority - 5;

                //$_SERVER['DO_NOT_CHECK_CACHE'] = 'true';
                myerror_log("blahg ");
            }
            //$complete_menu = CompleteMenu::getCompleteMenu($menu_id,'Y',0,2);
            $menu_type_priority = $menu_type_priority - 10;
        }
        $complete_menu = CompleteMenu::getCompleteMenu($menu_id,'Y',0,2);

        return $menu_id;
    }

    function getModifierGroupMinForThisIntegration($nuo_modifier_group)
    {
        $min = $nuo_modifier_group['minimum'] > 0 ? $nuo_modifier_group['minimum'] : 0;
        return $min;
    }

    function getModifierGroupMaxForThisIntegration($nuo_modifier_group)
    {
        $min = $nuo_modifier_group['maximum'] > 0 ? $nuo_modifier_group['maximum'] : $nuo_modifier_group['default_max'];
        return $min;
    }

    /********************/

     function getItemDescriptionFromItemData($item_data){}

     function getActiveFlagSetting($data){}

     function getMenuTypeCatId($menu_type_data){}

     function getObjectPriceFromItemData($item_data){}


    /* GENERAL ABSTACT METHODS FOR FRAMEWORK */

     function getRemoteData($merchant_resource){}

     function setMenuId(){}

}
