<?php

class OrdrInImporter extends SplickitImporter
{
	
	var $raw_menu_from_ordrin_as_array;
	
	function __construct($raw_menu_from_ordrin_as_array)
	{
		$this->raw_menu_from_ordrin_as_array = $raw_menu_from_ordrin_as_array;
	}
	
	function getMerchantAndMenuDataFromOrdrInJSONDump($json_dump)
	{
		$merchant = json_decode($json_dump,true);
		$data['menu'] = $merchant['menu']; 
		unset($merchant['menu']);
		$data['merchant'] = $merchant;
		return $data;
	}
		
	function importRemoteData($menu_as_array,$ordrin_id,$menu_name)
	{
		$menu_resource = $this->getOrdrInMenuResource($ordrin_id, $menu_name);
		$menu_id = $menu_resource->menu_id;
		$menu_type_priority = 200;
		foreach ($menu_as_array as $oi_menu_type)
		{
			$menu_type_resource = $this->getMenuTypeResource($menu_id, $oi_menu_type['id']);
			$menu_type_resource->priority = $menu_type_priority;
			$this->updateMenuTypeResource($oi_menu_type, $menu_type_resource);
			// now get sizes
			$size_resource = $this->getSizeForMenuTypeId($menu_type_resource->menu_type_id, $menu_type_resource->menu_type_name);
			
			$items = $oi_menu_type['children'];
			$item_priority = 200;
			foreach ($items as $oi_item_data)
			{
				$item_resource = $this->getItemResource($menu_type_resource->menu_type_id,$oi_item_data['id']);
				$item_id = $item_resource->item_id;
				$item_resource->priority = $item_priority;
				$this->updateItemResource($oi_item_data,$item_resource);
				
				//now deal with size price record
				$item_size_resource = $this->getItemSizePriceResource($item_resource->item_id, $size_resource->size_id,$oi_item_data['id']);
				$this->updateItemSizePriceResource($item_size_resource, $oi_item_data);
				
				//now create modifier group.  no re-use here always just attached to the item.
				if ($oi_modifier_groups = $oi_item_data['children'])
				{
					$modifier_group_priority = 200;
					foreach ($oi_modifier_groups as $oi_modifier_group_data)
					{
						$modifier_group_resource = $this->getModifierGroupResource($menu_id, $oi_modifier_group_data['id']);
						$modifier_group_resource->priority = $modifier_group_priority;
						$modifier_group_id = $modifier_group_resource->modifier_group_id;
						$this->updateModifierGroupResource($modifier_group_resource, $oi_modifier_group_data);
						$oi_modifier_items = $oi_modifier_group_data['children'];
						$modifier_item_priority = 200;
						foreach ($oi_modifier_items as $oi_modifier_item_data)
						{
							$modifier_item_resource = $this->getModifierItemResource($modifier_group_id, $oi_modifier_item_data['id']);
							$modifier_item_id = $modifier_item_resource->modifier_item_id;
							$modifier_item_resource->priority = $modifier_item_priority;
							$this->updateModifierItemResource($modifier_item_resource, $oi_modifier_item_data);
							
							// now do modifier size maps
							$modifier_size_resource = $this->getModifierSizeResource($modifier_item_id, $oi_modifier_item_data['id']);
							$this->updateModifierSizeResource($modifier_size_resource, $oi_modifier_item_data);
							$modifier_item_priority = $modifier_item_priority -5;
						}
						
						// now do Item Modifier Group Map
						$item_modifier_group_map_resource = $this->getItemModifierGroupMap($item_id, $modifier_group_id);
						$this->updateItemModifierGroupMapResource($item_modifier_group_map_resource, $oi_modifier_group_data, $modifier_group_priority);
						$modifier_group_priority = $modifier_group_priority - 5;
					}	
				}
				$item_priority = $item_priority - 5;
			}

			$menu_type_priority = $menu_type_priority - 5;
		}
		return $menu_id;
	}
	
	function getItemModifierGroupMap($item_id,$modifier_group_id)
	{
		$data['item_id'] = $item_id;
		$data['modifier_group_id'] = $modifier_group_id;
		return $this->getOrCreateMenuObjectResource($data, new ItemModifierGroupMapAdapter($mimetypes));
	}
	
	function updateItemModifierGroupMapResource(&$item_modifier_group_map_resource,$oi_modifier_group_data,$priority)
	{
		$item_modifier_group_map_resource->display_name = $oi_modifier_group_data['name'];
		$min = $oi_modifier_group_data['min_child_select'];
		$max = $oi_modifier_group_data['max_child_select'];
		if ($max == 0) {
			$max = 88888;
		}
		$item_modifier_group_map_resource->min = $min;
		$item_modifier_group_map_resource->max = $max;
		$item_modifier_group_map_resource->priority = $priority;
		$item_modifier_group_map_resource->save(); 
	}
	
	function updateModifierSizeResource(&$modifier_size_resource,$oi_modifier_item_data)
	{
		$modifier_size_resource->price = $oi_modifier_item_data['price'];
		$modifier_size_resource->active = 'Y';
		$modifier_size_resource->save();
	}
	
	function getModifierSizeResource($modifier_item_id,$external_id)
	{
		$data['modifier_item_id'] = $modifier_item_id;
		$data['external_id'] = $external_id;
		return $this->getOrCreateMenuObjectResource($data, new ModifierSizeMapAdapter($mimetypes));
	}
	
	function updateModifierItemResource(&$modifier_item_resource,$oi_modifier_item_data)
	{
		$modifier_item_resource->modifier_item_name = $oi_modifier_item_data['name'];
		$modifier_item_resource->modifier_print_name = $oi_modifier_item_data['name'];
		$modifier_item_resource->modifier_item_max = 1;
		$modifier_item_resource->save();
	}
	
	function getModifierItemResource($modifier_group_id,$external_modifier_item_id)
	{
		$data['modifier_group_id'] = $modifier_group_id;
		$data['external_modifier_item_id'] = $external_modifier_item_id;
		return $this->getOrCreateMenuObjectResource($data, new ModifierItemAdapter($mimetypes));
	}
	
	function updateModifierGroupResource(&$modifier_group_resource,$oi_modifier_group_data)
	{
		$modifier_group_resource->modifier_group_name = $oi_modifier_group_data['name'];
		$modifier_group_resource->modifier_description = $oi_modifier_group_data['descip'];
		$modifier_group_resource->active = 'Y';
		$modifier_group_resource->save();
	}
	
	function getModifierGroupResource($menu_id,$external_modifier_group_id) 
	{
		$data['menu_id'] = $menu_id;
		$data['external_modifier_group_id'] = $external_modifier_group_id;
		return $this->getOrCreateMenuObjectResource($data, new ModifierGroupAdapter($mimetypes));
	}
	
	function getItemSizePriceResource($item_id,$size_id,$external_id)
	{
		$data['item_id'] = $item_id;
		$data['size_id'] = $size_id;
		$data['external_id'] = $external_id;
		return $this->getOrCreateMenuObjectResource($data, new ItemSizeAdapter($mimetypes));
	}
	
	function updateItemSizePriceResource(&$item_size_resource,$oi_item_data)
	{
		$item_size_resource->price = $oi_item_data['price'];
		$item_size_resource->active = 'Y';
		$item_size_resource->save();
	}
	
	function getSizeForMenuTypeId($menu_type_id,$menu_type_name)
	{
		// ordr.in has no concept of sizes so there will be only 1 size per menu_type for now.  they may give us a way to group them in the future
		$data['menu_type_id'] = $menu_type_id;
		$data['size_name'] = $menu_type_name;
		$data['size_print_name'] = 'one size'; 
		return $this->getOrCreateMenuObjectResource($data, new SizeAdapter($mimetypes));
	}

	function getItemResource($menu_type_id,$external_item_id)
	{
		$data['external_item_id'] = $external_item_id;
		$data['menu_type_id'] = $menu_type_id;
		return $this->getOrCreateMenuObjectResource($data, new ItemAdapter($mimetypes));	
	}
	
	function updateItemResource($ordr_in_item_data,&$item_resource)
	{
		$item_resource->item_name = $ordr_in_item_data['name'];
		$item_resource->active = $this->getActiveFlagSetting($ordr_in_item_data);
		$item_resource->item_print_name = $ordr_in_item_data['name'];
		$item_resource->description = $ordr_in_item_data['descrip'];
		$item_resource->save();
	}
	
	function getMenuTypeResource($menu_id,$external_menu_type_id)
	{
		$data['external_menu_type_id'] = $external_menu_type_id;
		$data['menu_id'] = $menu_id;
		$menu_type_resource = $this->getOrCreateMenuObjectResource($data, new MenuTypeAdapter($mimetypes));
		return $menu_type_resource;
	}
	
	function updateMenuTypeResource($ordr_in_menu_type_data,&$menu_type_resource)
	{
		$menu_type_resource->menu_type_name = $ordr_in_menu_type_data['name'];
		$menu_type_resource->cat_id = $this->getMenuTypeCatId($ordr_in_menu_type_data);
		$menu_type_resource->active = $this->getActiveFlagSetting($ordr_in_menu_type_data);
		$menu_type_resource->save();
		
	}
	
	function getActiveFlagSetting($data)
	{
		if (true) {
			return 'Y';
		}
		
		if ($data['is_orderable'] == 1) {
			return 'Y';
		} else {
			return 'N';
		}
	}
	
	function getMenuTypeCatId($ordr_in_menu_type_data)
	{
		// will need to put some real function in here
		if (true) {
			return 'E';
		}
	}
	
	function getOrdrInMenuResource($ordrin_id,$menu_name)
	{
		$data['external_menu_id'] = "ordrin-$ordrin_id";
		$data['version'] = 2.0;
		$data['name'] = $menu_name;
		return $this->getOrCreateMenuObjectResource($data, new MenuAdapter($mimetypes));
		
		if ($menu_resource = $this->getOrCreateMenuObjectResource($data,new MenuAdapter($mimetypes))) {
			error_log("we have the parent menu resource");
			return $menu_resource;
		} else {
			throw new Exception("really bad shit trying to import menu");
		}		
	}
}
?>
