<?php
class ThanxCurl extends SplickitCurl
{
	static function curlIt($url,$payload,$headers,$user_password,$method)
	{
	    $json = json_encode($payload);
	    foreach ($headers as $header) {
	        $h = explode(':',$header);
	        $header_hash[$h[0]] = $h[1];
        }
	    $valid_access_token = 'e8016f7106d3a94853d887c1ae60a806704357992695ee0dfb6ccbe69a802e9d';
		$service_name = 'Thanx Loyalty Service';
        if (substr_count($url,'/users/') > 0  && $method == 'POST') {
            if (strtolower($payload['user']['first_name']) == 'exists') {
                $response = '{"error":{"code":"BAD_REQUEST","message":"User account exists"}}';
                return ['raw_result' => $response, 'http_code' => 400];
            } else if ($payload['user']['phone'] == '+18888888888') {
                $response = '{"error":{"code":"BAD_REQUEST","message":"Phone is invalid"}}';
                return ['raw_result' => $response, 'http_code' => 400];
            }
            $id = createCode(10);
            $email = $payload['user']['email'];
            $phone = $payload['user']['phone'];
            $response = '{"user":{"id":"' . $id . '","email":"' . $email . '","phone":"' . $phone . '","first_name":"first","last_name":"last","birth_date":{},"gender":"unknown"},"authorization":{"token_type":"Bearer","scope":"passwordless","created_at":1620660803,"access_token":"' . $valid_access_token . '","refresh_token":"e972197fd4e7e81258ccad6763a95a1736cab4fbcedae8eab86b984894ce41ba"}}';
            return ['raw_result' => $response, 'http_code' => 201];
        } else if (substr_count($url,'/users/') > 0  && $method == 'PATCH') {
            $response = '{"user":{"id":"b4e4970f2df7","email":"testuser_1631886037_ffi@order140.com","phone":"+12127991994","first_name":"first","last_name":"last","birth_date":{"year":1975,"month":8,"day":14},"gender":"unknown","zip_code":null}}';
            return ['raw_result' => $response, 'http_code' => 201];
        } else if (substr_count($url,'/users/me') > 0  && $method == 'GET') {
            $code = generateCode(10);
            if ($_SERVER['thanx_email'] != null) {
                $response = '{"user":{"id":"'.$_SERVER['thanx_id'].'","email":"'.$_SERVER['thanx_email'].'","phone":"'.$_SERVER['thanx_phone'].'","first_name":"'.$_SERVER['thanx_first_name'].'","last_name":"'.$_SERVER['thanx_last_name'].'","birth_date":{"year":1976,"month":11,"day":29},"gender":"unknown","zip_code":null}}';
            } else {
                $response = '{"user":{"first_name":null,"last_name":null,"email":null,"identifier":"'.$code.'","birth_date":null,"id":"'.$_SERVER['thanx_id'].'"}}';
            }
            return ['raw_result' => $response, 'http_code' => 200];
        } else if (substr_count($url,'/oauth/token') > 0  && $method == 'POST') {
            if ($payload['code'] == '12345678900987654321') {
                $response = '{"error":"invalid_grant","error_description":"The provided authorization grant is invalid, expired, revoked, does not match the redirection URI used in the authorization request, or was issued to another client."}';
                return ['raw_result'=>$response,'http_code'=>401];
            } else {
                $response = '{"access_token":"'.$valid_access_token.'","token_type":"Bearer","refresh_token":"d0adb1658b4a3c85e7f45bc33d9ff5755eed74706e839c36ff2b3799e6703b31","scope":"passwordless","created_at":1620394964}';
                return ['raw_result'=>$response,'http_code'=>200];
            }
        } else if (substr_count($url,'/api/account') > 0) {
            if ($header_hash['Authorization'] == " Bearer $valid_access_token") {
                if (isset($_SERVER['thanx_id'])) {
                    $response = '{"id":"'.$_SERVER['thanx_id'].'","email":"'.$_SERVER['thanx_email'].'","rewards":[],"progress":null}';
                } else {
                    $response = '{"id":"xk3zqr9cddnpw64","email":"arosenthal@order140.com","rewards":[{"id":"ABCD1234","value":6.0,"minimum":null,"maximum":null,"label":"a free pulled pork nachos","state":"redeemable","type":"item","products":[],"fine_print":"","retire_at":null},{"id":"X1h7Wd","value":10.0,"minimum":null,"maximum":null,"label":"$10 off first purchase","state":"redeemable","type":"item","products":[],"fine_print":"","retire_at":"2021-07-17T21:18:25Z"},{"id":"qGhBWG","value":10.0,"minimum":null,"maximum":null,"label":"$10 off","state":"redeemable","type":"item","products":[],"fine_print":"","retire_at":null},{"id":"ZnhDLj","value":10.0,"minimum":null,"maximum":null,"label":"$10 off your next purchase","state":"redeemable","type":"amount","products":[],"fine_print":"","retire_at":null},{"id":"B6hm1E","value":10.0,"minimum":null,"maximum":null,"label":"$10 off your next purchase","state":"redeemable","type":"amount","products":[],"fine_print":"","retire_at":null},{"id":"Y8hO18","value":10.0,"minimum":null,"maximum":null,"label":"$10 off your next purchase","state":"redeemable","type":"amount","products":[],"fine_print":"","retire_at":null},{"id":"zVhLl9","value":10.0,"minimum":null,"maximum":null,"label":"$10 off your next purchase","state":"redeemable","type":"amount","products":[],"fine_print":"","retire_at":null},{"id":"eZhW1J","value":10.0,"minimum":null,"maximum":null,"label":"$10 off your next purchase","state":"redeemable","type":"amount","products":[],"fine_print":"","retire_at":null}],"progress":null}';
                }
                return ['raw_result'=>$response,'http_code'=>200];
            }
        } else if (substr_count($url,'/api/baskets') > 0) {
            $reward = null;
            if (isset($payload['rewards'][0])) {
                $reward = $payload['rewards'][0];
            }
            $code = generateCode(6);
            if ($payload['state'] == 'completed') {
                // just a record of the order
                $response = '{"id":"'.$code.'","state":"completed","discount":null}';
                return ['raw_result'=>$response,'http_code'=>201];
            } else if ($payload['state'] == 'checkout') {
                if ($reward == 'ABCD1234') {
                    $response = '{"code":400,"message":"This reward cannot be applied to any items in your purchase"}';
                    return ['raw_result'=>$response,'http_code'=>400];
                } else if ($reward) {
                    $response = '{"id":"'.$code.'","state":"checkout","discount":"5.00"}';
                    return ['raw_result'=>$response,'http_code'=>200];
                } else {
                    $response = '{"id":"'.$code.'","state":"checkout","discount":null}';
                    return ['raw_result'=>$response,'http_code'=>200];
                }
            } else if ($payload['state'] == 'placed') {
                if ($_SERVER['FORCE_THANX_REWARD_FAIL']) {
                    $response = '{"code":400,"message":"This reward can no longer be used"}';
                    return ['raw_result'=>$response,'http_code'=>400];
                }

                if ($reward) {
                    $response = '{"id":"'.$code.'","state":"placed","discount":"5.00"}';
                    return ['raw_result'=>$response,'http_code'=>200];
                } else {
                    $response = '{"id":"'.$code.'","state":"placed","discount":null}';
                    return ['raw_result'=>$response,'http_code'=>200];
                }
            } else if ($payload['state'] == 'billed') {
                if ($reward) {
                    $response = '{"id":"'.$code.'","state":"billed","discount":"5.00"}';
                    return ['raw_result'=>$response,'http_code'=>200];
                } else {
                    $response = '{"id":"'.$code.'","state":"billed","discount":null}';
                    return ['raw_result'=>$response,'http_code'=>200];
                }
            } else if ($payload['state'] == 'refunded') {
                $response = '{"id":"'.$code.'","state":"refunded","discount":null}';
                return ['raw_result'=>$response,'http_code'=>201];
            }
        } /*   this is new API stuff.  NOT USING THIS ENDPOINT
            else if (substr_count($url,'/rewards') > 0) {
            $response = '{"pagination":{"total_pages":1,"per_page":10,"current_page":1},"rewards":[{"id":"p0397vjce5v94x5","user_id":"04bae133e568","merchant_id":"gkmy334henlyvx6","campaign_id":"p3wlrj4hkp5xqkd","state":"available","earn":{"type":"intro","text":"Signing up"},"redeem":{"type":"manual","text":"a Free Pulled Pork Nachos","venue":"all","window":60.0},"coupon_code":null,"fine_print":"","instructions":null,"available_at":"2021-05-07T12:29:02Z","activated_at":null,"retire_at":null,"used_at":null},{"id":"ne79z6ncqjzmx0w","user_id":"04bae133e568","merchant_id":"gkmy334henlyvx6","campaign_id":"mgzxwnkhgk8xyrn","state":"available","earn":{"type":"birthday","text":"Being Awesome"},"redeem":{"type":"manual","text":"$10 Off First Purchase","venue":"all","window":60.0},"coupon_code":null,"fine_print":"This reward expires at 07/17/2021.","instructions":null,"available_at":"2021-06-16T21:18:25Z","activated_at":null,"retire_at":"2021-07-17T21:18:25Z","used_at":null},{"id":"xozmqvqczle92lk","user_id":"04bae133e568","merchant_id":"gkmy334henlyvx6","campaign_id":"15vx3eghngplg2k","state":"available","earn":{"type":"invite","text":"Being referred"},"redeem":{"type":"manual","text":"$10 off","venue":"all","window":60.0},"coupon_code":null,"fine_print":"","instructions":null,"available_at":"2021-06-16T21:18:39Z","activated_at":null,"retire_at":null,"used_at":null},{"id":"lr5937jcov4mzyv","user_id":"04bae133e568","merchant_id":"gkmy334henlyvx6","campaign_id":"5d2lm3whqnz6w9q","state":"available","earn":{"type":"loyalty","text":"Spending $150"},"redeem":{"type":"manual","text":"$10 off your next purchase","venue":"all","window":60.0},"coupon_code":null,"fine_print":"","instructions":null,"available_at":"2021-06-16T21:18:58Z","activated_at":null,"retire_at":null,"used_at":null},{"id":"eo6mx14c5ve84yd","user_id":"04bae133e568","merchant_id":"gkmy334henlyvx6","campaign_id":"5d2lm3whqnz6w9q","state":"available","earn":{"type":"loyalty","text":"Spending $150"},"redeem":{"type":"manual","text":"$10 off your next purchase","venue":"all","window":60.0},"coupon_code":null,"fine_print":"","instructions":null,"available_at":"2021-06-16T21:19:42Z","activated_at":null,"retire_at":null,"used_at":null},{"id":"ze39d0kc20w84op","user_id":"04bae133e568","merchant_id":"gkmy334henlyvx6","campaign_id":"5d2lm3whqnz6w9q","state":"available","earn":{"type":"loyalty","text":"Spending $150"},"redeem":{"type":"manual","text":"$10 off your next purchase","venue":"all","window":60.0},"coupon_code":null,"fine_print":"","instructions":null,"available_at":"2021-06-16T21:19:43Z","activated_at":null,"retire_at":null,"used_at":null},{"id":"lkj8wj0c2gdm5wn","user_id":"04bae133e568","merchant_id":"gkmy334henlyvx6","campaign_id":"5d2lm3whqnz6w9q","state":"available","earn":{"type":"loyalty","text":"Spending $150"},"redeem":{"type":"manual","text":"$10 off your next purchase","venue":"all","window":60.0},"coupon_code":null,"fine_print":"","instructions":null,"available_at":"2021-06-16T21:19:43Z","activated_at":null,"retire_at":null,"used_at":null},{"id":"4e79k56c7yr90ko","user_id":"04bae133e568","merchant_id":"gkmy334henlyvx6","campaign_id":"5d2lm3whqnz6w9q","state":"available","earn":{"type":"loyalty","text":"Spending $150"},"redeem":{"type":"manual","text":"$10 off your next purchase","venue":"all","window":60.0},"coupon_code":null,"fine_print":"","instructions":null,"available_at":"2021-06-16T21:19:43Z","activated_at":null,"retire_at":null,"used_at":null}]}';
            return ['raw_result'=>$response,'http_code'=>201];
        }*/

	}
}
?>