<?php
Abstract class P2PPaymentService extends SplickitPaymentService
{
    var $service_name;

    function __construct($data)
    {
        parent::__construct($data);
    }

    function recordOrderTransactionsInBalanceChangeTable($order_resource,$payment_results)
    {
        logData($payment_results, "payment results",5);
        $balance_change_adapter = new BalanceChangeAdapter(getM());
        $balance_change_resource_for_order = parent::recordOrderTransactionsInBalanceChangeTable($order_resource,null);
        $billing_user_id = (isset($payment_results['user_id'])) ? $payment_results['user_id'] : $this->billing_user_id;
        if ($bc_resource = $balance_change_adapter->addRow($billing_user_id, 0, $this->amount, 0,"P2P" ,$this->getServiceName(), $order_resource->order_id, $payment_results['transaction_id'], 'PENDING')) {
            $this->balance_change_resource_for_payment = $bc_resource;
            myerror_log("successful insert of primary order record balance change row");
        } else {
            myerror_log("ERROR!  FAILED TO ADD ROW TO BALANCE CHANGE TABLE");
            MailIt::sendErrorEMail('Error thrown in PlaceOrderController','ERROR*****************  FAILED TO ADD ROW TO BALANCE CHANGE TABLE, user_id = '.$user_id.', AFTER RUNNING THEIR Levelup Account AND UPDATING BALANCE: '.$balance_change_adapter->getLastErrorText());
        }
    }

    function getServiceName()
    {
        return $this->service_name;
    }

    abstract function checkStatusOfTransactionId($transaction_id);

    abstract function cancelTransaction($transaction_id);

}
?>