<?php

abstract class MarketingService extends SplickitService
{

    /**
     * @description Will be set by each of the child objects. These are the corressponding fields on the user object
     * @var $join_fields Array
     */
    var $join_fields;

    var $join_data;

    var $service_name;

    var $third_party_provider_id;

    var $validation_error;

    var $marketing_service_brand_info = [];
    /*
     * the curl object
     */
    var $curl_object;

    function __construct($brand_id)
    {
        $this->marketing_service_brand_info = getThirdPartyParametersForMerchantSkinCombination($this->third_party_provider_id,getSkinIdForContext(),0,$brand_id);
    }

    /**
     * @description will probably be overridden by the child objects
     * @param $resource Resource
     * @return mixed
     */
    function createJoinPayload($resource)
    {
        //$resource->cleanResource();
        return $resource->getDataFieldsReally();
    }

    function validateJoinFields($resource)
    {
        foreach ($this->join_fields as $join_field) {
            $method_name = str_replace('-','','validate_'.$join_field);
            if (method_exists($this,$method_name)) {
              if ($this->$method_name($resource)) {
                  ; //cool
              } else {
                  $this->validation_error = "missing valid $join_field";
                  return false;
              }
            } else if (isset($resource->$join_field)) {
                ; // cool
            } else {
                $this->validation_error = "missing valid $join_field";
                return false;
            }
        }
        return true;
    }

    function getValidationError()
    {
        return $this->validation_error;
    }

    function checkForOptIn($resource)
    {
        if (isset($resource->marketing_email_opt_in)) {
            if ($resource->marketing_email_opt_in === 0) {
                return false;
            }
            return $resource->marketing_email_opt_in == 1 || $resource->marketing_email_opt_in == 'Y' ;
        }
        return false;
    }

    function setOptInOnResource(&$resource)
    {
        return $resource; // override this method to set the opt in to somethign other than marketing_email_opt_in;
    }

    function join($resource)
    {
        if ($this->checkForOptIn($resource)) {
            $this->setOptInOnResource($resource);
            $join_data = $this->createJoinPayload($resource);
            $results = $this->curlIt($join_data);
            if ($this->isSuccessfulResponse($results)) {
                return $results;
            } else {
                myerror_log("ERROR TRYING TO JOIN " . strtoupper($this->service_name));
                logError("error", $this->service_name . " Error. they don't really tell us", "");
                return false;
            }
        } else {
            return false;
        }

    }

    /**
     * @description this function will get exteded in the individual service to call the associated curl object
     * @return mixed
     */
    abstract function curlIt($data);


}

class NoAssociatedMarketingServiceException extends Exception
{
    public function __construct() {
        parent::__construct('No Active Marketing Service Associated With Skin');
    }
}