<?php

final Class MarketingServiceFactory
{

    /**
     *
     * Will return the marketing service if it exists for brand
     * @param $brand_id
     *
     * @return MarketingService
     */
    public static function getMarketingServiceFromBrandId($brand_id)
    {
        $tpppbma = new ThirdPartyProviderParameterBrandMapsAdapter();
        $sql = "SELECT c.name AS 'provider_name', b.name AS 'parameter_name' ,a.value ".
            "FROM Third_Party_Provider_Parameter_Brand_Maps a JOIN Third_Party_Provider_Parameters b ON a.third_party_provider_parameter_id = b.id ".
            "JOIN Third_Party_Providers c ON b.third_party_provider_id = c.id ".
            "WHERE a.brand_id = $brand_id and c.id > 6000 AND c.id < 7000 and b.name = 'active_flag' and a.value = 'Y' and a.logical_delete = 'N' AND b.logical_delete = 'N' AND c.logical_delete = 'N'";
        $options[TONIC_FIND_BY_SQL] = $sql;
        if ($results = $tpppbma->getRecord([],$options)) {
            $name = $results['provider_name'];
            $service_name = $name.'Service';
            if (file_exists("lib".DIRECTORY_SEPARATOR."services".DIRECTORY_SEPARATOR.strtolower($service_name).".php")) {
                require_once "lib".DIRECTORY_SEPARATOR."services".DIRECTORY_SEPARATOR.strtolower($service_name).".php";
                myerror_log("we have the marketing service name: $service_name");
                return new $service_name($brand_id);
            }
        }
    }
}
?>