<?php

class TelegramService extends SplickitService
{
    var $service_name = "telegram";
    var $bot_token;

    const TELEGRAM_THIRD_PARTY_PROVIDER_ID = 8001;

    function __construct($data)
    {
        parent::__construct($data);
        $this->info = getThirdPartyParametersForMerchantSkinCombination(self::TELEGRAM_THIRD_PARTY_PROVIDER_ID,$data['skin_id'],$data['merchant_id'],$data['brand_id']);
        $this->bot_token = $this->info['bot_token'];
    }

    function send($chat_id, $message)
    {
        if (empty($chat_id)) {
            return false;
        }
        if (empty($message)) {
            return false;
        }
        // https://api.telegram.org/bot1768567331:AAGaEDvibKunOmPFSB1-qcVD22HWvdu9qjA/sendMessage?chat_id=1829826226&text=$message
        // myerror_log("\r\n$message");
        $formatted_message = urlencode($message);
        $url = getProperty('telegram_api_url');
        $url = str_replace('%%bot_token%%',$this->info['bot_token'],$url);
        $url = $url."sendMessage?chat_id=$chat_id&text=$formatted_message";
        $response = TelegramCurl::curlIt($url,null);
        $this->curl_response = $response;
        $results_array = $this->processCurlResponse($response);
        $results_array['result']['raw_return'] = $this->raw_return;
        if ($this->isSuccessfulResponse($results_array)) {
            return $results_array;
        }
        //throw new UnsuccessfulIvrPushException($results_array['message'], $results_array['code']);
    }

    function doSMSMessage($phone_number,$message_text)
    {
        $data = array();
        $data['Body'] = substr($message_text,0,159);
        $url = 'https://api.twilio.com/2010-04-01/Accounts/' . $this->account_sid . '/SMS/Messages.json';
        $results_as_array = $this->send($phone_number,$url,$data);
        return array("response_id"=>$results_as_array['sid'],"response_text"=>"queued");
    }

    function doOutboundCall($phone_number, $message_response_url)
    {
        $twilio_domain ="https://api.twilio.com/2010-04-01/Accounts/";
        $url = $twilio_domain . $this->account_sid .'/Calls.json' ;
        $data['Url'] = $message_response_url;

        return $this->send($phone_number,$url,$data);

    }

    function isSuccessfulResponse($response)
    {
        return $response['http_code'] == 200;
    }

}
?>