<?php

class LennysOrderSend {

	private static $headers2  = "MIME-Version: 1.0;Content-Type: text; charset=UTF-8;From: support@order140.com\n";
	
	//private static $wsdl = "http://75.149.121.163/ATOnlineOrderingsvc/?WSDL";
	private static $wsdl = "http://www.lennysnet.com/onlineordering/ATOnlineOrdering.asmx?WSDL";

	public static function checkStore($store_id)
	{
		$wsdl = self::$wsdl;
		
		myerror_log("about to check store..........: ".$wsdl);
		try {		
				$client = new SoapClient($wsdl, array('trace' => TRUE, 'exceptions'=>true));
				$payload = array('vnRestaurantID'=>$store_id);
				$times = time();
				$result = $client->GetStoreInfo(array('vnRestaurantID'=>$store_id));
				$last = $client->__getLastRequest();
				myerror_log("**************");
				myerror_log($result->GetStoreInfoResult->any);
				myerror_log("**************");
				myerror_log("request: ".$last);
				myerror_log("**************");
				return $result->GetStoreInfoResult->any;
		}
		catch (Exception $e) {
			myerror_log("******CHECK STORE ERROR********");
			myerror_log("error: ".$e->getMessage());
			try {
				$last = $client->__getLastRequest();
			} catch (Exception $e2) {
				myerror_log("ERROR couldn't call URL.  Lennys server appears down");// do nothing
			}
			myerror_log("request: ".$last);
			myerror_log("******END CHECK STORE ERROR********");
			return false;
		}
	}
	
	public static function availabilityTest($store_id)
	{
		$wsdl = self::$wsdl;
		
		myerror_log("about to check store availability..........: ".$wsdl);
		try {		
				$client = new SoapClient($wsdl, array('trace' => TRUE, 'exceptions'=>true));
				$payload = array('vnRestaurantID'=>$store_id);
				$result = $client->AvailabilityTest(array('vnRestaurantID'=>$store_id));
				$last = $client->__getLastRequest();
				myerror_log("**************");
				$result_string = $result->AvailabilityTestResult->any;
				myerror_log($result_string);
				myerror_log("**************");
				myerror_log("request: ".$last);
				myerror_log("**************");
				return $result->GetAvailabilityTest->any;
		}
		catch (Exception $e) {
			myerror_log("******AvailabilityTest ERROR********");
			$last = $client->__getLastRequest();
			myerror_log("error: ".$e->getMessage());
			myerror_log("request: ".$last);
			myerror_log("******END CHECK STORE ERROR********");
			return false;
		}
	}

	public static function validateOrder($order_payload)
	{	
		$wsdl = self::$wsdl;
				
		$client = null;
		try {
			myerror_log("about to send validate payload to lennys to get tax");
			//if ($_SERVER['USER'] == 'radamnyc')
			$clean_payload = preg_replace('/(<AccountNumber>.+?)+(<\/AccountNumber>)/i', '<AccountNumber/>', $order_payload); 
			myerror_log($clean_payload); 
			@mail("splickit.orders.all@gmail.com",'XML Lennys',$clean_payload,self::$headers2); 
			$client = new SoapClient($wsdl, array('trace' => false, 'exceptions'=>true));
			$soapvar = new SoapVar($order_payload, XSD_ANYXML);
			$payload = array('voxmlRequest'=>$soapvar);
			$result = $client->ValidateTicket(array('voxmlRequest'=>$soapvar));
			myerror_log("******result1********");
			myerror_log($result->ValidateTicketResult->any);
			return $result->ValidateTicketResult->any;
		} catch (Exception $e) {
			$message = $e->getMessage();
			@mail('adam@order140.com','Lennys sending error in'.$_SERVER['SERVER_NAME'].'!',$message,self::$headers2);
			//@mail('3038844083@txt.att.net','Lennys sending error in'.$_SERVER['SERVER_NAME'],$message,self::$headers2);
			@mail('tarek@order140.com','SMS sending error!',$message,self::$headers2);
			//@mail('7208411460@txt.att.net','SMS sending error',$message,self::$headers2);			
			myerror_log("******ERROR********");
			//$last = $client->__getLastRequest();
			myerror_log("error: ".$message);
			//myerror_log($last);
			myerror_log("******ERROR2********");
			return false;
		}
	}

	public static function sendOrder($order_payload)
	{	
		
		$wsdl = self::$wsdl;
		myerror_log("********* Starting Lennys sendOrder ************");
			
		$client = null;
		try {
			myerror_log("about to send order payload to lennys");
			//@mail("adam@order140.com",'XML Lennys',$order_payload,self::$headers2); // code to send the lennys order
			$client = new SoapClient($wsdl, array('trace' => false, 'exceptions'=>true));
			$soapvar = new SoapVar($order_payload, XSD_ANYXML);
			$payload = array('voxmlRequest'=>$soapvar);
			$result = $client->RequestTicket(array('voxmlRequest'=>$soapvar));
			myerror_log($result->RequestTicketResult->any);
			myerror_log("*********************");
			return $result->RequestTicketResult->any;
		} catch (Exception $e) {
			$message = $e->getMessage();
			myerror_log("******ERROR********");
			myerror_log("error: ".$message);
			myerror_log("******ERROR END********");
			if ($message == 'Error Fetching http headers')
				return 'timeout';
			@mail('adam@order140.com','lennys sending error!',$message,self::$headers2);
			//@mail('3038844083@txt.att.net','lennys sending error',$message,self::$headers2);
			//$last = $client->__getLastRequest();
			//myerror_log("error: ".$message);
			//myerror_log($last);
			return false;
		}
	}
	
	static private function emailsmserror($message)
	{
		myerror_log("in the emailsmserror");
		myerror_log($message);
		
		@mail('adam@order140.com','lennys sending error!',$message,self::$headers2);
		//@mail('3038844083@txt.att.net','lennys sending error',$message,self::$headers2);
		@mail('tarek@order140.com','lennys sending error!',$message,self::$headers2);
		@mail('7208411460@txt.att.net','lennys sending error',$message,self::$headers2);			
	}
}
?>