<?php

use Phinx\Migration\AbstractMigration;

class PaymentFramework extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
   	$sqls[] = "CREATE TABLE IF NOT EXISTS `Splickit_Accepted_Payment_Types` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(100) NOT NULL,
  `description` VARCHAR(255) NOT NULL,
  `payment_service` VARCHAR(255) NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `logical_delete` CHAR NOT NULL DEFAULT 'N',
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1000;";
		
   		$sqls[] = "CREATE TABLE IF NOT EXISTS `Vio_Credit_Card_Processors` (
	  `id` int(11) NOT NULL AUTO_INCREMENT,
	  `name` VARCHAR(255) NOT NULL,
	  `desciption` VARCHAR(255) NOT NULL,
	  `splickit_accepted_payment_type_id` int(11) NOT NULL DEFAULT 2000,
	  `external_id` VARCHAR(100) DEFAULT NULL,
	  `parameters` VARCHAR(255) DEFAULT NULL,
	  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
	  `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
	  `logical_delete` CHAR NOT NULL DEFAULT 'N',
	  PRIMARY KEY (`id`),
	  UNIQUE KEY `name` (`name`),
	  CONSTRAINT `fk_MPTM_payment_type_id` FOREIGN KEY (`splickit_accepted_payment_type_id`) REFERENCES `Splickit_Accepted_Payment_Types` (`id`) ON DELETE CASCADE ON UPDATE NO ACTION
	) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1000;";
	    	
		$sqls[] = "CREATE TABLE IF NOT EXISTS `Billing_Entities` (
	  `id` int(11) NOT NULL AUTO_INCREMENT,
	  `vio_credit_card_processor_id` int(11) NOT NULL,
	  `name` VARCHAR(255) NOT NULL,
	  `description` VARCHAR(255) NOT NULL,
	  `brand_id` int(11) NOT NULL,
	  `external_id` VARCHAR(255) NOT NULL,
	  `credentials` VARCHAR(1024) NULL,
	  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
	  `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
	  `logical_delete` CHAR NOT NULL DEFAULT 'N',
	  PRIMARY KEY (`id`)
		) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1000;";
	    	    	
		$sqls[] = "CREATE TABLE IF NOT EXISTS `Merchant_Payment_Type_Maps` (
	  `id` int(11) NOT NULL AUTO_INCREMENT,
	  `merchant_id` int(11) NOT NULL,
	  `splickit_accepted_payment_type_id` int(11) NOT NULL,
	  `billing_entity_id` int(11) NULL,
	  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
	  `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
	  `logical_delete` CHAR NOT NULL DEFAULT 'N',
	  PRIMARY KEY (`id`),
	  KEY (`merchant_id`),
	  UNIQUE KEY `merchant_payment` (`merchant_id`,`splickit_accepted_payment_type_id`),
	  CONSTRAINT `fk_MPTM_merchant_id` FOREIGN KEY (`merchant_id`) REFERENCES `Merchant` (`merchant_id`) ON DELETE CASCADE ON UPDATE NO ACTION,
	  CONSTRAINT `fk_MPTM_billing_entitiy_id` FOREIGN KEY (`billing_entity_id`) REFERENCES `Billing_Entities` (`id`) ON DELETE CASCADE ON UPDATE NO ACTION,
	  CONSTRAINT `fk_MPTM_splickit_accepted_payment_type_id` FOREIGN KEY (`splickit_accepted_payment_type_id`) REFERENCES `Splickit_Accepted_Payment_Types` (`id`) ON DELETE CASCADE ON UPDATE NO ACTION
		) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1000;";

		$sqls[] = "ALTER TABLE `Balance_Change` CHANGE `cc_processor` `cc_processor` VARCHAR(255) NULL;";

		$sqls[] = "INSERT INTO Splickit_Accepted_Payment_Types VALUES (1000,'Cash','Cash','cashpaymentservice',NOW(),NOW(),'N')";
		$sqls[] = "INSERT INTO Splickit_Accepted_Payment_Types VALUES (2000,'Credit Card','Credit Card','viopaymentservice',NOW(),NOW(),'N')";
		$sqls[] = "INSERT INTO Splickit_Accepted_Payment_Types VALUES (3000,'Pit Card','Pit Card','pitcardstoredvaluepaymentservice',NOW(),NOW(),'N')";
		$sqls[] = "INSERT INTO Splickit_Accepted_Payment_Types VALUES (4000,'Boeing Employee Account','Employee Account','boeingemployeeaccountpaymentservice',NOW(),NOW(),'N')";
	 	$sqls[] = "INSERT INTO Vio_Credit_Card_Processors VALUES (2001,'Mercury','Mercury',2000,null,null,NOW(),NOW(),'N')";
		$sqls[] = "INSERT INTO Vio_Credit_Card_Processors VALUES (2002,'Sage','Sage',2000,null,null,NOW(),NOW(),'N')";
		$sqls[] = "INSERT INTO Vio_Credit_Card_Processors VALUES (2003,'Fpn','Fpn',2000,null,null,NOW(),NOW(),'N')";		
		
		foreach ($sqls as $sql)
		{
			$this->execute($sql);
		}
    	
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
		$sqls[] = "DROP TABLE Merchant_Payment_Type_Maps";
		$sqls[] = "DROP TABLE Billing_Entities";
		$sqls[] = "DROP TABLE Vio_Credit_Card_Processors";
		$sqls[] = "DROP TABLE Splickit_Accepted_Payment_Types";
		foreach ($sqls as $sql)
		{
			$this->execute($sql);
		}

    }
}