<?php

use Phinx\Migration\AbstractMigration;

class Cart extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
    	   	$sqls[] = "CREATE TABLE IF NOT EXISTS `Carts` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ucid` varchar(255) NOT NULL,
  `user_id` int(11) NOT NULL,
  `order_id` int(11) NULL,
  `stamps` VARCHAR(255) NOT NULL,
  `status` enum('A','E','X') NOT NULL DEFAULT 'A',
  `submitted_date_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `logical_delete` CHAR NOT NULL DEFAULT 'N',
  PRIMARY KEY (`id`),
  UNIQUE KEY `ucid` (`ucid`),
  UNIQUE KEY `order_id` (`order_id`),
  CONSTRAINT `fk_Carts_order_id` FOREIGN KEY (`order_id`) REFERENCES `Orders` (`order_id`) ON DELETE CASCADE ON UPDATE NO ACTION,
  CONSTRAINT `fk_Carts_user_id` FOREIGN KEY (`user_id`) REFERENCES `User` (`user_id`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1000;";

    	foreach ($sqls as $sql)
		{
			$this->execute($sql);
		}
    	
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
		$sql = "DROP TABLE Carts";
		$this->execute($sql);
    }
}