<?php

use Phinx\Migration\AbstractMigration;

class StatsRecord extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
		$sql = "CREATE TABLE IF NOT EXISTS `brand_stats_email_weekly_record` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `brand_id` int(11) NOT NULL,
			  `for_week_ending` date NOT NULL,
			  `data_as_json` TEXT NOT NULL,
			  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
			  `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
			  `logical_delete` CHAR NOT NULL DEFAULT 'N',
			  PRIMARY KEY (`id`),
			  KEY (`brand_id`),
			  CONSTRAINT `fk_bsewr_brand_id` FOREIGN KEY (`brand_id`) REFERENCES `Brand2` (`brand_id`) ON DELETE CASCADE ON UPDATE NO ACTION
			) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1000;";

		$this->execute($sql);
		
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
		$sql = "DROP TABLE brand_stats_email_weekly_record";
		$this->execute($sql);
		
    }
}