<?php

use Phinx\Migration\AbstractMigration;

class TokenAuth extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
		$sql = "CREATE TABLE IF NOT EXISTS `Token_Authentications` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `user_id` int(11) NOT NULL,
			  `token` VARCHAR(255) NOT NULL,
			  `expires_at` int(11) NOT NULL,
			  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
			  `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
			  `logical_delete` CHAR NOT NULL DEFAULT 'N',
			  PRIMARY KEY (`id`),
			  KEY (`user_id`),
			  UNIQUE KEY (`token`),
			  KEY (`expires_at`),
			  CONSTRAINT `fk_ta_user_id` FOREIGN KEY (`user_id`) REFERENCES `User` (`user_id`) ON DELETE CASCADE ON UPDATE NO ACTION
			) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1000;";

		$this->execute($sql);
		
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
		$sql = "DROP TABLE Token_Authentications";
		$this->execute($sql);
		
    }
}