<?php

use Phinx\Migration\AbstractMigration;

class CreateTaskRetailMapTable extends AbstractMigration
{

    
    /**
     * Migrate Up.
     */
    public function up()
    {
      $sql = "CREATE TABLE IF NOT EXISTS `Merchant_TaskRetail_Info_Maps` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `merchant_id` int(11) NOT NULL,
  `brand_id` int(11) NOT NULL,
  `location` varchar(100) NOT NULL,
  `created` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `logical_delete` char(1) NOT NULL DEFAULT 'N',
  PRIMARY KEY (`id`),
  UNIQUE KEY `merchant_id` (`merchant_id`),
  KEY `fk_MTRIM_brand_id` (`brand_id`),
  CONSTRAINT `fk_MTRIM_merchant_id` FOREIGN KEY (`merchant_id`) REFERENCES `Merchant` (`merchant_id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_MTRIM_brand_id` FOREIGN KEY (`brand_id`) REFERENCES `Brand2` (`brand_id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=102 DEFAULT CHARSET=utf8 DELAY_KEY_WRITE=1 COMMENT='To maintain Task Retail Location ID'";
          
      $this->execute($sql);
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
      $this->dropTable("Merchant_TaskRetail_Info_Maps");
    }
}