<?php

use Phinx\Migration\AbstractMigration;

class CreateBrandEarnedPointsObjectMaps extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $sql = "CREATE TABLE `Brand_Earned_Points_Object_Maps` (
              `id` int(11) NOT NULL AUTO_INCREMENT,
              `brand_id` int(11) NOT NULL,
              `points` int(11) NOT NULL,
              `object_type` varchar(255) NOT NULL,
              `object_id` int(11) NOT NULL,
              `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
              `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
              `logical_delete` char(1) NOT NULL DEFAULT 'N',
              PRIMARY KEY (`id`),
              UNIQUE KEY `brand_earned_point_id` (`brand_id`,`object_type`,`object_id`),
              CONSTRAINT `fk_BEPOM_brand_id_earned_points` FOREIGN KEY (`brand_id`) REFERENCES `Brand2` (`brand_id`) ON DELETE NO ACTION ON UPDATE NO ACTION
            ) ENGINE=InnoDB AUTO_INCREMENT=1000 DEFAULT CHARSET=utf8;";
        $this->execute($sql);
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $this->dropTable("Brand_Earned_Points_Object_Maps");
    }
}