<?php

use Phinx\Migration\AbstractMigration;

class AddUserPrivilegeFields extends AbstractMigration
{    
    /**
     * Migrate Up.
     */
    public function up() {
      $table = $this->table('User');
      $table->addColumn('caching_action', 'string', array('default' => 'respect'))
            ->addColumn('ordering_action', 'string', array('default' => 'send'))
            ->addColumn('send_emails', 'boolean', array('default' => true))
            ->addColumn('see_inactive_merchants', 'boolean', array('default' => false))
            ->save();
    }

    /**
     * Migrate Down.
     */
    public function down() {
      $table = $this->table('User');
      $table->removeColumn('caching_action')
            ->removeColumn('ordering_action')
            ->removeColumn('send_emails')
            ->removeColumn('see_inactive_merchants')
            ->save();
    }
}