<?php

use Phinx\Migration\AbstractMigration;
use Phinx\Migration\IrreversibleMigrationException;

class DeleteFavoritesFromInactiveUsers extends AbstractMigration
{   
    /**
     * Migrate Up.
     */
    public function up()
    {
      // need the tmp table and index because otherwise the delete takes too long to process. 
      $this->execute("create table tmp_users_not_active as select user_id from (select user_id, max(order_dt_tm) from Orders group by user_id having max(order_dt_tm) < (date_sub(now(), INTERVAL 3 MONTH))) as x");
      $this->execute("create index idx_tmp_users_not_active_user_id on tmp_users_not_active(user_id)");      

      $this->execute("delete from Favorite where user_id in (select user_id from tmp_users_not_active)");
      $this->execute("drop table tmp_users_not_active");
    }

    /**
     * Migrate Down.
     */
    public function down() {
      throw new IrreversibleMigrationException("Can't undelete these old favorites.");
    }
}