<?php

use Phinx\Migration\AbstractMigration;

class HoleHours extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
     * public function change()
     * {
     * }
     */

    /**
     * Migrate Up.
     */
    public function up()
    {
        $sql = "CREATE TABLE IF NOT EXISTS Hole_Hours (
                `id` INT(11) NOT NULL AUTO_INCREMENT,
                `merchant_id` INT(11) NOT NULL,
                `day_of_week` TINYINT NOT NULL,
                `order_type` ENUM('Pickup', 'Delivery') NOT NULL,
                `start_time` TIME NOT NULL,
                `end_time` TIME NOT NULL,
                `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
			    `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
			    `logical_delete` CHAR NOT NULL DEFAULT 'N',
                 PRIMARY KEY (`id`),
                 CONSTRAINT `fk_hole_hours_merchant_id` FOREIGN KEY (`merchant_id`) REFERENCES `Merchant` (`merchant_id`) ON DELETE CASCADE ON UPDATE NO ACTION)
			     ENGINE=InnoDB DEFAULT CHARSET=latin1;";
        $this->execute($sql);
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $sql = "DROP TABLE Hole_Hours";
        $this->execute($sql);
    }
}