<?php

use Phinx\Migration\AbstractMigration;

class CreatePromoType4ItemAmountMap extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $sql = "CREATE TABLE IF NOT EXISTS `Promo_Type4_Item_Amount_Maps` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `promo_id` int(11) NOT NULL,
			  `qualifying_object` varchar(20) NOT NULL,
			  `fixed_amount_off` decimal(10,2) NOT NULL DEFAULT 0.00,
              `percent_off` int(11) NOT NULL DEFAULT 0,
              `fixed_price` decimal(10,2) NULL,
              `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
			  `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
			  `logical_delete` CHAR NOT NULL DEFAULT 'N',
			  PRIMARY KEY (`id`),
			  UNIQUE KEY (`promo_id`),
			  CONSTRAINT `fk_type4_promo_id` FOREIGN KEY (`promo_id`) REFERENCES `Promo` (`promo_id`) ON DELETE CASCADE ON UPDATE NO ACTION
			) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1000;";

        $this->execute($sql);
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $sql = "DROP TABLE Promo_Type4_Item_Amount_Maps";
        $this->execute($sql);

    }
}