<?php

use Phinx\Migration\AbstractMigration;

class CreateMerchantFoundryInfoMaps extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $sql = "CREATE TABLE IF NOT EXISTS `Merchant_Foundry_Info_Maps` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `merchant_id` int(11) NOT NULL,
			  `foundry_store_id` VARCHAR(255),
			  `get_menu` boolean DEFAULT false,
			  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
			  `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
			  `logical_delete` CHAR NOT NULL DEFAULT 'N',
			  PRIMARY KEY (`id`),
			  UNIQUE KEY (`merchant_id`),
			  CONSTRAINT `fk_foundry_merchant_id` FOREIGN KEY (`merchant_id`) REFERENCES `Merchant` (`merchant_id`) ON DELETE CASCADE ON UPDATE NO ACTION
			) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1000;";

        $this->execute($sql);
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $sql = "DROP TABLE Merchant_Foundry_Info_Maps";
        $this->execute($sql);

    }
}