<?php

use Phinx\Migration\AbstractMigration;

class CreateAdmDma extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $sql = "CREATE TABLE IF NOT EXISTS `adm_dma` (
               `id`           INT(11) NOT NULL AUTO_INCREMENT,
               `city`            VARCHAR(48),
               `criteria_id`     INT(7),
               `state`           VARCHAR(20),
               `st`              CHAR(2) NOT NULL,
               `dma_region_code` INT(3),
               `created`         timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
               `modified`        timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
               `logical_delete`  CHAR NOT NULL DEFAULT 'N',
             PRIMARY KEY (`id`),
             INDEX (`dma_region_code`),
             CONSTRAINT `fk_dma_region_code` FOREIGN KEY (`dma_region_code`) REFERENCES `adm_dma_codes` (`dma_region_code`) ON DELETE CASCADE ON UPDATE NO ACTION,
             KEY `state` (`state`),
             KEY `st` (`st`),
             KEY `city` (`city`),
             CONSTRAINT `fk_region_code` FOREIGN KEY `adm_dma`(`dma_region_code`) REFERENCES `adm_dma_codes`(`dma_region_code`) ON DELETE NO ACTION ON UPDATE NO ACTION)
             ENGINE=InnoDB AUTO_INCREMENT=1000 DEFAULT CHARSET=utf8;";
        $this->execute($sql);
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $sql = "DROP TABLE adm_dma";
        $this->execute($sql);
    }
}