<?php

use Phinx\Migration\AbstractMigration;

class CreateGroupOrderIndividualOrderMaps extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $sql = "CREATE TABLE `Group_Order_Individual_Order_Maps` (
          `id` int(11) NOT NULL AUTO_INCREMENT,
          `group_order_id` INT(11) NOT NULL,
          `user_order_id` INT(11) NOT NULL,
          `status` VARCHAR(255),
          `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
          `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
          `logical_delete` CHAR (1) NOT NULL DEFAULT 'N',
          PRIMARY KEY (`id`),
          KEY (`group_order_id`),
          KEY (`user_order_id`),
		  CONSTRAINT `fk_group_order_id` FOREIGN KEY (`group_order_id`) REFERENCES `Group_Order` (`group_order_id`) ON DELETE CASCADE ON UPDATE NO ACTION,
		  CONSTRAINT `fk_user_order_id` FOREIGN KEY (`user_order_id`) REFERENCES `Orders` (`order_id`) ON DELETE CASCADE ON UPDATE NO ACTION
        ) ENGINE=InnoDB AUTO_INCREMENT=1000 DEFAULT CHARSET=utf8 COMMENT='Will be used for ALL group orders';";

        $this->execute($sql);

    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $sql = "DROP TABLE Group_Order_Individual_Order_Maps";
        $this->execute($sql);
    }
}