<?php

use Phinx\Migration\AbstractMigration;

class AddFieldsToBrandLoyaltyRules extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('Brand_Loyalty_Rules');
        $table->addColumn('loyalty_type','enum',array("values"=>"remote,remote_lite,splickit_points,splickit_cliff,splickit_earn,splickit_punchcard","after"=>'brand_id'))
            ->addColumn('earn_value_amount_multiplier', 'integer', array('after'=>'loyalty_type','default' => 10))
            ->addColumn('cliff_value','integer',array('after'=>'earn_value_amount_multiplier','default'=>0))
            ->save();
        
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $table = $this->table('Brand_Loyalty_Rules');
        $table->removeColumn('cliff_value')
            ->removeColumn('earn_value_amount_multiplier')
            ->removeColumn('loyalty_type')
            ->save();
    }
}