<?php

use Phinx\Migration\AbstractMigration;

class CreateLoyaltyParkingLot extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $sql = "CREATE TABLE IF NOT EXISTS `Loyalty_Parking_Lot_Records` (
			  `id` int(11) NOT NULL AUTO_INCREMENT,
			  `brand_id` int(11) NOT NULL,
			  `phone_number` VARCHAR(100),
			  `email` VARCHAR(255),
			  `remote_order_number` INT (11),
			  `amount` decimal(10,2) NOT NULL DEFAULT 0.00,
			  `process` VARCHAR(255),
			  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
			  `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
			  PRIMARY KEY (`id`),
			  CONSTRAINT `fk_loyalty_brand_id` FOREIGN KEY (`brand_id`) REFERENCES `Brand2` (`brand_id`) ON DELETE CASCADE ON UPDATE NO ACTION
			) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1000;";

        $this->execute($sql);

    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $sql = "DROP TABLE Loyalty_Parking_Lot_Records";
        $this->execute($sql);
    }
}