<?php

use Phinx\Migration\AbstractMigration;

class CreateMerchantEmagineInfoMaps extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('Merchant_Emagine_Info_Maps');
        $table->addColumn('merchant_id','integer')
            ->addColumn('location','string', array('limit'=> 50))
            ->addColumn('token','string', array('limit'=>255))
            ->addColumn('logical_delete','string', array('limit' => 1,'default' => 'N'))
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addForeignKey('merchant_id', 'Merchant', 'merchant_id', array('delete'=> 'CASCADE', 'update'=> 'NO_ACTION'));

        $table->save();

        $sql = "ALTER TABLE `Merchant_Emagine_Info_Maps` AUTO_INCREMENT = 1000;";
        $this->execute($sql);

    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $this->dropTable('Merchant_Emagine_Info_Maps');
    }
}