<?php

use Phinx\Migration\AbstractMigration;

class CreateBehaviorAwardTypes extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('Loyalty_Award_Brand_Trigger_Amounts');

        $table->addColumn('brand_id','integer')
            ->addColumn('loyalty_award_trigger_type_id','integer')
            ->addColumn('trigger_value','string')
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','string', array('limit' => 1,'default' => 'N'))
            ->addForeignKey('brand_id', 'Brand2', 'brand_id', array('delete'=> 'CASCADE', 'update'=> 'NO_ACTION'))
            ->addForeignKey('loyalty_award_trigger_type_id', 'Loyalty_Award_Trigger_Types', 'id', array('delete'=> 'CASCADE', 'update'=> 'NO_ACTION'));

        $table->save();

        $sql = "ALTER TABLE `Loyalty_Award_Brand_Trigger_Amounts` AUTO_INCREMENT = 1000;";
        $this->execute($sql);
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $sql = "DROP TABLE Loyalty_Award_Brand_Trigger_Amounts";
        $this->execute($sql);
    }
}