<?php

use Phinx\Migration\AbstractMigration;

class CreateBrandLoyaltyBehaviorAwardMaps extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('Loyalty_Brand_Behavior_Award_Amount_Maps');

        $table->addColumn('brand_id','integer')
            ->addColumn('loyalty_award_brand_trigger_amounts_id','integer')
            ->addColumn('process_type', 'enum', array('values' => array('fixed','percent','multiplier','free_item')))
            ->addColumn('value','integer')
            ->addColumn('active','boolean',array("default"=>true))
            ->addColumn('first_date_available','timestamp', array('default' => '2000-01-01'))
            ->addColumn('last_date_available','timestamp', array('default' => '2025-01-01'))
            ->addColumn('history_label','string', array('limit' => 50))
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','string', array('limit' => 1,'default' => 'N'))
            ->addForeignKey('brand_id', 'Brand2', 'brand_id', array('delete'=> 'CASCADE', 'update'=> 'NO_ACTION'))
            ->addForeignKey('loyalty_award_brand_trigger_amounts_id', 'Loyalty_Award_Brand_Trigger_Amounts', 'id', array('delete'=> 'CASCADE', 'update'=> 'NO_ACTION'));

        $table->save();

        $sql = "ALTER TABLE `Loyalty_Brand_Behavior_Award_Amount_Maps` AUTO_INCREMENT = 1000;";
        $this->execute($sql);

    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $sql = "DROP TABLE Loyalty_Brand_Behavior_Award_Amount_Maps";
        $this->execute($sql);
    }
}