<?php

use Phinx\Migration\AbstractMigration;

class CreateTablePromoDeliveryAmoutMap extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('Promo_Delivery_Amount_Map');
        $table->addColumn('promo_id','integer')
            ->addColumn('percent_off','decimal', array('precision' => 10, 'scale' => 2, 'default' => 0.00))
            ->addColumn('fixed_off','decimal', array('precision' => 10, 'scale' => 2, 'null' => true))
            ->addColumn('logical_delete','string', array('limit' => 1,'default' => 'N'))
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addForeignKey('promo_id', 'Promo', 'promo_id', array('delete'=> 'CASCADE', 'update'=> 'NO_ACTION'));
        $table->save();

        $sql = "ALTER TABLE `Promo_Delivery_Amount_Map` AUTO_INCREMENT = 1000;";
        $this->execute($sql);
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $this->dropTable('Promo_Delivery_Amount_Map');
    }
}