<?php

use Phinx\Migration\AbstractMigration;

class AddSmawStoreProcedureForPromoType300Generator extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $this->execute("DROP PROCEDURE IF EXISTS `SMAWSP_adm_PromoType300Generator`;");
        $this->execute("
        CREATE DEFINER=`itsquik`@`%` PROCEDURE `SMAWSP_adm_PromoType300Generator`(
          IN key_word VARCHAR(20),
          IN description VARCHAR(255),
          IN start_date VARCHAR(20),
          IN end_date VARCHAR(20),
          IN fixed_off DECIMAL(10,2),
          IN percent_off DECIMAL(10,2),
          IN merchants VARCHAR(1024)
        )
        BEGIN
          DECLARE v_merchant_id INT(11) DEFAULT  98098098098;
          DECLARE v_key_word VARCHAR(100);
        
          DECLARE record_not_found INTEGER DEFAULT 0;
          DECLARE num_rows INT DEFAULT 0;
        
          DECLARE idstring VARCHAR(10);
          DECLARE testifdonestring VARCHAR(1000);
          DECLARE sepcnt INT(11) ;
        
          DECLARE cur_locations CURSOR FOR
            SELECT DISTINCT TRIM(M.merchant_id)  AS merchant_id
            FROM Merchant M
            WHERE M.merchant_id IN ( SELECT merchant_id FROM temptbl_Merchants );
        
          DECLARE cur_keywords CURSOR FOR
            SELECT keyword FROM temptbl_Keywords;
        
          DECLARE CONTINUE HANDLER FOR NOT FOUND SET record_not_found = 1;
        
          SET @z_key_word:= (SELECT CAST(UNIX_TIMESTAMP(NOW()) AS CHAR) FROM DUAL);
          SET @x_description:= description;
          SET @x_start_date:= start_date;
          SET @x_end_date:= end_date;
          SET @x_percent_off:= percent_off;
          SET @x_fixed_off:= fixed_off;
        
          INSERT INTO Errors VALUES (null,'LOOPING the SMAWSP_adm_PromoType300Generator',CONCAT(' merchant_id: ', merchants),CONCAT('objects DE-record_not_found: '),NULL,now());
        
          SET @sql:=CONCAT('INSERT INTO Promo(promo_key_word, description, promo_type, payor_merchant_user_id, start_date, end_date, max_use, show_in_app, created) VALUES ( ? , ?, 300, 2, ?, ?, 0, \"N\", \"',NOW(),'\")');
          INSERT INTO Errors VALUES (null,'LOOPING the SMAWSP_adm_PromoType300Generator',CONCAT(''),CONCAT('@sql: ',@sql),NULL,now());
        
          PREPARE table_target_insert FROM @sql;
          EXECUTE table_target_insert USING @z_key_word, @x_description, @x_start_date, @x_end_date;
          DEALLOCATE PREPARE table_target_insert ;
        
          SET @v_promo_id:= (SELECT MAX(promo_id) FROM Promo);
        
          SET @sql:='INSERT INTO Promo_Delivery_Amount_Map(promo_id, percent_off, fixed_off) VALUES (?, ?, ? )';
          INSERT INTO Errors VALUES (null,'LOOPING the SMAWSP_adm_PromoType300Generator',CONCAT(''),CONCAT('@sql: ',@sql),NULL,now());
        
          PREPARE table_target_insert FROM @sql;
          EXECUTE table_target_insert USING @v_promo_id, @x_percent_off, @x_fixed_off;
          DEALLOCATE PREPARE table_target_insert ;
        
          SET @sql:='INSERT INTO Promo_Message_Map(promo_id, message1, message2) VALUES(?, \"Congratulations! You''re getting %%mount%% discount on delivery order!\", \"Congratulations! You''re getting free delivery!\")';
          INSERT INTO Errors VALUES (null,'LOOPING the SMAWSP_adm_PromoType300Generator',CONCAT(''),CONCAT('@sql: ',@sql),NULL,now());
        
          PREPARE table_target_insert FROM @sql;
          EXECUTE table_target_insert USING @v_promo_id;
          DEALLOCATE PREPARE table_target_insert ;
        
          DROP TABLE IF EXISTS temptbl_Merchants;
          CREATE TABLE temptbl_Merchants (merchant_id int);
          SET sepcnt=1;
        
          parse_merchants: LOOP
            SET @current_merchant_id:= ( SELECT trim(SUBSTRING_INDEX(SUBSTRING_INDEX(merchants,',', sepcnt),',',-1)) );
            INSERT INTO Errors VALUES (null,'SMAWSP_adm_PromoType300Generator ',CONCAT('idstring',@current_merchant_id),CONCAT(''),NULL,now());
            INSERT INTO temptbl_Merchants (merchant_id) values (@current_merchant_id);
            SET testifdonestring = ( SELECT TRIM(SUBSTRING_INDEX(SUBSTRING_INDEX(merchants,',', sepcnt),',', -sepcnt)) );
            INSERT INTO Errors VALUES (null,'SMAWSP_adm_PromoType300Generator ',CONCAT('testifdonestring',testifdonestring),CONCAT(''),NULL,now());
        
            IF TRIM(merchants) = TRIM(testifdonestring) THEN
              LEAVE parse_merchants;
            END IF;
        
            SET sepcnt= sepcnt + 1;
            INSERT INTO Errors VALUES (null,' SMAWSP_adm_PromoType300Generator',CONCAT('sepcnt',sepcnt),CONCAT(''),NULL,now());
          END LOOP parse_merchants;
        
          SET record_not_found := 0;
        
          OPEN cur_locations;
        
          SELECT found_rows() INTO num_rows;
        
          SET @sql:='INSERT INTO Promo_Merchant_Map(promo_id, merchant_id, start_date, end_date, max_discount_per_order) VALUES ( ?, ?, ?, ?, 0.00)';
          PREPARE table_target_insert FROM @sql;
          map_promo_merchant: LOOP
            FETCH  cur_locations INTO v_merchant_id;
            SET @x_merchant_id = v_merchant_id;
            INSERT INTO Errors VALUES (null,'STARTING LOOPING the SMAWSP_adm_PromoType300Generator',CONCAT('Start Loop'),CONCAT('Merchant: ',v_merchant_id,' num_rows: ',num_rows),NULL,now());
        
            IF record_not_found THEN
              CLOSE cur_locations;
              INSERT INTO Errors VALUES (null,'ENDING LOOPING the SMAWSP_adm_PromoType300Generator',CONCAT('Exit Loop '),CONCAT('Merchant: ',v_merchant_id),NULL,now());
              LEAVE map_promo_merchant;
            END IF;
        
            INSERT INTO Errors VALUES (null,'START LOOPING the SMAWSP_adm_PromoType300Generator',CONCAT('records found: ',record_not_found),CONCAT(''),NULL,now());
        
            EXECUTE table_target_insert USING @v_promo_id, @x_merchant_id, @x_start_date, @x_end_date;
        
          END LOOP map_promo_merchant ;
          DEALLOCATE PREPARE table_target_insert;
          DROP TABLE IF EXISTS temptbl_Merchants;
        
          DROP TABLE IF EXISTS temptbl_Keywords;
          INSERT INTO Errors VALUES (null,'SMAWSP_adm_PromoType300Generator',CONCAT('x_key_word: ',key_word),CONCAT(''),NULL,now());
        
          CREATE TABLE temptbl_Keywords (keyword VARCHAR(50));
          SET sepcnt=1;
          parse_keywords: LOOP
            SET @current_keyword:= ( SELECT trim(SUBSTRING_INDEX(SUBSTRING_INDEX(key_word,',', sepcnt),',',-1)) );
            INSERT INTO temptbl_Keywords (keyword) values (@current_keyword);
            INSERT INTO Errors VALUES (null,' SMAWSP_adm_PromoType300Generator',CONCAT('idstring',@current_keyword),CONCAT(''),NULL,now());
        
            SET testifdonestring = ( SELECT TRIM(SUBSTRING_INDEX(SUBSTRING_INDEX(key_word,',', sepcnt),',', -sepcnt)) );
            INSERT INTO Errors VALUES (null,'SMAWSP_adm_PromoType300Generator',CONCAT('testifdonestring',testifdonestring),CONCAT(''),NULL,now());
        
            IF TRIM(key_word) = TRIM(testifdonestring) THEN
              LEAVE parse_keywords;
            END IF;
        
            SET sepcnt= sepcnt + 1;
          END LOOP parse_keywords;
        
          SET record_not_found := 0;
        
          OPEN cur_keywords;
          SELECT found_rows() INTO num_rows;
          SET @sql:=CONCAT('INSERT INTO Promo_Key_Word_Map(promo_id, promo_key_word, brand_id, modified) VALUES (?, ?, 0, \"',NOW(),'\")');
          PREPARE table_target_insert FROM @sql;
        
          register_keywords: LOOP
            FETCH  cur_keywords INTO v_key_word;
            SET @x_key_word = v_key_word;
            INSERT INTO Errors VALUES (null,'STARTING LOOPING the SMAWSP_adm_PromoType300Generator',CONCAT('Start Loop'),CONCAT('Key Word: ',v_key_word,' num_rows: ',num_rows),NULL,now());
        
            IF record_not_found THEN
              CLOSE cur_keywords;
              INSERT INTO Errors VALUES (null,'ENDING LOOPING the SMAWSP_adm_PromoType300Generator',CONCAT('Exit Loop '),CONCAT('Key Word: ',v_key_word),NULL,now());
              LEAVE register_keywords;
            END IF;
        
            INSERT INTO Errors VALUES (null,'START LOOPING the SMAWSP_adm_PromoType300Generator',CONCAT('records found: ',record_not_found),CONCAT(''),NULL,now());
        
            EXECUTE table_target_insert USING @v_promo_id, @x_key_word;
          END LOOP register_keywords ;
          DEALLOCATE PREPARE table_target_insert ;
        
          DROP TABLE IF EXISTS temptbl_Keywords;
        
          INSERT INTO Errors VALUES (null,'END LOOPING the SMAWSP_adm_PromoType300Generator',CONCAT('merchant_id ', 'NULL'),CONCAT('objects mlrl: '),NULL,now());
        END
        ");
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $this->execute("DROP PROCEDURE IF EXISTS `SMAWSP_adm_PromoType300Generator`;");
    }
}