<?php

use Phinx\Migration\AbstractMigration;

class CreateCateringOrdersTable extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('Catering_Orders');

        $table->addColumn('number_of_people','integer')
            ->addColumn('event','string')
            ->addColumn('order_type', 'enum', array('values' => array('delivery','pickup'),'default'=>'pickup'))
            ->addColumn('order_id','integer')
            ->addColumn('user_delivery_location_id','integer',array('null' => true))
            ->addColumn('date_tm_of_event','datetime',array('null' => true))
            ->addColumn('timestamp_of_event','integer',array('null' => true))
            ->addColumn('contact_info','string')
            ->addColumn('notes','string',array('null' => true))
            ->addColumn('status','enum',array("values" => array('In Progress','Submitted','Completed','Cancelled'),"default"=>'In Progress'))
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','string', array('limit' => 1,'default' => 'N'))
            ->addForeignKey('order_id', 'Orders', 'order_id', array('delete'=> 'CASCADE', 'update'=> 'NO_ACTION'))
            ->addForeignKey('user_delivery_location_id', 'User_Delivery_Location', 'user_addr_id', array('delete'=> 'CASCADE', 'update'=> 'NO_ACTION'));

        $table->save();

        $sql = "ALTER TABLE `Catering_Orders` AUTO_INCREMENT = 1000;";
        $this->execute($sql);
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $sql = "DROP TABLE Catering_Orders";
        $this->execute($sql);
    }
}