<?php

use Phinx\Migration\AbstractMigration;

class CreateMerchantCateringInfosTable extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {

        $table = $this->table('Merchant_Catering_Infos');

        $table->addColumn('merchant_id','integer')
            ->addColumn('minimum_pickup_amount','decimal', array('precision' => 10, 'scale' => 2, 'default' => 0.00))
            ->addColumn('minimum_delivery_amount','decimal', array('precision' => 10, 'scale' => 2, 'default' => 0.00))
            ->addColumn('minimum_tip_percent','integer')
            ->addColumn('lead_time_in_hours', 'integer')
            ->addColumn('min_lead_time_in_hours_from_open_time', 'integer', array("default"=>2))
            ->addColumn('maximum_number_of_catering_orders_per_day_part','integer',array('default' => 10))
            ->addColumn('max_days_out','integer',array("default"=>7))
            ->addColumn('accepted_payment_types','enum', array('values' => array('Credit Card Only','Cash Or Credit Card','All'),"default"=>'All'))
            ->addColumn('allow_loyalty', "boolean", array('default' => false))
            ->addColumn('special_merchant_message_destination','string',array('null' => true))
            ->addColumn('special_merchant_message_format','string',array('null' => true))
            ->addColumn('catering_message_to_user_on_create_order','text')
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','string', array('limit' => 1,'default' => 'N'))
            ->addForeignKey('merchant_id', 'Merchant', 'merchant_id', array('delete'=> 'CASCADE', 'update'=> 'NO_ACTION'));

        $table->save();

        $sql = "ALTER TABLE `Merchant_Catering_Infos` AUTO_INCREMENT = 1000;";
        $this->execute($sql);

    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $sql = "DROP TABLE Merchant_Catering_Infos";
        $this->execute($sql);
    }
}