<?php

use Phinx\Migration\AbstractMigration;

class RemoveMerchantIdIndexOnMerchantDeliveryPriceDistance extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('Merchant_Delivery_Price_Distance');
        $table->removeIndexByName('merch_dist')
            ->removeIndexByName('merch_dist_up_to')
            ->save();
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $table = $this->table('Merchant_Delivery_Price_Distance');
        $table->addIndex(array('merchant_id','distance_up_to'),array("unique"=>true,"name"=>'merch_dist_up_to'));
        $table->save();
    }
}