<?php

use Phinx\Migration\AbstractMigration;

class AddUniqueIndexToUserDeliveryLocationMerchantPriceMaps extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('User_Delivery_Location_Merchant_Price_Maps');
        $table->addIndex(array('merchant_id'),array("unique"=>false));
        $table->addIndex(array('user_delivery_location_id'),array("unique"=>false));
        $table->addIndex(array("user_delivery_location_id","merchant_id","delivery_type"),array("unique"=>true,"name"=>'user_location_merchant_delivery_type'));
        $table->save();
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $table = $this->table('User_Delivery_Location_Merchant_Price_Maps');
        $table->removeIndexByName('user_location_merchant_delivery_type');
        $table->removeIndex('user_delivery_location_id');
        $table->removeIndex('merchant_id');
        $table->save();
    }
}