<?php

use Phinx\Migration\AbstractMigration;

class CreateNutritionInfos extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('Nutrition_Item_Size_Infos');
        $table->addColumn('item_id','integer')
            ->addColumn('size_id','integer')
            ->addColumn('serving_size','integer')
            ->addColumn('calories','integer')
            ->addColumn('calories_from_fat','integer')
            ->addColumn('total_fat','decimal', array('precision' => 10, 'scale' => 2))
            ->addColumn('saturated_fat','decimal', array('precision' => 10, 'scale' => 2))
            ->addColumn('trans_fat','decimal', array('precision' => 10, 'scale' => 2))
            ->addColumn('cholesterol','decimal', array('precision' => 10, 'scale' => 2))
            ->addColumn('sodium','decimal', array('precision' => 10, 'scale' => 2))
            ->addColumn('total_carbohydrates','decimal', array('precision' => 10, 'scale' => 2))
            ->addColumn('dietary_fiber','decimal', array('precision' => 10, 'scale' => 2))
            ->addColumn('sugars','decimal', array('precision' => 10, 'scale' => 2))
            ->addColumn('protein','decimal', array('precision' => 10, 'scale' => 2))
            ->addForeignKey('item_id', 'Item', 'item_id')
            ->addForeignKey('size_id', 'Sizes', 'size_id');
        $table->save();
        $sql = "ALTER TABLE `Nutrition_Item_Size_Infos` AUTO_INCREMENT = 1000;";
        $this->execute($sql);
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $this->dropTable('Nutrition_Item_Size_Infos');
    }
}