<?php

use Phinx\Migration\AbstractMigration;

class ModifyNutritionInfoSetFieldsToNullable extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('Nutrition_Item_Size_Infos');
        $table->changeColumn('calories','integer',array('null'=>true))
            ->changeColumn('calories_from_fat','integer',array('null'=>true))
            ->changeColumn('total_fat','decimal', array('precision' => 10, 'scale' => 2, 'null'=>true))
            ->changeColumn('saturated_fat','decimal', array('precision' => 10, 'scale' => 2, 'null'=>true))
            ->changeColumn('trans_fat','decimal', array('precision' => 10, 'scale' => 2, 'null'=>true))
            ->changeColumn('cholesterol','decimal', array('precision' => 10, 'scale' => 2, 'null'=>true))
            ->changeColumn('sodium','decimal', array('precision' => 10, 'scale' => 2, 'null'=>true))
            ->changeColumn('total_carbohydrates','decimal', array('precision' => 10, 'scale' => 2, 'null'=>true))
            ->changeColumn('dietary_fiber','decimal', array('precision' => 10, 'scale' => 2, 'null'=>true))
            ->changeColumn('sugars','decimal', array('precision' => 10, 'scale' => 2, 'null'=>true))
            ->changeColumn('protein','decimal', array('precision' => 10, 'scale' => 2, 'null'=>true))
            ->save();
            
    }

    /**
     * Migrate Down.
     */
    public function down()
    {

    }
}