<?php

use Phinx\Migration\AbstractMigration;

class CreateLeadTimeByDayPartMaps extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('Lead_Time_By_Day_Part_Maps');
        $table->addColumn('merchant_id','integer')
            ->addColumn('hour_type','string',array('default' => 'R'))
            ->addColumn('day_of_week', 'enum', array('values' => array(1,2,3,4,5,6,7)))
            ->addColumn('start_time','time')
            ->addColumn('end_time','time')
            ->addColumn('lead_time','integer')
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','string', array('limit' => 1,'default' => 'N'))
            ->addForeignKey('merchant_id', 'Merchant', 'merchant_id', array('delete'=> 'CASCADE', 'update'=> 'NO_ACTION'));

        $table->save();
        $sql = "ALTER TABLE `Lead_Time_By_Day_Part_Maps` AUTO_INCREMENT = 1000;";
        $this->execute($sql);
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $this->dropTable('Lead_Time_By_Day_Part_Maps');
    }
}