<?php

use Phinx\Migration\AbstractMigration;

class AddIndexToDeviceCallInHistory extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table("device_call_in_history");
        $table->addIndex("last_call_in_as_integer",array("name"=>"dcih_last_call_in_as_integer"))
            ->addForeignKey("merchant_id","Merchant", array("merchant_id"), array("delete" => "CASCADE"))
        ->save();
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $table = $this->table("device_call_in_history");
        $table->dropForeignKey("merchant_id")
            ->removeIndexByName("last_call_in_as_integer")
            ->save();
    }
}