<?php

use Phinx\Migration\AbstractMigration;

class CreatePortalAudits extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('audits');
        $table->addColumn('auditable_type', 'string', ['limit' => 255])
            ->addColumn('ip_address', 'string', ['limit' => 45])
            ->addColumn('event', 'string', ['limit' => 255])
            ->addColumn('auditable_id', 'integer')
            ->addColumn('user_id', 'integer')
            ->addColumn('old_values', 'text')
            ->addColumn('new_values', 'text')
            ->addColumn('url', 'text')
            ->addColumn('user_agent', 'string', ['limit' => 255])
            ->addColumn('tags', 'string', ['limit' => 255])
            ->addColumn('created_at', 'timestamp', ['null'=> 'true'])
            ->addColumn('updated_at', 'timestamp', ['null'=> 'true'])
            ->addIndex(['id'])
            ->addIndex(['auditable_id'])
            ->addIndex(['auditable_type'])
            ->addIndex(['tags'])
            ->addIndex(['user_id'])
            ->save();
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $this->dropTable('audits');
    }
}