<?php

use Phinx\Migration\AbstractMigration;

class CreateMerchantPortalUsers extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up ()
    {
        $table = $this->table('merchant_portal_users');
        $table->addColumn('created_at', 'datetime', ['null'=> 'true'])
            ->addColumn('updated_at', 'datetime', ['null'=> 'true'])
            ->addColumn('email', 'string', ['null'=> 'false','limit'=> '255'])
            ->addColumn('encrypted_password', 'string', ['null'=> 'false','limit'=> '128'])
            ->addColumn('reset_password_token', 'string', ['null'=> 'true','limit'=> '255'])
            ->addColumn('reset_password_sent_at', 'datetime', ['null'=> 'true'])
            ->addColumn('remember_created_at', 'datetime', ['null'=> 'true'])
            ->addColumn('sign_in_count', 'integer', ['null'=> 'true','default'=> '0'])
            ->addColumn('current_sign_in_at', 'datetime', ['null'=> 'true'])
            ->addColumn('last_sign_in_at', 'datetime', ['null'=> 'true'])
            ->addColumn('current_sign_in_ip', 'string', ['null'=> 'true','limit'=> '255'])
            ->addColumn('last_sign_in_ip', 'string', ['null'=> 'true','limit'=> '255'])
            ->addColumn('old_account_name', 'string', ['null'=> 'true','limit'=> '255'])
            ->addColumn('first_name', 'string', ['null'=> 'true','limit'=> '255'])
            ->addColumn('last_name', 'string', ['null'=> 'true','limit'=> '255'])
            ->addColumn('phone_number', 'string', ['null'=> 'true','limit'=> '255'])
            ->addIndex(['email'])
            ->addIndex(['reset_password_token'])
            ->save();

    }
    /**



     * Migrate Down.
     */
    public function down()
    {
        $this->dropTable('merchant_portal_users');
    }

}