<?php

use Phinx\Migration\AbstractMigration;

class CreatePortalOperatorMerchantMap extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up ()
    {
        $table = $this->table('portal_operator_merchant_map');
        $table->addColumn('user_id', 'integer', ['null'=> 'false'])
            ->addColumn('merchant_id', 'integer', ['null'=> 'false'])
            ->addIndex(['user_id'])
            ->addIndex(['merchant_id'])
            ->addForeignKey('merchant_id', 'Merchant', 'merchant_id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->addForeignKey('user_id', 'portal_users', 'id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->save();

    }
    /**



     * Migrate Down.
     */
    public function down()
    {
        $this->dropTable('portal_operator_merchant_map');
    }
}