<?php

use Phinx\Migration\AbstractMigration;

class CreatePortalLeads extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up ()
    {
        $table = $this->table('portal_leads');
        $table->addColumn('guid', 'string', ['null'=> 'false','limit'=> '100'])
            ->addColumn('store_name', 'string', ['null'=> 'false','limit'=> '100'])
            ->addColumn('store_address1', 'string', ['null'=> 'false','limit'=> '100'])
            ->addColumn('store_address2', 'string', ['null'=> 'false','limit'=> '100'])
            ->addColumn('store_city', 'string', ['null'=> 'false','limit'=> '100'])
            ->addColumn('store_state', 'char', ['null'=> 'false','limit'=> '2'])
            ->addColumn('store_zip', 'string', ['null'=> 'false','limit'=> '100'])
            ->addColumn('store_country', 'string', ['null'=> 'false','default'=> 'US','limit'=> '100'])
            ->addColumn('store_email', 'string', ['null'=> 'false','limit'=> '100'])
            ->addColumn('store_phone_no', 'string', ['null'=> 'false','limit'=> '100'])
            ->addColumn('contact_name', 'string', ['null'=> 'false','limit'=> '100'])
            ->addColumn('contact_title', 'string', ['null'=> 'false','limit'=> '100'])
            ->addColumn('contact_phone_no', 'string', ['null'=> 'false','limit'=> '100'])
            ->addColumn('contact_email', 'string', ['null'=> 'false','limit'=> '100'])
            ->addColumn('category', 'string', ['null'=> 'false','limit'=> '100'])
            ->addColumn('service', 'enum', ['null'=> 'false','limit'=> '19', 'values' => ['pickup only','delivery only','pickup and delivery']])
            ->addColumn('payment', 'enum', ['null'=> 'false','limit'=> '23', 'values' => ['in store only','credit card in advance','in store and in advance']])
            ->addColumn('web_url', 'string', ['null'=> 'true','limit'=> '100'])
            ->addColumn('grubbub', 'enum', ['null'=> 'false','default'=> 'N','limit'=> '1', 'values' => ['Y', 'N']])
            ->addColumn('eat24', 'enum', ['null'=> 'false','default'=> 'N','limit'=> '1', 'values' => ['Y', 'N']])
            ->addColumn('doordash', 'enum', ['null'=> 'false','default'=> 'N','limit'=> '1', 'values' => ['Y', 'N']])
            ->addColumn('postmates', 'enum', ['null'=> 'false','default'=> 'N','limit'=> '1', 'values' => ['Y', 'N']])
            ->addColumn('facebook', 'enum', ['null'=> 'false','default'=> 'N','limit'=> '1', 'values' => ['Y', 'N']])
            ->addColumn('chownum', 'enum', ['null'=> 'false','default'=> 'N','limit'=> '1', 'values' => ['Y', 'N']])
            ->addColumn('yelp', 'enum', ['null'=> 'false','default'=> 'N','limit'=> '1', 'values' => ['Y', 'N']])
            ->addColumn('google_places', 'enum', ['null'=> 'false','default'=> 'N','limit'=> '1', 'values' => ['Y', 'N']])
            ->addColumn('groupon', 'enum', ['null'=> 'false','default'=> 'N','limit'=> '1', 'values' => ['Y', 'N']])
            ->addColumn('ubereats', 'enum', ['null'=> 'false','default'=> 'N','limit'=> '1', 'values' => ['Y', 'N']])
            ->addColumn('offer_id', 'integer', ['null'=> 'false'])
            ->addColumn('email_send', 'timestamp', ['null'=> 'true'])
            ->addColumn('em', 'timestamp', ['null'=> 'true'])
            ->addColumn('created_at', 'timestamp', ['null'=> 'true'])
            ->addColumn('updated_at', 'timestamp', ['null'=> 'true'])
            ->addColumn('logical_delete', 'char', ['null'=> 'false','default'=> 'N','limit'=> '1'])
            ->addColumn('subdomain', 'string', ['null'=> 'false','limit'=> '100'])
            ->addColumn('store_time_zone', 'string', ['null'=> 'false','limit'=> '10'])
            ->addColumn('first_form_completion', 'timestamp', ['null'=> 'true'])
            ->addColumn('second_form_completion', 'timestamp', ['null'=> 'true'])
            ->addColumn('merchant_id', 'integer', ['null'=> 'true'])
            ->save();

    }
    /**



     * Migrate Down.
     */
    public function down()
    {
        $this->dropTable('portal_leads');
    }
}