<?php

use Phinx\Migration\AbstractMigration;

class CreatePortalObjectOwnership extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up ()
    {
        $table = $this->table('portal_object_ownership');
        $table->addColumn('user_id', 'integer', ['null'=> 'false'])
            ->addColumn('organization_id', 'integer', ['null'=> 'false'])
            ->addColumn('object_type', 'string', ['null'=> 'false','limit'=> '12'])
            ->addColumn('object_id', 'integer', ['null'=> 'false'])
            ->addColumn('created_at', 'timestamp', ['null'=> 'true'])
            ->addColumn('updated_at', 'timestamp', ['null'=> 'true'])
            ->addIndex(['user_id'])
            ->addIndex(['organization_id'])
            ->addForeignKey('user_id', 'portal_users', 'id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->save();

    }
    /**



     * Migrate Down.
     */
    public function down()
    {
        $this->dropTable('portal_object_ownership');
    }
}