<?php

use Phinx\Migration\AbstractMigration;

class CreatePortalMerchantMenuFiles extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up ()
    {
        $table = $this->table('portal_merchant_menu_files');
        $table->addColumn('merchant_id', 'integer', ['null'=> 'true'])
            ->addColumn('url', 'string', ['null'=> 'false','limit'=> '2000'])
            ->addColumn('created_at', 'timestamp', ['null'=> 'true'])
            ->addColumn('updated_at', 'timestamp', ['null'=> 'true'])
            ->addColumn('logical_delete', 'char', ['null'=> 'false','default'=> 'N','limit'=> '1'])
            ->addIndex(['merchant_id'])
            ->addForeignKey('merchant_id', 'Merchant', 'merchant_id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->save();

    }
    /**



     * Migrate Down.
     */
    public function down()
    {
        $this->dropTable('portal_merchant_menu_files');
    }

}