<?php

use Phinx\Migration\AbstractMigration;

class CreatePortalOfferAssets extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up ()
    {
        $table = $this->table('portal_offer_assets');
        $table->addColumn('offer_id', 'integer', ['null'=> 'false'])
            ->addColumn('description', 'string', ['null'=> 'true','limit'=> '100'])
            ->addColumn('type', 'enum', ['null'=> 'false','limit'=> '18',
                'values' => ['html','text','image','link','price_setup','price_subscription','price_opt_apps','price_opt_loyalty']])
            ->addColumn('value', 'text', ['null'=> 'false'])
            ->addColumn('created_at', 'timestamp', ['null'=> 'true'])
            ->addColumn('updated_at', 'timestamp', ['null'=> 'true'])
            ->addColumn('logical_delete', 'char', ['null'=> 'false','default'=> 'N','limit'=> '1'])
            ->save();

    }
    /**



     * Migrate Down.
     */
    public function down()
    {
        $this->dropTable('portal_offer_assets');
    }
}