<?php

use Phinx\Migration\AbstractMigration;

class CreatePortalEmails extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up ()
    {
        $table = $this->table('portal_emails');
        $table->addColumn('recipient', 'string', ['null'=> 'false','limit'=> '255'])
            ->addColumn('sender', 'string', ['null'=> 'false','limit'=> '255'])
            ->addColumn('sender_name', 'string', ['null'=> 'true','limit'=> '255'])
            ->addColumn('cc', 'string', ['null'=> 'true','limit'=> '255'])
            ->addColumn('bcc', 'string', ['null'=> 'true','limit'=> '255'])
            ->addColumn('subject', 'string', ['null'=> 'true','limit'=> '255'])
            ->addColumn('message', 'text', ['null'=> 'true','limit'=> 'TEXT_MEDIUM'])
            ->addColumn('attachments', 'string', ['null'=> 'true','limit'=> '255'])
            ->addColumn('priority', 'integer', ['null'=> 'true'])
            ->addColumn('queued_at', 'timestamp', ['null'=> 'true'])
            ->addColumn('sent_at', 'timestamp', ['null'=> 'true'])
            ->addColumn('status', 'enum', ['null'=> 'false','default'=> 'created','limit'=> '8', 'values'=>['created','queued','sent','canceled','error']])
            ->addColumn('email_type_id', 'integer', ['null'=> 'false'])
            ->addColumn('created_at', 'timestamp', ['null'=> 'true'])
            ->addColumn('updated_at', 'timestamp', ['null'=> 'true'])
            ->addIndex(['email_type_id'])
            ->addForeignKey('email_type_id', 'portal_email_types', 'id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->save();

    }
    /**



     * Migrate Down.
     */
    public function down()
    {
        $this->dropTable('portal_emails');
    }
}