<?php

use Phinx\Migration\AbstractMigration;

class CreatePortalReminderPeriods extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up ()
    {
        $table = $this->table('portal_reminder_periods');
        $table->addColumn('time_lapse', 'integer', ['null'=> 'false'])
            ->addColumn('unit', 'enum', ['null'=> 'false','default'=> 'minutes','limit'=> '7', 'values'=>['minutes','hours','days']])
            ->addColumn('email_type_id', 'integer', ['null'=> 'false'])
            ->addColumn('created_at', 'timestamp', ['null'=> 'true'])
            ->addColumn('updated_at', 'timestamp', ['null'=> 'true'])
            ->addIndex(['email_type_id'])
            ->addForeignKey('email_type_id', 'portal_email_types', 'id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->save();

    }
    /**



     * Migrate Down.
     */
    public function down()
    {
        $this->dropTable('portal_reminder_periods');
    }
}