<?php

use Phinx\Migration\AbstractMigration;

class CreateUserFacebookIdMaps extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('User_Facebook_Id_Maps');

        $table->addColumn('facebook_user_id','string')
            ->addColumn('user_id','integer')
            ->addColumn('created_stamp','string')
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','string', array('limit' => 1,'default' => 'N'))
            ->addForeignKey('user_id', 'User', 'user_id', array('delete'=> 'CASCADE', 'update'=> 'NO_ACTION'));
        $table->save();

        $sql = "ALTER TABLE `User_Facebook_Id_Maps` AUTO_INCREMENT = 1000;";
        $this->execute($sql);
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $table = $this->table('Menu_Type_Item_Upsell_Maps');
        $table->drop();
    }
}