<?php

use Phinx\Migration\AbstractMigration;

class AddEmailTemplateIdToPortalReminderPeriods extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('portal_reminder_periods');
        $table->addColumn('email_template_id', 'integer', ['null'=> 'false'])
            ->addIndex(['email_template_id'],['name'=>'prm_email_template_id'])
            ->addForeignKey('email_template_id', 'portal_email_templates', 'id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->update();
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $table = $this->table('portal_reminder_periods');
        $table->removeIndexByName("prm_email_template_id")
              ->dropForeignKey("email_template_id")
              ->removeColumn('email_template_id')
              ->update();

    }
}