<?php

use Phinx\Migration\AbstractMigration;

class AddDeliveryThrottleInfoToMechantPreptimeInfo extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('Merchant_Preptime_Info');
        $table->addColumn('pickup_throttling_on', 'enum', array('values' => array('Y','N'),'default'=>'Y','after'=>'merchant_id'))
            ->addColumn('delivery_throttling_on', 'enum', array('values' => array('Y','N'),'default'=>'Y','after'=>'concurrently_able_to_make'))
            ->addColumn('delivery_order_buffer_in_minutes', 'integer', array('default'=>5,'after'=>'delivery_throttling_on'))
            ->addColumn('concurrently_able_to_make_delivery', 'integer', array('default'=>1,'after'=>'delivery_order_buffer_in_minutes'))
            ->save();
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $table = $this->table('Merchant_Preptime_Info');
        $table->removeColumn('concurrently_able_to_make_delivery')
            ->removeColumn('delivery_order_buffer_in_minutes')
            ->removeColumn('delivery_throttling_on')
            ->removeColumn('pickup_throttling_on')
            ->save();
    }
}