<?php

use Phinx\Migration\AbstractMigration;

class CreatePortalBrandManagerBrandMap extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up ()
    {
        $table = $this->table('portal_brand_manager_brand_map');

        $table->addColumn('user_id', 'integer', ['null'=> 'false'])
            ->addColumn('brand_id', 'integer', ['null'=> 'false'])
            ->addIndex(['user_id'])
            ->addIndex(['brand_id'])
            ->addForeignKey('brand_id', 'Brand2', 'brand_id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->addForeignKey('user_id', 'portal_users', 'id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->save();

    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $this->dropTable('portal_brand_manager_brand_map');
    }
}