<?php

use Phinx\Migration\AbstractMigration;

class CreateOperatingHoursTable extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('Operating_Hours',array('id' => false, 'primary_key' => array('hour_id')));

        $table->addColumn('hour_id', 'integer', ['null'=> 'false', 'identity'=>true])
            ->addColumn('merchant_id', 'integer', ['null'=> 'false', 'limit'=>'11'])
            ->addColumn('hour_type', 'string', ['null'=> 'true','limit'=> '100'])
            ->addColumn('day_of_week', 'string', ['null'=> 'true','limit'=> '100'])

            ->addColumn('open', 'time', ['null'=> 'true'])
            ->addColumn('close', 'time', ['null'=> 'true'])
            ->addColumn('created', 'timestamp', ['null'=> 'true'])
            ->addColumn('modified', 'timestamp', ['null'=> 'true'])

            ->addIndex(['hour_id'])
            ->addForeignKey('merchant_id', 'Merchant', 'merchant_id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->save();
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $this->dropTable('Operating_Hours');
    }
}