<?php

use Phinx\Migration\AbstractMigration;

class CreateBrandPosMaps extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('Brand_Pos_Maps');
        $table->addColumn('brand_id', 'integer', ['null'=> 'false'])
            ->addColumn('pos_id', 'integer', ['null'=> 'false'])
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','string', array('limit' => 1,'default' => 'N'))
            ->addForeignKey('brand_id', 'Brand2', 'brand_id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->addForeignKey('pos_id', 'Splickit_Accepted_Pos_Types', 'id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->save();
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $table = $this->table('Brand_Pos_Maps');
        $table->drop();
    }
}