<?php

use Phinx\Migration\AbstractMigration;

class CreateMerchantPosMaps extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('Merchant_Pos_Maps');
        $table->addColumn('merchant_id', 'integer', ['null'=> 'false'])
            ->addColumn('pos_id', 'integer', ['null'=> 'false'])
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','string', array('limit' => 1,'default' => 'N'))
            ->addForeignKey('merchant_id', 'Merchant', 'merchant_id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->addForeignKey('pos_id', 'Splickit_Accepted_Pos_Types', 'id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->addIndex(array('merchant_id'),array("unique"=>true,'name'=>'merchant_pos_map'))
            ->save();
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $table = $this->table('Merchant_Pos_Maps');
        $table->drop();
    }
}