<?php

use Phinx\Migration\AbstractMigration;

class PortalOrganizationLookup extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('portal_organization_lookup');
        $table->addColumn('organization_id', 'string', ['null'=> 'false','limit'=> '255'])
            ->addColumn('lookup_driver', 'string', ['null'=> 'false','limit'=> '1'])
            ->addColumn('lookup_type_id_field', 'string', ['null'=> 'false','limit'=> '100'])
            ->addColumn('created_at', 'timestamp', ['null'=> 'true'])
            ->addColumn('updated_at', 'timestamp', ['null'=> 'true'])
            ->addIndex(['organization_id'])
            ->addIndex(['lookup_type_id_field'])
            ->save();
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $table = $this->table('portal_organization_lookup');
        $table->drop();
    }
}