<?php

use Phinx\Migration\AbstractMigration;

class CreateItemModifierItemPriceOverrideBySize extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        //ItemModifierItemPriceOverrideBySize
        $table = $this->table('Item_Modifier_Item_Price_Override_By_Sizes');

        $table->addColumn('item_id','integer', ['null'=> 'false'])
            ->addColumn('size_id','integer', ['null'=> 'false'])
            ->addColumn('modifier_group_id','integer', ['null'=> 'false'])
            ->addColumn('merchant_id','integer', ['null'=> 'false'])
            ->addColumn('price_override','decimal', array('precision' => 10, 'scale' => 2))
            ->addColumn('created', 'timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified', 'timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','string',array('limit' => 1,'default' => 'N'))
            ->addForeignKey('item_id', 'Item', 'item_id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->addForeignKey('size_id', 'Sizes', 'size_id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->addForeignKey('merchant_id', 'Merchant', 'merchant_id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->addForeignKey('modifier_group_id', 'Modifier_Group', 'modifier_group_id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->save();

        $sql = "ALTER TABLE `Item_Modifier_Item_Price_Override_By_Sizes` AUTO_INCREMENT = 1000;";
        $this->execute($sql);
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $table = $this->table('Item_Modifier_Item_Price_Override_By_Sizes');
        $table->drop();
    }
}