<?php

use Phinx\Migration\AbstractMigration;

class CreateUserBrandMaps extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $unique_columns = array("user_id","brand_id");
        $table = $this->table('User_Brand_Maps');

        $table->addColumn('user_id','integer', ['null'=> 'false'])
            ->addColumn('brand_id','integer', ['null'=> 'false'])
            ->addColumn('number_of_orders','integer', ['default'=> 0])
            ->addColumn('created', 'timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified', 'timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','string',array('limit' => 1,'default' => 'N'))
            ->addForeignKey('user_id', 'User', 'user_id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->addForeignKey('brand_id', 'Brand2', 'brand_id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->addIndex($unique_columns,array("unique"=>true,"name"=>"user_brand_contsraint"))

            ->save();

        $sql = "ALTER TABLE `User_Brand_Maps` AUTO_INCREMENT = 1000;";
        $this->execute($sql);
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $table = $this->table('User_Brand_Maps');
        $table->drop();
    }
}