<?php

use Phinx\Migration\AbstractMigration;

class AddMerchantMenuMapView extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $sql = "CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `smawv_mmm_status` AS
                    SELECT 
                        merchant_id,
                        MAX(IFNULL(CASE WHEN merchant_menu_type = 'pickup' and show_button = 'Y' THEN 1 END,0)) AS pickup_rec,
                        MAX(IFNULL(CASE WHEN merchant_menu_type = 'delivery' and show_button = 'Y' THEN 1 END,0)) AS delivery_rec
                    FROM Merchant_Menu_Map a
                    GROUP BY merchant_id;";
        $this->execute($sql);
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $this->execute('DROP VIEW `smawv_mmm_status`;');
    }
}