<?php

use Phinx\Migration\AbstractMigration;

class CreatePaymentServicesBusiness extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     */
    public function change()
    {
                // create the table
        $table = $this->table('payment_services_business');
        $table->addColumn('merchant_id', 'integer', ['null' => false])
            ->addColumn('dba', 'string')
            ->addColumn('fed_tax_id', 'string')
            ->addColumn('primary_owner_ssn', 'string')
            ->addColumn('bank_account_number', 'string')
            ->addColumn('bank_routing_number', 'string')
            ->addColumn('physical_address1', 'string')
            ->addColumn('physical_address2', 'string', ['null' => true])
            ->addColumn('physical_city', 'string')
            ->addColumn('physical_state', 'char', ['limit' => 2])
            ->addColumn('physical_zip', 'string')
            ->addColumn('physical_phone', 'string')
            ->addColumn('business_url', 'string', ['default' => ''])
            ->addColumn('ave_ticket_size', 'decimal', ['default' => 0, 'null' => false, 'precision'=>9, 'scale'=>2])
            ->addColumn('max_ticket_size', 'decimal', ['default' => 0, 'null' => false, 'precision'=>9, 'scale'=>2])
            ->addColumn('ave_annual_volume', 'decimal', ['default' => 0, 'null' => false, 'precision'=>9, 'scale'=>2])
            ->addColumn('apply_for_amex', 'boolean', ['default' => false])
            ->addColumn('created', 'timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified', 'timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','string',array('limit' => 1,'default' => 'N'))
            ->addForeignKey('merchant_id', 'Merchant', 'merchant_id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->create();
    }
    
    /**
     * Migrate Up.
     */
    public function up()
    {
    
    }

    /**
     * Migrate Down.
     */
    public function down()
    {

    }
}