<?php

use Phinx\Migration\AbstractMigration;

class CreatePaymentServicesOwner extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     */
    public function change()
    {
                        // create the table
        $table = $this->table('payment_services_owner');
        $table->addColumn('merchant_id', 'integer', ['null' => false])
            ->addColumn('primary_owner_first_name', 'string', ['null' => true])
            ->addColumn('primary_owner_last_name', 'string', ['null' => true])
            ->addColumn('primary_owner_dob', 'date')
            ->addColumn('primary_owner_address1', 'string')
            ->addColumn('primary_owner_address2', 'string', ['null' => true])
            ->addColumn('primary_owner_city', 'string')
            ->addColumn('primary_owner_state', 'char', ['limit' => 2])
            ->addColumn('primary_owner_zip', 'string')
            ->addColumn('primary_owner_phone', 'string')
            ->addColumn('legal_email', 'string')
            ->addColumn('created', 'timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified', 'timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','string',array('limit' => 1,'default' => 'N'))
            ->addForeignKey('merchant_id', 'Merchant', 'merchant_id', ['delete'=> 'CASCADE', 'update'=> 'NO_ACTION'])
            ->create();
    }
    
    
    /**
     * Migrate Up.
     */
    public function up()
    {
    
    }

    /**
     * Migrate Down.
     */
    public function down()
    {

    }
}