<?php

use Phinx\Migration\AbstractMigration;
use Phinx\Db\Adapter\MysqlAdapter;

class CreateNewReportScheduleTable extends AbstractMigration
{
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-change-method
     *
     * Uncomment this method if you would like to use it.
     *
    public function change()
    {
    }
    */
    
    /**
     * Migrate Up.
     */
    public function up()
    {
        $table = $this->table('portal_report_schedules');
        $table
            ->addColumn('report_name', 'string', ['null' => false])
            ->addColumn('payload', 'text', ['limit' => MysqlAdapter::TEXT_LONG])
            ->addColumn('frequency', 'string', ['null' => false])
            ->addColumn('start_date', 'date', ['null' => false])
            ->addColumn('end_date', 'date', ['null' => true])
            ->addColumn('recipient', 'string', ['null' => false])
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('available_at','biginteger', ['null' => true, 'signed' => false])
            ->addColumn('logical_delete','string',['limit' => 1,'default' => 'N'])
            ->save();

    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $this->dropTable('portal_report_schedules');
    }
}