<?php


use Phinx\Migration\AbstractMigration;

class PortalBrandLookup extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function up()
    {
        $table = $this->table('portal_brand_lookup');
        $table->addColumn('brand_id', 'integer', ['null'=> 'false','limit'=> '255'])
            ->addColumn('lookup_driver', 'string', ['null'=> 'false','limit'=> '1'])
            ->addColumn('lookup_type_id_field', 'string', ['null'=> 'false','limit'=> '100'])
            ->addColumn('created_at', 'timestamp', ['null'=> 'true'])
            ->addColumn('updated_at', 'timestamp', ['null'=> 'true'])
            ->addIndex(['brand_id'])
            ->save();
    }
}
