<?php


use Phinx\Migration\AbstractMigration;

class CreateFoundryBrandCardPaymentIds extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('Foundry_Brand_Card_Tender_Ids');
        $table
            ->addColumn('brand_id', 'integer', ['null' => false])
            ->addColumn('visa', 'integer', ['null' => true,'default'=> null])
            ->addColumn('master', 'integer', ['null' => true,'default'=> null])
            ->addColumn('american_express', 'integer', ['null' => true,'default'=> null])
            ->addColumn('discover', 'integer', ['null' => true,'default'=> null])
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','string',['limit' => 1,'default' => 'N'])
            ->save();
    }
}
