<?php


use Phinx\Migration\AbstractMigration;

class CreateUserBrandStoredValueMaps extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('User_Skin_Stored_Value_Maps');
        $table
            ->addColumn('user_id', 'integer', ['null' => false])
            ->addColumn('skin_id', 'integer', ['null' => false])
            ->addColumn('splickit_accepted_payment_type_id', 'integer', ['null' => false])
            ->addColumn('card_number', 'string',['null' => false])
            ->addColumn('balance','decimal',array('precision' => 10, 'scale' => 2, 'default' => 0.00) )
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','string',['limit' => 1,'default' => 'N'])
            ->addForeignKey('user_id', 'User', 'user_id', array('delete'=> 'CASCADE', 'update'=> 'NO_ACTION'))
            ->addForeignKey('Skin_id', 'Skin', 'skin_id', array('delete'=> 'CASCADE', 'update'=> 'NO_ACTION'))
            ->addForeignKey('splickit_accepted_payment_type_id', 'Splickit_Accepted_Payment_Types', 'id', array('delete'=> 'CASCADE', 'update'=> 'NO_ACTION'));


        $table->save();

        $sql = "ALTER TABLE `User_Skin_Stored_Value_Maps` AUTO_INCREMENT = 1000;";
        $this->execute($sql);

    }
}
