<?php


use Phinx\Migration\AbstractMigration;

class CreatePaymentMerchantApplications extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $sql = "CREATE TABLE `payment_merchant_applications` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `merchant_id` int(11) NOT NULL,
  `business_name` varchar(255) NOT NULL,
  `phone` varchar(255) NOT NULL,
  `email` varchar(255) NOT NULL,
  `dba` varchar(255) NOT NULL,
  `fed_tax_id` varchar(255) NOT NULL,
  `bank_account_number` varchar(255) NOT NULL,
  `bank_routing_number` varchar(255) NOT NULL,
  `bank_type_saving_checking` varchar(255) NOT NULL,
  `bank_type_business_personal` varchar(255) NOT NULL,
  `primary_owner_first_name` varchar(255) DEFAULT NULL,
  `primary_owner_last_name` varchar(255) DEFAULT NULL,
  `primary_owner_dob` date NOT NULL,
  `primary_owner_ss` varchar(255) NOT NULL,
  `primary_owner_phone` varchar(255) NOT NULL,
  `primary_owner_email` varchar(255) NOT NULL,
  `primary_owner_drivers_license_url` varchar(1024) NOT NULL,
  `primary_owner_void_check_url` varchar(1024) NOT NULL,
  `vio_result_status` varchar(3),
  `vio_account_number` varchar(255),
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `logical_delete` varchar(1) NOT NULL DEFAULT 'N',
  PRIMARY KEY (`id`),
  KEY `merchant_id` (`merchant_id`),
  CONSTRAINT `payment_merchant_application_ibfk_2` FOREIGN KEY (`merchant_id`) REFERENCES `Merchant` (`merchant_id`) ON DELETE CASCADE ON UPDATE NO ACTION
        ) ENGINE=InnoDB AUTO_INCREMENT=1000 DEFAULT CHARSET=utf8;";

       $this->execute($sql);
    }


}
