<?php


use Phinx\Migration\AbstractMigration;

class CreateVioDailyDepositSummariesTable extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function up()
    {
        $table = $this->table('vio_daily_deposit_summaries');
        $table->addColumn('fees', 'decimal', array('precision' => 10, 'scale' => 2, 'default' => 0.00))
            ->addColumn('amount',  'decimal', array('precision' => 10, 'scale' => 2, 'default' => 0.00))

            ->addColumn('merchant_id', 'integer', ['null'=> 'false'])
            ->addColumn('details', 'string', ['null' => true])
            ->addColumn('sweep_id', 'integer')
            ->addColumn('attn_number', 'integer', ['null' => true])
            ->addColumn('inv_number', 'integer', ['null' => true])
            ->addColumn('trans_id', 'integer')
            ->addColumn('identifier', 'string', ['null' => true])
            ->addColumn('report_date', 'timestamp', ['null' => true])
            ->addColumn('gross_amount', 'decimal', array('precision' => 10, 'scale' => 2, 'default' => 0.00))
            ->addColumn('vio_account_number', 'integer')
            ->addColumn('ach_return_code', 'string', ['null' => true])
            ->addColumn('transaction_type', 'string', ['null' => true])
            ->addColumn('transaction_date_time', 'timestamp')
            ->addColumn('charge_back_response_code', 'string', ['null' => true])
            ->addColumn('return_code_description', 'string', ['null' => true])
            ->addColumn('response_code_description', 'string', ['null' => true])
            ->addColumn('updated_at', 'timestamp')
            ->addColumn('created_at', 'timestamp')

            ->addIndex(array('merchant_id'),array("unique"=>false,'name'=>'vio_daily_merchant_id'))
            ->addIndex(array('vio_account_number'),array("unique"=>false,'name'=>'vio_daily_acct_number'))

            ->save();
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $this->dropTable('vio_daily_deposit_summaries');
    }
}
