<?php


use Phinx\Migration\AbstractMigration;

class CreateVioDailyTransactionsTable extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('vio_daily_transactions');
        $table->addColumn('Email', 'string', ['null' => true])
            ->addColumn('AttNum', 'string', ['null' => true])
            ->addColumn('Credit',  'decimal', array('precision' => 10, 'scale' => 2, 'default' => 0.00))
            ->addColumn('InvNum', 'string', ['null' => true])
            ->addColumn('AVSCode', 'string', ['null' => true])
            ->addColumn('BatchId', 'string', ['null' => true])
            ->addColumn('DiscFee',  'decimal', array('precision' => 10, 'scale' => 2, 'default' => 0.00))
            ->addColumn('ExpDate', 'string', ['null' => true])
            ->addColumn('HasCVV2', 'string', ['null' => true])
            ->addColumn('SweepId', 'string', ['null' => true])
            ->addColumn('AuthCode', 'string', ['null' => true])
            ->addColumn('BankCity', 'string', ['null' => true])
            ->addColumn('BankName', 'string', ['null' => true])
            ->addColumn('CVV2Resp', 'string', ['null' => true])
            ->addColumn('Comment1', 'string', ['null' => true])
            ->addColumn('Comment2', 'string', ['null' => true])
            ->addColumn('FundDate', 'timestamp')
            ->addColumn('LastName', 'string', ['null' => true])
            ->addColumn('UserName', 'string', ['null' => true])
            ->addColumn('FirstName', 'string', ['null' => true])
            ->addColumn('NetAmount',  'decimal', array('precision' => 10, 'scale' => 2, 'default' => 0.00))
            ->addColumn('OwnerCity', 'string', ['null' => true])
            ->addColumn('AccountNum', 'string', ['null' => true])
            ->addColumn('AuthAmount',  'decimal', array('precision' => 10, 'scale' => 2, 'default' => 0.00))
            ->addColumn('CardNumber', 'string', ['null' => true])
            ->addColumn('OwnerState', 'string', ['null' => true])
            ->addColumn('ReportDate', 'date', ['null' => true])
            ->addColumn('SettleDate', 'timestamp')
            ->addColumn('AffiliateId', 'string', ['null' => true])
            ->addColumn('BillingCity', 'string', ['null' => true])
            ->addColumn('CardPresent', 'string', ['null' => true])
            ->addColumn('GrossAmount',  'decimal', array('precision' => 10, 'scale' => 2, 'default' => 0.00))
            ->addColumn('PerTransFee',  'decimal', array('precision' => 10, 'scale' => 2, 'default' => 0.00))
            ->addColumn('BankAddress1', 'string', ['null' => true])
            ->addColumn('BankAddress2', 'string', ['null' => true])
            ->addColumn('BillingState', 'string', ['null' => true])
            ->addColumn('ResponseCode', 'string', ['null' => true])
            ->addColumn('ShippingCity', 'string', ['null' => true])
            ->addColumn('ShippingName', 'string', ['null' => true])
            ->addColumn('AffiliateName', 'string', ['null' => true])
            ->addColumn('BankTelephone', 'string', ['null' => true])
            ->addColumn('OwnerAddress1', 'string', ['null' => true])
            ->addColumn('OwnerAddress2', 'string', ['null' => true])
            ->addColumn('OwnerAddress3', 'string', ['null' => true])
            ->addColumn('OwnerLastName', 'string', ['null' => true])
            ->addColumn('ShippingState', 'string', ['null' => true])
            ->addColumn('BankPostalCode', 'string', ['null' => true])
            ->addColumn('BillingCountry', 'string', ['null' => true])
            ->addColumn('OwnerFirstName', 'string', ['null' => true])
            ->addColumn('BillingAddress1', 'string', ['null' => true])
            ->addColumn('BillingAddress2', 'string', ['null' => true])
            ->addColumn('BillingAddress3', 'string', ['null' => true])
            ->addColumn('DoingBusinessAs', 'string', ['null' => true])
            ->addColumn('OwnerPostalCode', 'string', ['null' => true])
            ->addColumn('TransactionDate', 'timestamp')
            ->addColumn('AuthCurrencyCode', 'string', ['null' => true])
            ->addColumn('OwnerCountryCode', 'string', ['null' => true])
            ->addColumn('SendingPayerName', 'string', ['null' => true])
            ->addColumn('ShippingAddress1', 'string', ['null' => true])
            ->addColumn('ShippingAddress2', 'string', ['null' => true])
            ->addColumn('TransDescription', 'string', ['null' => true])
            ->addColumn('BankStateProvince', 'string', ['null' => true])
            ->addColumn('BillingPostalCode', 'string', ['null' => true])
            ->addColumn('BusinessLegalName', 'string', ['null' => true])
            ->addColumn('SendingAccountNum', 'string', ['null' => true])
            ->addColumn('SendingPayerEmail', 'string', ['null' => true])
            ->addColumn('TransactionInfoId', 'string', ['null' => true])
            ->addColumn('AVSCodeDescription', 'string', ['null' => true])
            ->addColumn('ReceivingPayerName', 'string', ['null' => true])
            ->addColumn('ShippingPostalCode', 'string', ['null' => true])
            ->addColumn('ReceivingAccountNum', 'string', ['null' => true])
            ->addColumn('ReceivingPayerEmail', 'string', ['null' => true])
            ->addColumn('TransactionDetailName', 'string', ['null' => true])
            ->addColumn('TransactionDetailType', 'string', ['null' => true])
            ->addColumn('TransactionDetailEmail', 'string', ['null' => true])
            ->addColumn('ParentTransactionInfoId', 'string', ['null' => true])
            ->addColumn('ResponseCodeDescription', 'string', ['null' => true])
            ->addColumn('TransactionDetailAccount', 'string', ['null' => true])
            ->addColumn('merchant_id', 'integer', ['null'=> false])
            ->addColumn('modified', 'timestamp')
            ->addColumn('created', 'timestamp')

            ->addIndex(array('merchant_id'),array("unique"=>false,'name'=>'vio_daily_trans_merchant_id'))
            ->addIndex(array('AccountNum'),array("unique"=>false,'name'=>'vio_daily_trans_acct_number'))
            ->addIndex(array('TransactionInfoId'),array("unique"=>true,'name'=>'vio_transaction_id'))

            ->save();

    }
}
