<?php


use Phinx\Migration\AbstractMigration;

class VioDepositDetail extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function up()
    {
        $sql = "CREATE TABLE `vio_deposit_detail` (
  `id` int(11) NOT NULL AUTO_INCREMENT KEY,
  `AchReturnCode` varchar(10) DEFAULT NULL,
  `Amount` decimal(10,2) DEFAULT NULL,
  `ChargeBackResponeCode` varchar(255) DEFAULT NULL,
  `Details` varchar(255) DEFAULT NULL,
  `NetAmount` decimal(10,2) DEFAULT NULL,
  `ReportDate` Date DEFAULT NULL,
  `ResponeCodeDescription` varchar(255) DEFAULT NULL,
  `ReturnCodeDescription` varchar(255) DEFAULT NULL,
  `SweepId` int(11) DEFAULT NULL,
  `Trans_Id` int(11) DEFAULT NULL,
  `TransactionDateTime` varchar(255) DEFAULT NULL,
  `TransactionType` varchar(255) DEFAULT NULL,
  `account_num` int(11) DEFAULT NULL,
  `att_num` int(11) DEFAULT NULL,
  `inv_num` varchar(255) DEFAULT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `modified` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
";
        $this->execute($sql);

        $table = $this->table('vio_deposit_detail');
        $table->addIndex(array('account_num'),array("unique"=>false,'name'=>'vio_deposit_detail_acct_number'))
            ->addIndex(array('Trans_Id'),array("unique"=>true,'name'=>'vio_deposit_detail_transaction_id'))
            ->addIndex(array('SweepId'),array("unique"=>false,'name'=>'vio_deposit_detail_sweep_id'))

            ->save();

    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $sql = "DROP TABLE vio_deposit_detail";
        $this->execute($sql);

    }

}
