<?php


use Phinx\Migration\AbstractMigration;

class CreateThirdPartyProviderTypes extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('Third_Party_Provider_Types');
        $table
            ->addColumn('type', 'string', ['null' => false])
            ->addColumn('description', 'string')
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','string',['limit' => 1,'default' => 'N']);

        $table->create();

        $sql = "ALTER TABLE `Third_Party_Provider_Types` AUTO_INCREMENT = 1000;";
        $this->execute($sql);

        $sql = "INSERT INTO Third_Party_Provider_Types (`id`,`type`,`description`) VALUES (1000,'POS','Point Of Sale system'),(2000,'CC_Processor','credit card processor'),(3000,'Loyalty','Remote loyalty service'),(4000,'Delivery','Delivery Service')";
        $this->execute($sql);
    }
}
