<?php


use Phinx\Migration\AbstractMigration;

class CreateThirdPartyProviderParameters extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('Third_Party_Provider_Parameters');
        $table
            ->addColumn('third_party_provider_id','integer',['null' => false])
            ->addColumn('name', 'string', ['null' => false])
            ->addColumn('description', 'string',['null' => false])
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','string',['limit' => 1,'default' => 'N'])
            ->addForeignKey('third_party_provider_id', 'Third_Party_Providers', 'id', array('delete'=> 'CASCADE', 'update'=> 'NO_ACTION'))
            ->addIndex(array('third_party_provider_id','name'),array("unique"=>true,"name"=>'provider_parameter_name'));
        $table->create();

        $sql = "ALTER TABLE `Third_Party_Provider_Parameters` AUTO_INCREMENT = 1000;";
        $this->execute($sql);

        $sql = "INSERT INTO Third_Party_Provider_Parameters (`third_party_provider_id`,`name`,`description`)
                VALUES (1001,'brink_location_token',''),
                (1002,'location',''),
                (1002,'payment_id',''),
                (1002,'media_id',''),
                (1002,'task_retail_url',''),
                (1002,'task_retail_auth_url',''),
                (1002,'task_retail_username',''),
                (1002,'task_retail_password',''),
                (1002,'server_time_zone',''),
                (1002,'electronic_tip_media_id',''),
                (1003,'store_id',''),
                (1003,'merchant_key',''),
                (1003,'tender_id',''),
                (1003,'service_tip_id',''),
                (1003,'promo_charge_id',''),
                (1003,'alternate_url',''),
                (1004,'location',''),
                (1004,'token',''),
                (2002,'merchant_id_key',''),
                (2002,'merchant_id_number',''),
                (2001,'merchant_id',''),
                (2001,'password',''),
                (2003,'source_key',''),
                (2004,'terminal_gateway_id',''),
                (2004,'terminal_password',''),
                (2005,'secret_api_key',''),
                (2006,'secure_net_id',''),
                (2006,'secure_key',''),
                (2007,'account_num',''),
                (4001,'external_business_name','')";

        $this->execute($sql);
    }
}
