<?php


use Phinx\Migration\AbstractMigration;

class CreateThirdPartyParameterSkinMaps extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
            $table = $this->table('Third_Party_Provider_Parameter_Skin_Maps');
        $table
            ->addColumn('third_party_provider_parameter_id','integer',['null' => false])
            ->addColumn('skin_id','integer',['null' => false])
            ->addColumn('value', 'string')
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','string',['limit' => 1,'default' => 'N'])
            ->addForeignKey('skin_id','Skin','skin_id', array('delete'=> 'CASCADE', 'update'=> 'NO_ACTION'))
            ->addForeignKey('third_party_provider_parameter_id', 'Third_Party_Provider_Parameters', 'id', array('delete'=> 'CASCADE', 'update'=> 'NO_ACTION'))
            ->addIndex(array('third_party_provider_parameter_id','skin_id'),array("unique"=>true,"name"=>'provider_parameter_skin'));

        $table->create();

        $sql = "ALTER TABLE `Third_Party_Provider_Parameter_Skin_Maps` AUTO_INCREMENT = 1000;";
        $this->execute($sql);

    }
}
