<?php


use Phinx\Migration\AbstractMigration;

class CreateMenuObjectSchedulesByWeeks extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('Menu_Object_Schedules_By_Week_And_Day_Maps');
        $table
            ->addColumn('menu_schedule_id', 'integer', ['null' => false])
            ->addColumn('week_number_in_cycle', 'integer',['null' => false])
            ->addColumn('day_number', 'integer',['null' => false])
            ->addColumn('object_type', 'string',['null' => false])
            ->addColumn("object_id", "integer", ['null' => false])
            ->addColumn('notes', 'string')
            ->addColumn("active", "boolean", array('default' => true))
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','string',['limit' => 1,'default' => 'N'])
            ->addForeignKey(['menu_schedule_id'],'Menu_Schedules',['id']);
        $table->create();

        $sql = "ALTER TABLE `Menu_Object_Schedules_By_Week_And_Day_Maps` AUTO_INCREMENT = 1000;";
        $this->execute($sql);

    }
}
