<?php


use Phinx\Migration\AbstractMigration;

class CreateMessageManagerRequests extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('message_manager_requests');
        $table
            ->addColumn('date_of_request','date')
            ->addColumn('identifier', 'string', ['null' => false])
            ->addColumn('request_url', 'string', ['null' => false])
            ->addColumn('request_method', 'string', ['null' => false])
            ->addColumn('count', 'integer',['default'=>0])
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addIndex(['date_of_request','identifier','request_method'],['unique'=>true]);
        $table->create();
    }
}
