<?php


use Phinx\Migration\AbstractMigration;

class AddDefaultContextAndRequiredFieldsToThirdPartyProviderParameters extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('Third_Party_Provider_Parameters');
        $table->addColumn('required','boolean',['after'=>'description'])
            ->addColumn('default_context', 'enum', ['after'=>'description', 'values' => [null,'Skin','Brand','Merchant']]);
        $table->save();
    }
}
