<?php


use Phinx\Migration\AbstractMigration;

class AddColumnsToOrdersView extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function up()
    {
        $sql = "DROP VIEW IF EXISTS `smawv_nb_orders`; CREATE ALGORITHM=UNDEFINED DEFINER=`itsquik`@`%` SQL SECURITY DEFINER VIEW `smawv_nb_orders` AS select `B`.`status` AS `status`,`B`.`order_id` AS `order_id`,`M`.`brand_id` AS `brand_id`,`U`.`first_name` AS `first_name`,`U`.`last_name` AS `last_name`,`U`.`email` AS `email`,`M`.`name` AS `name`,`M`.`address1` AS `address1`,`M`.`city` AS `city`,`M`.`display_name` AS `display_name`,`M`.`phone_no` AS `phone_no`,`M`.`merchant_id` AS `merchant_id`,`M`.`merchant_external_id` AS `merchant_external_id`,`M`.`shop_email` AS `shop_email`,`B`.`order_dt_tm` AS `order_dt_tm`,`B`.`pickup_dt_tm` AS `pickup_dt_tm`,`B`.`promo_amt` AS `promo_amt`,`B`.`order_amt` AS `order_amt`,`B`.`total_tax_amt` AS `total_tax_amt`,`B`.`tip_amt` AS `tip_amt`,`B`.`customer_donation_amt` AS `customer_donation_amt`,`B`.`merchant_donation_amt` AS `merchant_donation_amt`,`B`.`trans_fee_amt` AS `trans_fee_amt`,`B`.`user_id` AS `user_id`,`B`.`promo_code` AS `promo_code`,`L`.`type_id_name` AS `type_id_name`,`K`.`type_id_name` AS `order_type`,`B`.`order_qty` AS `order_qty`,`B`.`grand_total` AS `grand_total`,`B`.`note` AS `note`,`B`.`delivery_amt` AS `delivery_amt`,`B`.`cash` AS `cash`,(case when (`C`.`order_id` is not null) then 'Catering' else NULL end) AS `is_catering` from (((((`Orders` `B` join `Merchant` `M` on((`B`.`merchant_id` = `M`.`merchant_id`))) left join `Lookup` `L` on(((`L`.`type_id_value` = `B`.`status`) and (`L`.`type_id_field` = 'status')))) left join `Lookup` `K` on(((`K`.`type_id_value` = `B`.`order_type`) and (`K`.`type_id_field` = 'order_type')))) join `User` `U` on((`U`.`user_id` = `B`.`user_id`))) left join `Catering_Orders` `C` on((`B`.`order_id` = `C`.`order_id`))) where (((`B`.`status` <> 'Y') or (`B`.`order_dt_tm` >= (now() - interval 2 day))) and (`B`.`order_dt_tm` > (now() - interval 3 month)))";
        $this->execute($sql);

    }

    public function down()
    {
        $sql = "DROP VIEW IF EXISTS `smawv_nb_orders`; CREATE ALGORITHM=UNDEFINED DEFINER=`itsquik`@`%` SQL SECURITY DEFINER VIEW `smawv_nb_orders` AS select `B`.`status` AS `status`,`B`.`order_id` AS `order_id`,`M`.`brand_id` AS `brand_id`,`U`.`first_name` AS `first_name`,`U`.`last_name` AS `last_name`,`U`.`email` AS `email`,`M`.`name` AS `name`,`M`.`address1` AS `address1`,`M`.`city` AS `city`,`M`.`display_name` AS `display_name`,`M`.`phone_no` AS `phone_no`,`M`.`merchant_id` AS `merchant_id`,`M`.`merchant_external_id` AS `merchant_external_id`,`M`.`shop_email` AS `shop_email`,`B`.`order_dt_tm` AS `order_dt_tm`,`B`.`pickup_dt_tm` AS `pickup_dt_tm`,`B`.`promo_amt` AS `promo_amt`,`B`.`order_amt` AS `order_amt`,`B`.`total_tax_amt` AS `total_tax_amt`,`B`.`tip_amt` AS `tip_amt`,`B`.`customer_donation_amt` AS `customer_donation_amt`,`B`.`merchant_donation_amt` AS `merchant_donation_amt`,`B`.`trans_fee_amt` AS `trans_fee_amt`,`B`.`user_id` AS `user_id`,`B`.`promo_code` AS `promo_code`,`L`.`type_id_name` AS `type_id_name`,`K`.`type_id_name` AS `order_type`,`B`.`order_qty` AS `order_qty`,`B`.`grand_total` AS `grand_total`,`B`.`note` AS `note`,`B`.`delivery_amt` AS `delivery_amt`,`B`.`cash` AS `cash`,(case when (`C`.`order_id` is not null) then 'Catering' else NULL end) AS `is_catering` from (((((`Orders` `B` join `Merchant` `M` on((`B`.`merchant_id` = `M`.`merchant_id`))) left join `Lookup` `L` on(((`L`.`type_id_value` = `B`.`status`) and (`L`.`type_id_field` = 'status')))) left join `Lookup` `K` on(((`K`.`type_id_value` = `B`.`order_type`) and (`K`.`type_id_field` = 'order_type')))) join `User` `U` on((`U`.`user_id` = `B`.`user_id`))) left join `Catering_Orders` `C` on((`B`.`order_id` = `C`.`order_id`))) where (((`B`.`status` <> 'Y') or (`B`.`order_dt_tm` >= (now() - interval 2 day))) and (`B`.`order_dt_tm` > (now() - interval 3 month)))";
        $this->execute($sql);
    }
}
