<?php


use Phinx\Migration\AbstractMigration;

class AddLogicalDeleteToPortalTables extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function up()
    {
        $sql = "ALTER TABLE `portal_brand_lookup` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_brand_lookup_map` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_brand_manager_brand_map` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_email_templates` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_email_types` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_emails` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_failed_jobs` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_leads` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_lookup_hierarchy` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_merchant_group_group_map` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_merchant_group_merchant_map` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_merchant_groups` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_merchant_menu_files` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_object_ownership` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_offer_assets` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_offers` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_operator_merchant_map` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_organization_lookup_map` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_organizations` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_partner_user_map` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_partners` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_permissions` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_permissions_roles_map` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_query_log` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_reminder_periods` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_report_schedules` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_role_user_map` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_roles` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_roles_hierarchy` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_tasks` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_user_parent_child` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_users` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_value_added_reseller_merchant_map` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; 
ALTER TABLE `portal_value_added_reseller_user_map` ADD COLUMN `logical_delete` CHAR(1) NOT NULL DEFAULT 'N'; ";
        $this->execute($sql);
    }

    public function down()
    {
        $sql = "ALTER TABLE `portal_brand_lookup` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_brand_lookup_map` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_brand_manager_brand_map` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_email_templates` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_email_types` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_emails` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_failed_jobs` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_leads` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_lookup_hierarchy` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_merchant_group_group_map` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_merchant_group_merchant_map` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_merchant_groups` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_merchant_menu_files` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_object_ownership` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_offer_assets` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_offers` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_operator_merchant_map` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_organization_lookup_map` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_organizations` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_partner_user_map` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_partners` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_permissions` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_permissions_roles_map` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_query_log` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_reminder_periods` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_report_schedules` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_role_user_map` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_roles` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_roles_hierarchy` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_tasks` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_user_parent_child` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_users` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_value_added_reseller_merchant_map` DROP COLUMN `logical_delete`; 
ALTER TABLE `portal_value_added_reseller_user_map` DROP COLUMN `logical_delete`; ";
        $this->execute($sql);
    }
}
