<?php


use Phinx\Migration\AbstractMigration;

class AddSkinIdToMerchantMenuMap extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('Merchant_Menu_Map');

        $table->addColumn('skin_id', 'integer', ['default' => '1','after'=>'allows_curbside_pickup'])
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00','after'=>'created'))
            ->addForeignKey(['skin_id'],'Skin',['skin_id'])
            ->removeIndexByName('merchant_id')
            ->addIndex(['merchant_id','merchant_menu_type','skin_id'],['unique'=>true,'name'=>'merchant_menutype_skin'])
            ->addIndex(['menu_id'],['unique'=>false])
            ->update();

    }
}
