<?php


use Phinx\Migration\AbstractMigration;

class CreateBrandTagsTable extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('portal_brand_tags');
        $table
            ->addColumn('brand_id', 'integer',['null' => false])
            ->addColumn('tag_name', 'string',['null' => false])
            ->addColumn('tag_type', 'char',['limit' => 1, 'null' => false])
            ->addColumn('tag_value', 'string',['null' => false])
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','char',['limit' => 1,'default' => 'N','null' => false])
            ->addForeignKey(['brand_id'],'Brand2',['brand_id'])
            ->addIndex("brand_id")
            ->addIndex("tag_name");
        $table->create();
    }
}



