<?php


use Phinx\Migration\AbstractMigration;

class CreatePortalMerchantAttributes extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('portal_merchant_attributes');
        $table
            ->addColumn('table', 'string',['null' => false])
            ->addColumn('field', 'string',['null' => false])
            ->addColumn('portal_attribute_control_definition', 'integer',['null' => false])
            ->addColumn('is_nullable', 'string',['null' => false])
            ->addColumn('column_default', 'string')
            ->addColumn('character_maximum_length', 'integer')
            ->addColumn('add_new_record', 'enum', array('values' => ['Y', 'N'], 'default' => 'N', 'null' => false ))
            ->addColumn('options', 'string')
            ->addColumn('description', 'string',['limit' => 2048])
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','char',['limit' => 1,'default' => 'N','null' => false])
            ->addForeignKey(['portal_attribute_control_definition'],'portal_attribute_control_definition',['id'],['delete'=> 'NO_ACTION', 'update'=> 'NO_ACTION'])
            ->addIndex("table")
            ->addIndex("field");
        $table->create();
    }
}
