<?php


use Phinx\Migration\AbstractMigration;

class CreateAllegenSymbolTable extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('Allergen_Symbols');
        $table
            ->addColumn('name', 'string',['null' => false])
            ->addColumn('label', 'string',['null' => false])
            ->addColumn('description', 'string')
            ->addColumn('created','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('modified','timestamp', array('default' => '0000-00-00 00:00:00'))
            ->addColumn('logical_delete','char',['limit' => 1,'default' => 'N','null' => false]);
        $table->create();

        $sql = "ALTER TABLE `Allergen_Symbols` AUTO_INCREMENT = 1001;";
        $this->execute($sql);


    }
}
