<?php


use Phinx\Migration\AbstractMigration;

class AddFieldsToDeliveryPriceDistance extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('Merchant_Delivery_Price_Distance');
        $table->addColumn('delivery_price_type', 'string', array('after'=>'name'))
            ->addColumn('priority', 'integer', array('default' =>100,'after'=>'active'))
            ->addColumn('maximum_order_amount', 'decimal', array('precision' => 10, 'scale' => 2, 'default' => 10000.00,'after'=>'minimum_order_amount'))
            ->addColumn('max_days_out','integer',['null' => false,'default' => 1,'after'=>'priority'])
            ->addColumn('minimum_delivery_time','integer',['null' => false,'default' => 45,'after'=>'priority'])
            ->addColumn('delivery_increment','integer',['null' => false,'default' => 15,'after'=>'priority'])
            ->addColumn('allow_asap_on_delivery','string',['null' => false,'limit' => 1,'default' => 'N','after'=>'priority'])
            ->update();
    }
}
