<?php


use Phinx\Migration\AbstractMigration;

class CreatePortalJobLogs extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {

        $table = $this->table('portal_job_logs');
        $table
            ->addColumn('name','string', ['null' => true])
            ->addColumn('class_name', 'string', ['null' => true])
            ->addColumn('method', 'string', ['null' => true])
            ->addColumn('code', 'string', ['null' => true])
            ->addColumn('description', 'text')
            ->addColumn('last_run', 'datetime', ['null' => true])
            ->addColumn('status', 'string', ['null' => true])
            ->addColumn('exception', 'text')
            ->addColumn('created_at','timestamp', array('default' => 'CURRENT_TIMESTAMP'))
            ->addColumn('updated_at','timestamp', array('default' => '0000-00-00 00:00:00'));
        $table->create();

    }
}
