<?php

use Phinx\Migration\AbstractMigration;

class CreateViewForSodexoSkins extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * https://book.cakephp.org/phinx/0/en/migrations.html
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
//    public function change()
//    {
//
//    }

    /**
     * Migrate Up.
     */
    public function up()
    {
        $sql = "CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `smawv_sodexo_skin` AS
                    SELECT b.skin_id
                    FROM portal_object_ownership a
                    JOIN Skin b ON a.object_id = b.brand_id
                    WHERE organization_id = 2 AND object_type = 'brand'
                    AND skin_id != 153";
        $this->execute($sql);
    }

    /**
     * Migrate Down.
     */
    public function down()
    {
        $this->execute('DROP VIEW `smawv_sodexo_skin`;');
    }
}
