require 'mysql'

ENVIRONMENTS = {
	"development" => {
		:weborder => {
			:HOST => "rds-test.splickit.com",
			:USER => "itsquik",
			:PWRD => "xxxxxxxxx",
			:DB => "web_ordering_test"
		},
		
		:smaw => {
			:HOST => "rds-test.splickit.com",
			:USER => "itsquik",
			:PWRD => "xxxxxxxxx",
			:DB => "smaw_test"		
		}
	},
	
	"staging" => {
		:weborder => {
			:HOST => "rds-test.splickit.com",
			:USER => "itsquik",
			:PWRD => "xxxxxxxxx",
			:DB => "web_ordering_test"
		},
		
		:smaw => {
			:HOST => "rds-test.splickit.com",
			:USER => "itsquik",
			:PWRD => "xxxxxxxxx",
			:DB => "smaw_test"		
		}	
	},
	
	"prod" => {
		:weborder => {
			:HOST => "rds-prod.splickit.com",
			:USER => "itsquik",
			:PWRD => "xxxxxxxxx",
			:DB => "web_ordering_prod"
		},
		
		:smaw => {
			:HOST => "rds-prod.splickit.com",
			:USER => "itsquik",
			:PWRD => "xxxxxxxxx",
			:DB => "smaw_prod"		
		}	
	}
}

unless ARGV[0] == 'development' or ARGV[0] == 'staging' or ARGV[0] == 'prod'
	raise ArgumentError.new "You must specify one of development/staging/prod as the first argument to this script. You passed '#{ARGV[0]}'."
end

all_conn_info = ENVIRONMENTS[ARGV[0]]
web_conn_info = all_conn_info[:weborder]
smaw_conn_info = all_conn_info[:smaw]

web_conn = Mysql::connect(web_conn_info[:HOST], web_conn_info[:USER], web_conn_info[:PWRD], web_conn_info[:DB])
smaw_conn = Mysql::connect(smaw_conn_info[:HOST], smaw_conn_info[:USER], smaw_conn_info[:PWRD], smaw_conn_info[:DB])

skin_ids = smaw_conn.query "SELECT distinct external_identifier from Skin"
skin_ids.each do |external_id|	
	external_id = external_id[0]
	skin_info = {}
	web_info = web_conn.query "SELECT setting_key, setting_value from merchant_settings where merchant_id = '#{external_id}' and (setting_key = 'lat' or setting_key = 'long' or setting_key = 'zip')"
	web_info.each do |info|
		skin_info[info[0]] = info[1]
	end	
	
	smaw_conn.query "UPDATE Skin set lat = '#{skin_info["lat"]}', lng = '#{skin_info["long"]}', zip = '#{skin_info["zip"]}' where external_identifier = '#{external_id}'"
	puts "finished processing #{external_id}"
end