<?php


use Phinx\Seed\AbstractSeed;

class EmmaMarketingInfo extends AbstractSeed
{
    /**
     * Run Method.
     *
     * Write your database seeder using this method.
     *
     * More information on writing seeders is available here:
     * http://docs.phinx.org/en/latest/seeding.html
     */
    public function run()
    {
        $data = ['id'=>6003,'third_party_provider_type_id'=>6000,'name'=>'Emma','description'=>'Emma Marketing Service'];

        $this->table('Third_Party_Providers')
            ->insert($data)
            ->save();

        $data = [
            ['third_party_provider_id'=>6003,'name'=>'active_flag','default_context'=>'brand','required'=>1],
            ['third_party_provider_id'=>6003,'name'=>'groups','default_context'=>'brand','required'=>1],
            ['third_party_provider_id'=>6003,'name'=>'account_id','default_context'=>'brand','required'=>1],
            ['third_party_provider_id'=>6003,'name'=>'public_api_key','default_context'=>'brand','required'=>1],
            ['third_party_provider_id'=>6003,'name'=>'private_api_key','default_context'=>'brand','required'=>1],
        ];

        $this->table('Third_Party_Provider_Parameters')
            ->insert($data)
            ->save();


        $data = [
            ['name'=>'emma_url','value'=>'https://api.e2ma.net/%%account_id%%/members/add','environment'=>'default']
        ];

        $this->table('Configuration_By_Environment_Variables')
            ->insert($data)
            ->save();


    }
}
