<?php


use Phinx\Seed\AbstractSeed;

class GivexDataFields extends AbstractSeed
{


    /*
     * INSERT INTO Third_Party_Providers (id,third_party_provider_type_id,name,description)
VALUES (5002,5000,'GiveX','GiveX Stored Value');

INSERT INTO Third_Party_Provider_Parameters (third_party_provider_id,name,default_context,required)
VALUES (5002,'user_id','skin',1),(5002,'password','skin',1);

INSERT INTO Splickit_Accepted_Payment_Types
VALUES (12020,'GiveX Stored Value','GiveX Stored Value','givexpaymentservice',NOW(),NOW(),'N');


INSERT INTO Configuration_By_Environment_Variables (`name`,`value`,`environment`) VALUES ('givex_url','https://dev-dataconnect.givex.com:50104','default');
INSERT INTO Configuration_By_Environment_Variables (`name`,`value`,`environment`) VALUES ('givex_url','https://dc-us2.givex.com:50104','production');

     */


    public function run()
    {
        $data = ['id'=>5002,'third_party_provider_type_id'=>5000,'name'=>'GiveX','description'=>'GiveX Stored Value'];

        $this->table('Third_Party_Providers')
            ->insert($data)
            ->save();

        $data = [
            ['third_party_provider_id'=>5002,'name'=>'user_id','default_context'=>'skin','required'=>1],
            ['third_party_provider_id'=>5002,'name'=>'password','default_context'=>'skin','required'=>1]
                ];

        $this->table('Third_Party_Provider_Parameters')
            ->insert($data)
            ->save();


        $data = ['id'=>12020,'name'=>'GiveX Stored Value','description'=>'GiveX Stored Value','payment_service'=>'givexpaymentservice'];

        $this->table('Splickit_Accepted_Payment_Types')
            ->insert($data)
            ->save();

        $data = [['type_id_field'=>'Splickit_Accepted_Payment_Types','type_id_value'=>12020,'type_id_name'=>'GiveX','active'=>'Y']];
        $this->table('Lookup')
            ->insert($data)
            ->save();


        $data = [
            ['name'=>'givex_url','value'=>'https://dev-dataconnect.givex.com:50104','environment'=>'default'],
            ['name'=>'givex_url','value'=>'https://dc-us2.givex.com:50104','environment'=>'production']
        ];

        $this->table('Configuration_By_Environment_Variables')
            ->insert($data)
            ->save();


    }
}
