<?php


use Phinx\Seed\AbstractSeed;

class MessageControllerInfosList extends AbstractSeed
{
    /**
     * Run Method.
     *
     * Write your database seeder using this method.
     *
     * More information on writing seeders is available here', 'base_format'=>'
     * http', 'base_format'=>'//docs.phinx.org/en/latest/seeding.html
     */
    public function run()
    {

        $data = [
            ['name' => 'China Printer','url_name' => 'chinaipprinter', 'base_format'=>'H', 'controller_name' => 'ChinaIPPrinterController', 'is_pulled_message_type'=>1],
            ['name' => 'Windows Service','url_name' => 'winapp', 'base_format'=>'W', 'controller_name' => 'WindowsServiceController', 'is_pulled_message_type'=>1],
            ['name' => 'Epson Printer','url_name' => 'epsonprinter', 'base_format'=>'S', 'controller_name' => 'EpsonPrinterController', 'is_pulled_message_type'=>1],
            ['name' => 'Compris POS','url_name' => 'compris', 'base_format'=>'O', 'controller_name' => 'ComprisController', 'is_pulled_message_type'=>1],
            ['name' => 'Foundry','url_name' => 'foundry', 'base_format'=>'U', 'controller_name' => 'FoundryController', 'is_pulled_message_type'=>1],
            ['name' => 'Portal','url_name' => 'portal', 'base_format'=>'P', 'controller_name' => 'PortalController', 'is_pulled_message_type'=>1],
            ['name' => 'Json','url_name' => 'json', 'base_format'=>'J', 'controller_name' => 'JsonController', 'is_pulled_message_type'=>1],
            ['name' => 'Star Micros Printer','url_name' => 'starmicros', 'base_format'=>'R', 'controller_name' => 'StarmicrosPrinterController', 'is_pulled_message_type'=>1],
            ['name' => 'Fax Machine','url_name' => 'fax', 'base_format'=>'F', 'controller_name' => 'FaxController'],
            ['name' => 'Robo Call','url_name' => 'ivr', 'base_format'=>'I', 'controller_name' => 'IvrController'],
            ['name' => 'Email','url_name' => 'email', 'base_format'=>'E', 'controller_name' => 'EmailController'],
            ['name' => 'Text Message','url_name' => 'text', 'base_format'=>'T', 'controller_name' => 'TextController'],
            ['name' => 'DbLog','url_name' => 'dblog', 'base_format'=>'D', 'controller_name' => 'DbLogController'],
            ['name' => 'Curl','url_name' => 'curl', 'base_format'=>'C', 'controller_name' => 'CurlController'],
            ['name' => 'Task Retail POS','url_name' => 'taskretail', 'base_format'=>'A', 'controller_name' => 'TaskRetailController'],
            ['name' => 'Brink POS','url_name' => 'brink', 'base_format'=>'B', 'controller_name' => 'BrinkController'],
            ['name' => 'Xoikos POS','url_name' => 'xoikos', 'base_format'=>'X', 'controller_name' => 'XoikosController'],
            ['name' => 'Vivonet POS','url_name' => 'vivonet', 'base_format'=>'V', 'controller_name' => 'VivonetController'],
            ['name' => 'Emagine POS','url_name' => 'emagine', 'base_format'=>'N', 'controller_name' => 'EmagineController'],
            ['name' => 'Xenial POS', 'url_name' => 'xenial', 'base_format'=> 'L', 'controller_name' => 'EnterpriseController']
        ];

        $this->table('Message_Controller_Template_Infos')
            ->insert($data)
            ->save();
    }
}
