<?php


use Phinx\Seed\AbstractSeed;

class TelegramData extends AbstractSeed
{
    /**
     * Run Method.
     *
     * Write your database seeder using this method.
     *
     * More information on writing seeders is available here:
     * https://book.cakephp.org/phinx/0/en/seeding.html
     */
    public function run()
    {
        $data = ['id'=>8000,'type'=>'Communication','description'=>'Communication Types That Need Configuration'];
        $this->table('Third_Party_Provider_Types')
            ->insert($data)
            ->save();


        $data = ['id'=>8001,'third_party_provider_type_id'=>8000,'name'=>'Telegram','description'=>'Telegram'];

        $this->table('Third_Party_Providers')
            ->insert($data)
            ->save();

        $data = [
            ['third_party_provider_id'=>8001,'name'=>'bot_token','default_context'=>'brand','required'=>1]
        ];

        $this->table('Third_Party_Provider_Parameters')
            ->insert($data)
            ->save();

        $data = [
            ['name'=>'telegram_api_url','value'=>'https://api.telegram.org/bot%%bot_token%%/','environment'=>'default']
        ];

        $this->table('Configuration_By_Environment_Variables')
            ->insert($data)
            ->save();
    }
}
