<?php


use Phinx\Seed\AbstractSeed;

class WorldPayDataFields extends AbstractSeed
{
    /**
     * Run Method.
     *
     * Write your database seeder using this method.
     *
     * More information on writing seeders is available here:
     * https://book.cakephp.org/phinx/0/en/seeding.html
     */
    public function run()
    {

        $data = ['id'=>7000,'type'=>'P2P','description'=>'Point To Point Payment'];
        $this->table('Third_Party_Provider_Types')
            ->insert($data)
            ->save();


        $data = ['id'=>7001,'third_party_provider_type_id'=>7000,'name'=>'WorldPay','description'=>'WorldPay'];

        $this->table('Third_Party_Providers')
            ->insert($data)
            ->save();

        $data = [
            ['third_party_provider_id'=>7001,'name'=>'worldpay_merchant_id','default_context'=>'merchant','required'=>1],
        ];

        $this->table('Third_Party_Provider_Parameters')
            ->insert($data)
            ->save();


        $data = ['id'=>13010,'name'=>'WorldPay','description'=>'World Pay','payment_service'=>'worldpaypaymentservice'];

        $this->table('Splickit_Accepted_Payment_Types')
            ->insert($data)
            ->save();

        $data = [['type_id_field'=>'Splickit_Accepted_Payment_Types','type_id_value'=>13010,'type_id_name'=>'WorldPay','active'=>'Y']];
        $this->table('Lookup')
            ->insert($data)
            ->save();


        $data = [
            ['name'=>'worldpay_url','value'=>'https://world-xchange.com/webservices/kiosk/add_purchase_code-brandon.php','environment'=>'default'],
            ['name'=>'worldpay_url','value'=>'https://sumumdomain.com','environment'=>'production'],
            ['name'=>'world_pay_mxtoken','value'=>'$2y$10$Qfn5Ct4p86GaaTA0vm5iOu.evm57p7dLgbs6x1IAALgfPkaXydrme','environment'=>'default'],
            ['name'=>'world_pay_mxtoken','value'=>'sumdumtoken','environment'=>'production']
        ];

        $this->table('Configuration_By_Environment_Variables')
            ->insert($data)
            ->save();

    }
}
