<?php
$_SERVER['request_time1'] = microtime(true);
error_reporting(E_ERROR|E_COMPILE_ERROR|E_COMPILE_WARNING|E_PARSE);
ini_set('display_errors','0');
//error_reporting(E_ALL);
$no_error = true;
include 'lib'.DIRECTORY_SEPARATOR.'utilities'.DIRECTORY_SEPARATOR.'functions.inc';
include 'lib'.DIRECTORY_SEPARATOR.'utilities'.DIRECTORY_SEPARATOR.'dispatch_functions.inc';
include 'lib'.DIRECTORY_SEPARATOR.'utilities'.DIRECTORY_SEPARATOR.'SmsInterface.inc';

$request = new Request();

try {
	$body=$request->validateAndParseRequestBody();
    $_SERVER['request_body'] = $body;
} catch (Exception $e) {
	myerror_log("Error throw trying to parse request body: ".$e->getMessage());
	$response = getResponseWithJsonForError($e->getMessage(), $e->getCode(), $error_title, $text_for_button, $fatal, $url,422);
}
$_SERVER['request_url'] = $request->url;

if (substr_count($request->url,'/dummyandroidpushcall') > 0 && (isTest() || isLaptop())) {
	PushAndroid::dummyAndroidPush();
	die();
} else if (substr_count($request->url,'/static_assets') > 0) {
	getStaticAssetRequest($request);
	die;
} else if  (substr_count($request->url,'/testtimeout') > 0 ) {
	sleep(100);
	die;
} else if (substr_count($request->url,'/menustatus') > 0 ) {
			$resource = CompleteMenu::getMenuStatus($request,$mimetypes);
			$response = getResponseWithJsonFromResource($resource, $headers);
}
if (isset($response)) {
	$response->output();
	die();
}

if (substr_count($request->url,'/placeorder') > 0 ) {
	$_SERVER['STAMP'] = 'placeorder-'.$code;
} else if (substr_count($request->url,'/usersession') > 0 ) {
	$_SERVER['STAMP'] = 'userssession-'.$code;
} else if (substr_count($request->url,'/users') > 0 ) {
	$_SERVER['STAMP'] = 'users-'.$code;
} else {
	$_SERVER['STAMP'] = $code;
}

myerror_log("********* starting dispatch.php *********  ".$_SERVER['PHP_AUTH_USER']."  *******");
logData(getallheaders(), "All Headers",6);

include 'lib'.DIRECTORY_SEPARATOR.'utilities'.DIRECTORY_SEPARATOR.'dispatch_login.inc';

if (isLoggedInUserStoreTesterLevelOrBetter()) {
	myerror_log("logged in user is store tester or better so let logging to 5");
    $log_level = 5;
    $_SERVER['log_level'] = 5;
}

try {	
	if ($authorized && $no_error) {
		if (substr_count($request->url,'/usersession') > 0 ) {
			$usersession_controller = new UsersessionController($mimetypes, $user, $request, $log_level);
			// $user_resource was created in dispatch_login.inc
			$resource =& $usersession_controller->getUserSession($user_resource);
		} else if (substr_count($request->url,'/getauthtoken') > 0 ) {
			$usersession_controller = new UsersessionController($mimetypes, $user, $request, $log_level);
			// $user_resource was created in dispatch_login.inc
			$resource =& $usersession_controller->getUserSession($user_resource);
			$data['auth_token'] = $resource->splickit_authentication_token;
			$json = json_encode($data);
			$response = new Response(200);
			$response->body = $json;
			$response->output();
			die;
		} else if (substr_count($request->url,'/sendwindowsservicetestmessage') > 0 ) {
			$merchant_controller = new MerchantController($mimetypes,$user,$request,4);
			$merchant_controller->createWindowsTestMessage();
			die();
		} else if (substr_count($request->url,'/getmerchantmetadata/') > 0 ) {
			$merchant_adapter = new MerchantAdapter($mimetypes);
			$resource = $merchant_adapter->getMerchantMetadata($request->url);
		} else if (substr_count($request->url,'/jerseymikesstore/') > 0 ) {
			$jersey_mikes_importer = new JerseyMikesImporter();
			$resource = $jersey_mikes_importer->createStoreLinkResponseFromRequest($request); 
		} else if (substr_count($request->url,'/importjerseymikesprices/') > 0 ) {
			$response = JerseyMikesImporter::stageImportFromRequest($request);
		} else if (substr_count($request->url,'/airports') > 0 ) {
			$airport_controller = new AirportController($mimetypes, $user, $request,$log_leve);
			$resource = $airport_controller->processRequest();
		} else if (substr_count($request->url,'/merchants') > 0 ) {
			$merchant_controller = new MerchantController($mimetypes,$user,$request,$log_level);
			if (preg_match('%/merchants/([0-9]{2,10})%', $request->url, $matches)) 
			{
				if (substr_count($request->url,'/getstatus') > 0 )
				{
					$merchant_numeric_id = $matches[1];
					$getstatusactivity = new SendMerchantStatusActivity(NULL);
					$getstatusactivity->set("destination", "browser");
					$resource = $getstatusactivity->getTempMerchantStatus($merchant_numeric_id);
					$_REQUEST['show'] = 'true';					
				}
				else
				{
					$merchant_id = str_ireplace('/merchants/','', $matches[0]);
					$merchant_controller->setMerchantId($merchant_id);
					$time1 = microtime(true);
					$resource = $merchant_controller->getMerchant();
					$time2 = microtime(true);
					$elapsed = $time2-$time1;
					myerror_logging(5,"Dispatch Total time for get Merchant and Menu ".$resource->merchant_id.": ".$elapsed);
					$resource->_representation = '/merchants/merchant.xml';
					if ($skin_id == 4 && getProperty('moes_ordering_on') == 'false' && shouldSystemProcessAsRegularUser($user['user_id'])) {
						$resource->set('user_message', getProperty('moes_ordering_off_message'));	
					} else if ($skin_id == 72 && getProperty('jersey_mikes_ordering_on') == 'false'  && shouldSystemProcessAsRegularUser($user['user_id'])) {
						$resource->set('user_message', getProperty('jersey_mikes_ordering_off_message'));				
					}							
				}
			} else {
				// merchants and merchants2 is for backward compatability with earlier versions.
				$time1 = microtime(true);
				if (substr_count($request->url,'/merchants2') > 0 )
					$resource = $merchant_controller->getMerchantList2($skin_id);
				else 
					$resource = $merchant_controller->getMerchantList($skin_id);
				$time2 = microtime(true);
				$elapsed = $time2-$time1;
				myerror_log("elapsed time for getMerchantList: ".$elapsed."    ".$skin['external_identifier']);	
			}
		} else if (substr_count($request->url,'/users') > 0 ) {			
			$user_controller = new UserController($mimetypes, $user, $request,$log_level);
			$resource = $user_controller->processRequest();
		} else if (substr_count($request->url,'/resetpassword') > 0 ) {
			$user_controller = new UserController($mimetypes, $user, $request, $log_level);
			$resource = $user_controller->changePasswordWithToken();
			$resource->_representation = '/json.xml';
		} else if (substr_count($request->url,'/forgotpassword') > 0 ) {	
			$user_controller = new UserController($mimetypes, $user, $request, $log_level);
			$resource = $user_controller->forgotPassword();
		} else if (substr_count($request->url,'/communicationsettings') > 0 ) {
			$user_controller = new UserController($mimetypes, $user, $request, $log_level);
			$resource = $user_controller->setCommunication();
		} else if (substr_count($request->url,'/getdeliverydistance') > 0 ) {
			//$request->_parseRequestBody();
			$merchant_id = $request->data['merchant_id'];
			$user_delivery_location_id = $request->data['user_addr_id'];
			$mdpd_adapter = new MerchantDeliveryPriceDistanceAdapter($mimetypes);
			$miles = $mdpd_adapter->getMilesFromUserDeliveryLocationAndMerchantIds($user_delivery_location_id, $merchant_id);
			myerror_log("the calculated miles are: ".$miles);
			$results['delivery_distance'] = $miles;
			$resource =& Resource::dummyfactory($results);
			
		} else if (substr_count($request->url,'/isindeliveryarea') > 0 ) {
			$delivery_controller = new DeliveryController($mimetypes,$user,$request,$log_level);
			$delivery_info = $delivery_controller->getRelevantDeliveryInfoFromRequest();
			$response = getResponseWithJsonFromHash($delivery_info,$headers);
		} else if ($skin_id == 4 && getProperty('moes_ordering_on') == 'false' && shouldSystemProcessAsRegularUser($user['user_id'])) {
			$resource = returnErrorResource(getProperty('moes_ordering_off_message'),999);	
		} else if ($skin_id == 72 && getProperty('jersey_mikes_ordering_on') == 'false'  && shouldSystemProcessAsRegularUser($user['user_id'])) {
			$resource = returnErrorResource(getProperty('jersey_mikes_ordering_off_message'),999);				
		} else if (substr_count($request->url,'/getpaywithpointsoptionslist') > 0 ) {
			//$resource = returnErrorResource("endpoint has not been activated yet");
			$loyalty_controller = new LoyaltyController($mimetypes, $user, $request, $log_level);
			$cart_data = $request->data;
			$resource = $loyalty_controller->getSortedAndFormatedPointsCombinationsFromCartDataAsResource($cart_data);	
		} else if ($user['email'] == 'admin' || $user['email'] == 'nouser') {
			// admin user should NOT be able to access anything beyond this point
			myerror_log("ERROR!  admin endpoint not allowed!");
			respondWithPlainTextBody('Unauthorized access', 401);
			die;
		} else if (substr_count($request->url,'/getcheckoutdata') > 0 ) {	
			$place_order_controller = new PlaceOrderController($mimetypes,$user,$request,$log_level);
			$resource = $place_order_controller->getCheckoutDataFromOrderRquest();
			date_default_timezone_set($default_timezone);
		} else if (substr_count($request->url,'/setuserdelivery') > 0 ) {			
			$user_controller = new UserController($mimetypes, $user, $request,$log_level);
			$resource = $user_controller->setDeliveryAddr();
		} else if (substr_count($request->url,'/deleteuserdelivery') > 0 ) {			
			$user_controller = new UserController($mimetypes, $user, $request,$log_level);
			$resource = $user_controller->deleteDeliveryAddr();
		} else if (substr_count($request->url,'/deletefavorite') > 0 ) {
			$favorite_controller = new FavoriteController($mimetypes, $user, $request, $log_level);
			$resource = $favorite_controller->deleteFavorite();
		} else if (substr_count($request->url,'/favorites') > 0 ) {
			$favorite_controller = new FavoriteController($mimetypes, $user, $request, $log_level);
			//$resource = $favorite_controller->process();
			if ($request->method == 'post')
				$resource = $favorite_controller->saveFavorite();
			else
				$resource = $favorite_controller->getFavorite();
		} else if (substr_count($request->url,'/creategrouporder') > 0 ) {
			$group_order_controller = new GroupOrderController($mimetypes, $user, $request, $log_level);
			$resource = $group_order_controller->createGroupOrder();
			
		} else if (substr_count($request->url,'/addtogrouporder') > 0 ) {
			$group_order_controller = new GroupOrderController($mimetypes, $user, $request, $log_level);
			$resource = $group_order_controller->addToGroupOrderFromRequest();
		} else if (substr_count($request->url,'/getgrouporderdetails') > 0 ) {
			$group_order_controller = new GroupOrderController($mimetypes, $user, $request, $log_level);
			$resource = $group_order_controller->getGroupOrderData();
		} else if (substr_count($request->url,'gift') > 0 ) {
      $resource = createErrorResourceWithHttpCode("Gifting has been turned off at SplickIt.", 410);
		} else if (substr_count($request->url,'/placeorder') > 0 ) {
			$ordering_shutdown = ($global_properties['ordering_shutdown'] == 'true');			
			if ($ordering_shutdown && $user['user_id'] > 1000) {
				$response = getResponseWithJsonForError("Sorry, the mobile ordering system is currently offline.  Please try again shortly.", 0, $error_title, $text_for_button, $fatal, $url, $headers);
			} else {
				myerror_log("starting place order code with server log level of: ".$_SERVER['log_level']);
				// any auth_data will be on the user object if needed
				$place_order_controller = new PlaceOrderController($mimetypes,$user,$request,$log_level);
				$resource = $place_order_controller->placeOrderFromRequest();
			}
		} else if (substr_count($request->url,'/validatepromo') > 0 ) {
			$promo_controller = new PromoController($mimetypes,$user,$request,1);
			$resource = $promo_controller->validatePromo($order_data);
		} else if (substr_count($request->url,'/validateoffer') > 0 ) {
			$promo_controller = new PromoController($mimetypes,$user,$request,1);
			$resource = $promo_controller->validateOffer();
			if (isset($resource->tax_amt) && $resource->tax_amt > 0.00) {
				$resource->amt = $resource->amt + $resource->tax_amt;
			}
		} else if (substr_count($request->url,'/sendcustomerserviceresult') > 0 ) {
			logData($request->data, "customer service results");
			die("end of code");	
		} else if (substr_count($request->url,'/createskin') > 0 && ($user['user_id'] == 20000 || $user['user_id'] == 20582) ){
			$skin_adapter = new SkinAdapter($mimetypes);
			$sql = "call SMAWSP_ADMIN_CREATE_SKIN('".$request->data['skin_id']."','".$request->data['skin_name']."')";
			if ($skin_adapter->_query($sql)) {
				respondOkWithTextPlainbody("Skin has been created");
			} else {
				$response = getResponseWithJsonForError('there was an error: '.$skin_adapter->getLastErrorText(), $error_code, $error_title, $text_for_button, $fatal, $url, $headers);
			}
		}
    } else if (substr_count($request->url,'/getmerchantmetadata/') > 0 ) {
        $merchant_adapter = new MerchantAdapter($mimetypes);
        $resource = $merchant_adapter->getMerchantMetadata($request->url);

    } else if ($response == null) {
        myerror_log("bad anonymous request: ".$request->url);
        $response = getResponseWithJsonForError('Authentication Error', 401, $error_title, $text_for_button, $fatal, $url, $headers,401);
    }
} catch (Exception $e) {
	myerror_log("HOLY COW!  we had an exception thrown! message: ".$e->getMessage());
	$resource = returnErrorResource($e->getMessage(),$e->getCode());
	recordError("Error thrown on smaw_dispatch", "error: ".$e->getMessage());
}

$final_response = isset($response) ? $response : getResponseWithJsonFromResource($resource, $headers);
$final_response->output();

?>
