<?php
$_SERVER['request_time1'] = microtime(true);
$_SERVER['DISPATCH'] = 'MESSAGE: ';
$_SERVER['LOG_COUNT'] = 0;

error_reporting(E_ERROR|E_COMPILE_ERROR|E_COMPILE_WARNING|E_PARSE);
ini_set('display_errors','0');
ini_set('mysql.connect_timeout', 20);
//error_reporting(E_ALL);

$path = $_SERVER['DOCUMENT_ROOT'].'/app2/';
set_include_path(get_include_path() . PATH_SEPARATOR . $path);

include 'lib'.DIRECTORY_SEPARATOR.'utilities'.DIRECTORY_SEPARATOR.'functions.inc';
include 'lib'.DIRECTORY_SEPARATOR.'utilities'.DIRECTORY_SEPARATOR.'SmsInterface.inc';

$login_headers = apache_request_headers();
foreach ($login_headers as $key=>$value) {
    $_SERVER['HTTP_'.$key] = $value;
    $_SERVER['HTTP_'.strtoupper($key)] = $value;
    $_SERVER[$key] = $value;
    $_SERVER[strtoupper($key)] = $value;
}

$_SERVER['RAW_STAMP'] = $code;
$_SERVER['STAMP'] = 'message-'.$code;

if (isProd()) {
    $host = $_SERVER['HTTP_HOST'];
    if ($host != 'device.splickit.com' && $host != 'localhost') {
        myerror_log("SERCURITY VIOLATION MESSAGE DISPATCH:  $host != device.splickit.com",2);
    }
}


$request = new Request();
$request->_parseRequestBody();

if (extension_loaded ('newrelic')) {
    $raw_url = $request->url;
    $clean_url = preg_replace('%/getnextmessagebymerchantid/([0-9a-zA-Z]+)%','/getnextmessagebymerchantid/ID',$raw_url);
    $url_parts = explode('?',$clean_url);
    newrelic_name_transaction ($url_parts[0]);
}
$_SERVER['request_url'] = $request->url;
if ((substr_count($request->url, 'sendnextmessage') < 1) && (substr_count($request->url,'/getnextmessagebymerchantid') < 1 )) {
	myerror_log("hitting smaw_message_dispatch with url: ".$request->url,3);
	if (count($request->data) > 0) {
		logData($request->data, "request data on message dispatch",3);
	}
	
}

if ($request->data['log_level']) {
    $log_level = $request->data['log_level'];
} else {
    $log_level = $global_properties['log_level_message_manager'];
}
$_SERVER['log_level'] = $log_level;
$fixed_url = str_replace('/','-',$request->url);
if (substr_count($request->url,'callback') > 0 ) {
    myerror_log("CALLBACK INCOMINGxxxURL: $fixed_url",3);
} else {
    myerror_log("INCOMINGxxxURL: $fixed_url",3);
}


myerror_log("************* starting message dispatch.php ************* $fixed_url",3);
try
{
    $mmha = new MerchantMessageHistoryAdapter(getM());
		
	// ****** first get the correct controller if its listed in the request, like for pings ********
	if ($message_controller = ControllerFactory::getMessageControllerFromRequest($request)) {
		myerror_logging(2,"************* got ".get_class($message_controller)." controller *************");
        $id = $message_controller->getSubmittedIdentifier();
	}
	if (substr_count($request->url,'/sendnextmessage') > 0) {
		// first get array of all the available messages, excluding Pings
		myerror_logging(4, "****** IN THE NEW MESSAGE SENDING LOGIC *******");
		$fixed_controller = false;
		if ($message_controller)
		{
			$fixed_controller = true;
			$format = $message_controller->getFormat();
			$message_data['message_format'] = array("LIKE"=>''.$format.'%');			
		}
		
		$worker_load = getProperty('worker_message_load');
		logData($request->data, "sendnextmessage paramters",3);
					
		$priority = isset($request->data['priority']) ? $request->data['priority'] : getProperty('message_priority');
			
		if ($priority == '1') {
			// order id's of less than 1000 are error codes.
			$message_data['order_id'] = array(">"=>1000);
		} else if ($priority == '2') {
			$message_data['order_id'] = array("IS"=>"NULL");
		}
		logData($message_data,"message data",5);
		$mmha_options[TONIC_FIND_BY_METADATA] = $message_data;
		while ($message_resources = $mmha->getAvailableMessageResourcesArray($mmha_options)) {
			myerror_logging(3,"Worker has grabbed ".sizeof($message_resources)." messages ready to be sent.  now try to get a lock on them one at a time to send");
			// we have available messages so we cycle through and try to grab it with a lock, if its unable to grab the mesage goto the next one.
			$sent_messages = 0;
			foreach ($message_resources as $unlocked_message_resource) {
                myerror_log("we have the unlocked message resource: map_id ".$unlocked_message_resource->map_id,5);
                logData($unlocked_message_resource->getDataFieldsReally(),"MESSAGE",5);
				if ($message_resource = $mmha->getLockedMessageResourceForSending($unlocked_message_resource)) {
					if (! $fixed_controller) {
                        $message_controller = ControllerFactory::generateFromMessageResource($message_resource, $mimetypes, $user, $request, $log_level);
                    }
					if ($message_controller->isControllerForAPulledMessageType()) {
                        myerror_log("ERROR!!!!  Pulled message type pickup up by push message worker");
                        myerror_log("resetting locked to 'P'");
                        $message_resource->locked = 'P';
                        $message_resource->save();
                        $message_resource = null;
                        continue;
                    }
					if ($message_controller) {
                        $message_controller->sendThisMessage($message_resource);
                    } else {
						myerror_log("ERROR! Serious problem with message sending message_id: ".$message_resource->map_id.".  No controller matching message type of: ".$message_resource->message_format);
						MailIt::sendErrorEmailSupport("MESSAGE SENDING ERROR!", "Serious problem with message sending message_id: ".$message_resource->map_id.".  No controller matching message type of: ".$message_resource->message_format);						
					}
				}
				$message_resource = null;
			}
			myerror_logging(3,"Worker has finished this set of messages, worker will now try to grab up to $worker_load more");
			
			//reset the counter
			set_time_limit(30);
		}
		myerror_logging(3, "No more messages ready to be sent.  Worker will now die");
		$response = new Response(200);
		$response->output();
		die("message have been sent: ".getRawStamp()."    \r\n");

	}
	else if ($message_controller == null) {
	    $clean_url = substr_replace('/','-',$request->url);
	    myerror_log("NO CONTROLLER SPECIFIED ERROR!!!");
	    myerror_log("Horrible death. No controller specified: $clean_url");
	    die("Horrible death. No controller specified: $clean_url");
    }
	// ****** now determine what action to take *********
	else if (getControllerAction($message_controller) == 'getnextmessagebymerchantid') {
        myerror_log("GET NEXT MESSAGE BY MERCHANT ID URL: ".$request->url,3);
        logData($message_controller->data,"MESSAGE CONTROLLER DATA",5);

        $message_manager_requests_adapter = new MessageManagerRequestsAdapter(getM());
	    $message_manager_requests_adapter->recordMessageManangerRequest($id,$_SERVER['SCRIPT_URI'],$request->method);
		if ($resource = $message_controller->pullNextMessageResourceByMerchant($id)) {
		    if (isset($resource->map_id)) {
                myerror_log("successful retrieval of message: ".$resource->map_id.", by merchant id: $id, about to send message as response to Pull Request");
            }
			if ($message_controller->message_resource->locked == 'Y') {
			    $message_controller->message_resource->message_text = $resource->message_text;
				$message_controller->markMessageDelivered();
			}
			/*
			 * need to create the response here and output for both message_text and others......
			 */
		} else if ($message_controller->hasMessagingError()) {
			$response = new Response($message_controller->getErrorCode());
			$response->body = $message_controller->getErrorMessage();
			$response->output();
			die;
		} else {
			myerror_logging(3,"there are no orders for the PULL from merchant");
			$response = $message_controller->getNoPulledMessageAvailableResponse();
			myerror_logging(3,'sending back a status of: '.$response->statusCode);
			logData($response->headers, "response headers",3);
			$response->output();
			die;
		}
	}
	else if (getControllerAction($message_controller) == 'callback') {
	    $resource = $message_controller->callBack($id);
        Response::respond200OkAndDie();
	} else if (getControllerAction($message_controller) == 'getorderbyid') {
		$resource = $message_controller->getOrderById($id);
	} else {
	    MailIt::sendErrorEmail("DEAD ENDPOINT ERROR message_dispatch","We have a dead endpoint error for url: ".$request->url);
		die ("horrible death. no endpoint for: $fixed_url");
	}

	//Resource::encodeResourceIntoTonicFormat($resource);
	if ($resource->_representation == '/json.xml') {
		if (isset($resource->error)) {
            $datafields = array('ERROR' => $resource->error,
                'ERROR_CODE' => $resource->error_code,
                'TEXT_TITLE' => $resource->text_title,
                'TEXT_FOR_BUTTON' => $resource->text_for_button,
                'FATAL' => $resource->fatal,
                'URL' => $resource->url
            );
        } else {
            $datafields = Resource::encodeResourceIntoJsonPrepArray($resource);
        } try {
			$jsonString = json_encode($datafields);
		} catch (Exception $e) {
			myerror_log("error encoding ".$e->getMessage()); // do nothing
		}
		$resource->set('json',$jsonString);
	}
	
	$representation =& $resource->loadRepresentation($file_adapter);
		
	if ($resource && $representation) {
        $response =& $representation->get($request);
    }

	if ($log_level > 2) {
        if (substr_count($request->url, '/epsonprinter/') > 0) {
            myerror_log("********** headers ***********");
            foreach ($response->headers as $header_name => $header_value) {
                myerror_log("$header_name : $header_value");
            }
        }
        myerror_log("********** body *************");
        $text = $response->getOutputAsText();
        myerror_log($text);
        myerror_log("**************************");
    }
	$response->output();	
} catch (Exception $e) {
	MailIt::sendErrorEmail("EXCEPTION THROWN ON smaw_message_dispatch", $e->getMessage());
	$response = new Response(500,$e->getMessage());
	$response->output();
}
myerror_logging(2,"***********finishing message_dispatch************");


/**
 * @param $message_controller MessageController
 * @return bool
 */
function getControllerAction($message_controller)
{
    if ($message_controller) {
        return $message_controller->getSubmittedAction();
    } else {
        return '';
    }
}

?>