<?php
$_SERVER['request_time1'] = microtime(true);
$_SERVER['DISPATCH'] = 'PORTAL: ';
$_SERVER['LOG_COUNT'] = 0;

error_reporting(E_ERROR|E_COMPILE_ERROR|E_COMPILE_WARNING|E_PARSE);
set_time_limit(1000);
//error_reporting(E_ALL);
//ini_set('display_errors','1');

$path = $_SERVER['DOCUMENT_ROOT'].'/app2/';

set_include_path(get_include_path() . PATH_SEPARATOR . $path);

include 'lib'.DIRECTORY_SEPARATOR.'utilities'.DIRECTORY_SEPARATOR.'functions.inc';
include 'lib'.DIRECTORY_SEPARATOR.'utilities'.DIRECTORY_SEPARATOR.'dispatch_functions.inc';
include 'lib'.DIRECTORY_SEPARATOR.'utilities'.DIRECTORY_SEPARATOR.'SmsInterface.inc';
include 'lib'.DIRECTORY_SEPARATOR.'utilities'.DIRECTORY_SEPARATOR.'smlrpc.inc';

$_SERVER['STAMP'] = 'portal-'.$code;

logData(getallheaders(),"HEADERS",3);
$request = new Request();
if (extension_loaded ('newrelic')) {
    newrelic_name_transaction ($request->url);
}

$request->_parseRequestBody();
$_SERVER['request_url'] = $request->url;
logData($request->data,"REQUEST DATA",3);
if ($brand_name = $request->data['brand_name']) {
	myerror_log("WE HAVE A SUBMITTED BRAND NAME: $brand_name");
	if ($skin = SkinAdapter::getSkin('com.splickit.'.$brand_name)) {
		$skin_id = $skin['skin_id'];
		setGlobalSkinValuesForContextAndDevice($skin,'PortalDispatch');
	}
}
$resource = new Resource();
$log_level = isset($request->data['log_level']) ? $request->data['log_level'] : $global_properties['log_level_portal'];
myerror_log("******starting smaw_portal_dispatch********* with ".getCapitalizedRequestMethod($request)." method",1);
myerror_log("request url: ".$request->url." we have set the log level to $log_level on the portal dispatch",1);
$_SERVER['log_level'] = $log_level;
$_SERVER['PORTAL_REQUEST'] = true;

if ($user_id = $request->data['user_id']) {
	$user_adapter = new UserAdapter($mimetypes);
	if (is_numeric($user_id)) {
        $user = $user_adapter->getRecord(array("user_id" => $user_id));
    } else {
        $user = $user_adapter->getRecord(array('email'=>$user_id));
	}
}
try {
    if (substr_count($request->url, '/pos/') > 0 ) {
        $pos_controller = new PosController($mt, $user, $request, 5);
        $pos_controller->setAdmin();
        $resource = $pos_controller->processV2Request();
    } else if (substr_count($request->url, '/import/') > 0 ) {
        $pos_controller = new PosController($mt, $user, $request, 5);
        $resource = $pos_controller->processV2Request();
    } else if (substr_count($request->url,'/flushcache')) {
        $splickit_cache = new SplickitCache();
        $resource = $splickit_cache->processCachBustRequest($request->url);
    } else if (substr_count($request->url,'/pushmessage/')) {
        $pmc = new PushMessageController($m, $u, $request);
        $pmc->pushMessageToUserFromRequest();
        $result = array('result' => 'success', 'stamp' => getRawStamp());
        $response = new Response(200, "<html><body>" . json_encode($result) . "</body></html>");
    } else if (substr_count($request->fullUrl,'/messages') > 0 ) {
        $portal_message_controller = new PortalMessageController(getM(),null,$request,getBaseLogLevel());
        $resource = $portal_message_controller->processRequest();
    } else if (substr_count($request->fullUrl,'/orders/') > 0 ) {
        $order_controller = new OrderController(getM(),null,$request);
        $resource = $order_controller->processV2Request();
    } else if (substr_count($request->fullUrl,'/menus') > 0 ) {
        $menu_controller = new MenuController(getM(),null,$request,getBaseLogLevel());
        $resource = $menu_controller->processV2Request();
    } else if (substr_count($request->fullUrl,'/promos') > 0 ) {
        $promo_controller = new PromoController(getM(),null,$request,getBaseLogLevel());
        $resource = $promo_controller->processV2Request();
    } else if (substr_count($request->fullUrl,'/brands') > 0 ) {
        $brand_controller = new BrandController(getM(),null,$request,getBaseLogLevel());
        $resource = $brand_controller->processRequest();
    } else if (substr_count($request->fullUrl,'/skins') > 0 ) {
        $skin_controller = new SkinController(getM(),null,$request,getBaseLogLevel());
        $resource = $skin_controller->processRequest();
    } else if (substr_count($request->fullUrl,'/users') > 0 ) {
        $user_controller = new UserController(getM(),null,$request,getBaseLogLevel());
        $resource = $user_controller->processV2Request();
    } else if (substr_count($request->fullUrl,'/payments') > 0 ) {
        $card_gateway_controller = new CardGatewayController(getM(),null,$request,getBaseLogLevel());
        $resource = $card_gateway_controller->processRequest();
    }else if (substr_count($request->fullUrl,'/merchants') > 0 ) {
        $merchant_controller = new MerchantController(getM(),null,$request,getBaseLogLevel());
        $resource = $merchant_controller->processV2Request();
    } else {
		$resource = createErrorResourceWithHttpCode("No known endpoint",422,0);
	}// end if mercant_menu or menuitem else

} catch (Exception $e) {
    myerror_log("there was an error: ".$e->getMessage());
    myerror_log($e->getTraceAsString());
    //$resource = createErrorResourceWithHttpCode($e->getMessage(),422,422);
    $error = $e->getMessage();
    $resource = createErrorResourceWithHttpCode($error,500,500);
}
myerror_log("THIS IS THE RESOURCE",5);
Resource::encodeResourceIntoTonicFormat($resource);

$final_response = getPortalResponseWithJsonFromResource($resource, $headers);
myerror_log("responding with: ".$final_response->body,3);
$final_response->output();
?>