<?php

$menu_xml = file_get_contents('TJ-Aloha.xml');

$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');

include_once "lib/utilities/functions.inc";


$menu_array = parseXMLintoHashmap($menu_xml);

$menu_categories = $menu_array['MENUCATEGORIES']['MENUCATEGORY'];
$menu_items = getItemHashByTJItemId($menu_array['MENUITEMS']['MENUITEM']);
$modifier_groups = getModifierGroupHashByTJModifierGroupId($menu_array['MODIFIERGROUPS']['MODIFIERGROUP'],$menu_items);
$tax_rates = $menu_array['MENUTAXES']['MENUTAX'];
$menu = array();
foreach ($menu_categories as $tj_menu_type) {
    $menu_type = array();
    $menu_type['name'] = getNameFromAttribute($tj_menu_type,'DESC');
    $menu_type['external_id'] = getNameFromAttribute($tj_menu_type,'CATEGORYID');
    $menu_type['items'] = array();
    foreach ($tj_menu_type['MENUITEM'] as $menu_type_item) {
        $item = array();
        $item = $menu_items[getNameFromAttribute($menu_type_item,'ITEMID')];
        $menu_type['items'][$item['name']] = $item;
    }
    $menu['menu_types'][$menu_type['name']] = $menu_type;
}
$menu['modifier_groups'] = $modifier_groups;
$menu_string = print_r($menu,true);
myerror_log($menu_string);


function getNameFromAttribute($row,$attribute_name)
{
    return $row['@attributes'][strtoupper($attribute_name)][0];
}

function getItemHashByTJItemId($menu_items)
{
    $tj_item_hash = array();
    foreach ($menu_items as $menu_item) {
        $item = array();
        $item['external_id'] = getNameFromAttribute($menu_item,'ITEMID');
        $item['name'] = getNameFromAttribute($menu_item,'LONGDESC');
        $item['print_name'] = getNameFromAttribute($menu_item,'SHORTDESC');
        $item['price'] = number_format(getNameFromAttribute($menu_item,'PRICE'),2);
        $item['tax_rate_id'] = getNameFromAttribute($menu_item,'TAXID1');
        $item['item_modifier_group_maps'] = array();
        foreach ($menu_item['MENUITEMMODIFIERS']['MENUITEMMODGRP'] as $group_id_row) {
            $tj_modifier_group_id = getNameFromAttribute($group_id_row,'MODGRPID');
            $item['item_modifier_group_maps'][] = $tj_modifier_group_id;
        }
        if (count($item['item_modifier_group_maps']) == 0) {
            unset($item['item_modifier_group_maps']);
        }
        $tj_item_hash[$item['external_id']] = $item;
    }
    return $tj_item_hash;
}

function getModifierGroupHashByTJModifierGroupId($tj_modifier_groups,$menu_items)
{
    $tj_modifier_group_hash = array();
    foreach ($tj_modifier_groups as $tj_modifier_group) {
        $modifier_group = array();
        $modifier_group['external_id'] = getNameFromAttribute($tj_modifier_group,'MODGRPID');
        $modifier_group['name'] = getNameFromAttribute($tj_modifier_group,'LONGDESC');
        $modifier_group['min'] = getNameFromAttribute($tj_modifier_group,'MINIMUM');
        $modifier_group['max'] = getNameFromAttribute($tj_modifier_group,'MAXIMUM');
        $modifier_group['modifier_items'] = array();
        foreach ($tj_modifier_group['MODIFIERS']['MODIFIER'] as $tj_modifier_item_row) {
            $modifier_item = array();
            $modifier_item = $menu_items[getNameFromAttribute($tj_modifier_item_row,'ITEMID')];
            $modifier_item['price'] = getNameFromAttribute($tj_modifier_item_row,'PRICE');
            $modifier_item['weighting'] = getNameFromAttribute($tj_modifier_item_row,'WEIGHTING');
            $modifier_group['modifier_items'][$modifier_item['name']] = $modifier_item;
        }
        $tj_modifier_group_hash[$modifier_group['external_id']] = $modifier_group;
    }
    return $tj_modifier_group_hash;
}