<?php
/*
POST https://labapi.brinkpos.net/Settings.svc HTTP/1.1
Host: labapi.brinkpos.net
Content-Type: text/xml; charset=utf-8
SOAPAction: "http://tempuri.org/ISettingsWebService/GetModifierCodes"
Content-Length: XXX

<s:Envelope xmlns:s="http://schemas.xmlsoap.org/soap/envelope/"><s:Body><GetModifierCodes xmlns="http://tempuri.org/"><accessToken>xxxxxxxxxxxxxxxx</accessToken><locationToken>xxxxxxxxxxxxxxxx</locationToken></GetModifierCodes></s:Body></s:Envelope>
*/
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');

include_once "lib/utilities/functions.inc";

$method = "GetOptions";
$response0 = curlIt($method);
myerror_log($response0);

$method = "GetDayParts";
$response0 = curlIt($method);
myerror_log($response0);

$method = "GetModifierGroups";
$response = curlIt($method);
$modifier_group_list = parseXMLResponseIntoArray($response,$method);
$modifier_group_list_hash = createHashmapFromArrayOfArraysByFieldName($modifier_group_list['ModifierGroup'],'Id');

$method = "GetItems";
$response2 = curlIt($method);
$item_list = parseXMLResponseIntoArray($response2,$method);
$item_list_hash = createHashmapFromArrayOfArraysByFieldName($item_list['Item'],'Id');

$method = "GetItemGroups";
$response3 = curlIt($method);
$item_group_list = parseXMLResponseIntoArray($response3,$method);

$menu = array();
foreach ($item_group_list['ItemGroup'] as $brink_menu_type) {
    $menu_type = array();
    if (substr_count(strtolower($brink_menu_type['Name']),'splickit') > 0) {
        $brink_menu_type['Name'] = str_ireplace('splickit - ','',$brink_menu_type['Name']);
    } else {
        continue;
    }
    $menu_type['name'] = $brink_menu_type['Name'];
    foreach ($brink_menu_type['Items']['ItemGroupItem'] as $item_id) {
        $item = array();
        myerror_log("we have the item_id: ".$item_id['ItemId']);
        $brink_item = $item_list_hash[$item_id['ItemId']];
        myerror_log("we have the brink item");
        $item['name'] = $brink_item['Name'];
        $item['external_id'] = $brink_item['Id'];
        $item['price'] = $brink_item['Price'];
        $item['print_name'] = $brink_item['KitchenName'];
        $ingredients = array();
        foreach ($brink_item['IngredientItemIds']['int'] as $ingredient_id) {
            myerror_log("we ahve an ingredient_id of: ".$ingredient_id[0]);
            $brink_ingredient = $item_list_hash[$ingredient_id[0]];
            $ingredient['Name'] = $brink_ingredient['Name'];
            $ingredient['external_id'] = $brink_ingredient['Id'];
            $ingredient['SortPriority'] = $brink_ingredient['SortPriority'];
            $ingredient['RevenueCenterId'] = $brink_ingredient['RevenueCenterId'];
            $ingredient['Price'] = $brink_ingredient['Price'];
            $ingredient['KitchenName'] = $brink_ingredient['KitchenName'];
            $ingredients[] = $ingredient;
        }
        $item['ingredients'] = $ingredients;
        $modifier_groups = array();
        foreach ($brink_item['ModifierGroupIds']['int'] as $modifier_group_id) {
            $brink_modifier_group = $modifier_group_list_hash[$modifier_group_id[0]];
            if (substr_count(strtolower($brink_modifier_group['Name']),'splickit') > 0) {
                $brink_modifier_group['Name'] = str_ireplace('splickit - ','',$brink_modifier_group['Name']);
                if (strtolower($brink_modifier_group['Name']) == 'combo') {
                    myerror_log("we are skipping combos for now");
                    continue;
                }
            } else {
                continue;
            }
            foreach ($brink_modifier_group['Items']['ModifierGroupItem'] as &$brink_modifier_item) {
                $modifier_item = $item_list_hash[$brink_modifier_item['ItemId']];
                $brink_modifier_item['Name'] = $modifier_item['Name'];
            }
            $modifier_groups[] = $brink_modifier_group;
        }
        $item['modifier_groups'] = $modifier_groups;
        $menu_type['items'][] = $item;
    }

    $menu['menu_types'][] = $menu_type;
}
myerror_log("we have the menu");

function myBrinkToArray($xml) {
    $array = (array)$xml;

    foreach ( array_slice($array, 0) as $key => $value )
    {
        if ( $value instanceof SimpleXMLElement )
        {
            $ns = $value->getNamespaces(true);
            if ($ns['b']) {
                $value = $array[$key]->children($ns['b']);
            }
            $array[$key] = empty($value) ? NULL : myBrinkToArray($value);
        } else if (is_array($value)) {
            foreach ($value as $sub_key => $sub_value) {
                $array[$key][$sub_key] = myBrinkToArray($sub_value);
            }
        }
    }
    return $array;
}

function parseXMLResponseIntoArray($response,$method)
{
    $start = strpos($response,"<".$method."Result");
    $end_string = "</".$method."Result>";
    $end = strpos($response,$end_string) + strlen($end_string);
    $payload = substr($response,$start,$end-$start);
    $xml=simplexml_load_string($payload, NULL, NULL, "http://schemas.datacontract.org/2004/07/Pos.Web.Service.Data") or die("Error: Cannot create object");
    $ns = $xml->getNamespaces(true);
    $res = $xml->children($ns['a']);
    $hashmap = myBrinkToArray($res);
    return $hashmap;
}

function curlIt($method)
{
    $brink_importer = new BrinkImporter("1234567890");
    $brink_importer->merchant_location_token = 'b6jBHX0XBkWGxyFkXwTzLw==';
    return $brink_importer->curlIt($method,$merchant_resource);
}


?>