<?php
/**
 * File for class TaskretailServiceCancel
 * @package Taskretail
 * @subpackage Services
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
/**
 * This class stands for TaskretailServiceCancel originally named Cancel
 * @package Taskretail
 * @subpackage Services
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
class TaskretailServiceCancel extends TaskretailWsdlClass
{
	/**
	 * Method to call the operation originally named CancelOrder
	 * @uses TaskretailWsdlClass::getSoapClient()
	 * @uses TaskretailWsdlClass::setResult()
	 * @uses TaskretailWsdlClass::getResult()
	 * @uses TaskretailWsdlClass::saveLastError()
	 * @uses TaskretailStructCancelOrder::getSaleID()
	 * @param TaskretailStructCancelOrder $_taskretailStructCancelOrder
	 * @return TaskretailStructCancelOrderResponse
	 */
	public function CancelOrder(TaskretailStructCancelOrder $_taskretailStructCancelOrder)
	{
		try
		{
			$this->setResult(new TaskretailStructCancelOrderResponse(self::getSoapClient()->CancelOrder(array('SaleID'=>$_taskretailStructCancelOrder->getSaleID()))));
		}
		catch(SoapFault $soapFault)
		{
			return !$this->saveLastError(__METHOD__,$soapFault);
		}
		return $this->getResult();
	}
	/**
	 * Returns the result
	 * @see TaskretailWsdlClass::getResult()
	 * @return TaskretailStructCancelOrderResponse
	 */
	public function getResult()
	{
		return parent::getResult();
	}
	/**
	 * Method returning the class name
	 * @return string __CLASS__
	 */
	public function __toString()
	{
		return __CLASS__;
	}
}
?>