<?php
/**
 * File for class TaskretailServiceGet
 * @package Taskretail
 * @subpackage Services
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
/**
 * This class stands for TaskretailServiceGet originally named Get
 * @package Taskretail
 * @subpackage Services
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
class TaskretailServiceGet extends TaskretailWsdlClass
{
	/**
	 * Method to call the operation originally named GetItems
	 * @uses TaskretailWsdlClass::getSoapClient()
	 * @uses TaskretailWsdlClass::setResult()
	 * @uses TaskretailWsdlClass::getResult()
	 * @uses TaskretailWsdlClass::saveLastError()
	 * @uses TaskretailStructGetItems::getLastUpdated()
	 * @param TaskretailStructGetItems $_taskretailStructGetItems
	 * @return TaskretailStructGetItemsResponse
	 */
	public function GetItems(TaskretailStructGetItems $_taskretailStructGetItems)
	{
		try
		{
			$this->setResult(new TaskretailStructGetItemsResponse(self::getSoapClient()->GetItems(array('lastUpdated'=>$_taskretailStructGetItems->getLastUpdated()))));
		}
		catch(SoapFault $soapFault)
		{
			return !$this->saveLastError(__METHOD__,$soapFault);
		}
		return $this->getResult();
	}
	/**
	 * Method to call the operation originally named GetMedias
	 * @uses TaskretailWsdlClass::getSoapClient()
	 * @uses TaskretailWsdlClass::setResult()
	 * @uses TaskretailWsdlClass::getResult()
	 * @uses TaskretailWsdlClass::saveLastError()
	 * @return TaskretailStructGetMediasResponse
	 */
	public function GetMedias()
	{
		$soap_client = self::getSoapClient();
		try
		{
			$response = $soap_client->GetMedias();
			$_result = new TaskretailStructGetMediasResponse($response);
			$this->setResult($_result);
			//$this->setResult(new TaskretailStructGetMediasResponse(self::getSoapClient()->GetMedias()));
		}
		catch(SoapFault $soapFault)
		{
			$request_xml = $soap_client->__getLastRequest();
			$headers = $soap_client->__getLastRequestHeaders();
			error_log("request: ".$request_xml);
			error_log("headers: ".$headers);
			$trace = $soapFault->getTraceAsString();
			error_log("trace:  ".$trace);
			return !$this->saveLastError(__METHOD__,$soapFault);
		}
		return $this->getResult();
	}
	/**
	 * Method to call the operation originally named GetLocations
	 * @uses TaskretailWsdlClass::getSoapClient()
	 * @uses TaskretailWsdlClass::setResult()
	 * @uses TaskretailWsdlClass::getResult()
	 * @uses TaskretailWsdlClass::saveLastError()
	 * @uses TaskretailStructGetLocations::getLastUpdated()
	 * @param TaskretailStructGetLocations $_taskretailStructGetLocations
	 * @return TaskretailStructGetLocationsResponse
	 */
	public function GetLocations(TaskretailStructGetLocations $_taskretailStructGetLocations)
	{
		try
		{
			$this->setResult(new TaskretailStructGetLocationsResponse(self::getSoapClient()->GetLocations(array('lastUpdated'=>$_taskretailStructGetLocations->getLastUpdated()))));
		}
		catch(SoapFault $soapFault)
		{
			return !$this->saveLastError(__METHOD__,$soapFault);
		}
		return $this->getResult();
	}
	/**
	 * Method to call the operation originally named GetSaleStatus
	 * @uses TaskretailWsdlClass::getSoapClient()
	 * @uses TaskretailWsdlClass::setResult()
	 * @uses TaskretailWsdlClass::getResult()
	 * @uses TaskretailWsdlClass::saveLastError()
	 * @uses TaskretailStructGetSaleStatus::getSaleID()
	 * @param TaskretailStructGetSaleStatus $_taskretailStructGetSaleStatus
	 * @return TaskretailStructGetSaleStatusResponse
	 */
	public function GetSaleStatus(TaskretailStructGetSaleStatus $_taskretailStructGetSaleStatus)
	{
		try
		{
			$this->setResult(new TaskretailStructGetSaleStatusResponse(self::getSoapClient()->GetSaleStatus(array('saleID'=>$_taskretailStructGetSaleStatus->getSaleID()))));
		}
		catch(SoapFault $soapFault)
		{
			return !$this->saveLastError(__METHOD__,$soapFault);
		}
		return $this->getResult();
	}
	/**
	 * Method to call the operation originally named GetFreeProductsForMember
	 * @uses TaskretailWsdlClass::getSoapClient()
	 * @uses TaskretailWsdlClass::setResult()
	 * @uses TaskretailWsdlClass::getResult()
	 * @uses TaskretailWsdlClass::saveLastError()
	 * @uses TaskretailStructGetFreeProductsForMember::getMemberID()
	 * @param TaskretailStructGetFreeProductsForMember $_taskretailStructGetFreeProductsForMember
	 * @return TaskretailStructGetFreeProductsForMemberResponse
	 */
	public function GetFreeProductsForMember(TaskretailStructGetFreeProductsForMember $_taskretailStructGetFreeProductsForMember)
	{
		try
		{
			$this->setResult(new TaskretailStructGetFreeProductsForMemberResponse(self::getSoapClient()->GetFreeProductsForMember(array('MemberID'=>$_taskretailStructGetFreeProductsForMember->getMemberID()))));
		}
		catch(SoapFault $soapFault)
		{
			return !$this->saveLastError(__METHOD__,$soapFault);
		}
		return $this->getResult();
	}
	/**
	 * Method to call the operation originally named GetIngredents
	 * @uses TaskretailWsdlClass::getSoapClient()
	 * @uses TaskretailWsdlClass::setResult()
	 * @uses TaskretailWsdlClass::getResult()
	 * @uses TaskretailWsdlClass::saveLastError()
	 * @uses TaskretailStructGetIngredents::getPlu()
	 * @param TaskretailStructGetIngredents $_taskretailStructGetIngredents
	 * @return TaskretailStructGetIngredentsResponse
	 */
	public function GetIngredents(TaskretailStructGetIngredents $_taskretailStructGetIngredents)
	{
		try
		{
			$this->setResult(new TaskretailStructGetIngredentsResponse(self::getSoapClient()->GetIngredents(array('plu'=>$_taskretailStructGetIngredents->getPlu()))));
		}
		catch(SoapFault $soapFault)
		{
			return !$this->saveLastError(__METHOD__,$soapFault);
		}
		return $this->getResult();
	}
	/**
	 * Method to call the operation originally named GetModifiers
	 * @uses TaskretailWsdlClass::getSoapClient()
	 * @uses TaskretailWsdlClass::setResult()
	 * @uses TaskretailWsdlClass::getResult()
	 * @uses TaskretailWsdlClass::saveLastError()
	 * @uses TaskretailStructGetModifiers::getProductPLU()
	 * @param TaskretailStructGetModifiers $_taskretailStructGetModifiers
	 * @return TaskretailStructGetModifiersResponse
	 */
	public function GetModifiers(TaskretailStructGetModifiers $_taskretailStructGetModifiers)
	{
		try
		{
			$this->setResult(new TaskretailStructGetModifiersResponse(self::getSoapClient()->GetModifiers(array('ProductPLU'=>$_taskretailStructGetModifiers->getProductPLU()))));
		}
		catch(SoapFault $soapFault)
		{
			return !$this->saveLastError(__METHOD__,$soapFault);
		}
		return $this->getResult();
	}
	/**
	 * Returns the result
	 * @see TaskretailWsdlClass::getResult()
	 * @return TaskretailStructGetFreeProductsForMemberResponse|TaskretailStructGetIngredentsResponse|TaskretailStructGetItemsResponse|TaskretailStructGetLocationsResponse|TaskretailStructGetMediasResponse|TaskretailStructGetModifiersResponse|TaskretailStructGetSaleStatusResponse
	 */
	public function getResult()
	{
		return parent::getResult();
	}
	/**
	 * Method returning the class name
	 * @return string __CLASS__
	 */
	public function __toString()
	{
		return __CLASS__;
	}
}
?>