<?php
/**
 * File for class TaskretailStructItem
 * @package Taskretail
 * @subpackage Structs
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
/**
 * This class stands for TaskretailStructItem originally named Item
 * Meta informations extracted from the WSDL
 * - from schema : {@link http://136.179.5.40/xchangenetfr/services/xn_secureorders.asmx?WSDL}
 * @package Taskretail
 * @subpackage Structs
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
class TaskretailStructItem extends TaskretailWsdlClass
{
	/**
	 * The PLU
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var long
	 */
	public $PLU;
	/**
	 * The QTY
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var long
	 */
	public $QTY;
	/**
	 * The Value
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var decimal
	 */
	public $Value;
	/**
	 * The Modifiers
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 0
	 * @var TaskretailStructArrayOfModifier
	 */
	public $Modifiers;
	/**
	 * Constructor method for Item
	 * @see parent::__construct()
	 * @param long $_pLU
	 * @param long $_qTY
	 * @param decimal $_value
	 * @param TaskretailStructArrayOfModifier $_modifiers
	 * @return TaskretailStructItem
	 */
	public function __construct($_pLU,$_qTY,$_value,$_modifiers = NULL)
	{
		parent::__construct(array('PLU'=>$_pLU,'QTY'=>$_qTY,'Value'=>$_value,'Modifiers'=>($_modifiers instanceof TaskretailStructArrayOfModifier)?$_modifiers:new TaskretailStructArrayOfModifier($_modifiers)));
	}
	/**
	 * Get PLU value
	 * @return long
	 */
	public function getPLU()
	{
		return $this->PLU;
	}
	/**
	 * Set PLU value
	 * @param long $_pLU the PLU
	 * @return long
	 */
	public function setPLU($_pLU)
	{
		return ($this->PLU = $_pLU);
	}
	/**
	 * Get QTY value
	 * @return long
	 */
	public function getQTY()
	{
		return $this->QTY;
	}
	/**
	 * Set QTY value
	 * @param long $_qTY the QTY
	 * @return long
	 */
	public function setQTY($_qTY)
	{
		return ($this->QTY = $_qTY);
	}
	/**
	 * Get Value value
	 * @return decimal
	 */
	public function getValue()
	{
		return $this->Value;
	}
	/**
	 * Set Value value
	 * @param decimal $_value the Value
	 * @return decimal
	 */
	public function setValue($_value)
	{
		return ($this->Value = $_value);
	}
	/**
	 * Get Modifiers value
	 * @return TaskretailStructArrayOfModifier|null
	 */
	public function getModifiers()
	{
		return $this->Modifiers;
	}
	/**
	 * Set Modifiers value
	 * @param TaskretailStructArrayOfModifier $_modifiers the Modifiers
	 * @return TaskretailStructArrayOfModifier
	 */
	public function setModifiers($_modifiers)
	{
		return ($this->Modifiers = $_modifiers);
	}
	/**
	 * Method called when an object has been exported with var_export() functions
	 * It allows to return an object instantiated with the values
	 * @see TaskretailWsdlClass::__set_state()
	 * @uses TaskretailWsdlClass::__set_state()
	 * @param array $_array the exported values
	 * @return TaskretailStructItem
	 */
	public static function __set_state(array $_array,$_className = __CLASS__)
	{
		return parent::__set_state($_array,$_className);
	}
	/**
	 * Method returning the class name
	 * @return string __CLASS__
	 */
	public function __toString()
	{
		return __CLASS__;
	}
}
?>