<?php
/**
 * File for class TaskretailStructMedia
 * @package Taskretail
 * @subpackage Structs
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
/**
 * This class stands for TaskretailStructMedia originally named Media
 * Meta informations extracted from the WSDL
 * - from schema : {@link http://136.179.5.40/xchangenetfr/services/xn_secureorders.asmx?WSDL}
 * @package Taskretail
 * @subpackage Structs
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
class TaskretailStructMedia extends TaskretailWsdlClass
{
	/**
	 * The MediaID
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var long
	 */
	public $MediaID;
	/**
	 * The Value
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var decimal
	 */
	public $Value;
	/**
	 * Constructor method for Media
	 * @see parent::__construct()
	 * @param long $_mediaID
	 * @param decimal $_value
	 * @return TaskretailStructMedia
	 */
	public function __construct($_mediaID,$_value)
	{
		parent::__construct(array('MediaID'=>$_mediaID,'Value'=>$_value));
	}
	/**
	 * Get MediaID value
	 * @return long
	 */
	public function getMediaID()
	{
		return $this->MediaID;
	}
	/**
	 * Set MediaID value
	 * @param long $_mediaID the MediaID
	 * @return long
	 */
	public function setMediaID($_mediaID)
	{
		return ($this->MediaID = $_mediaID);
	}
	/**
	 * Get Value value
	 * @return decimal
	 */
	public function getValue()
	{
		return $this->Value;
	}
	/**
	 * Set Value value
	 * @param decimal $_value the Value
	 * @return decimal
	 */
	public function setValue($_value)
	{
		return ($this->Value = $_value);
	}
	/**
	 * Method called when an object has been exported with var_export() functions
	 * It allows to return an object instantiated with the values
	 * @see TaskretailWsdlClass::__set_state()
	 * @uses TaskretailWsdlClass::__set_state()
	 * @param array $_array the exported values
	 * @return TaskretailStructMedia
	 */
	public static function __set_state(array $_array,$_className = __CLASS__)
	{
		return parent::__set_state($_array,$_className);
	}
	/**
	 * Method returning the class name
	 * @return string __CLASS__
	 */
	public function __toString()
	{
		return __CLASS__;
	}
}
?>