<?php
/**
 * File for class TaskretailStructMember
 * @package Taskretail
 * @subpackage Structs
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
/**
 * This class stands for TaskretailStructMember originally named Member
 * Meta informations extracted from the WSDL
 * - from schema : {@link http://136.179.5.40/xchangenetfr/services/xn_secureorders.asmx?WSDL}
 * @package Taskretail
 * @subpackage Structs
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
class TaskretailStructMember extends TaskretailWsdlClass
{
	/**
	 * The CardNumber
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var long
	 */
	public $CardNumber;
	/**
	 * The ExternalID
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var long
	 */
	public $ExternalID;
	/**
	 * The PostCode
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var int
	 */
	public $PostCode;
	/**
	 * The Birthday
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var dateTime
	 */
	public $Birthday;
	/**
	 * The Sex
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var boolean
	 */
	public $Sex;
	/**
	 * The FirstName
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 0
	 * @var string
	 */
	public $FirstName;
	/**
	 * The Surname
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 0
	 * @var string
	 */
	public $Surname;
	/**
	 * The StreetAddress
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 0
	 * @var string
	 */
	public $StreetAddress;
	/**
	 * The Suburb
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 0
	 * @var string
	 */
	public $Suburb;
	/**
	 * The State
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 0
	 * @var string
	 */
	public $State;
	/**
	 * The Country
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 0
	 * @var string
	 */
	public $Country;
	/**
	 * The HomePhone
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 0
	 * @var string
	 */
	public $HomePhone;
	/**
	 * The MobilePhone
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 0
	 * @var string
	 */
	public $MobilePhone;
	/**
	 * The EmailAddress
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 0
	 * @var string
	 */
	public $EmailAddress;
	/**
	 * The CompanyName
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 0
	 * @var string
	 */
	public $CompanyName;
	/**
	 * The Nationality
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 0
	 * @var string
	 */
	public $Nationality;
	/**
	 * Constructor method for Member
	 * @see parent::__construct()
	 * @param long $_cardNumber
	 * @param long $_externalID
	 * @param int $_postCode
	 * @param dateTime $_birthday
	 * @param boolean $_sex
	 * @param string $_firstName
	 * @param string $_surname
	 * @param string $_streetAddress
	 * @param string $_suburb
	 * @param string $_state
	 * @param string $_country
	 * @param string $_homePhone
	 * @param string $_mobilePhone
	 * @param string $_emailAddress
	 * @param string $_companyName
	 * @param string $_nationality
	 * @return TaskretailStructMember
	 */
	public function __construct($_cardNumber,$_externalID,$_postCode,$_birthday,$_sex,$_firstName = NULL,$_surname = NULL,$_streetAddress = NULL,$_suburb = NULL,$_state = NULL,$_country = NULL,$_homePhone = NULL,$_mobilePhone = NULL,$_emailAddress = NULL,$_companyName = NULL,$_nationality = NULL)
	{
		parent::__construct(array('CardNumber'=>$_cardNumber,'ExternalID'=>$_externalID,'PostCode'=>$_postCode,'Birthday'=>$_birthday,'Sex'=>$_sex,'FirstName'=>$_firstName,'Surname'=>$_surname,'StreetAddress'=>$_streetAddress,'Suburb'=>$_suburb,'State'=>$_state,'Country'=>$_country,'HomePhone'=>$_homePhone,'MobilePhone'=>$_mobilePhone,'EmailAddress'=>$_emailAddress,'CompanyName'=>$_companyName,'Nationality'=>$_nationality));
	}
	/**
	 * Get CardNumber value
	 * @return long
	 */
	public function getCardNumber()
	{
		return $this->CardNumber;
	}
	/**
	 * Set CardNumber value
	 * @param long $_cardNumber the CardNumber
	 * @return long
	 */
	public function setCardNumber($_cardNumber)
	{
		return ($this->CardNumber = $_cardNumber);
	}
	/**
	 * Get ExternalID value
	 * @return long
	 */
	public function getExternalID()
	{
		return $this->ExternalID;
	}
	/**
	 * Set ExternalID value
	 * @param long $_externalID the ExternalID
	 * @return long
	 */
	public function setExternalID($_externalID)
	{
		return ($this->ExternalID = $_externalID);
	}
	/**
	 * Get PostCode value
	 * @return int
	 */
	public function getPostCode()
	{
		return $this->PostCode;
	}
	/**
	 * Set PostCode value
	 * @param int $_postCode the PostCode
	 * @return int
	 */
	public function setPostCode($_postCode)
	{
		return ($this->PostCode = $_postCode);
	}
	/**
	 * Get Birthday value
	 * @return dateTime
	 */
	public function getBirthday()
	{
		return $this->Birthday;
	}
	/**
	 * Set Birthday value
	 * @param dateTime $_birthday the Birthday
	 * @return dateTime
	 */
	public function setBirthday($_birthday)
	{
		return ($this->Birthday = $_birthday);
	}
	/**
	 * Get Sex value
	 * @return boolean
	 */
	public function getSex()
	{
		return $this->Sex;
	}
	/**
	 * Set Sex value
	 * @param boolean $_sex the Sex
	 * @return boolean
	 */
	public function setSex($_sex)
	{
		return ($this->Sex = $_sex);
	}
	/**
	 * Get FirstName value
	 * @return string|null
	 */
	public function getFirstName()
	{
		return $this->FirstName;
	}
	/**
	 * Set FirstName value
	 * @param string $_firstName the FirstName
	 * @return string
	 */
	public function setFirstName($_firstName)
	{
		return ($this->FirstName = $_firstName);
	}
	/**
	 * Get Surname value
	 * @return string|null
	 */
	public function getSurname()
	{
		return $this->Surname;
	}
	/**
	 * Set Surname value
	 * @param string $_surname the Surname
	 * @return string
	 */
	public function setSurname($_surname)
	{
		return ($this->Surname = $_surname);
	}
	/**
	 * Get StreetAddress value
	 * @return string|null
	 */
	public function getStreetAddress()
	{
		return $this->StreetAddress;
	}
	/**
	 * Set StreetAddress value
	 * @param string $_streetAddress the StreetAddress
	 * @return string
	 */
	public function setStreetAddress($_streetAddress)
	{
		return ($this->StreetAddress = $_streetAddress);
	}
	/**
	 * Get Suburb value
	 * @return string|null
	 */
	public function getSuburb()
	{
		return $this->Suburb;
	}
	/**
	 * Set Suburb value
	 * @param string $_suburb the Suburb
	 * @return string
	 */
	public function setSuburb($_suburb)
	{
		return ($this->Suburb = $_suburb);
	}
	/**
	 * Get State value
	 * @return string|null
	 */
	public function getState()
	{
		return $this->State;
	}
	/**
	 * Set State value
	 * @param string $_state the State
	 * @return string
	 */
	public function setState($_state)
	{
		return ($this->State = $_state);
	}
	/**
	 * Get Country value
	 * @return string|null
	 */
	public function getCountry()
	{
		return $this->Country;
	}
	/**
	 * Set Country value
	 * @param string $_country the Country
	 * @return string
	 */
	public function setCountry($_country)
	{
		return ($this->Country = $_country);
	}
	/**
	 * Get HomePhone value
	 * @return string|null
	 */
	public function getHomePhone()
	{
		return $this->HomePhone;
	}
	/**
	 * Set HomePhone value
	 * @param string $_homePhone the HomePhone
	 * @return string
	 */
	public function setHomePhone($_homePhone)
	{
		return ($this->HomePhone = $_homePhone);
	}
	/**
	 * Get MobilePhone value
	 * @return string|null
	 */
	public function getMobilePhone()
	{
		return $this->MobilePhone;
	}
	/**
	 * Set MobilePhone value
	 * @param string $_mobilePhone the MobilePhone
	 * @return string
	 */
	public function setMobilePhone($_mobilePhone)
	{
		return ($this->MobilePhone = $_mobilePhone);
	}
	/**
	 * Get EmailAddress value
	 * @return string|null
	 */
	public function getEmailAddress()
	{
		return $this->EmailAddress;
	}
	/**
	 * Set EmailAddress value
	 * @param string $_emailAddress the EmailAddress
	 * @return string
	 */
	public function setEmailAddress($_emailAddress)
	{
		return ($this->EmailAddress = $_emailAddress);
	}
	/**
	 * Get CompanyName value
	 * @return string|null
	 */
	public function getCompanyName()
	{
		return $this->CompanyName;
	}
	/**
	 * Set CompanyName value
	 * @param string $_companyName the CompanyName
	 * @return string
	 */
	public function setCompanyName($_companyName)
	{
		return ($this->CompanyName = $_companyName);
	}
	/**
	 * Get Nationality value
	 * @return string|null
	 */
	public function getNationality()
	{
		return $this->Nationality;
	}
	/**
	 * Set Nationality value
	 * @param string $_nationality the Nationality
	 * @return string
	 */
	public function setNationality($_nationality)
	{
		return ($this->Nationality = $_nationality);
	}
	/**
	 * Method called when an object has been exported with var_export() functions
	 * It allows to return an object instantiated with the values
	 * @see TaskretailWsdlClass::__set_state()
	 * @uses TaskretailWsdlClass::__set_state()
	 * @param array $_array the exported values
	 * @return TaskretailStructMember
	 */
	public static function __set_state(array $_array,$_className = __CLASS__)
	{
		return parent::__set_state($_array,$_className);
	}
	/**
	 * Method returning the class name
	 * @return string __CLASS__
	 */
	public function __toString()
	{
		return __CLASS__;
	}
}
?>