<?php
/**
 * File for class TaskretailStructModifier
 * @package Taskretail
 * @subpackage Structs
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
/**
 * This class stands for TaskretailStructModifier originally named Modifier
 * Meta informations extracted from the WSDL
 * - from schema : {@link http://136.179.5.40/xchangenetfr/services/xn_secureorders.asmx?WSDL}
 * @package Taskretail
 * @subpackage Structs
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
class TaskretailStructModifier extends TaskretailWsdlClass
{
	/**
	 * The RecipeID
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var long
	 */
	public $RecipeID;
	/**
	 * The OldPLU
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var long
	 */
	public $OldPLU;
	/**
	 * The OldQTY
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var long
	 */
	public $OldQTY;
	/**
	 * The NewPLU
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var long
	 */
	public $NewPLU;
	/**
	 * The NewQTY
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var long
	 */
	public $NewQTY;
	/**
	 * Constructor method for Modifier
	 * @see parent::__construct()
	 * @param long $_recipeID
	 * @param long $_oldPLU
	 * @param long $_oldQTY
	 * @param long $_newPLU
	 * @param long $_newQTY
	 * @return TaskretailStructModifier
	 */
	public function __construct($_recipeID,$_oldPLU,$_oldQTY,$_newPLU,$_newQTY)
	{
		parent::__construct(array('RecipeID'=>$_recipeID,'OldPLU'=>$_oldPLU,'OldQTY'=>$_oldQTY,'NewPLU'=>$_newPLU,'NewQTY'=>$_newQTY));
	}
	/**
	 * Get RecipeID value
	 * @return long
	 */
	public function getRecipeID()
	{
		return $this->RecipeID;
	}
	/**
	 * Set RecipeID value
	 * @param long $_recipeID the RecipeID
	 * @return long
	 */
	public function setRecipeID($_recipeID)
	{
		return ($this->RecipeID = $_recipeID);
	}
	/**
	 * Get OldPLU value
	 * @return long
	 */
	public function getOldPLU()
	{
		return $this->OldPLU;
	}
	/**
	 * Set OldPLU value
	 * @param long $_oldPLU the OldPLU
	 * @return long
	 */
	public function setOldPLU($_oldPLU)
	{
		return ($this->OldPLU = $_oldPLU);
	}
	/**
	 * Get OldQTY value
	 * @return long
	 */
	public function getOldQTY()
	{
		return $this->OldQTY;
	}
	/**
	 * Set OldQTY value
	 * @param long $_oldQTY the OldQTY
	 * @return long
	 */
	public function setOldQTY($_oldQTY)
	{
		return ($this->OldQTY = $_oldQTY);
	}
	/**
	 * Get NewPLU value
	 * @return long
	 */
	public function getNewPLU()
	{
		return $this->NewPLU;
	}
	/**
	 * Set NewPLU value
	 * @param long $_newPLU the NewPLU
	 * @return long
	 */
	public function setNewPLU($_newPLU)
	{
		return ($this->NewPLU = $_newPLU);
	}
	/**
	 * Get NewQTY value
	 * @return long
	 */
	public function getNewQTY()
	{
		return $this->NewQTY;
	}
	/**
	 * Set NewQTY value
	 * @param long $_newQTY the NewQTY
	 * @return long
	 */
	public function setNewQTY($_newQTY)
	{
		return ($this->NewQTY = $_newQTY);
	}
	/**
	 * Method called when an object has been exported with var_export() functions
	 * It allows to return an object instantiated with the values
	 * @see TaskretailWsdlClass::__set_state()
	 * @uses TaskretailWsdlClass::__set_state()
	 * @param array $_array the exported values
	 * @return TaskretailStructModifier
	 */
	public static function __set_state(array $_array,$_className = __CLASS__)
	{
		return parent::__set_state($_array,$_className);
	}
	/**
	 * Method returning the class name
	 * @return string __CLASS__
	 */
	public function __toString()
	{
		return __CLASS__;
	}
}
?>