<?php
/**
 * File for class TaskretailStructOrder
 * @package Taskretail
 * @subpackage Structs
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
/**
 * This class stands for TaskretailStructOrder originally named Order
 * Meta informations extracted from the WSDL
 * - from schema : {@link http://136.179.5.40/xchangenetfr/services/xn_secureorders.asmx?WSDL}
 * @package Taskretail
 * @subpackage Structs
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
class TaskretailStructOrder extends TaskretailWsdlClass
{
	/**
	 * The PickupLocation
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var int
	 */
	public $PickupLocation;
	/**
	 * The PickUpDate
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var dateTime
	 */
	public $PickUpDate;
	/**
	 * The OrderedDate
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var dateTime
	 */
	public $OrderedDate;
	/**
	 * The TableNumber
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var int
	 */
	public $TableNumber;
	/**
	 * The IsDelivery
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var boolean
	 */
	public $IsDelivery;
	/**
	 * The SaleName
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 0
	 * @var string
	 */
	public $SaleName;
	/**
	 * The Member
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 0
	 * @var TaskretailStructMember
	 */
	public $Member;
	/**
	 * The Items
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 0
	 * @var TaskretailStructArrayOfItem
	 */
	public $Items;
	/**
	 * The Medias
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 0
	 * @var TaskretailStructArrayOfMedia
	 */
	public $Medias;
	/**
	 * Constructor method for Order
	 * @see parent::__construct()
	 * @param int $_pickupLocation
	 * @param dateTime $_pickUpDate
	 * @param dateTime $_orderedDate
	 * @param int $_tableNumber
	 * @param boolean $_isDelivery
	 * @param string $_saleName
	 * @param TaskretailStructMember $_member
	 * @param TaskretailStructArrayOfItem $_items
	 * @param TaskretailStructArrayOfMedia $_medias
	 * @return TaskretailStructOrder
	 */
	public function __construct($_pickupLocation,$_pickUpDate,$_orderedDate,$_tableNumber,$_isDelivery,$_saleName = NULL,$_member = NULL,$_items = NULL,$_medias = NULL)
	{
		parent::__construct(array('PickupLocation'=>$_pickupLocation,'PickUpDate'=>$_pickUpDate,'OrderedDate'=>$_orderedDate,'TableNumber'=>$_tableNumber,'IsDelivery'=>$_isDelivery,'SaleName'=>$_saleName,'Member'=>$_member,'Items'=>($_items instanceof TaskretailStructArrayOfItem)?$_items:new TaskretailStructArrayOfItem($_items),'Medias'=>($_medias instanceof TaskretailStructArrayOfMedia)?$_medias:new TaskretailStructArrayOfMedia($_medias)));
	}
	/**
	 * Get PickupLocation value
	 * @return int
	 */
	public function getPickupLocation()
	{
		return $this->PickupLocation;
	}
	/**
	 * Set PickupLocation value
	 * @param int $_pickupLocation the PickupLocation
	 * @return int
	 */
	public function setPickupLocation($_pickupLocation)
	{
		return ($this->PickupLocation = $_pickupLocation);
	}
	/**
	 * Get PickUpDate value
	 * @return dateTime
	 */
	public function getPickUpDate()
	{
		return $this->PickUpDate;
	}
	/**
	 * Set PickUpDate value
	 * @param dateTime $_pickUpDate the PickUpDate
	 * @return dateTime
	 */
	public function setPickUpDate($_pickUpDate)
	{
		return ($this->PickUpDate = $_pickUpDate);
	}
	/**
	 * Get OrderedDate value
	 * @return dateTime
	 */
	public function getOrderedDate()
	{
		return $this->OrderedDate;
	}
	/**
	 * Set OrderedDate value
	 * @param dateTime $_orderedDate the OrderedDate
	 * @return dateTime
	 */
	public function setOrderedDate($_orderedDate)
	{
		return ($this->OrderedDate = $_orderedDate);
	}
	/**
	 * Get TableNumber value
	 * @return int
	 */
	public function getTableNumber()
	{
		return $this->TableNumber;
	}
	/**
	 * Set TableNumber value
	 * @param int $_tableNumber the TableNumber
	 * @return int
	 */
	public function setTableNumber($_tableNumber)
	{
		return ($this->TableNumber = $_tableNumber);
	}
	/**
	 * Get IsDelivery value
	 * @return boolean
	 */
	public function getIsDelivery()
	{
		return $this->IsDelivery;
	}
	/**
	 * Set IsDelivery value
	 * @param boolean $_isDelivery the IsDelivery
	 * @return boolean
	 */
	public function setIsDelivery($_isDelivery)
	{
		return ($this->IsDelivery = $_isDelivery);
	}
	/**
	 * Get SaleName value
	 * @return string|null
	 */
	public function getSaleName()
	{
		return $this->SaleName;
	}
	/**
	 * Set SaleName value
	 * @param string $_saleName the SaleName
	 * @return string
	 */
	public function setSaleName($_saleName)
	{
		return ($this->SaleName = $_saleName);
	}
	/**
	 * Get Member value
	 * @return TaskretailStructMember|null
	 */
	public function getMember()
	{
		return $this->Member;
	}
	/**
	 * Set Member value
	 * @param TaskretailStructMember $_member the Member
	 * @return TaskretailStructMember
	 */
	public function setMember($_member)
	{
		return ($this->Member = $_member);
	}
	/**
	 * Get Items value
	 * @return TaskretailStructArrayOfItem|null
	 */
	public function getItems()
	{
		return $this->Items;
	}
	/**
	 * Set Items value
	 * @param TaskretailStructArrayOfItem $_items the Items
	 * @return TaskretailStructArrayOfItem
	 */
	public function setItems($_items)
	{
		return ($this->Items = $_items);
	}
	/**
	 * Get Medias value
	 * @return TaskretailStructArrayOfMedia|null
	 */
	public function getMedias()
	{
		return $this->Medias;
	}
	/**
	 * Set Medias value
	 * @param TaskretailStructArrayOfMedia $_medias the Medias
	 * @return TaskretailStructArrayOfMedia
	 */
	public function setMedias($_medias)
	{
		return ($this->Medias = $_medias);
	}
	/**
	 * Method called when an object has been exported with var_export() functions
	 * It allows to return an object instantiated with the values
	 * @see TaskretailWsdlClass::__set_state()
	 * @uses TaskretailWsdlClass::__set_state()
	 * @param array $_array the exported values
	 * @return TaskretailStructOrder
	 */
	public static function __set_state(array $_array,$_className = __CLASS__)
	{
		return parent::__set_state($_array,$_className);
	}
	/**
	 * Method returning the class name
	 * @return string __CLASS__
	 */
	public function __toString()
	{
		return __CLASS__;
	}
}
?>