<?php
/**
 * File for class TaskretailStructResult
 * @package Taskretail
 * @subpackage Structs
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
/**
 * This class stands for TaskretailStructResult originally named Result
 * Meta informations extracted from the WSDL
 * - from schema : {@link http://136.179.5.40/xchangenetfr/services/xn_secureorders.asmx?WSDL}
 * @package Taskretail
 * @subpackage Structs
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
class TaskretailStructResult extends TaskretailWsdlClass
{
	/**
	 * The Successful
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var boolean
	 */
	public $Successful;
	/**
	 * The ErrorNumber
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 1
	 * @var int
	 */
	public $ErrorNumber;
	/**
	 * The ErrorString
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 0
	 * @var string
	 */
	public $ErrorString;
	/**
	 * The Data
	 * @var TaskretailStructData
	 */
	public $Data;
	/**
	 * The Field
	 * Meta informations extracted from the WSDL
	 * - maxOccurs : 1
	 * - minOccurs : 0
	 * @var string
	 */
	public $Field;
	/**
	 * Constructor method for Result
	 * @see parent::__construct()
	 * @param boolean $_successful
	 * @param int $_errorNumber
	 * @param string $_errorString
	 * @param TaskretailStructData $_data
	 * @param string $_field
	 * @return TaskretailStructResult
	 */
	public function __construct($_successful,$_errorNumber,$_errorString = NULL,$_data = NULL,$_field = NULL)
	{
		parent::__construct(array('Successful'=>$_successful,'ErrorNumber'=>$_errorNumber,'ErrorString'=>$_errorString,'Data'=>$_data,'Field'=>$_field));
	}
	/**
	 * Get Successful value
	 * @return boolean
	 */
	public function getSuccessful()
	{
		return $this->Successful;
	}
	/**
	 * Set Successful value
	 * @param boolean $_successful the Successful
	 * @return boolean
	 */
	public function setSuccessful($_successful)
	{
		return ($this->Successful = $_successful);
	}
	/**
	 * Get ErrorNumber value
	 * @return int
	 */
	public function getErrorNumber()
	{
		return $this->ErrorNumber;
	}
	/**
	 * Set ErrorNumber value
	 * @param int $_errorNumber the ErrorNumber
	 * @return int
	 */
	public function setErrorNumber($_errorNumber)
	{
		return ($this->ErrorNumber = $_errorNumber);
	}
	/**
	 * Get ErrorString value
	 * @return string|null
	 */
	public function getErrorString()
	{
		return $this->ErrorString;
	}
	/**
	 * Set ErrorString value
	 * @param string $_errorString the ErrorString
	 * @return string
	 */
	public function setErrorString($_errorString)
	{
		return ($this->ErrorString = $_errorString);
	}
	/**
	 * Get Data value
	 * @return TaskretailStructData|null
	 */
	public function getData()
	{
		return $this->Data;
	}
	/**
	 * Set Data value
	 * @param TaskretailStructData $_data the Data
	 * @return TaskretailStructData
	 */
	public function setData($_data)
	{
		return ($this->Data = $_data);
	}
	/**
	 * Get Field value
	 * @return string|null
	 */
	public function getField()
	{
		return $this->Field;
	}
	/**
	 * Set Field value
	 * @param string $_field the Field
	 * @return string
	 */
	public function setField($_field)
	{
		return ($this->Field = $_field);
	}
	/**
	 * Method called when an object has been exported with var_export() functions
	 * It allows to return an object instantiated with the values
	 * @see TaskretailWsdlClass::__set_state()
	 * @uses TaskretailWsdlClass::__set_state()
	 * @param array $_array the exported values
	 * @return TaskretailStructResult
	 */
	public static function __set_state(array $_array,$_className = __CLASS__)
	{
		return parent::__set_state($_array,$_className);
	}
	/**
	 * Method returning the class name
	 * @return string __CLASS__
	 */
	public function __toString()
	{
		return __CLASS__;
	}
}
?>