<?php
/**
 * File for the class which returns the class map definition
 * @package Taskretail
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
/**
 * Class which returns the class map definition by the static method TaskretailClassMap::classMap()
 * @package Taskretail
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
class TaskretailClassMap
{
	/**
	 * This method returns the array containing the mapping between WSDL structs and generated classes
	 * This array is sent to the SoapClient when calling the WS
	 * @return array
	 */
	final public static function classMap()
	{
		return array (
  'ArrayOfFreeProduct' => 'TaskretailStructArrayOfFreeProduct',
  'ArrayOfItem' => 'TaskretailStructArrayOfItem',
  'ArrayOfMedia' => 'TaskretailStructArrayOfMedia',
  'ArrayOfModifier' => 'TaskretailStructArrayOfModifier',
  'CancelOrder' => 'TaskretailStructCancelOrder',
  'CancelOrderResponse' => 'TaskretailStructCancelOrderResponse',
  'Data' => 'TaskretailStructData',
  'FreeProduct' => 'TaskretailStructFreeProduct',
  'GetFreeProductsForMember' => 'TaskretailStructGetFreeProductsForMember',
  'GetFreeProductsForMemberResponse' => 'TaskretailStructGetFreeProductsForMemberResponse',
  'GetIngredents' => 'TaskretailStructGetIngredents',
  'GetIngredentsResponse' => 'TaskretailStructGetIngredentsResponse',
  'GetItems' => 'TaskretailStructGetItems',
  'GetItemsResponse' => 'TaskretailStructGetItemsResponse',
  'GetLocations' => 'TaskretailStructGetLocations',
  'GetLocationsResponse' => 'TaskretailStructGetLocationsResponse',
  'GetMedias' => 'TaskretailStructGetMedias',
  'GetMediasResponse' => 'TaskretailStructGetMediasResponse',
  'GetModifiers' => 'TaskretailStructGetModifiers',
  'GetModifiersResponse' => 'TaskretailStructGetModifiersResponse',
  'GetSaleStatus' => 'TaskretailStructGetSaleStatus',
  'GetSaleStatusResponse' => 'TaskretailStructGetSaleStatusResponse',
  'Item' => 'TaskretailStructItem',
  'Media' => 'TaskretailStructMedia',
  'Member' => 'TaskretailStructMember',
  'Modifier' => 'TaskretailStructModifier',
  'Order' => 'TaskretailStructOrder',
  'Result' => 'TaskretailStructResult',
  'UploadOrder' => 'TaskretailStructUploadOrder',
  'UploadOrderAndFreeProducts' => 'TaskretailStructUploadOrderAndFreeProducts',
  'UploadOrderAndFreeProductsResponse' => 'TaskretailStructUploadOrderAndFreeProductsResponse',
  'UploadOrderResponse' => 'TaskretailStructUploadOrderResponse',
);
	}
}
?>