<?php
/**
 * File for class TaskretailServiceUpload
 * @package Taskretail
 * @subpackage Services
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
/**
 * This class stands for TaskretailServiceUpload originally named Upload
 * @package Taskretail
 * @subpackage Services
 * @author Mikaël DELSOL <contact@wsdltophp.com>
 * @version 20140107-01
 * @date 2014-01-13
 */
class TaskretailServiceUpload extends TaskretailWsdlClass
{
	/**
	 * Method to call the operation originally named UploadOrder
	 * @uses TaskretailWsdlClass::getSoapClient()
	 * @uses TaskretailWsdlClass::setResult()
	 * @uses TaskretailWsdlClass::getResult()
	 * @uses TaskretailWsdlClass::saveLastError()
	 * @uses TaskretailStructUploadOrder::getO()
	 * @param TaskretailStructUploadOrder $_taskretailStructUploadOrder
	 * @return TaskretailStructUploadOrderResponse
	 */
	public function UploadOrder(TaskretailStructUploadOrder $_taskretailStructUploadOrder)
	{
		try
		{
			$this->setResult(new TaskretailStructUploadOrderResponse(self::getSoapClient()->UploadOrder(array('o'=>$_taskretailStructUploadOrder->getO()))));
		}
		catch(SoapFault $soapFault)
		{
			return !$this->saveLastError(__METHOD__,$soapFault);
		}
		return $this->getResult();
	}
	/**
	 * Method to call the operation originally named UploadOrderAndFreeProducts
	 * @uses TaskretailWsdlClass::getSoapClient()
	 * @uses TaskretailWsdlClass::setResult()
	 * @uses TaskretailWsdlClass::getResult()
	 * @uses TaskretailWsdlClass::saveLastError()
	 * @uses TaskretailStructUploadOrderAndFreeProducts::getO()
	 * @uses TaskretailStructUploadOrderAndFreeProducts::getFreeProducts()
	 * @param TaskretailStructUploadOrderAndFreeProducts $_taskretailStructUploadOrderAndFreeProducts
	 * @return TaskretailStructUploadOrderAndFreeProductsResponse
	 */
	public function UploadOrderAndFreeProducts(TaskretailStructUploadOrderAndFreeProducts $_taskretailStructUploadOrderAndFreeProducts)
	{
		try
		{
			$this->setResult(new TaskretailStructUploadOrderAndFreeProductsResponse(self::getSoapClient()->UploadOrderAndFreeProducts(array('o'=>$_taskretailStructUploadOrderAndFreeProducts->getO(),'freeProducts'=>$_taskretailStructUploadOrderAndFreeProducts->getFreeProducts()))));
		}
		catch(SoapFault $soapFault)
		{
			return !$this->saveLastError(__METHOD__,$soapFault);
		}
		return $this->getResult();
	}
	/**
	 * Returns the result
	 * @see TaskretailWsdlClass::getResult()
	 * @return TaskretailStructUploadOrderAndFreeProductsResponse|TaskretailStructUploadOrderResponse
	 */
	public function getResult()
	{
		return parent::getResult();
	}
	/**
	 * Method returning the class name
	 * @return string __CLASS__
	 */
	public function __toString()
	{
		return __CLASS__;
	}
}
?>