<?php
/*
POST /onlineordering/order.asmx HTTP/1.1
Host: splickit.infokingsystems.com
Content-Type: text/xml; charset=utf-8
Content-Length: length
SOAPAction: "http://www.subshop.com/getMenu"

<?xml version="1.0" encoding="utf-8"?>
<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
  <soap:Body>
    <getMenu xmlns="http://www.subshop.com/" />
  </soap:Body>
</soap:Envelope>
*/
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');

include_once "lib/utilities/functions.inc";

$method = "getMenuByStore";
$store_id = 8888;
$response0 = curlIt($method,$store_id);
myerror_log($response0);
//$myfile = "xiokos_return.xml";
//$f = fopen($myfile, "w");
//fwrite($f, $response0);
//fclose($f);
$menu = parseXMLResponseIntoArray($response0,$method);


foreach ($item_group_list['ItemGroup'] as $brink_menu_type) {
    $menu_type = array();
    if ($brink_menu_type['Name'] == 'All Items') {
        continue;
    }
    $menu_type['name'] = $brink_menu_type['Name'];
    foreach ($brink_menu_type['Items']['ItemGroupItem'] as $item_id) {
        $item = array();
        myerror_log("we have the item_id: ".$item_id['ItemId']);
        $brink_item = $item_list_hash[$item_id['ItemId']];
        myerror_log("we have the brink item");
        $item['name'] = $brink_item['Name'];
        $item['external_id'] = $brink_item['Id'];
        $item['price'] = $brink_item['Price'];
        $item['print_name'] = $brink_item['KitchenName'];
        $ingredients = array();
        foreach ($brink_item['IngredientItemIds']['int'] as $ingredient_id) {
            myerror_log("we ahve an ingredient_id of: ".$ingredient_id[0]);
            $brink_ingredient = $item_list_hash[$ingredient_id[0]];
            $ingredient['Name'] = $brink_ingredient['Name'];
            $ingredient['external_id'] = $brink_ingredient['Id'];
            $ingredient['SortPriority'] = $brink_ingredient['SortPriority'];
            $ingredient['RevenueCenterId'] = $brink_ingredient['RevenueCenterId'];
            $ingredient['Price'] = $brink_ingredient['Price'];
            $ingredient['KitchenName'] = $brink_ingredient['KitchenName'];
            $ingredients[] = $ingredient;
        }
        $item['ingredients'] = $ingredients;
        $modifier_groups = array();
        foreach ($brink_item['ModifierGroupIds']['int'] as $modifier_group_id) {
            $brink_modifier_group = $modifier_group_list_hash[$modifier_group_id[0]];
            foreach ($brink_modifier_group['Items']['ModifierGroupItem'] as &$brink_modifier_item) {
                $modifier_item = $item_list_hash[$brink_modifier_item['ItemId']];
                $brink_modifier_item['Name'] = $modifier_item['Name'];
            }
            $modifier_groups[] = $brink_modifier_group;
        }
        $item['modifier_groups'] = $modifier_groups;
        $menu_type['items'][] = $item;
    }

    $menu['menu_types'][] = $menu_type;
}
myerror_log("we have the menu");

function myBrinkToArray($xml) {
    $array = (array)$xml;

    foreach ( array_slice($array, 0) as $key => $value )
    {
        if ( $value instanceof SimpleXMLElement )
        {
            $ns = $value->getNamespaces(true);
            if ($ns['b']) {
                $value = $array[$key]->children($ns['b']);
            }
            $array[$key] = empty($value) ? NULL : myBrinkToArray($value);
        } else if (is_array($value)) {
            foreach ($value as $sub_key => $sub_value) {
                $array[$key][$sub_key] = myBrinkToArray($sub_value);
            }
        }
    }
    return $array;
}

function parseXMLResponseIntoArray($response,$method)
{
    $start = strpos($response,"<".$method."Result");
    $end_string = "</".$method."Result>";

    $start = strpos($response,"<DocumentElement");
    $end_string = "</DocumentElement>";


    $end = strpos($response,$end_string) + strlen($end_string);
    $payload = substr($response,$start,$end-$start);
    $hash = parseXMLintoHashmap($payload);

    $xml=simplexml_load_string($payload) or die("error: cannot create object");
    $hashmap = myBrinkToArray($xml);


    $xml=simplexml_load_string($payload, NULL, NULL, "http://schemas.datacontract.org/2004/07/Pos.Web.Service.Data") or die("Error: Cannot create object");
    $ns = $xml->getNamespaces(true);
    $res = $xml->children($ns['a']);
    $hashmap = myBrinkToArray($res);
    return $hashmap;
}

function curlIt($method,$store_id)
{
    $url = "http://splickit.infokingsystems.com/onlineordering/order.asmx";
    $soap_action = "http://www.subshop.com/$method";
    $curl = curl_init($url);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 10);
    curl_setopt($curl, CURLOPT_VERBOSE, 1);

    $body = '<?xml version="1.0" encoding="utf-8"?><soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/"><soap:Body><'.$method.' xmlns="http://www.subshop.com/" ><store>'.$store_id.'</store></'.$method.'></soap:Body></soap:Envelope>';
    error_log("body: $body");
    error_log(" ");
    curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $body);
    $headers = array('Content-Type: text/xml; charset=utf-8', 'Content-Length: ' . strlen($body), "SOAPAction: $soap_action");
    curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    $result = curl_exec($curl);
    error_log($result);
    return $result;
}


?>