<?php

$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');

require_once 'lib/utilities/unit_test_functions.inc';
require_once 'lib/utilities/functions.inc';

class TextControllerTest extends PHPUnit_Framework_TestCase
{
	var $text_controller;
	var $ids;
	
	function setUp()
	{
		$this->text_controller = new TextController($mt, $u, $r,5);
		setProperty('use_primary_sms', 'true');
		$this->ids = $_SERVER['unit_test_ids'];
		
	}
	
	function tearDown() 
	{
       // delete your instance
       //$this->text_controller->failAllMonitorsSMSs
       
       unset($this->text_controller);
       unset($this->ids);
       setProperty('use_primary_sms', 'true');
	}

	function testTwillioSend()
	{
		setProperty('test_sms_messages_on','false');
		$result = SmsSender2::send_with_twilio(getProperty("test_sms_number"),"twillio message");
		$this->assertNotNull($result['response_id']);
		$this->assertEquals("queued",$result['response_text']);
		$this->assertEquals(2,count($result),"Should have been 2 fields returned");
	}

    function testRecentProviderSwitch()
    {
    	$time = time()-100;
    	$sql = "UPDATE Property SET modified = $time WHERE name='use_primary_sms'";
    	$property_adapter = new PropertyAdapter($mimetypes);
    	$property_adapter->_query($sql);
    	
    	$result = TextController::checkRecentProviderResetWithinThisManySeconds(60);
    	$this->assertFalse($result);
    	$this->text_controller->switchProviders();
    	$result = TextController::checkRecentProviderResetWithinThisManySeconds(60);
    	$this->assertTrue($result);

    }
    
    function testSwitchProviders()
    {
    	$text_controller = $this->text_controller;
    	$result = $text_controller->switchProviders();
    	$this->assertEquals("setting use_primary_sms=false", $result);
    }

   static function setUpBeforeClass()
    {
    	set_time_limit(30);
    	$_SERVER['request_time1'] = microtime(true);
    	$tz = date_default_timezone_get();
    	$_SERVER['starting_tz'] = $tz;
    	date_default_timezone_set(getProperty("default_server_timezone"));
    	ini_set('max_execution_time',300);
    	      SplickitCache::flushAll();         $db = DataBase::getInstance(); $mysqli = $db->getConnection();$mysqli->begin_transaction(); ;
    	
    	$menu_id = createTestMenuWithNnumberOfItems(5);
    	$ids['menu_id'] = $menu_id;
    	
    	$merchant_resource = createNewTestMerchant($menu_id);
    	$ids['merchant_id'] = $merchant_resource->merchant_id;
    	
    	$user_resource = createNewUser(array("flags"=>"1C20000001"));
    	$ids['user_id'] = $user_resource->user_id;
    	
    	$_SERVER['log_level'] = 5; 
		$_SERVER['unit_test_ids'] = $ids;
    	
    }
    
	static function tearDownAfterClass()
    {
    	SplickitCache::flushAll();         $db = DataBase::getInstance(); $mysqli = $db->getConnection();       $mysqli->rollback();
    	date_default_timezone_set($_SERVER['starting_tz']);
    }

	/* mail method for testing */
    static function main() {
		$suite = new PHPUnit_Framework_TestSuite( __CLASS__);
  		PHPUnit_TextUI_TestRunner::run( $suite);
 	}
    
}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    TextControllerTest::main();
}
    
?>