<?php

$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');

require_once 'lib/utilities/unit_test_functions.inc';
require_once 'lib/utilities/functions.inc';

class MicrosControllerTest extends PHPUnit_Framework_TestCase
{
    var $stamp;
    var $ids;

    function setUp()
    {
        $_SERVER['HTTP_NO_CC_CALL'] = 'true';
        $this->stamp = $_SERVER['STAMP'];
        $_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
        $this->ids = $_SERVER['unit_test_ids'];

    }

    function tearDown()
    {
        //delete your instance
        $_SERVER['STAMP'] = $this->stamp;
        unset($this->ids);
    }

    function testCurlToMicrosLocal()
    {
        $body = '<POSREQUEST><CHECKREQUESTS><ADDCHECK TABLENUMBER="" EXTCHECKID="SPLICK-IT-12346" READYTIME="" READYDATETIME="" NOTE="" ORDERMODEFEE="" ORDERID="" PRICEONLY="" ORDERMODE="1"><ITEMREQUESTS><ADDITEM QTY="1" ITEMID="8018005" PRICE="" FOR="" /></ITEMREQUESTS></ADDCHECK></CHECKREQUESTS><token>1234567890</token></POSREQUEST>';
        $body = '<POSREQUEST><CHECKREQUESTS><ADDCHECK TABLENUMBER="" EXTCHECKID="SPLICK-IT-280446" READYTIME="" READYDATETIME="" NOTE="the note" ORDERMODEFEE="" ORDERID="" PRICEONLY="" ORDERMODE="2"><ITEMREQUESTS><ADDITEM ITEMID="7-1" QTY="1" ORDERNOW="Y"></ADDITEM></ITEMREQUESTS><CONTACT FIRSTNAME="First" LASTNAME="Last" PHONE1="the note" EMAIL="testuser_1423506682_t47@order140.com" /></ADDCHECK></CHECKREQUESTS><token>1234567890</token></POSREQUEST>';
        $url = "http://54.189.188.51:81/LocalService";
        if ($ch = curl_init($url)) {
            curl_setopt($ch, CURLOPT_HEADER, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $body);
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                    "Accept: */*",
                    'Content-Type: text/xml',
                    'Content-Length: ' . strlen($body))
            );
            $response = SplickitCurl::curlIt($ch);
            curl_close($ch);
        }

    }

    static function setUpBeforeClass()
    {
        $_SERVER['request_time1'] = microtime(true);
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));
        ini_set('max_execution_time',300);
        mysqli_query("BEGIN");

        $skin_resource = createWorldHqSkin();
        $ids['skin_id'] = $skin_resource->skin_id;

        //map it to a menu
        $menu_id = createTestMenuWithNnumberOfItems(2);
        $ids['menu_id'] = $menu_id;

        $modifier_group_resource = createModifierGroupWithNnumberOfItems($menu_id, 3);
        $modifier_group_id = $modifier_group_resource->modifier_group_id;
        $item_records = CompleteMenu::getAllMenuItemsAsArray($menu_id, 'Y', $mimetypes);
        assignModifierGroupToItemWithFirstNAsComesWith($item_records[0]['item_id'], $modifier_group_id, 0);
        assignModifierGroupToItemWithFirstNAsComesWith($item_records[1]['item_id'], $modifier_group_id, 1);
        assignModifierGroupToItemWithFirstNAsComesWith($item_records[2]['item_id'], $modifier_group_id, 2);

        $merchant_resource = createNewTestMerchant($menu_id);
        attachMerchantToSkin($merchant_resource->merchant_id, $ids['skin_id']);
        $ids['merchant_id'] = $merchant_resource->merchant_id;

        $user_resource = createNewUser(array("flags"=>"1C20000001"));
        $ids['user_id'] = $user_resource->user_id;

        $_SERVER['log_level'] = 5;
        $_SERVER['unit_test_ids'] = $ids;
    }

    static function tearDownAfterClass()
    {
        mysqli_query("ROLLBACK");
        date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main() {
        $suite = new PHPUnit_Framework_TestSuite( __CLASS__);
        PHPUnit_TextUI_TestRunner::run( $suite);
    }

}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    MicrosControllerTest::main();
}

?>