<?php
error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');

$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;


//$_SERVER['ENVIRONMENT'] = isset($_SERVER['XDEBUG_CONFIG']) ? "unit_test_ide" : "unit_test";
//$_SERVER['DB_INFO_FILE_PATH'] = "config/smaw_database_unittest.conf";

require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';


class ComprisIntegrationTest extends PHPUnit_Framework_TestCase
{
    var $stamp;
    var $ids;
    var $api_port = "80";

    function setUp()
    {
        $_SERVER['HTTP_NO_CC_CALL'] = 'true';
        $_SERVER['DO_NOT_RUN_CC'] = 'true';
        $this->stamp = $_SERVER['STAMP'];
        $_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
        $this->ids = $_SERVER['unit_test_ids'];
        if (isset($_SERVER['XDEBUG_CONFIG'])) {
            $this->api_port = "10080";
        }
    }

    function tearDown()
    {
        //delete your instance
        $_SERVER['STAMP'] = $this->stamp;
        unset($this->ids);
    }

    function createOrder($test_json)
    {
        $test_order_as_array = json_decode($test_json,true);
        $merchant_id = $this->ids['merchant_id'];
        $user_resource = createNewUserWithCCNoCVV();
        $user = logTestUserResourceIn($user_resource);
        $cart_data = ['merchant_id'=>$merchant_id,'user_id'=>$user_resource->uuid];
        $cart_data['items'] = $test_order_as_array['items'];
        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,getTomorrowTwelveNoonTimeStampDenver());
        $this->assertNull($checkout_resource->error);
        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,0.00);
        $this->assertNull($order_resource->error);

        $order_id = $order_resource->order_id;
        $compris_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id,'O');
        $this->assertNotNull($compris_message_resource);

        $compris_controller = ControllerFactory::generateFromMessageResource($compris_message_resource);
        $resource = $compris_controller->prepMessageForSending($compris_message_resource);
        $body = $resource->message_text;
        myerror_log($body);
        return $body;
    }

    function testIncludedSides()
    {
        $test_json = '{"user_id":"2461-uhy52-206iw-1s2vo","merchant_id":"108501","submitted_order_type":"pickup","group_order_token":null,"user_addr_id":null,"items":[{"item_id":312200,"external_detail_id":"73335994-6fad-4b4a-829f-89ad287deda8","quantity":1,"mods":[{"modifier_item_id":2403778,"mod_quantity":1,"name":"Fries"},{"modifier_item_id":2403780,"mod_quantity":1,"name":"6 Hushpuppies"},{"modifier_item_id":2371310,"mod_quantity":1,"name":"Tartar Sauce"},{"modifier_item_id":2371311,"mod_quantity":1,"name":"Malt Vinegar"},{"modifier_item_id":2371309,"mod_quantity":1,"name":"Cocktail Sauce"}],"size_id":"100455","status":"new","order_detail_id":null,"points_used":null,"brand_points_id":null,"note":""}],"total_points_used":0}';
        $result = $this->createOrder($test_json);
    }

    function testSides()
    {
        $test_json = '{"user_id":"2461-uhy52-206iw-1s2vo","merchant_id":"108501","submitted_order_type":"pickup","group_order_token":null,"user_addr_id":null,"items":[{"item_id":312189,"external_detail_id":"57e3cba5-ca86-490d-a472-17d4b2a62319","quantity":1,"mods":[{"modifier_item_id":2411633,"mod_quantity":1,"name":"Grilled Shrimp Taco Southwest"},{"modifier_item_id":2403760,"mod_quantity":1,"name":"Grilled Salmon Taco Southwest"},{"modifier_item_id":2371311,"mod_quantity":1,"name":"Malt Vinegar"},{"modifier_item_id":2371309,"mod_quantity":1,"name":"Cocktail Sauce"},{"modifier_item_id":2371315,"mod_quantity":1,"name":"Sweet \\\\u0026 Sour"},{"modifier_item_id":2371316,"mod_quantity":1,"name":"BBQ Sauce"},{"modifier_item_id":2403752,"mod_quantity":1,"name":"Corn"},{"modifier_item_id":2403755,"mod_quantity":1,"name":"6 Hushpuppies"}],"size_id":"100452","status":"new","order_detail_id":null,"points_used":null,"brand_points_id":null,"note":""}],"total_points_used":0}';
        $result = $this->createOrder($test_json);
    }


    function testSmallItems()
    {
        // crab cake and fries
        $test_json = '{"user_id":"2461-uhy52-206iw-1s2vo","merchant_id":"108501","submitted_order_type":"pickup","group_order_token":null,"user_addr_id":null,"items":[{"item_id":312212,"external_detail_id":"0497faeb-7843-4d51-864c-f083b90fad44","quantity":1,"mods":[],"size_id":"100457","status":"new","order_detail_id":null,"points_used":null,"brand_points_id":null,"note":"sasquatch"},{"item_id":312215,"external_detail_id":"534c3cd9-3de5-41ae-bac3-d6f03936149d","quantity":1,"mods":[],"size_id":"104765","status":"new","order_detail_id":null,"points_used":null,"brand_points_id":null,"note":""}],"total_points_used":0}';
        $result = $this->createOrder($test_json);
    }

    function testCreateOrderXmlSimple()
    {
        // papa burger combo
        $test_json = '{"user_id":"2461-uhy52-206iw-1s2vo","merchant_id":"108501","submitted_order_type":"pickup","group_order_token":null,"user_addr_id":null,"items":[{"item_id":312189,"external_detail_id":"46eabe4f-012c-44d1-9695-297c3afe2597","quantity":1,"mods":[{"modifier_item_id":2403757,"mod_quantity":1,"name":"Grilled Salmon Taco Seasoned"},{"modifier_item_id":2411783,"mod_quantity":1,"name":"Grilled Shrimp Taco Southwest"},{"modifier_item_id":2371313,"mod_quantity":1,"name":"Ketchup"},{"modifier_item_id":2371314,"mod_quantity":1,"name":"Hot Sauce"},{"modifier_item_id":2403753,"mod_quantity":1,"name":"Fries"}],"size_id":"100452","status":"new","order_detail_id":null,"points_used":null,"brand_points_id":null,"note":"sasquatch2"}],"total_points_used":0}';
        $result = $this->createOrder($test_json);
    }

    function testCreateXmlAgain()
    {
        $test_json = '{"user_id":"2461-uhy52-206iw-1s2vo","merchant_id":"108501","submitted_order_type":"pickup","group_order_token":null,"user_addr_id":null,"items":[{"item_id":328980,"external_detail_id":"fd4b127a-a4d7-4967-a977-86da900a7fab","quantity":1,"mods":[{"modifier_item_id":2403776,"mod_quantity":1,"name":"Coleslaw"},{"modifier_item_id":2404578,"mod_quantity":1,"name":"Diet Pepsi"},{"modifier_item_id":2403750,"mod_quantity":1,"name":"Honey Mustard"},{"modifier_item_id":2371315,"mod_quantity":1,"name":"Sweet \\\\u0026 Sour"}],"size_id":"100453","status":"new","order_detail_id":null,"points_used":null,"brand_points_id":null,"note":"bobbyrobert"}],"total_points_used":0}';
        $result = $this->createOrder($test_json);
    }

    static function setUpBeforeClass()
    {
        $_SERVER['request_time1'] = microtime(true);
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));
        ini_set('max_execution_time',300);
        $menu_id = 103047;
        $brand_id = 517;
        $skin_id = 237;
        getOrCreateSkinAndBrandIfNecessary('longjohnsilvers','longjohnsilvers',$skin_id,$brand_id);

        $menu_adapter = new MenuAdapter(getM());
        if ($menu_resource = Resource::find($menu_adapter,"$menu_id")){
//            $menu_resource->version = 2.0;
//            $menu_resource->save();
        } else {
            //create menu
            $menu_adapter->importMenu($menu_id,'rrtprod','local',$brand_id);
//            $menu_resource = Resource::find($menu_adapter,"$menu_id");
//            $menu_resource->version = 2.0;
//            $menu_resource->save();
        }

        setContext('com.splickit.longjohnsilvers');


        //$merchant_resource_new = getOrCreateNewTestMerchantBasedOnExternalId('LJS-1000');

        $merchant_resource = createNewTestMerchant($menu_id);
        $menu_map_resource = Resource::createByData(new MerchantMenuMapAdapter($m),array("merchant_id"=>$merchant_resource->merchant_id,"menu_id"=>$menu_id));
        $message_map_resource = Resource::createByData(new MerchantMessageMapAdapter(getM()),array("merchant_id"=>$merchant_resource->merchant_id,"message_format"=>'O',"delivery_addr"=>"Compris","message_type"=>"X"));

        $tpppa = new ThirdPartyProviderParametersAdapter(getM());
        $parameters = $tpppa->getParametersFromProviderId(1007);
        $i = 1000;
        foreach ($parameters as $parameter_row) {
            $data = [];
            $data['third_party_provider_parameter_id'] = $parameter_row['third_party_provider_parameter_id'];
            $data['skin_id'] = $skin_id;
            $data['value'] = $i;
            $tpppsma = new ThirdPartyProviderParameterSkinMapsAdapter(getM());
            Resource::createByData($tpppsma,$data);
            $i = $i + 1000;
        }

        $ids['merchant_resource'] = $merchant_resource;
        $ids['merchant_id'] = $merchant_resource->merchant_id;
        $ids['menu_id'] = $menu_id;

        $user_resource = createNewUserWithCCNoCVV();
        $ids['user_resource'] = $user_resource;
        $ids['user_id'] = $user_resource->user_id;

        $_SERVER['log_level'] = 5;
        $_SERVER['unit_test_ids'] = $ids;
    }


    static function tearDownAfterClass()
    {
//        $db = DataBase::getInstance();
//        $mysqli = $db->getConnection();
//        $mysqli->rollback();

        date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main() {
        $suite = new PHPUnit_Framework_TestSuite( __CLASS__);
        PHPUnit_TextUI_TestRunner::run( $suite);
    }

}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    ComprisIntegrationTest::main();
}

?>
