<?php
error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');

$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;


//$_SERVER['ENVIRONMENT'] = isset($_SERVER['XDEBUG_CONFIG']) ? "unit_test_ide" : "unit_test";
//$_SERVER['DB_INFO_FILE_PATH'] = "config/smaw_database_unittest.conf";

require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';


class DoublzBrinkIntegrationTest extends PHPUnit_Framework_TestCase
{
    var $stamp;
    var $ids;
    var $api_port = "80";

    function setUp()
    {
        $_SERVER['HTTP_NO_CC_CALL'] = 'true';
        $_SERVER['DO_NOT_RUN_CC'] = 'true';
        $this->stamp = $_SERVER['STAMP'];
        $_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
        $this->ids = $_SERVER['unit_test_ids'];
        if (isset($_SERVER['XDEBUG_CONFIG'])) {
            $this->api_port = "10080";
        }
    }

    function tearDown()
    {
        //delete your instance
        $_SERVER['STAMP'] = $this->stamp;
        unset($this->ids);
    }

//    function testStageEntireBrand()
//    {
//        //first add a non brink merchant
//
//        $menu_id = createTestMenuWithNnumberOfItems(1);
//        $merchant_resource = getOrCreateNewTestMerchantBasedOnExternalId('non-brink',$menu_id);
//
//        $doit_ts = time()-2;
//        $info = 'object=BrinksnarfsImporter;method=staticStageImportForEntireBrandList;thefunctiondatastring=pos/import/brinksnarfs/all';
//        //$info = 'merchant_id=all';
//        $activity_history_adapter = new ActivityHistoryAdapter(getM());
//        $activity_history_resource = $activity_history_adapter->createActivityReturnActivityResource('BrinkSnarfsPriceSync', $doit_ts, $info, '',60*60*24);
//        $this->assertNotNull($activity_history_resource);
//
//        removeContext();
//
//        $activity_history_resource->locked = 'Y';
//        $activity_history_resource->save();
//        $activity = SplickitActivity::getActivity($activity_history_resource);
//        $result = $activity->doit();
//
//    }


//    function testGetDestinations()
//    {
//        $brink_importer = new BrinkImporter();
//        $method = "GetDestinations";
//        $response0 = $brink_importer->curlIt($method,$merchant_resource);
//        myerror_log($response0);
//    }

    function testImporterNewWithLoadModifiers()
    {
        $merchant_resource = $this->ids['merchant_resource'];
        $merchant_id = $merchant_resource->merchant_id;
        $external_id = $merchant_resource->merchant_external_id;
        $doit_ts = time()-2;
        $info = "merchant_alphanumeric_id=$merchant_resource->alphanumeric_id;build_modifiers=1";
        $activity_history_adapter = new ActivityHistoryAdapter(getM());
        $activity_history_resource = $activity_history_adapter->createActivityReturnActivityResource('BrinkPriceSync', $doit_ts, $info, '');
        $this->assertNotNull($activity_history_resource);

        removeContext();

        $activity_history_resource->locked = 'Y';
        $activity_history_resource->save();
        $activity = SplickitActivity::getActivity($activity_history_resource);
        $result = $activity->doit();
        $complete_menu = new CompleteMenu($this->ids['menu_id']);
        $item_sizes = $complete_menu->getAllMenuItemSizePrices($this->ids['menu_id'],'Y',$merchant_id,getM());
        $count = sizeof($item_sizes);
        $this->assertTrue($count>10,"It should have imported a bunch of prices for the merchant but it only imported: $count");

//        $modifier_size_list = $complete_menu->getAllModifierItemPricesForMenu($this->ids['menu_id'],'Y',getM(),$merchant_id);
//        $no = 0;
//        $yes = 0;
//        foreach($modifier_size_list as $modifier_sizes) {
//            foreach ($modifier_sizes as $modifier_size) {
//                if ($modifier_size['active'] == 'N') {
//                    myerror_log("we ahve a NO");
//                    $no++;
//                } else {
//                    myerror_log("we have a YES: ".$modifier_size['active']);
//                    $yes++;
//                }
//            }
//        }
//        myerror_log("NO: $no,   YES: $yes");
    }

    function testItShouldGetTheTaxFromBrinkOnGetCheckoutData()
    {
        $merchant_id = $this->ids['merchant_id'];
        //set tax to 0.00 for merchant
        $tax_resource = Resource::find(new TaxAdapter(getM()),null,[TONIC_FIND_BY_METADATA=>['merchant_id'=>$merchant_id]]);
        $tax_resource->rate = 0.00;
        $tax_resource->save();

        $code = generateAlphaCode(3);
        $user_resource = createNewUserWithCCNoCVV(array("email"=>"bobnewhart_$code@order140.com","first_name"=>"bob","last_name"=>"newhart","contact_no"=>'8888888888'));
        $user = logTestUserResourceIn($user_resource);
        $order_adapter = new OrderAdapter($m);
        $menu = CompleteMenu::getCompleteMenu($this->ids['menu_id'],'Y',$merchant_id,2,'pickup');
        array_shift($menu['menu_types']);
        array_shift($menu['menu_types']);
        $order_data = $order_adapter->getOrderArrayFromFullMenuWithOneModiferPerModifierGroup($menu,$merchant_id,"some note",1,0,1);
        $checkout_resource = getCheckoutResourceFromOrderData($order_data,getTomorrowTwelveNoonTimeStampDenver());
        $this->assertNull($checkout_resource->error,"It should not throw an error");
        $checkout_receipt_items = createHashmapFromArrayOfArraysByFieldName($checkout_resource->order_summary['receipt_items'],'title');
        $checkout_tax = $checkout_receipt_items['Tax'];
        $this->assertTrue($checkout_resource->total_tax_amt > 0.00,"Tax should have been set by the brink pull");
        $tax_amount = $checkout_resource->total_tax_amt;
        $this->assertEquals('$'.$tax_amount,$checkout_tax['amount']);
        $total = $checkout_receipt_items['Total']['amount'];
        //$this->assertEquals("$8.13",$total,"total should have been set to the brink values");
//        $complete_order = CompleteOrder::staticGetCompleteOrder($order_id,$m);
        $order_amt = floatval($checkout_resource->order_amt);
        $total_tax_amt = floatval($checkout_resource->total_tax_amt);
        $this->assertTrue($total_tax_amt > 0.00,"It should have sent back a valid total tax amount but sent back: ".$checkout_resource->total_tax_amt);
        $tax_rate = intval(100*$total_tax_amt/$order_amt);
        $this->assertNotEquals(20,$tax_rate,"tax rate should be calculated by brink, not the 20% that is in our system");

        //make sure totals are correct.
        $complete_order = CompleteOrder::staticGetCompleteOrder($checkout_resource->oid_test_only,$m);
        $grand_total_from_math = $complete_order['order_amt']+$complete_order['total_tax_amt']+$complete_order['delivery_amt']+$complete_order['tip_amt']+$complete_order['promo_amt'];
        $this->assertEquals($grand_total_from_math,$complete_order['grand_total'],"the set grand total should equal the sum of the parts");
    }



    static function setUpBeforeClass()
    {
        $_SERVER['request_time1'] = microtime(true);
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));
        ini_set('max_execution_time',300);
        
        $skin_resource = getOrCreateSkinAndBrandIfNecessary('doublz','doublz',298,578);

        $menu_id = 103187;
        $brand_id = 578;
        $skin_id = 298;
        $menu_adapter = new MenuAdapter(getM());
        if ($menu_resource = Resource::find($menu_adapter,"$menu_id")){
//            $menu_resource->version = 2.0;
//            $menu_resource->save();
        } else {
            //create menu
            $menu_adapter->importMenu($menu_id,'prod','local',$brand_id);
//            $menu_resource = Resource::find($menu_adapter,"$menu_id");
//            $menu_resource->version = 2.0;
//            $menu_resource->save();
        }

        setContext('com.splickit.doublz');

        $merchant_resource = getOrCreateNewTestMerchantBasedOnExternalId('88888');
        $menu_map_resource = Resource::createByData(new MerchantMenuMapAdapter(getM()),array("merchant_id"=>$merchant_resource->merchant_id,"menu_id"=>$menu_id));
        $message_map_resource = Resource::createByData(new MerchantMessageMapAdapter(getM()),array("merchant_id"=>$merchant_resource->merchant_id,"message_format"=>'BO',"delivery_addr"=>"Brink","message_type"=>"X"));
        $tpppmap_resource = Resource::createByData(new ThirdPartyProviderParameterMerchantMapsAdapter(getM()),["merchant_id"=>$merchant_resource->merchant_id,"third_party_provider_parameter_id"=>1000,"value"=>'Z4et7DHitEmRmjfze2/zzg==']);


        $tpppa = new ThirdPartyProviderParametersAdapter(getM());
        $brink_third_party_parameters = $tpppa->getRecords(['third_party_provider_id'=>1001]);
        foreach ($brink_third_party_parameters as $brink_parameter) {

                $id = $brink_parameter['id'];
                $name = $brink_parameter['name'];

                if ($name == 'brink_domain') {
                    $value = 'api3.brinkpos.net';
                    $tpppmap_resource = Resource::createByData(new ThirdPartyProviderParameterSkinMapsAdapter(getM()),["skin_id"=>$skin_id,"third_party_provider_parameter_id"=>$id,"value"=>'api88.brinkpos.net']);
                } else if ($name == 'brink_pickup_destination_id') {
                    $value = '217253';
                } else if ($name == 'brink_delivery_destination_id') {
                    $value = '217254';
                } else if ($name == 'brink_tender_id') {
                    $value = '217255';
                }
                $ids[$name] = $value;
                $tpppmap_resource = Resource::createByData(new ThirdPartyProviderParameterBrandMapsAdapter(getM()),["brand_id"=>$brand_id,"third_party_provider_parameter_id"=>$brink_parameter['id'],"value"=>$value]);
        }

//        $tpppmap_resource = Resource::createByData(new ThirdPartyProviderParameterBrandMapsAdapter(getM()),["brand_id"=>$brand_id,"third_party_provider_parameter_id"=>1039,"value"=>'217253']);
//        $tpppmap_resource = Resource::createByData(new ThirdPartyProviderParameterBrandMapsAdapter(getM()),["brand_id"=>$brand_id,"third_party_provider_parameter_id"=>1040,"value"=>'217254']);
//        //$tpppmap_resource = Resource::createByData(new ThirdPartyProviderParameterBrandMapsAdapter(getM()),["brand_id"=>$brand_id,"third_party_provider_parameter_id"=>1041,"value"=>'note-10001041']);
//        $tpppmap_resource = Resource::createByData(new ThirdPartyProviderParameterBrandMapsAdapter(getM()),["brand_id"=>$brand_id,"third_party_provider_parameter_id"=>1042,"value"=>'217255']);
////        $tpppmap_resource = Resource::createByData(new ThirdPartyProviderParameterBrandMapsAdapter(getM()),["brand_id"=>$brand_id,"third_party_provider_parameter_id"=>1043,"value"=>'promo-10001043']);
////        $tpppmap_resource = Resource::createByData(new ThirdPartyProviderParameterBrandMapsAdapter(getM()),["brand_id"=>$brand_id,"third_party_provider_parameter_id"=>1044,"value"=>'loyalty-10001044']);
//        $tpppmap_resource = Resource::createByData(new ThirdPartyProviderParameterBrandMapsAdapter(getM()),["brand_id"=>$brand_id,"third_party_provider_parameter_id"=>1045,"value"=>'api3.brinkpos.net']);


        $ids['merchant_resource'] = $merchant_resource;
        $ids['merchant_id'] = $merchant_resource->merchant_id;

        
        $ids['menu_id'] = $menu_id;

        $user_resource = createNewUserWithCCNoCVV();
        $ids['user_resource'] = $user_resource;
        $ids['user_id'] = $user_resource->user_id;

        $_SERVER['log_level'] = 5;
        $_SERVER['unit_test_ids'] = $ids;
    }


    static function tearDownAfterClass()
    {
//        $db = DataBase::getInstance();
//        $mysqli = $db->getConnection();
//        $mysqli->rollback();

        date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main() {
        $suite = new PHPUnit_Framework_TestSuite( __CLASS__);
        PHPUnit_TextUI_TestRunner::run( $suite);
    }

}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    DoublzBrinkIntegrationTest::main();
}

?>
