<?php

$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');

require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';

class FpnLoyaltyTestPOS extends PHPUnit_Framework_TestCase
{
	var $stamp;
	var $ids;

	function setUp()
	{
		//setContext('com.splickit.jerseymikes');
		//$_SERVER['HTTP_NO_CC_CALL'] = 'true';
		$this->stamp = $_SERVER['STAMP'];
		$_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
		$this->ids = $_SERVER['unit_test_ids'];
		$this->url = getProperty('fpn_loyalty_url');
	}
	
	function tearDown() 
	{
		//delete your instance
		$_SERVER['STAMP'] = $this->stamp;
		unset($this->ids);
		unset($this->url);
    }

/*    function testVoidTransactions()
    {
    	$fpn_loyalty_service = new FpnLoyaltyService();
    	$ids = $this->ids;
		$new_order_data['brand_loyalty_number'] = $ids['loyalty_number'];
		$new_order_data['merchant_rock_comm_id'] = $ids['merchant_rock_comm_id'];

		$new_order_data['order_id'] = 730965269;
		$new_order_data['approved_code'] = 36299410;
		$xml = $fpn_loyalty_service->createVoidXMLDocument($new_order_data);
		$loyalty_return = FpnLoyaltyCurl::curlIt($this->url, $xml);
		$this->assertEquals(200, $loyalty_return['http_code']);
		
		$new_order_data['order_id'] = 23620528;
		$new_order_data['approved_code'] = 36300688;
		$xml = $fpn_loyalty_service->createVoidXMLDocument($new_order_data);
		$loyalty_return = FpnLoyaltyCurl::curlIt($this->url, $xml);
		$this->assertEquals(200, $loyalty_return['http_code']);
/*
		$new_order_data['order_id'] = $order_id;
		$new_order_data['approved_code'] = $approved_code;
		$xml = $fpn_loyalty_service->createVoidXMLDocument($new_order_data);
		$loyalty_return = FpnLoyaltyCurl::curlIt($this->url, $xml);
		$this->assertEquals(200, $loyalty_return['http_code']);
*/		
    	
 //   }
/*    
    function testGetBalance()
    {
    	$ids = $this->ids;
		$new_order_data['brand_loyalty_number'] = $ids['loyalty_number'];
		$new_order_data['merchant_rock_comm_id'] = $ids['merchant_rock_comm_id'];
		$order_id = rand(111111, 999999999);
		$new_order_data['order_id'] = 743764309;
		$fpn_loyalty_service = new FpnLoyaltyService();
		$inquiry_xml = $fpn_loyalty_service->createBalanceInquiryXMLDocument($new_order_data);
		error_log("fpn xml: ".$inquiry_xml);
		$loyalty_return = FpnLoyaltyCurl::curlIt($this->url, $inquiry_xml);
		$this->assertEquals(200, $loyalty_return['http_code']);
		$result = $fpn_loyalty_service->processRawReturnForBalanceInquiry($loyalty_return['raw_result']);
		$raw_jason_payload = $fpn_loyalty_service->raw_response;
		$response_array = json_decode($raw_jason_payload,true);
		$response_data = $response_array['xml'];
		myerror_log("FPN cert values:  ".$response_data['PointsBalance']."   ".$response_data['GiftcardBalance']);
		
    }
//*/

	function testSendMessage()
	{
		$ids = $this->ids;
		$order_amount = rand(1000,3000)/100;
		$new_order_data['order_amt'] = $order_amount;
		$new_order_data['brand_loyalty_number'] = $ids['loyalty_number'];
		$new_order_data['merchant_rock_comm_id'] = $ids['merchant_rock_comm_id'];
		$order_id = rand(111111, 999999999);
		$new_order_data['order_id'] = $order_id;
		$fpn_loyalty_service = new FpnLoyaltyService();
		$xml = $fpn_loyalty_service->createLoyaltySoapXmlDocument($new_order_data);
		$mmh_data['merchant_id'] = $this->ids['merchant_id'];
		$mmh_data['order_id'] = $order_id;
		$mmh_data['message_format'] = "C";
		$mmh_data['info'] = "service=FpnLoyalty";
		$mmh_data['locked'] = "N";
		$mmh_data['message_delivery_addr'] = "".$this->url;
		$mmh_data['message_text'] = $xml;
		$mmh_data['next_message_dt_tm'] = time()-5;
		$mmh_adapter = new MerchantMessageHistoryAdapter($m);
		$message_resource = Resource::factory($mmh_adapter,$mmh_data);
		$message_resource->save();

		$message_controller = ControllerFactory::generateFromMessageResource($message_resource,$m,$u,$r,5);
		$this->assertTrue($message_controller->sendThisMessage($message_resource));
		$this->assertNull($message_controller->getErrorMessage(),"should not have been an error on the send");
		$new_message_resource = Resource::find($mmh_adapter,"".$message_resource->map_id);

		$this->assertEquals('S',$new_message_resource->locked,"message should have been sent");
		$this->assertNotNull($new_message_resource->response,"response should have been saved");


	}

    function testAddPoints()
    {
    	//die("stupid");
    	$ids = $this->ids;
		$new_order_data['order_amt'] = 25.00;
		$new_order_data['brand_loyalty_number'] = $ids['loyalty_number'];
		$new_order_data['merchant_rock_comm_id'] = $ids['merchant_rock_comm_id'];
		$order_id = rand(111111, 999999999);
		$new_order_data['order_id'] = $order_id;
		$fpn_loyalty_service = new FpnLoyaltyService();
		
		$xml = $fpn_loyalty_service->createLoyaltySoapXmlDocument($new_order_data);
		error_log("fpn xml: ".$xml);
		$loyalty_return = FpnLoyaltyCurl::curlIt($this->url, $xml);
		$this->assertEquals(200, $loyalty_return['http_code']);
		$result = $fpn_loyalty_service->processRawReturnForAddPoints($loyalty_return['raw_result']);
		$raw_jason_payload = $fpn_loyalty_service->raw_response;
		$response_array = json_decode($raw_jason_payload,true);
		$response_data = $response_array['xml'];
		logData($response_data, 'fpn add points return');
		$auth_code = $response_data['Approved'];
		$this->assertTrue($result);
				
		// balance shoudl be 25
		$inquiry_xml = $fpn_loyalty_service->createBalanceInquiryXMLDocument($new_order_data);
		error_log("fpn xml: ".$inquiry_xml);
		$loyalty_return = FpnLoyaltyCurl::curlIt($this->url, $inquiry_xml);
		$this->assertEquals(200, $loyalty_return['http_code']);
		$result = $fpn_loyalty_service->processRawReturnForBalanceInquiry($loyalty_return['raw_result']);
		$raw_jason_payload = $fpn_loyalty_service->raw_response;
		$response_array = json_decode($raw_jason_payload,true);
		$response_data = $response_array['xml'];
		myerror_log("FPN cert values:  ".$response_data['PointsBalance']."   ".$response_data['GiftcardBalance']);
		
    	// void order
		$new_order_data['approved_code'] = $auth_code;
		$xml = $fpn_loyalty_service->createVoidXMLDocument($new_order_data);
		$loyalty_return = FpnLoyaltyCurl::curlIt($this->url, $xml);
		$this->assertEquals(200, $loyalty_return['http_code']);
		$result = $fpn_loyalty_service->processRawReturnForVoidTransaction($loyalty_return['raw_result']);
		
		// balance shoudl be 0
		$inquiry_xml = $fpn_loyalty_service->createBalanceInquiryXMLDocument($new_order_data);
		error_log("fpn xml: ".$inquiry_xml);
		$loyalty_return = FpnLoyaltyCurl::curlIt($this->url, $inquiry_xml);
		$this->assertEquals(200, $loyalty_return['http_code']);
		$result = $fpn_loyalty_service->processRawReturnForBalanceInquiry($loyalty_return['raw_result']);
		$raw_jason_payload = $fpn_loyalty_service->raw_response;
		$response_array = json_decode($raw_jason_payload,true);
		$response_data = $response_array['xml'];
		myerror_log("FPN cert values:  ".$response_data['PointsBalance']."   ".$response_data['GiftcardBalance']);
		
		//now add 35 points
		$new_order_data['order_amt'] = 35.00;
		$order_id = rand(111111, 999999999);
		$new_order_data['order_id'] = $order_id;
		$xml = $fpn_loyalty_service->createLoyaltySoapXmlDocument($new_order_data);
		error_log("fpn xml: ".$xml);
		$loyalty_return = FpnLoyaltyCurl::curlIt($this->url, $xml);
		$this->assertEquals(200, $loyalty_return['http_code']);
		
		// balance shoudl be 35
		$inquiry_xml = $fpn_loyalty_service->createBalanceInquiryXMLDocument($new_order_data);
		error_log("fpn xml: ".$inquiry_xml);
		$loyalty_return = FpnLoyaltyCurl::curlIt($this->url, $inquiry_xml);
		$this->assertEquals(200, $loyalty_return['http_code']);
		$result = $fpn_loyalty_service->processRawReturnForBalanceInquiry($loyalty_return['raw_result']);
		$raw_jason_payload = $fpn_loyalty_service->raw_response;
		$response_array = json_decode($raw_jason_payload,true);
		$response_data = $response_array['xml'];
		myerror_log("FPN cert values:  ".$response_data['PointsBalance']."   ".$response_data['GiftcardBalance']);

		//now add 50 points
		$new_order_data['order_amt'] = 50.00;
		$order_id = rand(111111, 999999999);
		$new_order_data['order_id'] = $order_id;
		$xml = $fpn_loyalty_service->createLoyaltySoapXmlDocument($new_order_data);
		error_log("fpn xml: ".$xml);
		$loyalty_return = FpnLoyaltyCurl::curlIt($this->url, $xml);
		$this->assertEquals(200, $loyalty_return['http_code']);
		
		// balance shoudl be 85
		$inquiry_xml = $fpn_loyalty_service->createBalanceInquiryXMLDocument($new_order_data);
		error_log("fpn xml: ".$inquiry_xml);
		$loyalty_return = FpnLoyaltyCurl::curlIt($this->url, $inquiry_xml);
		$this->assertEquals(200, $loyalty_return['http_code']);
		$result = $fpn_loyalty_service->processRawReturnForBalanceInquiry($loyalty_return['raw_result']);
		$raw_jason_payload = $fpn_loyalty_service->raw_response;
		$response_array = json_decode($raw_jason_payload,true);
		$response_data = $response_array['xml'];
		myerror_log("FPN cert values:  ".$response_data['PointsBalance']."   ".$response_data['GiftcardBalance']);

		//now add 20 points
		$new_order_data['order_amt'] = 20.00;
		$order_id = rand(111111, 999999999);
		$new_order_data['order_id'] = $order_id;
		$xml = $fpn_loyalty_service->createLoyaltySoapXmlDocument($new_order_data);
		error_log("fpn xml: ".$xml);
		$loyalty_return = FpnLoyaltyCurl::curlIt($this->url, $xml);
		$this->assertEquals(200, $loyalty_return['http_code']);
		$result = $fpn_loyalty_service->processRawReturnForAddPoints($loyalty_return['raw_result']);
		$raw_jason_payload = $fpn_loyalty_service->raw_response;
		$response_array = json_decode($raw_jason_payload,true);
		$response_data = $response_array['xml'];
		logData($response_data, 'fpn add points return');
		$auth_code2 = $response_data['Approved'];
		$this->assertTrue($result);
		
		// balance shoudl be $15 cash   5 points
		$inquiry_xml = $fpn_loyalty_service->createBalanceInquiryXMLDocument($new_order_data);
		error_log("fpn xml: ".$inquiry_xml);
		$loyalty_return = FpnLoyaltyCurl::curlIt($this->url, $inquiry_xml);
		$this->assertEquals(200, $loyalty_return['http_code']);
		$result = $fpn_loyalty_service->processRawReturnForBalanceInquiry($loyalty_return['raw_result']);
		$raw_jason_payload = $fpn_loyalty_service->raw_response;
		$response_array = json_decode($raw_jason_payload,true);
		$response_data = $response_array['xml'];
		myerror_log("FPN cert values:  ".$response_data['PointsBalance']."   ".$response_data['GiftcardBalance']);
		
		//now void
		$new_order_data['approved_code'] = $auth_code2;
		$void_xml = $fpn_loyalty_service->createVoidXMLDocument($new_order_data);
		$loyalty_return = FpnLoyaltyCurl::curlIt($this->url, $void_xml);
		$this->assertEquals(200, $loyalty_return['http_code']);
		
		// balance shoudl be 85
		$inquiry_xml = $fpn_loyalty_service->createBalanceInquiryXMLDocument($new_order_data);
		error_log("fpn xml: ".$inquiry_xml);
		$loyalty_return = FpnLoyaltyCurl::curlIt($this->url, $inquiry_xml);
		$this->assertEquals(200, $loyalty_return['http_code']);
		$result = $fpn_loyalty_service->processRawReturnForBalanceInquiry($loyalty_return['raw_result']);
		$raw_jason_payload = $fpn_loyalty_service->raw_response;
		$response_array = json_decode($raw_jason_payload,true);
		$response_data = $response_array['xml'];
		myerror_log("FPN cert values:  ".$response_data['PointsBalance']."   ".$response_data['GiftcardBalance']);

    }
    
	static function setUpBeforeClass()
    {
    	$_SERVER['request_time1'] = microtime(true);
    	$_SERVER['NO_MOCKS'] = true;
    	$tz = date_default_timezone_get();
    	$_SERVER['starting_tz'] = $tz;
    	date_default_timezone_set(getProperty("default_server_timezone"));
    	mysqli_query("BEGIN");

    	$ids['skin_id'] = 88; // ECW
    	$ids['brand_id'] = 379;  // ECW
    	
    	$simple_menu_id = createTestMenuWithOneItem("item_one");
    	$ids['menu_id'] = $simple_menu_id;
    	
    	$merchant_resource = createNewTestMerchant($simple_menu_id);
    	attachMerchantToSkin($merchant_resource->merchant_id, $ids['skin_id']);
    	$ids['merchant_id'] = $merchant_resource->merchant_id;
    	
    	$ids['merchant_rock_comm_id'] = 'ECW92130';
    	$mfpnma = new MerchantFPNMapAdapter($mimetypes);
    	$data['merchant_id'] = $ids['merchant_id'];
    	$data['fpn_merchant_key'] = '41Mk65OH04krz32O4ZG2vy3Oj884882A';
    	$data['fpn_merchant_pin'] = 1405;
    	$data['merchant_rock_comm_id'] = $ids['merchant_rock_comm_id'];
    	Resource::createByData($mfpnma, $data);

    	$user_resource = createNewUser(array("flags"=>"1C20000001"));
    	$ids['user_id'] = $user_resource->user_id;
    	//$ids['loyalty_number'] = '900292740611';
    	$ids['loyalty_number'] = '900292740629';
    	$ubpa = new UserBrandPointsMapAdapter($mimetypes);
    	$ubpa->createUserLoyaltyAccount($ids['user_id'], $ids['brand_id'], $ids['loyalty_number']);

    	$_SERVER['log_level'] = 5; 
		$_SERVER['unit_test_ids'] = $ids;
    }
    
	static function tearDownAfterClass()
    {
    	mysqli_query("ROLLBACK");
    	date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main() {
		$suite = new PHPUnit_Framework_TestSuite( __CLASS__);
  		PHPUnit_TextUI_TestRunner::run( $suite);
 	}
    
}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    FpnLoyaltyTestPOS::main();
}

?>