<?php
error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');

$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;

require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';


class FoundryImporterTest extends PHPUnit_Framework_TestCase
{
    var $stamp;
    var $ids;

    function setUp()
    {
        $_SERVER['HTTP_NO_CC_CALL'] = 'true';
        $this->stamp = $_SERVER['STAMP'];
        $_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
        $this->ids = $_SERVER['unit_test_ids'];
        setContext('com.splickit.osf');
        if (isset($_SERVER['XDEBUG_CONFIG'])) {
            $this->api_port = "10080";
        } else {
            $this->api_port = "80";
        }

    }

    function tearDown()
    {
        //delete your instance
        $_SERVER['STAMP'] = $this->stamp;
        unset($this->ids);
    }

    function testBackwardsCompatibilityOfStagingImport()
    {
        $merchant_resource = createNewTestMerchant($this->ids['menu_id']);
        $merchant_id = $merchant_resource->merchant_id;
        $mfima = new MerchantFoundryInfoMapsAdapter(getM());
        $fdata['merchant_id'] = $merchant_resource->merchant_id;
        $fdata['foundry_store_id'] = '12335';
        $mfim_resource = Resource::createByData($mfima,$fdata);
        $this->assertEquals(0,$mfim_resource->get_menu,"It should have the flag unset");

        $import_url = "http://127.0.0.1:".$this->api_port."/app2/portal/import/foundry/".$merchant_resource->alphanumeric_id;

//        $request = createRequestObject($import_url,'POST');
//        $pos_controller = new PosController(getM(),null,$request,5);
//        $response = makeMockPortalRequest($pos_controller);

        $response = makeLocalhostRequest($import_url,null,'POST',null);

        $mfim_resource = $mfim_resource->getRefreshedResource();
        $this->assertEquals(1,$mfim_resource->get_menu,"It should have the flag unset");

        $url = "http://127.0.0.1:".$this->api_port."/app2/messagemanager/foundry/getnextmessagebymerchantid?reqtype=01&siteid=".$merchant_resource->alphanumeric_id."&reqfmt=01";
//        $request = createRequestObject($url,'GET');
//        $foundry_controller = ControllerFactory::getMessageControllerFromRequest($request);
//        $response = $foundry_controller->pullNextMessageResourceByMerchant($merchant_resource->alphanumeric_id);

        $response = makeLocalhostRequest($url,$up);
        $result = $response['result'];
        $this->assertContains('SVRREQ="1"',$result);

        $mfim_resource = $mfim_resource->getRefreshedResource();
        $this->assertEquals(0,$mfim_resource->get_menu,"It should have the flag unset");


        $raw = file_get_contents("./unit_tests_pos_integrations/resources/OSF_mirage-menu-extraction.xml");
        $url = "http://127.0.0.1:".$this->api_port."/app2/messagemanager/foundry/getnextmessagebymerchantid/".$merchant_resource->alphanumeric_id."";
        $response = makeLocalhostRequest($url,null,'PUT',$raw,'application/xml');
        $this->assertEquals('There were 89 item prices imported, and 1222 modifier prices imported.',$response['result']);
    }


    function testTriggerImport()
    {
        //$raw = file_get_contents("./unit_tests_pos_integrations/resources/OSF_ID_20.xml");
        //setProperty('write_foundry_import_file','true');
        $raw = file_get_contents("./unit_tests_pos_integrations/resources/OSF_mirage-menu-extraction.xml");

        $map_resource = $this->ids['map_resource'];
        $this->assertEquals("0",$map_resource->value);

        $url = "http://127.0.0.1:".$this->api_port."/app2/portal/import/foundry/".$this->ids['merchant_resource']->alphanumeric_id;
//        $request = createRequestObject($url,'POST');
//        $pos_controller = new PosController(getM(),null,$request);
//        $response = makeMockRequest($pos_controller);


        $response = $this->makeRequest($url,null,'POST');
        $response_array = json_decode($response,true);

        $map_resource = Resource::find(new ThirdPartyProviderParameterMerchantMapsAdapter(getM()),$map_resource->id);
        $this->assertEquals("1",$map_resource->value);

//        $map_resource = $this->ids['map_resource'];
//        $map_resource->value = 1;
//        $map_resource->save();

        // first test upload message response
        $merchant_resource = $this->ids['merchant_resource'];
        $url = "http://127.0.0.1:".$this->api_port."/app2/messagemanager/foundry/getnextmessagebymerchantid?reqtype=01&siteid=".$merchant_resource->alphanumeric_id."&reqfmt=01";
        $response = makeLocalhostRequest($url,$up);
        $result = $response['result'];
        $this->assertContains('SVRREQ="1"',$result);

        $url = "http://127.0.0.1:".$this->api_port."/app2/messagemanager/foundry/getnextmessagebymerchantid/".$merchant_resource->alphanumeric_id."";
        $request = createRequestObject($url,'PUT',$raw,'application/xml');
        $foundry_controller = new FoundryController(getM(),null,$request,5);
        $resource = $foundry_controller->pullNextMessageResourceByMerchant($merchant_resource->alphanumeric_id);

        $number_imported_item_prices = $foundry_controller->importer->number_of_item_price_records_imported;
        $this->assertTrue($number_imported_item_prices > 50,"It should have imported a good number of item prices");

        $merchant_id = $merchant_resource->merchant_id;
        $sql = "UPDATE Item_Size_Map SET price = 1.01, active = 'N' WHERE merchant_id = $merchant_id";
        $isa = new ItemSizeAdapter(getM());
        $isa->_query($sql);

        //now run import again. and there should be NO size prices imported.
        $request2 = createRequestObject($url,'PUT',$raw,'application/xml');
        $foundry_controller2 = new FoundryController(getM(),null,$request,5);
        $resource2 = $foundry_controller2->pullNextMessageResourceByMerchant($merchant_resource->alphanumeric_id);
        $new_number_imported_item_prices = $foundry_controller2->importer->number_of_item_price_records_imported;
        $this->assertEquals(0,$new_number_imported_item_prices,"it should not have imported any prices");

        //$response = makeLocalhostRequest($url,$up,'PUT',$raw,'text/xml');
        $map_resource = $map_resource->getRefreshedResource();
        $this->assertEquals("0",$map_resource->value);

        return $merchant_resource;
    }

    /**
     * @depends testTriggerImport
     */
    function testImportUrlForManualTriggerOfImport($merchant_resource)
    {
        $merchant_id = $merchant_resource->merchant_id;

        // first check that flag is NOT set

        $map_resource = $this->ids['map_resource'];
        $map_resource = Resource::find(new ThirdPartyProviderParameterMerchantMapsAdapter(getM()),$map_resource->id);
        $this->assertEquals("0",$map_resource->value);

        $import_url = "http://127.0.0.1:".$this->api_port."/app2/portal/import/foundry/".$merchant_resource->alphanumeric_id;

//        $request = createRequestObject($import_url,'POST');
//        $pos_controller = new PosController(getM(),null,$request,5);
//        $response = makeMockPortalRequest($pos_controller);

        $response = makeLocalhostRequest($import_url,null,'POST',null);

        $map_resource = Resource::find(new ThirdPartyProviderParameterMerchantMapsAdapter(getM()),$map_resource->id);
        $this->assertEquals("1",$map_resource->value);

    }

    function testGetPayloadFromDump()
    {
        //$raw = file_get_contents("./unit_tests_pos_integrations/resources/foundry_osf_3086.xml");
        $raw = file_get_contents("./unit_tests_pos_integrations/resources/OSF_ID_20.xml");

        $fi = new FoundryImporter($this->ids['merchant_resource']);
        $fi->setMenuId(102988);
        $fi->processRawExport($raw);
        $fi->importRemoteData($this->ids['merchant_resource']);
        $result = $fi->imported_prices;
        $this->assertTrue(sizeof($result) > 500);
        return $result;
    }

    /**
     * @depends testGetPayloadFromDump
     */
    function testUpdateOfPrices($result)
    {
        $merchant_id = $this->ids['merchant_id'];
        $sql = "UPDATE Item_Size_Map SET price = 1.01 WHERE merchant_id = $merchant_id";
        $isa = new ItemSizeAdapter(getM());
        $isa->_query($sql);

        $item_size_resources = CompleteMenu::getAllItemSizesAsResources($this->ids['menu_id'],$merchant_id);
        foreach ($item_size_resources as $item_size_resource) {
            $this->assertEquals(1.01,$item_size_resource->price,"All prices should be 1.01");
        }

        //$raw = file_get_contents("./unit_tests_pos_integrations/resources/foundry_osf_3086.xml");
        $raw = file_get_contents("./unit_tests_pos_integrations/resources/OSF_ID_20.xml");
        $fi = new FoundryImporter($this->ids['merchant_resource']);
        $fi->setMenuId(102988);
        $fi->processRawExport($raw);
        $fi->importRemoteData($this->ids['merchant_resource']);
        $result2 = $fi->imported_prices;
        $this->assertTrue(sizeof($result) == sizeof($result2),"It should have had the same number of imported prices");

        $item_size_resources2 = CompleteMenu::getAllItemSizesAsResources($this->ids['menu_id'],$merchant_id);
        foreach ($item_size_resources2 as $item_size_resource) {
            if ($item_size_resource->active == 'N') {
                continue;
            }
            $this->assertNotEquals(1.01,$item_size_resource->price,"All     active prices should NOT be 1.01");
        }
    }

    function makeRequest($url,$userpassword,$method = 'GET',$data = null)
    {
        unset($this->info);
        $method = strtoupper($method);
        $curl = curl_init($url);
        if ($userpassword) {
            curl_setopt($curl, CURLOPT_USERPWD, $userpassword);
        }
        $client_id = getPublicClientIdForContext();
        $headers = array("X_ORDER140_CLIENT_ID:$client_id","X_ORDER140_CLIENT_DEVICE:unit_testing","X_ORDER140_CLIENT:APIDispatchTest","NO_CC_CALL:true");
        if ($authentication_token = $data['splickit_authentication_token']) {
            $headers[] = "splickit_authentication_token:$authentication_token";
        }
        if ($data['headers']) {
            $headers = $data['headers'];
        }
        if ($method == 'POST') {
            curl_setopt($curl, CURLOPT_POST, 1);
            if ($data != null) {
                $json = json_encode($data);
                curl_setopt($curl, CURLOPT_POSTFIELDS,$json);
                $headers[] = 'Content-Type: application/json';
                $headers[] = 'Content-Length: ' . strlen($json);
            }
        } else if ($method == 'DELETE') {
            curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "DELETE");
        }
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        logCurl($url,$method,$userpassword,$headers,$json);
        $result = curl_exec($curl);
        $this->info = curl_getinfo($curl);
        curl_close($curl);
        return $result;
    }


    static function setUpBeforeClass()
    {
        $_SERVER['request_time1'] = microtime(true);
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));
        ini_set('max_execution_time',300);

        $menu_id = 102988;
        $brand_id = 480;
        $skin_id = 199;
        $menu_adapter = new MenuAdapter(getM());
        if ($menu_resource = Resource::find($menu_adapter,"$menu_id")){
//            $menu_resource->version = 2.0;
//            $menu_resource->save();
        } else {
            //create menu
            $menu_adapter->importMenu($menu_id,'prod','local',$brand_id);
//            $menu_resource = Resource::find($menu_adapter,"$menu_id");
//            $menu_resource->version = 2.0;
//            $menu_resource->save();
        }

        getOrCreateSkinAndBrandIfNecessary('osf','osf',$skin_id,$brand_id);
        setContext('com.splickit.osf');

        $code = generateAlphaCode(10);
        $sql = "UPDATE Merchant SET merchant_external_id = '$code' WHERE merchant_external_id = '3086'";
        $menu_adapter->_query($sql);

        $merchant_resource = getOrCreateNewTestMerchantBasedOnExternalId('3086');
        $tpppa = new ThirdPartyProviderParametersAdapter(getM());
        $foundry_third_party_parameters = $tpppa->getRecords(['third_party_provider_id' => 1005]);
        foreach ($foundry_third_party_parameters as $foundry_parameter) {
            $name = $foundry_parameter['name'];
            if ($name == 'modecode') {
                $value = '1';
            } else if ($name == 'modecode_holds') {
                $value = '2';
            } else if ($name == 'promo_id') {
                $value = '12345';
            } else if ($name == 'tender_id_visa') {
                $value = '215';
            } else if ($name == 'tender_id_mastercard') {
                $value = '216';
            } else if ($name == 'tender_id_american_express') {
                $value = '217';
            } else if ($name == 'tender_id_discover') {
                $value = '218';
            } else if ($name == 'brand_order_mode_delivery') {
                $value = '3';
            } else if ($name == 'brand_order_mode_pickup') {
                $value = '3';
            } else if ($name == 'get_menu') {
                $value = '0';
                $ids['map_resource'] = Resource::createByData(new ThirdPartyProviderParameterMerchantMapsAdapter(getM()), ["merchant_id" => $merchant_resource->merchant_id, "third_party_provider_parameter_id" => $foundry_parameter['id'], "value" => $value]);
                continue;
            }
            $tpppbm_resource = Resource::createByData(new ThirdPartyProviderParameterBrandMapsAdapter(getM()), ["brand_id" => $brand_id, "third_party_provider_parameter_id" => $foundry_parameter['id'], "value" => $value]);
        }
        //if (isset($merchant_resource->insert_id)) {
//            $mfima = new MerchantFoundryInfoMapsAdapter(getM());
//            $fdata['merchant_id'] = $merchant_resource->merchant_id;
//            $fdata['foundry_store_id'] = '3086';
//        $ids['map_resource'] = Resource::createByData($mfima,$fdata);
        //}

        MerchantMessageMapAdapter::createMerchantMessageMap($merchant_resource->merchant_id,'U','Foundry','X');
        $data['merchant_resource'] = $merchant_resource;
        $data['merchant_id'] = $merchant_resource->merchant_id;
        $data['menu_id'] = $menu_id;
        // we do it this way to prevent the creation of daughter records till the import
        Resource::createByData(new MerchantMenuMapAdapter(getM()),$data);

        $ids['merchant_resource'] = $merchant_resource;
        $ids['merchant_id'] = $merchant_resource->merchant_id;
        $ids['menu_id'] = $menu_id;


//      **********  THIS IS JUST TO PUSH A MENU TO STAGING
//        $raw = file_get_contents("./unit_tests_pos_integrations/resources/new_epl_menu_with_groups.xml");
//        $curl = curl_init("https://device.splickit-dev.com/app2/messagemanager/foundry/getnextmessagebymerchantid");
//        if (strtoupper('POST') == 'POST') {
//            curl_setopt($curl, CURLOPT_POSTFIELDS, $raw);
//            curl_setopt($curl, CURLOPT_POST, 1);
//            $headers[] = "Content-type: application/xml; charset=utf-8";
//            $headers[] = 'Content-Length: '.strlen($raw);
//            curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
//        }
//        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
//        $result = curl_exec($curl);
//        $info = curl_getinfo($curl);
//        curl_close($curl);
/*      ****************  END STAGING PUSH ******************/
        
//        $request = new Request();
//        $request->body = $raw;
//        $request->method = 'POST';
//        $request->mimetype = 'application/xml';
//        $request->url = '/messagemanager/foundry/getnextmessagebymerchantid';
//        $request->_parseRequestBody();
//        $message_controller = ControllerFactory::generateFromUrl($request->url, $mimetypes, $user, $request, 5);
//        $message_controller->pullNextMessageResourceByMerchant($a);
//        $ids['imported_prices'] = $message_controller->importer->imported_prices;
//        $ids['large_drink_upcharge'] = $message_controller->importer->large_drink_combo_upcharge;

        $user_resource = createNewUserWithCC();
        $ids['user_id'] = $user_resource->user_id;

        $_SERVER['log_level'] = 5;
        $_SERVER['unit_test_ids'] = $ids;
    }

    static function tearDownAfterClass()
    {
       // mysqli_query("ROLLBACK");
        date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main() {
        $suite = new PHPUnit_Framework_TestSuite( __CLASS__);
        PHPUnit_TextUI_TestRunner::run( $suite);
    }

}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    FoundryImporterTest::main();
}

?>