<?php
error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');

$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;
$_SERVER['CREDENTIALS_FILE_PATH'] = "config/credentials.conf";

require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';


class LjsImportTest extends PHPUnit_Framework_TestCase
{
    var $stamp;
    var $ids;

    function setUp()
    {
        $_SERVER['HTTP_NO_CC_CALL'] = 'true';
        $this->stamp = $_SERVER['STAMP'];
        $_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
        $this->ids = $_SERVER['unit_test_ids'];
        //setContext('com.splickit.osf');
        if (isset($_SERVER['XDEBUG_CONFIG'])) {
            $this->api_port = "10080";
        } else {
            $this->api_port = "80";
        }

    }

    function tearDown()
    {
        //delete your instance
        $_SERVER['STAMP'] = $this->stamp;
        unset($this->ids);
    }

//    function loadImportTable()
//    {
//        // $raw = file_get_contents("./unit_tests_pos_integrations/resources/master_pricing_export_DMBFiltered_11-19-2020.csv");
//
//        //$handle = fopen("./unit_tests_pos_integrations/resources/master_pricing_export_DMBFiltered_11-19-2020.csv", "r");
//        $handle = fopen("./unit_tests_pos_integrations/resources/Ljs_Prices_Dump_70125.csv", "r");
//
//
//        $lineNumber = 1;
//        $headers = [];
//        $organized_price_data = [];
//        $index_of_price = 0;
//        while (($raw_string = fgets($handle)) !== false) {
//            $row = str_getcsv($raw_string);
//
//            // into an array: ['1', 'a', 'b', 'c']
//            // And do what you need to do with every line
//            $sql_adapter = new MySQLAdapter(getM());
//            if ($lineNumber == 1) {
//                $names = '';
//                $delete_sql = "DROP TABLE IF EXISTS `Ljs_Prices_Dump`";
//                $sql_adapter->_query($delete_sql);
//
//                $sql = "CREATE TABLE IF NOT EXISTS `Ljs_Prices_Dump` ( `id` int(11) NOT NULL AUTO_INCREMENT ";
//                foreach ($row as $index=>$name) {
//                    if ($name == 'Price') {
//                        $sql .= ",`$name` decimal(10,2) NOT NULL DEFAULT '0.000' ";
//                        $index_of_price = $index;
//                    } else {
//                        $sql .= ",`$name` varchar(255) ";
//                    }
//
//                    $names .= $sql_adapter->_escapeFieldName($name).', ';
//                }
//                $sql .= ",PRIMARY KEY (`id`) )";
//                $names = substr($names, 0, -2);
//                $sql_adapter->_query($sql);
//            } else {
//                $values = '';
//                if ($row[3] != '70125') {
//                    continue;
//                }
//                foreach ($row as $index=>$value) {
//
//                    if ($index == $index_of_price) {
//                        if (!is_numeric($value)) {
//                            myerror_log("SOMETHING OTHER THAN A NUMBER SUBMITTED FOR PRICE. skipping row: ".json_encode($row));
//                            break;
//                        }
//                        $values .= "$value, ";
//                    } else {
//                        $values .= $sql_adapter->_delimitString($value).', ';
//                    }
//
//                }
//                $values = substr($values, 0, -2);
//                $sql = sprintf(
//                    'INSERT INTO %s (%s) VALUES (%s)',
//                    '`Ljs_Prices_Dump`',$names,$values
//                );
//                $sql_adapter->_query($sql);
//            }
//
//            // Increase the current line
//            $lineNumber++;
//        }
//
//        myerror_log("price data loaded");
//    }

//    function testNoFile()
//    {
//        setProperty('ljs_import_file_name','some_bad_name.csv');
//        $ljs_importer = new LjsImporter();
//        $results = $ljs_importer->importDataFromS3FileToDataBase();
//        $this->assertFalse($results);
//    }

    function testLoadTableFromActivity()
    {
        //setProperty('ljs_import_file_name','pricing_70125.csv');
        //setProperty('ljs_import_file_name','master_pricing_export_DMBFiltered.csv');
//        setProperty('ljs_import_file_name','pricing.csv');
//        setProperty('S3_AWS_ACCESS_KEY_ID','AKIAZARGOULSAOWT7BD5');
//        setProperty('S3_AWS_SECRET_ACCESS_KEY','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');
//        setProperty('bucket_prefix','net.rrtusa');

        $activity_history_adapter = new ActivityHistoryAdapter(getM());
        $original_activity_history_resource = $activity_history_adapter->createActivityReturnActivityResource('LjsPriceSync', time() - 5, 'process=LoadTable', null);
        $id = $original_activity_history_resource->activity_id;

        $activity = $activity_history_adapter->getNextActivityToDo(null);
        $this->assertEquals($id, $activity->getActivityHistoryId());
        $activity->executeThisActivity();
        return true;
    }

    /**
     * @depends testLoadTableFromActivity
     */
    function testImportPricesFromLoadedTable($boo)
    {
        $merchant_id = $this->ids['merchant_id'];
        $item_size_resources = CompleteMenu::getAllItemSizesAsResources($this->ids['pickup_menu_id'],$merchant_id);
        foreach ($item_size_resources as $item_size_resource) {
            $this->assertEquals(1.01,$item_size_resource->price,"All prices should be 1.01");
        }
        $activity_history_adapter = new ActivityHistoryAdapter(getM());
        $activity = $activity_history_adapter->getNextActivityToDo(null);
        $activity->executeThisActivity();

        $item_size_resources = CompleteMenu::getAllItemSizesAsResources($this->ids['pickup_menu_id'],$merchant_id);
        foreach ($item_size_resources as $item_size_resource) {
            if ($item_size_resource->active == 'Y') {
                $this->assertNotEquals(1.01,$item_size_resource->price,"All active prices should NOT be 1.01");
            } else {
                $this->assertEquals(1.01,$item_size_resource->price,"All innactive prices should be 1.01");
            }

        }

        $imgma = new ItemModifierGroupMapAdapter(getM());
        $imgm_records = $imgma->getRecords(['merchant_id'=>$merchant_id]);
        $this->assertEquals(217,sizeof($imgm_records));
    }

    function makeRequest($url,$userpassword,$method = 'GET',$data = null)
    {
        unset($this->info);
        $method = strtoupper($method);
        $curl = curl_init($url);
        if ($userpassword) {
            curl_setopt($curl, CURLOPT_USERPWD, $userpassword);
        }
        $client_id = getPublicClientIdForContext();
        $headers = array("X_ORDER140_CLIENT_ID:$client_id","X_ORDER140_CLIENT_DEVICE:unit_testing","X_ORDER140_CLIENT:APIDispatchTest","NO_CC_CALL:true");
        if ($authentication_token = $data['splickit_authentication_token']) {
            $headers[] = "splickit_authentication_token:$authentication_token";
        }
        if ($data['headers']) {
            $headers = $data['headers'];
        }
        if ($method == 'POST') {
            curl_setopt($curl, CURLOPT_POST, 1);
            if ($data != null) {
                $json = json_encode($data);
                curl_setopt($curl, CURLOPT_POSTFIELDS,$json);
                $headers[] = 'Content-Type: application/json';
                $headers[] = 'Content-Length: ' . strlen($json);
            }
        } else if ($method == 'DELETE') {
            curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "DELETE");
        }
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        logCurl($url,$method,$userpassword,$headers,$json);
        $result = curl_exec($curl);
        $this->info = curl_getinfo($curl);
        curl_close($curl);
        return $result;
    }


    static function setUpBeforeClass()
    {
        $_SERVER['request_time1'] = microtime(true);
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));
        ini_set('max_execution_time',300);
        // 103047 - delivery
        // 103415 - pickup
        //setProperty('ljs_import_file_name','Ljs_Prices_Dump_70125.csv');

        $pickup_menu_id = 103415;
        $ids['pickup_menu_id'] = $pickup_menu_id;
        $brand_id = 517;

//        $merchant_adapter = new MerchantAdapter(getM());
//        $code = generateAlphaCode(10);
//        $sql = "UPDATE Merchant SET merchant_external_id = '$code' WHERE merchant_external_id = '70125'";
//        $menu_adapter->_query($sql);

        $ljs_skin = getOrCreateSkinAndBrandIfNecessary('ljs','ljs',237,517);
        $ljssomi_skin = getOrCreateSkinAndBrandIfNecessary('ljssomi','ljs',344,517);
        setContext($ljs_skin->external_identifier);
        $merchant_resource = getOrCreateNewTestMerchantBasedOnExternalId('99995');
        $merchant_id = $merchant_resource->merchant_id;
        $ids['merchant_id'] = $merchant_id;


        $menu_adapter = new MenuAdapter(getM());
        if ($menu_resource = Resource::find($menu_adapter,"$pickup_menu_id")){
            ; // all good
        } else {
            //create menu
            $menu_adapter->importMenu($pickup_menu_id,'rrtprod','local',$brand_id);
            MerchantMenuMapAdapter::createMerchantMenuMap($merchant_resource->merchant_id, $pickup_menu_id, 'pickup');
            createDaughterRecordsForMerchantMenuCombination($merchant_id,$pickup_menu_id,1.01);

        }

        $delivery_menu_id = 103047;
        $ids['delivery_menu_id'] = $delivery_menu_id;
        $menu_adapter = new MenuAdapter(getM());
        if ($menu_resource = Resource::find($menu_adapter,"$delivery_menu_id")){
            ; // all good
        } else {
            //create menu
            $menu_adapter->importMenu($delivery_menu_id,'rrtprod','local',$brand_id);
            MerchantMenuMapAdapter::createMerchantMenuMap($merchant_resource->merchant_id, $delivery_menu_id, 'delivery');
            createDaughterRecordsForMerchantMenuCombination($merchant_id,$delivery_menu_id,2.02);
            MerchantMenuMapAdapter::createMerchantMenuMap($merchant_resource->merchant_id, $delivery_menu_id, 'pickup',$ljssomi_skin->skin_id);

        }


        $sql = "UPDATE Item_Size_Map set price = 1.01 WHERE merchant_id = $merchant_id";
        $isma = new ItemSizeAdapter(getM());
        $isma->_query($sql);

        $sql = "UPDATE Modifier_Size_Map SET modifier_price = 2.02 where merchant_id = $merchant_id";
        $isma->_query($sql);

        // delete existing activities
        $sql = "DELETE FROM Activity_History WHERE 1=1";
        $isma->_query($sql);

        $_SERVER['log_level'] = 5;
        $_SERVER['unit_test_ids'] = $ids;

        $sql = 'DROP TABLE IF EXISTS `Ljs_Prices_Dump`';
        $mysql = new MySQLAdapter();
        $mysql->_query($sql);

        $sql = "CREATE TABLE `Ljs_Prices_Dump` (
                `id` int(11) NOT NULL AUTO_INCREMENT,
                `BOHLinkID` varchar(255) DEFAULT NULL,
                `MXID` varchar(255) DEFAULT NULL,
                `SystemID` varchar(255) DEFAULT NULL,
                `SiteCode` varchar(255) DEFAULT NULL,
                `POSProductName` varchar(255) DEFAULT NULL,
                `MS2Description` varchar(255) DEFAULT NULL,
                `BetterDescription` varchar(255) DEFAULT NULL,
                `ProductType` varchar(255) DEFAULT NULL,
                `ProductGroup` varchar(255) DEFAULT NULL,
                `Price` decimal(10,2) NOT NULL DEFAULT '0.00',
                PRIMARY KEY (`id`),
                KEY `index_SystemID` (`SystemID`),
                KEY `index_SiteCode` (`SiteCode`)
                ) ENGINE=InnoDB AUTO_INCREMENT=1000 DEFAULT CHARSET=latin1;";
        $mysql->_query($sql);
    }

    static function tearDownAfterClass()
    {
       // mysqli_query("ROLLBACK");
        date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main() {
        $suite = new PHPUnit_Framework_TestSuite( __CLASS__);
        PHPUnit_TextUI_TestRunner::run( $suite);
    }

}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    LjsImportTest::main();
}

?>