<?php
error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');

$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;


//$_SERVER['ENVIRONMENT'] = isset($_SERVER['XDEBUG_CONFIG']) ? "unit_test_ide" : "unit_test";
//$_SERVER['DB_INFO_FILE_PATH'] = "config/smaw_database_unittest.conf";

require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';


class MooseBrinkIntegrationTest extends PHPUnit_Framework_TestCase
{
    var $stamp;
    var $ids;
    var $api_port = "80";

    function setUp()
    {
        $_SERVER['HTTP_NO_CC_CALL'] = 'true';
        $_SERVER['DO_NOT_RUN_CC'] = 'true';
        $this->stamp = $_SERVER['STAMP'];
        $_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
        $this->ids = $_SERVER['unit_test_ids'];
        if (isset($_SERVER['XDEBUG_CONFIG'])) {
            $this->api_port = "10080";
        }
        $_SERVER['no_new_merchant_payment'] = true;
    }

    function tearDown()
    {
        //delete your instance
        $_SERVER['STAMP'] = $this->stamp;
        unset($this->ids);
    }

//    function testGetDestinations()
//    {
//        $brink_importer = new BrinkImporter();
//        $method = "GetDestinations";
//        $response0 = $brink_importer->curlIt($method,$merchant_resource);
//        myerror_log($response0);
//    }

    function testStageEntireBrand()
    {
        $doit_ts = time()-2;
        $info = 'object=BrinkmooseImporter;method=staticStageImportForEntireBrandList;thefunctiondatastring=pos/import/brinkmoose/all';
        $activity_history_adapter = new ActivityHistoryAdapter(getM());
        $activity_history_resource = $activity_history_adapter->createActivityReturnActivityResource('ExecuteObjectFunction', $doit_ts, $info, '',60*60*24);
        $this->assertNotNull($activity_history_resource);

        removeContext();

        $activity_history_resource->locked = 'Y';
        $activity_history_resource->save();
        $activity = SplickitActivity::getActivity($activity_history_resource);
        $result = $activity->doit();

    }

    function testImporter()
    {
        $external_id = generateAlphaCode(10);
        $merchant_resource = createNewTestMerchant($this->ids['menu_id']);
        $merchant_resource->merchant_external_id = $external_id;
        $merchant_resource->save();
        $merchant_id = $merchant_resource->merchant_id;
        //Resource::createByData(new MerchantBrinkInfoMapsAdapter(getM()),array("merchant_id"=>$merchant_resource->merchant_id,"brink_location_token"=>"pdq/GA4ick6MAqkDZaWnoQ=="));
        //CSML+PqaYEq4Nrv2UkAs5w==
        Resource::createByData(new MerchantBrinkInfoMapsAdapter(getM()),array("merchant_id"=>$merchant_resource->merchant_id,"brink_location_token"=>"CSML+PqaYEq4Nrv2UkAs5w=="));
        $map_resource = Resource::createByData(new MerchantMessageMapAdapter(getM()),array("merchant_id"=>$merchant_resource->merchant_id,"message_format"=>'B',"delivery_addr"=>"Brink","message_type"=>"X"));

//        //$url = "http://127.0.0.1:".$this->api_port."/app2/pos/import/brinkmoose/$external_id";
//        $url = "http://127.0.0.1:".$this->api_port."/app2/pos/import/brinkmoose/all";
//        //$response = makeUnitTestRequest($url,'admin:welcome','POST');
//        $response = makeUnitTestRequest($url,null,'POST');
//        $response_array = json_decode($response,true);
//        $this->assertContains('The import has been completed.',$response_array['data']['message']);

        $brink_importer = ImporterFactory::getImporterFromUrl("http://localhost/app2/apiv2/pos/import/brinkmoose/$external_id");
        $brink_importer->create_zero_records = false;
        $this->assertTrue($brink_importer->importRemoteMerchantMetaDataForLoadedMerchant());

        //$menu = CompleteMenu::getCompleteMenu($this->ids['menu_id'],'Y',$this->ids['merchant_id'],2,'pickup');
        $complete_menu = new CompleteMenu($this->ids['menu_id']);
        $item_sizes = $complete_menu->getAllMenuItemSizePrices($this->ids['menu_id'],'Y',$merchant_id,getM());
        $count = sizeof($item_sizes);
        $this->assertTrue($count>10,"It should have imported a bunch of prices for the merchant but it only imported: $count");

        $modifier_size_list = $complete_menu->getAllModifierItemPricesForMenu($this->ids['menu_id'],'Y',getM(),$merchant_id);
        $no = 0;
        $yes = 0;
        foreach($modifier_size_list as $modifier_sizes) {
            foreach ($modifier_sizes as $modifier_size) {
                if ($modifier_size['active'] == 'N') {
                    myerror_log("we ahve a NO");
                    $no++;
                } else {
                    myerror_log("we have a YES: ".$modifier_size['active']);
                    $yes++;
                }
            }
        }
        myerror_log("NO: $no,   YES: $yes");
    }

    function testLoadPricesForMerchant()
    {
        $ids = $this->ids;
        $menu_id = $ids['menu_id'];
        $external_id = $this->ids['merchant_resource']->merchant_external_id;

        $brink_importer = ImporterFactory::getImporterFromUrl("http://localhost/app2/apiv2/pos/import/brinkmoose/$external_id");
        $brink_importer->create_zero_records = false;
        $this->assertTrue($brink_importer->importRemoteMerchantMetaDataForLoadedMerchant());

        //$menu = CompleteMenu::getCompleteMenu($this->ids['menu_id'],'Y',$this->ids['merchant_id'],2,'pickup');
        $complete_menu = new CompleteMenu($menu_id);
        $item_sizes = $complete_menu->getAllMenuItemSizePrices($menu_id,'Y',$ids['merchant_id'],$m);
        $count = sizeof($item_sizes);
        $this->assertTrue($count>10,"It shoudl have imported a bunch of prices for the merchant but it only imported: $count");

//        CompleteMenu::getAllMenuItemsAsArray($menu_id, 'Y', E$);
    }

    function testNewBreadBowlThing()
    {
        $order_adapter = new OrderAdapter(getM());
        $sql = "UPDATE Item_Size_Map SET active = 'Y'";
        $order_adapter->_query($sql);
        $sql = "UPDATE Modifier_Size_Map SET active = 'Y'";
        $order_adapter->_query($sql);

        $order_adapter = new OrderAdapter(getM());

        $size_id = 94653;
        $item_id = 302872;

        $merchant_id = $this->ids['merchant_id'];
        $user_resource = createNewUserWithCCNoCVV();
        $user = logTestUserResourceIn($user_resource);

        $order_data = $order_adapter->getCartArrayWithOneModierPerModifierGroup($merchant_id,'pickup',1);

        $order_data['items'][0]['item_id'] = $item_id;
        $order_data['items'][0]['size_id'] = $size_id;
        $mod_ids = [2356870,2355996];
        $mods = [];
        foreach ($mod_ids as $mod_id) {
            $mods[] = array('modifier_item_id'=>$mod_id,'mod_quantity'=>1);
        }
        $order_data['items'][0]['mods'] = $mods;
        $order_data['items'][0]['item_total_price'] = 5.75;
        $order_data['total_price'] = 5.75;

        $checkout_resource = getCheckoutResourceFromOrderData($order_data,time());
        $this->assertNull($checkout_resource->error);
        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,0.00,time());
        $this->assertNull($order_resource->error);
        $order_id = $order_resource->order_id;

        $brink_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id,'B');
        $brink_message_controller = ControllerFactory::generateFromMessageResource($brink_message_resource);
        $ready_to_send_message_resource = $brink_message_controller->prepMessageForSending($brink_message_resource);
        $body2 = $ready_to_send_message_resource->message_text;




    }

    function testNewTemplateWithExceptions()
    {

        $order_adapter = new OrderAdapter(getM());

        $size_id = 94651;
        $item_id = 302866;

        $merchant_id = $this->ids['merchant_id'];
        $user_resource = createNewUserWithCCNoCVV();
        $user_resource->balance = 100;
        $user_resource->save();

        $user = logTestUserResourceIn($user_resource);

        $order_data = $order_adapter->getCartArrayWithOneModierPerModifierGroup($merchant_id,'pickup',1);

        $order_data['items'][0]['item_id'] = $item_id;
        $order_data['items'][0]['size_id'] = $size_id;
        $mod_ids = [2351672,2351673,2351674,2351677,2351678,2351867];
        foreach ($mod_ids as $mod_id) {
            $mods[] = array('modifier_item_id'=>$mod_id,'mod_quantity'=>1);
        }
        unset($order_data['note']);
        $order_data['note'] = 'this & that';
        $order_data['items'][0]['mods'] = $mods;
        $order_data['items'][0]['note'] = 'this & that';
        $request = createRequestObject('app2/apiv2/cart','post',json_encode($order_data),'application/json');
        $place_order_controller = new PlaceOrderController(getM(),$user,$request,5);
        $create_cart_response = $place_order_controller->processV2Request();
        $this->assertNull($create_cart_response->error);
        $ucid = $create_cart_response->ucid;

        $brink_controller = new BrinkController(getM(),$u,$r,5);
        $order_id = $create_cart_response->oid_test_only;
        $calculate_order_message_resource = $brink_controller->prepMessageForSending(Resource::dummyfactory(array("order_id"=>$order_id,"message_format"=>'BC')));
        $body = $calculate_order_message_resource->message_text;
        myerror_log($body);
        $clean_body = cleanUpDoubleSpacesCRLFTFromString($body);
        $expected_hold_it_block = cleanUpDoubleSpacesCRLFTFromString('<NewOrderItemModifier>
                                                    <Description i:nil="true" />
                                                    <Id>3</Id>
                                                    <ItemId>640202224</ItemId>
                                                    <Modifiers i:nil="true" />
                                                    <Price>0.000</Price>
                                                    <ModifierCodeId>2</ModifierCodeId>
                                                    <ModifierGroupId>640202349</ModifierGroupId>
                                                </NewOrderItemModifier>');
        $this->assertContains($expected_hold_it_block,$clean_body,"It should have the expected hold it block");

        // now check place order xml
        $brink_controller = new BrinkController(getM(),$u,$r,5);
        $calculate_order_message_resource2 = $brink_controller->prepMessageForSending(Resource::dummyfactory(array("order_id"=>$order_id,"message_format"=>'B')));
        $body2 = $calculate_order_message_resource2->message_text;
        myerror_log($body2);
        $clean_body2 = cleanUpDoubleSpacesCRLFTFromString($body2);
        $this->assertNotContains('this & that',$clean_body2,'it should have excaped the ampersand');
        $expected_hold_it_block = cleanUpDoubleSpacesCRLFTFromString('<NewOrderItemModifier>
                                                    <Description i:nil="true" />
                                                    <Id>4</Id>
                                                    <ItemId>640202224</ItemId>
                                                    <Modifiers i:nil="true" />
                                                    <Price>0.000</Price>
                                                    <ModifierCodeId>2</ModifierCodeId>
                                                    <ModifierGroupId>640202349</ModifierGroupId>
                                                </NewOrderItemModifier>');
        $this->assertContains($expected_hold_it_block,$clean_body2,"It should have the expected hold it block");



//
//        $request = createRequestObject("app2/apiv2/cart/$ucid/checkout","GET");
//        $place_order_controller = new PlaceOrderController(getM(),$user,$request,5);
//        $place_order_controller->setCurrentTime(getTomorrowTwelveNoonTimeStampDenver());
//        $checkout_resource = $place_order_controller->processV2Request();
//        $this->assertNull($checkout_resource->error,"It should not throw an error");
//
//        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,getM(),0.00,time());
//        $this->assertNull($order_resource->error);
//        $order_id = $order_resource->order_id;
//
//        $brink_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id,'B');
//        $brink_message_controller = ControllerFactory::generateFromMessageResource($brink_message_resource);
//        $ready_to_send_message_resource = $brink_message_controller->prepMessageForSending($brink_message_resource);
//        $body2 = $ready_to_send_message_resource->message_text;
//        myerror_log($body2);
//        $this->assertContains($expected_hold_it_block,$body2,'Brink place order should have the hold it block');
    }


    function testPlaceOrderCoffee()
    {
//        $size_id = 94664;
//        $item_id = 302906;

        $size_id = 94665;
        $item_id = 302906;


        $merchant_id = $this->ids['merchant_id'];
        $user_resource = createNewUserWithCCNoCVV();
        $user = logTestUserResourceIn($user_resource);
        $order_adapter = new OrderAdapter($m);
        $order_data = $order_adapter->getCartArrayWithOneModierPerModifierGroup($merchant_id,'pickup',1);
        //$order_data['items'][0] = array('mods'=>array(),'quantity'=>1,'item_id'=>$item_id,'size_id'=>$size_id,'item_total_price'=>2.0);
        $order_data['items'][0] = array('mods'=>array(array('modifier_item_id'=>2352071,'mod_quantity'=>1)),'quantity'=>1,'item_id'=>$item_id,'size_id'=>$size_id,'item_total_price'=>2.0);
        $request = createRequestObject('app2/apiv2/cart','post',json_encode($order_data),'application/json');
        $place_order_controller = new PlaceOrderController($m,$user,$request,5);
        $create_cart_response = $place_order_controller->processV2Request();
        $ucid = $create_cart_response->ucid;

        $request = createRequestObject("app2/apiv2/cart/$ucid/checkout","GET");
        $place_order_controller = new PlaceOrderController($m,$user,$request,5);
        $place_order_controller->setCurrentTime(getTomorrowTwelveNoonTimeStampDenver());
        $checkout_resource = $place_order_controller->processV2Request();
        $this->assertNull($checkout_resource->error,"It should not throw an error");



    }

    function testItShouldGetTheTaxFromBrinkOnGetCheckoutData()
    {
        $merchant_id = $this->ids['merchant_id'];
        //set tax to 0.00 for merchant
        $tax_resource = Resource::find(new TaxAdapter(getM()),null,[TONIC_FIND_BY_METADATA=>['merchant_id'=>$merchant_id]]);
        $tax_resource->rate = 0.00;
        $tax_resource->save();

        $user_resource = createNewUserWithCCNoCVV(array("email"=>"bobnewhart@order140.com","first_name"=>"bob","last_name"=>"newhart","contact_no"=>'8888888888'));
        $user = logTestUserResourceIn($user_resource);
        $order_adapter = new OrderAdapter($m);
        $menu = CompleteMenu::getCompleteMenu($this->ids['menu_id'],'Y',$merchant_id,2,'pickup');
        $order_data = $order_adapter->getOrderArrayFromFullMenuWithOneModiferPerModifierGroup($menu,$merchant_id,"some note",1,0,1);
        $request = createRequestObject('app2/apiv2/cart','post',json_encode($order_data),'application/json');
        $place_order_controller = new PlaceOrderController($m,$user,$request,5);
        $create_cart_response = $place_order_controller->processV2Request();
        $ucid = $create_cart_response->ucid;

        $request = createRequestObject("app2/apiv2/cart/$ucid/checkout","GET");
        $place_order_controller = new PlaceOrderController($m,$user,$request,5);
        $place_order_controller->setCurrentTime(getTomorrowTwelveNoonTimeStampDenver());
        $checkout_resource = $place_order_controller->processV2Request();
        $this->assertNull($checkout_resource->error,"It should not throw an error");
        $checkout_receipt_items = createHashmapFromArrayOfArraysByFieldName($checkout_resource->order_summary['receipt_items'],'title');
        $checkout_tax = $checkout_receipt_items['Tax'];
        $this->assertTrue($checkout_resource->total_tax_amt > 0.00,"Tax should have been set by the brink pull");
        $tax_amount = $checkout_resource->total_tax_amt;
        $this->assertEquals('$'.$tax_amount,$checkout_tax['amount']);
        $total = $checkout_receipt_items['Total']['amount'];
        //$this->assertEquals("$8.13",$total,"total should have been set to the brink values");
//        $complete_order = CompleteOrder::staticGetCompleteOrder($order_id,$m);
        $order_amt = floatval($checkout_resource->order_amt);
        $total_tax_amt = floatval($checkout_resource->total_tax_amt);
        $this->assertTrue($total_tax_amt > 0.00,"It should have sent back a valid total tax amount but sent back: ".$checkout_resource->total_tax_amt);
        $tax_rate = intval(100*$total_tax_amt/$order_amt);
        $this->assertNotEquals(20,$tax_rate,"tax rate should be calculated by brink, not the 20% that is in our system");

        //make sure totals are correct.
        $complete_order = CompleteOrder::staticGetCompleteOrder($checkout_resource->oid_test_only,$m);
        $grand_total_from_math = $complete_order['order_amt']+$complete_order['total_tax_amt']+$complete_order['delivery_amt']+$complete_order['tip_amt']+$complete_order['promo_amt'];
        $this->assertEquals($grand_total_from_math,$complete_order['grand_total'],"the set grand total should equal the sum of the parts");
    }

    static function setUpBeforeClass()
    {
        $_SERVER['no_new_merchant_payment'] = true;
        $_SERVER['request_time1'] = microtime(true);
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));
        ini_set('max_execution_time',300);

        $menu_id = 102745;
        $brand_id = 152;
        $skin_id = 6;
        $menu_adapter = new MenuAdapter($mimetypes);
        if ($menu_resource = Resource::find($menu_adapter,"$menu_id")){
//            $menu_resource->version = 2.0;
//            $menu_resource->save();
        } else {
            //create menu
            $menu_adapter->importMenu($menu_id,'prod','local',$brand_id);
//            $menu_resource = Resource::find($menu_adapter,"$menu_id");
//            $menu_resource->version = 2.0;
//            $menu_resource->save();
        }

        $skin_resource = getOrCreateSkinAndBrandIfNecessary("smilingmoose","smilingmoose",$skin_id,$brand_id);
        setContext('com.splickit.smilingmoose');
        $merchant_resource = getOrCreateNewTestMerchantBasedOnExternalId('Lab-Test');
        $map_resource = Resource::createByData(new MerchantMessageMapAdapter($mimetypes),array("merchant_id"=>$merchant_resource->merchant_id,"message_format"=>'B',"delivery_addr"=>"Brink","message_type"=>"X"));

//        $db = DataBase::getInstance();
//        $mysqli = $db->getConnection();
//        $mysqli->begin_transaction();

        Resource::createByData(new MerchantMenuMapAdapter($m),array("merchant_id"=>$merchant_resource->merchant_id,"menu_id"=>$menu_id));
        $ids['merchant_resource'] = $merchant_resource;
        $ids['merchant_id'] = $merchant_resource->merchant_id;
        Resource::createByData(new MerchantBrinkInfoMapsAdapter($m),array("merchant_id"=>$merchant_resource->merchant_id,"brink_location_token"=>"NOLhhYXbv0+VcMIEyW1PMA=="));

        $ids['menu_id'] = $menu_id;

        $map_resource = Resource::createByData(new MerchantMessageMapAdapter($mimetypes),array("merchant_id"=>$merchant_resource->merchant_id,"message_format"=>'B',"delivery_addr"=>"Brink","message_type"=>"X"));

        $user_resource = createNewUser(array("flags"=>"1C20000001"));
        $ids['user_resource'] = $user_resource;
        $ids['user_id'] = $user_resource->user_id;

        $_SERVER['log_level'] = 5;
        $_SERVER['unit_test_ids'] = $ids;
    }


    static function tearDownAfterClass()
    {
//        $db = DataBase::getInstance();
//        $mysqli = $db->getConnection();
//        $mysqli->rollback();

        date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main() {
        $suite = new PHPUnit_Framework_TestSuite( __CLASS__);
        PHPUnit_TextUI_TestRunner::run( $suite);
    }

}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    MooseBrinkIntegrationTest::main();
}

?>
