<?php

error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');
$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;
require_once 'lib/curl_objects/splickitcurl.php';
require_once 'lib/mocks/viopaymentcurl.php';
require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';

class NuOrderMenuImportTest extends PHPUnit_Framework_TestCase
{
    var $stamp;
    var $ids;

    function setUp()
    {
        $_SERVER['HTTP_NO_CC_CALL'] = 'true';
        $_SERVER['DO_NOT_RUN_CC'] = 'true';
        $this->stamp = $_SERVER['STAMP'];
        $_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
        $this->ids = $_SERVER['unit_test_ids'];
        setContext('com.splickit.worldhq');
        if (isset($_SERVER['XDEBUG_CONFIG'])) {
            $this->api_port = "10080";
        }
    }

    function tearDown()
    {
        //delete your instance
        $_SERVER['STAMP'] = $this->stamp;
        unset($this->ids);
    }

//    function testGetCompleteMenu()
//    {
//        $complete_menu = CompleteMenu::getCompleteMenu(102556,'Y',0,2);
//        myerror_log("ereh 9 a");
//    }


    function testImportMenuFromActivity()
    {
        $_SERVER['DO_NOT_CHECK_CACHE'] = 'true';
        $doit_ts = time()-10;
        //$info = 'filename=lib/activities/resources/mckenzie_river_pizza.json;type=1';

        //$info = 'filename=lib/activities/resources/La_Parrilla_2907.json;nuorder_menu_type=2'; //'NuOrder: 2479'
        //$info = 'filename=lib/activities/resources/mrp_sizes_3.json;nuorder_menu_type=1'; //'NuOrder: 2680'
        //$info = 'filename=lib/activities/resources/chop_stop.json;nuorder_menu_type=3';
        //$info = 'filename=lib/activities/resources/salem.json;nuorder_menu_type=2';
        //$info = 'filename=lib/activities/resources/illegal_petes.json;nuorder_menu_type=2';
        $info = 'filename=lib/activities/resources/punch_pizza.json;nuorder_menu_type=2';
        //$info = 'filename=lib/activities/resources/new_osf.json;nuorder_menu_type=3'; //'NuOrder: 2541'
        //$info = 'filename=lib/activities/resources/old_spaghettifactory.json;nuorder_menu_type=2'; //'NuOrder: 2541'
        //$info = 'filename=lib/activities/resources/intelity_3182.json;nuorder_menu_type=2';
        $activity_history_adapter = new ActivityHistoryAdapter(getM());
        $activity_resource = $activity_history_adapter->createActivityReturnActivityResource('Nuorder', $doit_ts, $info, null);

        $activity_history_adapter = new ActivityHistoryAdapter(getM());
        $activity_history_adapter->doAllActivitiesReadyToBeExecuted();

//        $url = "http://127.0.0.1:" . $this->api_port . "/app2/admin/doactivities";
//        $curl = curl_init($url);
//        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
//        logCurl($url,'GET',NULL,null,null);
//        $response = curl_exec($curl);
//        $this->info = curl_getinfo($curl);
//        curl_close($curl);
    }

    function testImportMenuFromJson()
    {
        //$options[TONIC_FIND_BY_METADATA]['external_menu_id'] = 'NuOrder: 2102';
        //$options[TONIC_FIND_BY_METADATA]['external_menu_id'] = 'NuOrder: 2541';
        $options[TONIC_FIND_BY_METADATA]['external_menu_id'] = 'NuOrder: 2479';


        if ($menu_resource = Resource::find(new MenuAdapter(getM()),null,$options)) {
            $menu_id =  $menu_resource->menu_id;
        } else {
            $nuorder_importer = new NuorderImporter([]);
            //$filename = "unit_tests_pos_integrations/resources/chopstop.json";
            $filename = "unit_tests_pos_integrations/resources/oldspaghetti.json";
            $menu_id = $nuorder_importer->importMenuData($filename);

        }
        $complete_menu = CompleteMenu::getCompleteMenu($menu_id,'Y',0,2);

        myerror_log('adf');
        return $menu_id;
    }

    /**
     * @depends testImportMenuFromJson
     */
    function testCheckModifiers($menu_id)
    {
        $merchant_resource = createNewTestMerchant($menu_id);
        $merchant_id = $merchant_resource->merchant_id;

        $request = new Request();
        $request->url = "/apiv2/merchants/$merchant_id";
        $request->method = 'GET';
        $merchant_controller = new MerchantController(getM(), null, $request, 5);
        $resource = $merchant_controller->processV2Request();

        $menu = $resource->menu;
        myerror_log("sg");

    }


    /**
     * @depends testImportMenuFromJson
     */
    function testPlaceOrder($menu_id)
    {
        $data['message_data'] = ["message_format"=>"U",'delivery_addr'=>"Foundry"];
        $merchant_resource = createNewTestMerchant($menu_id,$data);
        $merchant_id = $merchant_resource->merchant_id;

        $user_resource = createNewUserWithCCNoCVV();
        $user = logTestUserResourceIn($user_resource);

        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($merchant_id,'pickup','note',4);
        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,getTomorrowTwelveNoonTimeStampDenver());
        $this->assertNull($checkout_resource->error);
        $order_resource = placeOrderFromCheckoutResource($checkout_resource);
        $this->assertNull($order_resource->error);
        return $order_resource->order_id;
    }

    /**
     * @depends testPlaceOrder
     */
    function testCreateMessage($order_id)
    {
        $message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id,'U');
        $foundry_controller = ControllerFactory::generateFromMessageResource($message_resource,$m,$u,$r,5);
        $message_to_send_resource = $foundry_controller->prepMessageForSending($message_resource);

    }


    /**
     * @depends testImportMenuFromJson
     */
    function testPlaceOrderWithComesWith($menu_id)
    {
        $merchant_resource = createNewTestMerchant($menu_id);
        $merchant_id = $merchant_resource->merchant_id;

        $item_modifier_item_adapter = new ItemModifierItemMapAdapter(getM());
        $sql = "select distinct(a.item_id) From Item_Modifier_Item_Map a JOIN Item b ON a.item_id = b.item_id JOIN Menu_Type c ON b.menu_type_id = c.menu_type_id WHERE c.menu_id = $menu_id order by item_id";
        $options[TONIC_FIND_BY_SQL] = $sql;
        $resources = Resource::findAll($item_modifier_item_adapter,null, $options);
        $items_with_comes_with = [];
        foreach ($resources as $resource) {
            $items_with_comes_with[''.$resource->item_id] = true;
        }


        $complete_menu = CompleteMenu::getCompleteMenu($menu_id,'Y',$merchant_id,2);

        $user_resource = createNewUserWithCCNoCVV();
        $user = logTestUserResourceIn($user_resource);

        $cart_data = ['merchant_id'=>$merchant_id,'user_id'=>$user['user_id']];
        $cart_data['items'] = [];

        $i = 0;

        foreach ($complete_menu['menu_types'] as $menu_type) {
            $j = 0;
            $menu_type_name = $menu_type['menu_type_name'];
            foreach ($menu_type['menu_items'] as $menu_item) {
                $item_id = $menu_item['item_id'];
            //if ($menu_item = $menu_type['menu_items'][$rand]) {
//                if (! $items_with_comes_with["$item_id"]) {
//                    continue;
//                }
                if ($j > 0) {
                    continue;
                }
                $j++;
                $cart_item = [];
                $cart_item['quantity'] = 1;
                $cart_item['item_id'] = $menu_item['item_id'];
                $cart_item['size_id'] = $menu_item['size_prices'][0]['size_id'];
                $cart_item['mods'] = [];
                if ($modifier_groups = $menu_item['modifier_groups']) {
                    foreach ($modifier_groups as $modifier_group) {
                        foreach ($modifier_group['modifier_items'] as $modifier_item) {
                            if ($modifier_item['modifier_item_pre_selected'] == 'yes') {
                                $mod = ['mod_quantity'=>1,'modifier_item_id'=>$modifier_item['modifier_item_id']];
                                $cart_item['mods'][] = $mod;
                            }
                        }
                    }
                }
                $cart_data['items'][] = $cart_item;
            }
            $i++;
        }

        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,getTomorrowTwelveNoonTimeStampDenver());
        $this->assertNull($checkout_resource->error);
        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,0.00);
        $this->assertNull($order_resource->error);

    }


    static function setUpBeforeClass()
    {
        $ids = [];
        $_SERVER['request_time1'] = microtime(true);
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));
        ini_set('max_execution_time', 300);


        $_SERVER['unit_test_ids'] = $ids;
    }


        static function tearDownAfterClass()
    {
        date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main() {
        $suite = new PHPUnit_Framework_TestSuite( __CLASS__);
        PHPUnit_TextUI_TestRunner::run( $suite);
    }

}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    NuOrderMenuImportTest::main();
}

?>