<?php

error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');
//$db_info = new DatabaseInfo();
$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;

require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';

class SessionMBatchUploadTest extends PHPUnit_Framework_TestCase
{
    var $stamp;
    var $mmha;
    var $ids;

    function setUp()
    {
        $_SERVER['STAMP'] = __CLASS__.'-'.setNewStamp();
        $this->ids = $_SERVER['unit_test_ids'];
        $_SERVER['HTTP_NO_CC_CALL'] = 'true';
        $_SERVER['DO_NOT_RUN_CC'] = 'true';
        setContext($this->ids['context']);
    }

    function tearDown()
    {
        //delete your instance
        $_SERVER['FORCE_RRTPROD'] = 'false';
        unset($this->ids);
    }

    function testCreateAndSendBatchTransactionFileFromActivity()
    {
//        $_SERVER['FORCE_RRTPROD'] = 'true';
//        $db = DataBase::getNewInstance();
//        $info = ['ids_for_third_party_parameters'=>['brand_id'=>517]];
//        $sessionm_service = new SessionMService($info);
//        $sessionm_service->createAndSendBatchTransactionFile('2021-03-01,2021-04-01');
//
//        $_SERVER['FORCE_RRTPROD'] = 'false';
//        $db = DataBase::getNewInstance();


        $activity_history_adapter = new ActivityHistoryAdapter(getM());
        $info = 'process=Transactions;constructor_value=brand_id:517;thefunctiondatastring=2021-03-01,2021-04-01';
        $activity_history_resource = $activity_history_adapter->createActivityReturnActivityResource('SessionM', time() - 5, $info, null,0);
        $activity = $activity_history_adapter->getActivityFromUnlockedActivityHistoryResource($activity_history_resource);
        $activity->executeThisActivity();



    }

    function testCreateAndSendBatchMenuFileFromActivity()
    {
        $activity_history_adapter = new ActivityHistoryAdapter(getM());
        $original_activity_history_resource = $activity_history_adapter->createActivityReturnActivityResource('SessionM', time() - 5, 'process=Menu;constructor_value=237;thefunctiondatastring=103415,103047', null);

        $activity = SplickitActivity::getActivity(LockedActivityRetriever::returnLockedActivityResource($original_activity_history_resource));
        $this->assertTrue($activity->executeThisActivity());

    }


    function testTransactionalIntegration()
    {
        $merchant_id = $this->ids['merchant_id'];
        $user_resource = createNewUserWithCCNoCVV();
        $user = logTestUserResourceIn($user_resource);

        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($merchant_id,'pickup','note',1);
        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,getTomorrowTwelveNoonTimeStampDenver());
        $this->assertNull($checkout_resource->error);
        $order_resource = placeOrderFromCheckoutResource($checkout_resource);
        $order_id = $order_resource->order_id;
        $this->assertNull($order_resource->error);

        $message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id,'C');
        $curl_controller = ControllerFactory::generateFromMessageResource($message_resource);
        $this->assertTrue(is_a($curl_controller,'CurlController'),"It should be a curl controller");

        $response = $curl_controller->sendThisMessage($message_resource);
//        $ready_to_send_message_resource = $curl_controller->prepMessageForSending($message_resource);
//        $body_of_message = $ready_to_send_message_resource->message_text;
//        $expected_json = ''; // need to figure out what the expected json is
//        $this->assertEquals($expected_json,$body_of_message);
    }


    function testCreateAndSendBatchUserFileFromActivity()
    {
        // create some users
        $user_resource = createNewUserWithCCNoCVV();
        $activity_history_adapter = new ActivityHistoryAdapter(getM());
        $original_activity_history_resource = $activity_history_adapter->createActivityReturnActivityResource('SessionM', time() - 5, 'process=Users;constructor_value=237', null);

        $activity = SplickitActivity::getActivity(LockedActivityRetriever::returnLockedActivityResource($original_activity_history_resource));
        $this->assertTrue($activity->executeThisActivity());
    }

    function testCreateAndBatchMerchantFileFromActivity()
    {
        $external_id = rand(1111111,99999999);
        $merchant_resource = getOrCreateNewTestMerchantBasedOnExternalId("$external_id");
        $activity_history_adapter = new ActivityHistoryAdapter(getM());
        $original_activity_history_resource = $activity_history_adapter->createActivityReturnActivityResource('SessionM', time() - 5, 'process=Merchants;constructor_value=237', null);

        $activity = SplickitActivity::getActivity(LockedActivityRetriever::returnLockedActivityResource($original_activity_history_resource));
        $this->assertTrue($activity->executeThisActivity());
    }

    static function setUpBeforeClass()
    {
        $_SERVER['request_time1'] = microtime(true);
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));
        ini_set('max_execution_time',300);
        // 103047 - delivery
        // 103415 - pickup
        //setProperty('ljs_import_file_name','Ljs_Prices_Dump_70125.csv');

        $pickup_menu_id = 103415;
        $ids['pickup_menu_id'] = $pickup_menu_id;
        $brand_id = 517;

//        $merchant_adapter = new MerchantAdapter(getM());
//        $code = generateAlphaCode(10);
//        $sql = "UPDATE Merchant SET merchant_external_id = '$code' WHERE merchant_external_id = '70125'";
//        $menu_adapter->_query($sql);

        $ljs_skin = getOrCreateSkinAndBrandIfNecessary('Long John Silvers','Long John Silvers',237,517);
        $ljssomi_skin = getOrCreateSkinAndBrandIfNecessary('ljssomi','ljs',344,517);
        setContext($ljs_skin->external_identifier);
        $ids['context'] = $ljs_skin->external_identifier;
        $external_id = rand(1111111,99999999);
        $ids['merchant_external_id'] = $external_id;
        $merchant_resource = getOrCreateNewTestMerchantBasedOnExternalId("$external_id");
        $merchant_id = $merchant_resource->merchant_id;

        $mmm_resource = MerchantMessageMapAdapter::createMerchantMessageMap($merchant_id,'C','SessionM','I');
        $mmm_resource->info = 'service=SessionM;type=transaction';
        $mmm_resource->save();

        $ids['merchant_id'] = $merchant_id;


        $menu_adapter = new MenuAdapter(getM());
        if ($menu_resource = Resource::find($menu_adapter,"$pickup_menu_id")){
            ; // all good
        } else {
            //create menu
            $menu_adapter->importMenu($pickup_menu_id,'rrtprod','local',$brand_id);

        }

        MerchantMenuMapAdapter::createMerchantMenuMap($merchant_resource->merchant_id, $pickup_menu_id, 'pickup');
        createDaughterRecordsForMerchantMenuCombination($merchant_id,$pickup_menu_id);

        $delivery_menu_id = 103047;
        $ids['delivery_menu_id'] = $delivery_menu_id;
        $menu_adapter = new MenuAdapter(getM());
        if ($menu_resource = Resource::find($menu_adapter,"$delivery_menu_id")){
            ; // all good
        } else {
            //create menu
            $menu_adapter->importMenu($delivery_menu_id,'rrtprod','local',$brand_id);
        }

        MerchantMenuMapAdapter::createMerchantMenuMap($merchant_resource->merchant_id, $delivery_menu_id, 'delivery');
        createDaughterRecordsForMerchantMenuCombination($merchant_id,$delivery_menu_id);
        MerchantMenuMapAdapter::createMerchantMenuMap($merchant_resource->merchant_id, $delivery_menu_id, 'pickup',$ljssomi_skin->skin_id);

        attachMerchantToSkin($merchant_resource->merchant_id, $ids['skin_id']);
        $ids['merchant_id'] = $merchant_resource->merchant_id;

        $tpppa = new ThirdPartyProviderParametersAdapter(getM());
        $parameters = $tpppa->getParametersFromProviderId(3004);

/*
 * Transaction Endpoint Credentials
 * Url: https://domains-connecteast1.stg-sessionm.com
 * App Key:SessionM_ljsilvers
 * Secret: Wjwa8CJB0whTnfFbFD8S
 * Retailer ID:2460fba2-6e40-441a-ae5f-c7ca15f0a91d
 */

        foreach ($parameters as $parameter_row) {
            $data = [];
            if ($parameter_row['name'] == 'transaction_url') {
                $data['value'] = 'https://domains-connecteast1.stg-sessionm.com/transactions/api/1.0/transactions/processing/process';
            } else if ($parameter_row['name'] == 'transaction_app_key') {
                $data['value'] = 'SessionM_ljsilvers';
            } else if ($parameter_row['name'] == 'transaction_secret') {
                $data['value'] = 'Wjwa8CJB0whTnfFbFD8S';
            } else if ($parameter_row['name'] == 'customer_url') {
                $data['value'] = 'https://api-ljsilvers.stg-sessionm.com/priv/v1/apps/%%app_key%%/users';
            } else if ($parameter_row['name'] == 'customer_app_key') {
                $data['value'] = 'ed685deed05be9e6a0a81ab1725d640a9e6db027';
            } else if ($parameter_row['name'] == 'customer_secret') {
                $data['value'] = '97411da077908574e55e5af8e897538d5d89ff5d';
            } else if ($parameter_row['name'] == 'retailer_id') {
                $data['value'] = '2460fba2-6e40-441a-ae5f-c7ca15f0a91d';
            } else if ($parameter_row['name'] == 'store_guid') {
                $data['value'] = 'c39a3b91-fd49-463c-9fae-18812158e6a6';
            }
            $data['third_party_provider_parameter_id'] = $parameter_row['third_party_provider_parameter_id'];
            $data['brand_id'] = 517;
            $tpppbma = new ThirdPartyProviderParameterBrandMapsAdapter(getM());
            Resource::createByData($tpppbma,$data);
        }

        $_SERVER['log_level'] = 5;
        $_SERVER['unit_test_ids'] = $ids;
    }

    static function tearDownAfterClass()
    {
        SplickitCache::flushAll();
//        $db = DataBase::getInstance();
//        $mysqli = $db->getConnection();
//        $mysqli->rollback();
    }

    /* main method for testing */
    static function main() {
        $suite = new PHPUnit_Framework_TestSuite( __CLASS__);
        PHPUnit_TextUI_TestRunner::run( $suite);
    }

}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    SessionMBatchUploadTest::main();
}

?>
