<?php
error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');

$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;


//$_SERVER['ENVIRONMENT'] = isset($_SERVER['XDEBUG_CONFIG']) ? "unit_test_ide" : "unit_test";
//$_SERVER['DB_INFO_FILE_PATH'] = "config/smaw_database_unittest.conf";

require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';


class SnarfsBrinkIntegrationTest extends PHPUnit_Framework_TestCase
{
    var $stamp;
    var $ids;
    var $api_port = "80";

    function setUp()
    {
        $_SERVER['HTTP_NO_CC_CALL'] = 'true';
        $_SERVER['DO_NOT_RUN_CC'] = 'true';
        $this->stamp = $_SERVER['STAMP'];
        $_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
        $this->ids = $_SERVER['unit_test_ids'];
        if (isset($_SERVER['XDEBUG_CONFIG'])) {
            $this->api_port = "10080";
        }
    }

    function tearDown()
    {
        //delete your instance
        $_SERVER['STAMP'] = $this->stamp;
        unset($this->ids);
    }

//    function testStageEntireBrand()
//    {
//        //first add a non brink merchant
//
//        $menu_id = createTestMenuWithNnumberOfItems(1);
//        $merchant_resource = getOrCreateNewTestMerchantBasedOnExternalId('non-brink',$menu_id);
//
//        $doit_ts = time()-2;
//        $info = 'object=BrinksnarfsImporter;method=staticStageImportForEntireBrandList;thefunctiondatastring=pos/import/brinksnarfs/all';
//        //$info = 'merchant_id=all';
//        $activity_history_adapter = new ActivityHistoryAdapter(getM());
//        $activity_history_resource = $activity_history_adapter->createActivityReturnActivityResource('BrinkSnarfsPriceSync', $doit_ts, $info, '',60*60*24);
//        $this->assertNotNull($activity_history_resource);
//
//        removeContext();
//
//        $activity_history_resource->locked = 'Y';
//        $activity_history_resource->save();
//        $activity = SplickitActivity::getActivity($activity_history_resource);
//        $result = $activity->doit();
//
//    }


//    function testGetDestinations()
//    {
//        $brink_importer = new BrinkImporter();
//        $method = "GetDestinations";
//        $response0 = $brink_importer->curlIt($method,$merchant_resource);
//        myerror_log($response0);
//    }

    function testImporterNew()
    {


        $merchant_resource = $this->ids['merchant_resource_new'];
        $merchant_id = $merchant_resource->merchant_id;
        $alphanumeric_id = $merchant_resource->alphanumeric_id;

        $url = "http://127.0.0.1:".$this->api_port."/app2/portal/import/brink/$alphanumeric_id";

        //$user = logTestUserIn(1);
        clearAuthenticatedUserParametersForSession();
        removeContext();

//        $request = createRequestObject("$url",'POST');
//        $pos_controller = new PosController(getM(),null,$request,5);
//        $response = makeMockPortalRequest($pos_controller);


        $response = $this->makeRequest($url,null,'POST','');
        $response_array = json_decode($response,true);
        $activity_id = $response_array['data']['activity_id'];
        $activity_history_adapter = new ActivityHistoryAdapter(getM());
        $activity_history_resource = Resource::find($activity_history_adapter,$activity_id);
        $activity_history_resource->info = $activity_history_resource->info.';build_modifiers=1';
        $activity_history_resource->save();

        removeContext();

        $activity_history_resource->locked = 'Y';
        $activity_history_resource->save();
        $activity = SplickitActivity::getActivity($activity_history_resource);
        $result = $activity->doit();
        $complete_menu = new CompleteMenu($this->ids['menu_id']);
        $item_sizes = $complete_menu->getAllMenuItemSizePrices($this->ids['menu_id'],'Y',$merchant_id,getM());
        $count = sizeof($item_sizes);
        $this->assertTrue($count>10,"It should have imported a bunch of prices for the merchant but it only imported: $count");

        $modifier_size_list = $complete_menu->getAllModifierItemPricesForMenu($this->ids['menu_id'],'Y',getM(),$merchant_id);
        $no = 0;
        $yes = 0;
        foreach($modifier_size_list as $modifier_sizes) {
            foreach ($modifier_sizes as $modifier_size) {
                if ($modifier_size['active'] == 'N') {
                    myerror_log("we ahve a NO");
                    $no++;
                } else {
                    myerror_log("we have a YES: ".$modifier_size['active']);
                    $yes++;
                }
            }
        }
        myerror_log("NO: $no,   YES: $yes");
    }

    function testLoadPricesForMerchant()
    {
        $ids = $this->ids;
        $menu_id = $ids['menu_id'];
        $alphanumeric_id = $this->ids['merchant_resource']->alphanumeric_id;

        $brink_importer = ImporterFactory::getImporterFromUrl("http://localhost/app2/apiv2/pos/import/brink/$alphanumeric_id");
        $brink_importer->create_zero_records = false;
        $this->assertTrue($brink_importer->importRemoteMerchantMetaDataForLoadedMerchant());

        //$menu = CompleteMenu::getCompleteMenu($this->ids['menu_id'],'Y',$this->ids['merchant_id'],2,'pickup');
        $complete_menu = new CompleteMenu($menu_id);
        $item_sizes = $complete_menu->getAllMenuItemSizePrices($menu_id,'Y',$ids['merchant_id'],getM());
        $count = sizeof($item_sizes);
        $this->assertTrue($count>10,"It shoudl have imported a bunch of prices for the merchant but it only imported: $count");

//        CompleteMenu::getAllMenuItemsAsArray($menu_id, 'Y', E$);
    }

    function testLoyaltyWithSnarfsBrinkIntegration()
    {
        $menu_id = $this->ids['menu_id'];
        $merchant_id = $this->ids['merchant_id'];
        $complete_menu = CompleteMenu::getCompleteMenu($menu_id,'Y',$merchant_id,2);
        $code = generateAlphaCode(3);
        $user_resource = createNewUserWithCCNoCVV(array("email"=>"bobnewhartthesecond_".$code."@order140.com","first_name"=>"bob","last_name"=>"newhart","contact_no"=>'8888888889'));
        $user = logTestUserResourceIn($user_resource);

        $ubpma = new UserBrandPointsMapAdapter(getM());
        $options[TONIC_FIND_BY_METADATA] = array("user_id"=>$user_resource->user_id,"brand_id"=>150);
        $ubpmr = Resource::find($ubpma,null,$options);
        $ubpmr->points = 1300;
        $ubpmr->save();

        $order_adapter = new OrderAdapter(getM());
        $cart_data = $order_adapter->getCartArrayWithOneModierPerModifierGroup($this->ids['merchant_id'],'pickup',2);



        // now add the points stuff to the item
        $cart_data['items'][0]['item_id'] = 305435;
        $cart_data['items'][0]['size_id'] = 96546;
        $cart_data['items'][0]['mods'] = [];
        $cart_data['items'][0]['points_used'] = 1000;
        $cart_data['items'][0]['amt_off'] = 6.95;
        $cart_data['items'][0]['item_total_price'] = 6.95;
        $cart_data['items'][0]['brand_points_id'] = 1010;
        $cart_data['total_points_used'] = 1000;
        $cart_data['items'][1]['item_id'] = 305435;
        $cart_data['items'][1]['size_id'] = 96546;
        $cart_data['items'][1]['mods'] = [];
        $cart_data['items'][1]['item_total_price'] = 6.95;
        $cart_data['total_price'] = 6.95;
        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,getTomorrowTwelveNoonTimeStampDenver());
        $this->assertNull($checkout_resource->error);

        $this->assertEquals(.56, $checkout_resource->total_tax_amt);
        $this->assertEquals(7.51,$checkout_resource->grand_total);


        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,20.00);
        $this->assertNull($order_resource->error);
        $order_id = $order_resource->order_id;

        // now try to create the message
        $message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id,'BO');
        $brink_controller = ControllerFactory::generateFromMessageResource($message_resource);
        $message_to_send = $brink_controller->prepMessageForSending($message_resource);
        $message_xml = $message_to_send->message_text;
//        $expected_tip = floor(.99*$message_to_send->brink_grand_total);
//        $this->assertContains('<TipAmount>'.$expected_tip.'</TipAmount>',$message_xml,"It should have reduced the tip to 99% of the grand total");
//        $expected_fake_item_value = 20.00 - $expected_tip;
//        $this->assertContains('<Price>'.$expected_fake_item_value.'</Price>',$message_xml,'It should have the fake item price as the extra tip amount');
//        $this->assertContains('<ItemId>640229379</ItemId>',$message_xml,"It should have the fake item id for the tip");

        $grand_total = $order_resource->grand_total;

        $this->assertContains('<TipAmount>0</TipAmount>',$message_xml,"It should have reduced the tip to 0 and put it all in the custom id");
        $this->assertContains('<Price>20.00</Price>',$message_xml,'It should have the fake item price as the extra tip amount');
        $this->assertContains('<ItemId>'.BrinkController::BRINK_SNARFS_LARGE_TIP_ITEM_ID.'</ItemId>',$message_xml,"It should have the fake item id for the tip");
       // $this->assertContains('<Amount>'.$grand_total.'</Amount>',$message_xml,"It should have the payment amount as the splickit grand total");

        // now send it
        $message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id,'BO');
        $brink_controller = ControllerFactory::generateFromMessageResource($message_resource);
        $result = $brink_controller->sendThisMessage($message_resource);

    }

    function testLoyaltyWithNoCharge()
    {
        $menu_id = $this->ids['menu_id'];
        $merchant_id = $this->ids['merchant_id'];
        $complete_menu = CompleteMenu::getCompleteMenu($menu_id,'Y',$merchant_id,2);
        $code = generateAlphaCode(3);
        $user_resource = createNewUserWithCCNoCVV(array("email"=>"bobnewhartthesecond_".$code."@order140.com","first_name"=>"bob","last_name"=>"newhart","contact_no"=>'8888888889'));
        $user = logTestUserResourceIn($user_resource);

        $ubpma = new UserBrandPointsMapAdapter(getM());
        $options[TONIC_FIND_BY_METADATA] = array("user_id"=>$user_resource->user_id,"brand_id"=>150);
        $ubpmr = Resource::find($ubpma,null,$options);
        $ubpmr->points = 1300;
        $ubpmr->save();

        $order_adapter = new OrderAdapter(getM());
        $cart_data = $order_adapter->getCartArrayWithOneModierPerModifierGroup($this->ids['merchant_id'],'pickup',1);



        // now add the points stuff to the item
        $cart_data['items'][0]['item_id'] = 305435;
        $cart_data['items'][0]['size_id'] = 96546;
        $cart_data['items'][0]['mods'] = [];
        $cart_data['items'][0]['points_used'] = 1000;
        $cart_data['items'][0]['amt_off'] = 6.95;
        $cart_data['items'][0]['item_total_price'] = 6.95;
        $cart_data['items'][0]['brand_points_id'] = 1010;
        $cart_data['total_points_used'] = 1000;
        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,getTomorrowTwelveNoonTimeStampDenver());
        $this->assertNull($checkout_resource->error);

        $this->assertEquals(.00, $checkout_resource->total_tax_amt);
        $this->assertEquals(0.00,$checkout_resource->grand_total);


        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,0.00);
        $this->assertNull($order_resource->error);
        $order_id = $order_resource->order_id;

        // now try to create the message
        $message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id,'BO');
        $brink_controller = ControllerFactory::generateFromMessageResource($message_resource);
        $message_to_send = $brink_controller->prepMessageForSending($message_resource);

        // validate that there is no tender id in the message;
        $this->assertNotContains('<Payments>',$message_to_send->message_text);
        $this->assertNotContains('</Payments>',$message_to_send->message_text);
        $this->assertNotContains('NewOrderPayment',$message_to_send->message_text);
        $this->assertContains('<Payments/>',$message_to_send->message_text);


    }










//    function testPlaceOrder()
//    {
////        $size_id = 94664;
////        $item_id = 302906;
//
//        $size_id = 'xxxxxxxx';
//        $item_id = 'xxxxxxxx';
//
//
//        $merchant_id = $this->ids['merchant_id'];
//        $user_resource = createNewUserWithCCNoCVV();
//        $user = logTestUserResourceIn($user_resource);
//        $order_adapter = new OrderAdapter($m);
//        $order_data = $order_adapter->getCartArrayWithOneModierPerModifierGroup($merchant_id,'pickup',1);
//        //$order_data['items'][0] = array('mods'=>array(),'quantity'=>1,'item_id'=>$item_id,'size_id'=>$size_id,'item_total_price'=>2.0);
//        $order_data['items'][0] = array('mods'=>array(array('modifier_item_id'=>2352071,'mod_quantity'=>1)),'quantity'=>1,'item_id'=>$item_id,'size_id'=>$size_id,'item_total_price'=>2.0);
//        $request = createRequestObject('app2/apiv2/cart','post',json_encode($order_data),'application/json');
//        $place_order_controller = new PlaceOrderController($m,$user,$request,5);
//        $create_cart_response = $place_order_controller->processV2Request();
//        $ucid = $create_cart_response->ucid;
//
//        $request = createRequestObject("app2/apiv2/cart/$ucid/checkout","GET");
//        $place_order_controller = new PlaceOrderController($m,$user,$request,5);
//        $place_order_controller->setCurrentTime(getTomorrowTwelveNoonTimeStampDenver());
//        $checkout_resource = $place_order_controller->processV2Request();
//        $this->assertNull($checkout_resource->error,"It should not throw an error");



//    }

    function testItShouldGetTheTaxFromBrinkOnGetCheckoutData()
    {
        $merchant_id = $this->ids['merchant_id'];
        //set tax to 0.00 for merchant
        $tax_resource = Resource::find(new TaxAdapter(getM()),null,[TONIC_FIND_BY_METADATA=>['merchant_id'=>$merchant_id]]);
        $tax_resource->rate = 0.00;
        $tax_resource->save();

        $code = generateAlphaCode(3);
        $user_resource = createNewUserWithCCNoCVV(array("email"=>"bobnewhart_$code@order140.com","first_name"=>"bob","last_name"=>"newhart","contact_no"=>'8888888888'));
        $user = logTestUserResourceIn($user_resource);
        $order_adapter = new OrderAdapter($m);
        $menu = CompleteMenu::getCompleteMenu($this->ids['menu_id'],'Y',$merchant_id,2,'pickup');
        array_shift($menu['menu_types']);
        $order_data = $order_adapter->getOrderArrayFromFullMenuWithOneModiferPerModifierGroup($menu,$merchant_id,"some note",1,0,1);
        $request = createRequestObject('app2/apiv2/cart','post',json_encode($order_data),'application/json');
        $place_order_controller = new PlaceOrderController($m,$user,$request,5);
        $create_cart_response = $place_order_controller->processV2Request();
        $ucid = $create_cart_response->ucid;

        $request = createRequestObject("app2/apiv2/cart/$ucid/checkout","GET");
        $place_order_controller = new PlaceOrderController($m,$user,$request,5);
        $place_order_controller->setCurrentTime(getTomorrowTwelveNoonTimeStampDenver());
        $checkout_resource = $place_order_controller->processV2Request();
        $this->assertNull($checkout_resource->error,"It should not throw an error");
        $checkout_receipt_items = createHashmapFromArrayOfArraysByFieldName($checkout_resource->order_summary['receipt_items'],'title');
        $checkout_tax = $checkout_receipt_items['Tax'];
        $this->assertTrue($checkout_resource->total_tax_amt > 0.00,"Tax should have been set by the brink pull");
        $tax_amount = $checkout_resource->total_tax_amt;
        $this->assertEquals('$'.$tax_amount,$checkout_tax['amount']);
        $total = $checkout_receipt_items['Total']['amount'];
        //$this->assertEquals("$8.13",$total,"total should have been set to the brink values");
//        $complete_order = CompleteOrder::staticGetCompleteOrder($order_id,$m);
        $order_amt = floatval($checkout_resource->order_amt);
        $total_tax_amt = floatval($checkout_resource->total_tax_amt);
        $this->assertTrue($total_tax_amt > 0.00,"It should have sent back a valid total tax amount but sent back: ".$checkout_resource->total_tax_amt);
        $tax_rate = intval(100*$total_tax_amt/$order_amt);
        $this->assertNotEquals(20,$tax_rate,"tax rate should be calculated by brink, not the 20% that is in our system");

        //make sure totals are correct.
        $complete_order = CompleteOrder::staticGetCompleteOrder($checkout_resource->oid_test_only,$m);
        $grand_total_from_math = $complete_order['order_amt']+$complete_order['total_tax_amt']+$complete_order['delivery_amt']+$complete_order['tip_amt']+$complete_order['promo_amt'];
        $this->assertEquals($grand_total_from_math,$complete_order['grand_total'],"the set grand total should equal the sum of the parts");
    }

    function makeRequest($url,$userpassword,$method = 'GET',$data = null)
    {
        logData($data," curl data");
        unset($this->info);
        $method = strtoupper($method);
        $curl = curl_init($url);
        if ($userpassword) {
            curl_setopt($curl, CURLOPT_USERPWD, $userpassword);
        }
        if ($external_id = getContext()) {
            $headers = array("X_SPLICKIT_CLIENT_ID:$external_id","X_SPLICKIT_CLIENT_DEVICE:unit_testing","X_SPLICKIT_CLIENT:AdminDispatchTest","NO_CC_CALL:true");
        }

        if ($authentication_token = $data['splickit_authentication_token']) {
            $headers[] = "splickit_authentication_token:$authentication_token";
        }
        if ($data['headers']) {
            $headers = $data['headers'];
            unset($data['headers']);
        }
        if ($method == 'POST') {
            curl_setopt($curl, CURLOPT_POST, 1);
            if ($data) {
                $json = json_encode($data);
                curl_setopt($curl, CURLOPT_POSTFIELDS,$json);
                $headers[] = 'Content-Type: application/json';
                $headers[] = 'Content-Length: ' . strlen($json);
            }
        } else if ($method == 'DELETE') {
            curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "DELETE");
        }
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        logCurl($url,$method,$userpassword,$headers,$json);
        $result = curl_exec($curl);

        $this->info = curl_getinfo($curl);
        curl_close($curl);
        return $result;
    }

    static function setUpBeforeClass()
    {
        $_SERVER['request_time1'] = microtime(true);
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));
        ini_set('max_execution_time',300);

        $menu_id = 102892;
        $brand_id = 150;
        $skin_id = 5;
        $menu_adapter = new MenuAdapter(getM());
        $blr_resource = Resource::findOrCreateIfNotExistsByData(new BrandLoyaltyRulesAdapter($m),array("brand_id"=>150,"loyalty_type"=>"splickit_points"));
        if ($menu_resource = Resource::find($menu_adapter,"$menu_id")){
//            $menu_resource->version = 2.0;
//            $menu_resource->save();
        } else {
            //create menu
            $menu_adapter->importMenu($menu_id,'prod','local',$brand_id);
//            $menu_resource = Resource::find($menu_adapter,"$menu_id");
//            $menu_resource->version = 2.0;
//            $menu_resource->save();
        }

        setContext('com.splickit.snarfs');

        //old way merchant
        $merchant_resource = getOrCreateNewTestMerchantBasedOnExternalId('Snarf-Lab');
        $map_resource = Resource::createByData(new MerchantMessageMapAdapter(getM()),array("merchant_id"=>$merchant_resource->merchant_id,"message_format"=>'BO',"delivery_addr"=>"Brink","message_type"=>"X"));
        Resource::createByData(new MerchantMenuMapAdapter($m),array("merchant_id"=>$merchant_resource->merchant_id,"menu_id"=>$menu_id));
        Resource::createByData(new MerchantBrinkInfoMapsAdapter($m),array("merchant_id"=>$merchant_resource->merchant_id,"brink_location_token"=>"Lw/iYlLd9E6wFcterTYlsw=="));
        $ids['merchant_resource'] = $merchant_resource;
        $ids['merchant_id'] = $merchant_resource->merchant_id;


        $merchant_resource_new = getOrCreateNewTestMerchantBasedOnExternalId('1');
        $menu_map_resource = Resource::createByData(new MerchantMenuMapAdapter($m),array("merchant_id"=>$merchant_resource_new->merchant_id,"menu_id"=>$menu_id));
        $message_map_resource = Resource::createByData(new MerchantMessageMapAdapter(getM()),array("merchant_id"=>$merchant_resource_new->merchant_id,"message_format"=>'BO',"delivery_addr"=>"Brink","message_type"=>"X"));
        $tpppmap_resource = Resource::createByData(new ThirdPartyProviderParameterMerchantMapsAdapter(getM()),["merchant_id"=>$merchant_resource_new->merchant_id,"third_party_provider_parameter_id"=>1000,"value"=>'Lw/iYlLd9E6wFcterTYlsw==']);
        $ids['merchant_resource_new'] = $merchant_resource_new;
        $ids['merchant_id_new'] = $merchant_resource_new->merchant_id;


        $brand_resource = Resource::find(new BrandAdapter($m),"$brand_id");
        $brand_resource->loyalty = 'Y';
        $brand_resource->save();
        $ids['brand_loyalty_rules_id'] = $blr_resource->brand_loyalty_rules_id;

        $bp_records = BrandPointsAdapter::staticGetRecords(array("brand_id"=>$brand_id), 'BrandPointsAdapter');
        $ids['brand_points_records'] = $bp_records;




        $ids['menu_id'] = $menu_id;

        $user_resource = createNewUserWithCCNoCVV();
        $ids['user_resource'] = $user_resource;
        $ids['user_id'] = $user_resource->user_id;

        $_SERVER['log_level'] = 5;
        $_SERVER['unit_test_ids'] = $ids;
    }


    static function tearDownAfterClass()
    {
//        $db = DataBase::getInstance();
//        $mysqli = $db->getConnection();
//        $mysqli->rollback();

        date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main() {
        $suite = new PHPUnit_Framework_TestSuite( __CLASS__);
        PHPUnit_TextUI_TestRunner::run( $suite);
    }

}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    SnarfsBrinkIntegrationTest::main();
}

?>
