<?php
error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');

//chdir("/Users/radamnyc/code/Environments/smaw");
$_SERVER['ENVIRONMENT'] = isset($_SERVER['XDEBUG_CONFIG']) ? "unit_test_ide" : "unit_test";
$_SERVER['DB_INFO_FILE_PATH'] = "config/smaw_database_unittest.conf";
require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';



class TaskRetailPOSAlternateGroupTest extends PHPUnit_Framework_TestCase
{
    var $stamp;
    var $ids;

    function setUp()
    {
        $_SERVER['HTTP_NO_CC_CALL'] = 'true';
        $_SERVER['DO_NOT_RUN_CC'] = 'true';
        $this->stamp = $_SERVER['STAMP'];
        $_SERVER['STAMP'] = __CLASS__ . '-' . $_SERVER['STAMP'];
        $this->ids = $_SERVER['unit_test_ids'];
        setContext($this->ids['context']);
    }

    function tearDown()
    {
        //delete your instance
        $_SERVER['STAMP'] = $this->stamp;
        unset($this->ids);
    }

    function testDebugOfAlternateThing()
    {
        $json = '{"user_id":"1234-56789-abcde-10002","merchant_id":"107136","submitted_order_type":"pickup","group_order_token":null,"user_addr_id":null,"items":[{"item_id":305583,"external_detail_id":"b138c1c0-2bd0-4616-842c-bb392081e413","quantity":1,"mods":[{"modifier_item_id":2359313,"mod_quantity":1,"name":"1/3 Lb. Burger"},{"modifier_item_id":2357414,"mod_quantity":1,"name":"White"},{"modifier_item_id":2357421,"mod_quantity":1,"name":"Extra Well"},{"modifier_item_id":2358858,"mod_quantity":1,"name":"You top it yourself when you get here!"}],"size_id":"96868","status":"new","order_detail_id":null,"points_used":null,"brand_points_id":null,"note":null},{"item_id":306836,"external_detail_id":"7ab5ec3e-87a4-46bc-b09e-d987cabd92e5","quantity":1,"mods":[{"modifier_item_id":2359312,"mod_quantity":1,"name":"1/2 Lb. Burger"},{"modifier_item_id":2357414,"mod_quantity":1,"name":"White"},{"modifier_item_id":2357421,"mod_quantity":1,"name":"Extra Well"},{"modifier_item_id":2358833,"mod_quantity":1,"name":"American Cheese"},{"modifier_item_id":2358834,"mod_quantity":1,"name":"Bleu cheese"},{"modifier_item_id":2358835,"mod_quantity":1,"name":"Cheddar Cheese"},{"modifier_item_id":2358836,"mod_quantity":1,"name":"Pepper Jack Cheese"},{"modifier_item_id":2358838,"mod_quantity":1,"name":"Provolone Cheese"},{"modifier_item_id":2358858,"mod_quantity":1,"name":"You top it yourself when you get here!"}],"size_id":"96738","status":"new","order_detail_id":null,"points_used":null,"brand_points_id":null,"note":null}],"total_points_used":0}';
        $order_array = json_decode($json,true);
        $items = $order_array['items'];

        $ids = $this->ids;
        $merchant_id = $ids['merchant_id'];

        $user_resource = createNewUserWithCCNoCVV();
        $user = logTestUserResourceIn($user_resource);

        $cart_data = getEmptyCart($user,$merchant_id);
        $cart_data['items'] =  $items;


        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,getTomorrowTwelveNoonTimeStampDenver());
        $this->assertNull($checkout_resource->error);
        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,0.00);
        $this->assertNull($order_resource->error);
        $order_id = $order_resource->order_id;

        $complete_order = CompleteOrder::staticGetCompleteOrder($order_id);

        $task_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id, 'A');
        $this->assertNotNull($task_message_resource,"It should have created a task message");
        $task_message_controller = ControllerFactory::generateFromMessageResource($task_message_resource);
        $ready_to_send_message = $task_message_controller->prepMessageForSending($task_message_resource);



    }

    function testSimpleOrderWithOneChosen()
    {
        $ids = $this->ids;
        $merchant_id = $ids['merchant_id'];
        $item_id = $ids['item_id'];
        $size_id = $ids['size_id'];
        $modifier_item_ids = $ids['modifier_item_ids'];
        $mod_hash = $ids['hash_of_mods_sizes'];

        $user_resource = createNewUserWithCCNoCVV();
        $user = logTestUserResourceIn($user_resource);

        $mods = [];

        $mods[] = ['mod_quantity'=>1,"modifier_item_id"=>2359313];
        $mods[] = ['mod_quantity'=>1,"modifier_item_id"=>2357414];
        $mods[] = ['mod_quantity'=>1,"modifier_item_id"=>2357421];
        $mods[] = ['mod_quantity'=>1,"modifier_item_id"=>$modifier_item_ids[0]];
        $mods[] = ['mod_quantity'=>1,"modifier_item_id"=>2358857];

        $cart_data = getEmptyCart($user,$merchant_id);
        $cart_data['items'][] =  ['mods'=> $mods,'quantity'=>1,'item_id'=>$item_id,'size_id'=>$size_id];

        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,getTomorrowTwelveNoonTimeStampDenver());
        $this->assertNull($checkout_resource->error);
        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,0.00);
        $this->assertNull($order_resource->error);
        $order_id = $order_resource->order_id;

        $complete_order = CompleteOrder::staticGetCompleteOrder($order_id);
        $this->assertCount(5,$complete_order['order_details'][0]['order_detail_complete_modifier_list_no_holds'],"It should have 5 ordered modifiers");

        $task_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id, 'A');
        $this->assertNotNull($task_message_resource,"It should have created a task message");
        $task_message_controller = ControllerFactory::generateFromMessageResource($task_message_resource);
        $ready_to_send_message = $task_message_controller->prepMessageForSending($task_message_resource);
        $modifiers_for_task = $ready_to_send_message->order_details[0]['order_detail_complete_modifier_list_no_holds'];
        $this->assertCount(6,$modifiers_for_task,'there should now be 6 modifiers');

        $last_modifier = array_pop($modifiers_for_task);
        $this->assertEquals($modifier_item_ids[0],$last_modifier['modifier_item_id']);
        $this->assertEquals(0.00,$last_modifier['mod_price']);

        $last_modifier = array_pop($modifiers_for_task);
        $this->assertCount(5,$last_modifier,'It should be the controller modifier that was added');
        $this->assertEquals(TaskRetailController::SINGLE_MODIFIER_PLU_FOR_ONE_OR_MANY_GROUP,$last_modifier['external_id']);
        $this->assertEquals(1.00,$last_modifier['mod_price']);

        $message_text = cleanUpDoubleSpacesCRLFTFromString($ready_to_send_message->message_text);
        $expected_mods_for_one_or_many = '<Item><PLU>'.TaskRetailController::SINGLE_MODIFIER_PLU_FOR_ONE_OR_MANY_GROUP.'</PLU><QTY>1</QTY><Value>1</Value><Modifiers xsi:nil="true" /></Item><Item><PLU>'.$mod_hash[$modifier_item_ids[0]]['external_id'].'</PLU><QTY>1</QTY><Value>0</Value><Modifiers xsi:nil="true" /></Item>';
        $this->assertContains($expected_mods_for_one_or_many,$message_text,"It should have the correctly formatted modifier for single one chosen");


    }

    function testPlaceOrderWithManyChosenFromChooseOneOrMany()
    {
        $ids = $this->ids;
        $merchant_id = $ids['merchant_id'];
        $item_id = $ids['item_id'];
        $size_id = $ids['size_id'];
        $modifier_item_ids = $ids['modifier_item_ids'];
        $mod_hash = $ids['hash_of_mods_sizes'];

        $user_resource = createNewUserWithCCNoCVV();
        $user = logTestUserResourceIn($user_resource);

        $mods = [];

        $mods[] = ['mod_quantity'=>1,"modifier_item_id"=>2359313];
        $mods[] = ['mod_quantity'=>1,"modifier_item_id"=>2357414];
        $mods[] = ['mod_quantity'=>1,"modifier_item_id"=>2357421];
        $mods[] = ['mod_quantity'=>1,"modifier_item_id"=>$modifier_item_ids[0]];
        $mods[] = ['mod_quantity'=>1,"modifier_item_id"=>$modifier_item_ids[1]];
        $mods[] = ['mod_quantity'=>1,"modifier_item_id"=>$modifier_item_ids[2]];
        $mods[] = ['mod_quantity'=>1,"modifier_item_id"=>$modifier_item_ids[3]];
        $mods[] = ['mod_quantity'=>1,"modifier_item_id"=>$modifier_item_ids[4]];
        $mods[] = ['mod_quantity'=>1,"modifier_item_id"=>2358857];

        $cart_data = getEmptyCart($user,$merchant_id);
        $cart_data['items'][] =  ['mods'=> $mods,'quantity'=>1,'item_id'=>$item_id,'size_id'=>$size_id];

        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,getTomorrowTwelveNoonTimeStampDenver());
        $this->assertNull($checkout_resource->error);
        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,0.00);
        $this->assertNull($order_resource->error);
        $order_id = $order_resource->order_id;

        $complete_order = CompleteOrder::staticGetCompleteOrder($order_id);
        $this->assertCount(9,$complete_order['order_details'][0]['order_detail_complete_modifier_list_no_holds'],"It should have 9 ordered modifiers");

        $task_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id, 'A');
        $this->assertNotNull($task_message_resource,"It should have created a task message");
        $task_message_controller = ControllerFactory::generateFromMessageResource($task_message_resource);
        $ready_to_send_message = $task_message_controller->prepMessageForSending($task_message_resource);
        $modifiers_for_task = $ready_to_send_message->order_details[0]['order_detail_complete_modifier_list_no_holds'];
        $this->assertCount(10,$modifiers_for_task,'there should now be 10 modifiers');


        $message_text = cleanUpDoubleSpacesCRLFTFromString($ready_to_send_message->message_text);
        $controll_modifier = '<Item><PLU>'.TaskRetailController::UNLIMITED_MODIFIER_PLU_FOR_ONE_OR_MANY_GROUP.'</PLU><QTY>1</QTY><Value>2</Value><Modifiers xsi:nil="true" /></Item>';
        $this->assertContains($controll_modifier,$message_text,"It should have the controll modifier XML");

        $modifier_item_1 = '<Item><PLU>'.$mod_hash[$modifier_item_ids[0]]['external_id'].'</PLU><QTY>1</QTY><Value>0</Value><Modifiers xsi:nil="true" /></Item>';
        $this->assertContains($modifier_item_1,$message_text,"It should have one of the mods with a price of 0.00");
        $modifier_item_2 = '<Item><PLU>'.$mod_hash[$modifier_item_ids[1]]['external_id'].'</PLU><QTY>1</QTY><Value>0</Value><Modifiers xsi:nil="true" /></Item>';
        $this->assertContains($modifier_item_2,$message_text,"It should have one of the mods with a price of 0.00");
        $modifier_item_3 = '<Item><PLU>'.$mod_hash[$modifier_item_ids[2]]['external_id'].'</PLU><QTY>1</QTY><Value>0</Value><Modifiers xsi:nil="true" /></Item>';
        $this->assertContains($modifier_item_3,$message_text,"It should have one of the mods with a price of 0.00");
        $modifier_item_4 = '<Item><PLU>'.$mod_hash[$modifier_item_ids[3]]['external_id'].'</PLU><QTY>1</QTY><Value>0</Value><Modifiers xsi:nil="true" /></Item>';
        $this->assertContains($modifier_item_4,$message_text,"It should have one of the mods with a price of 0.00");


    }





    static function setUpBeforeClass()
    {
        $_SERVER['request_time1'] = microtime(true);
        $_SERVER['NO_MOCKS'] = true;
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));

        $menu_id = 102898;
        $brand_id = 372;
        $menu_adapter = new MenuAdapter(getM());
        if ($menu_adapter->getRecord(array("menu_id" => $menu_id))) {
            ; // do nothing
        } else {
            //create menu
            $menu_adapter->importMenu($menu_id, 'prod', 'local', $brand_id);
        }

        $menu_resource = Resource::find($menu_adapter,$menu_id);
        $menu_resource->version = 2.00;
        $menu_resource->save();



        //mysql_query("BEGIN");

        $skin_id = 114;
        $name = "Fuddruckers";
        $skin_resource = getOrCreateSkinAndBrandIfNecessaryWithLoyalty($name, $name, $skin_id, $brand_id);
        $skin_resource->show_notes_field = 0;
        $skin_resource->save();
        $ids['context'] = "com.splickit.$name";
        $ids['brand_id'] = $brand_id;
        $ids['skin_id'] = $skin_id;

        //map it to a menu
        $ids['menu_id'] = $menu_id;

        $message_data = array("message_format" => 'A', "delivery_addr" => 'TaskRetail');
        $data['message_data'] = $message_data;
        $merchant_resource = createNewTestMerchant($menu_id, $data);
        attachMerchantToSkin($merchant_resource->merchant_id, $ids['skin_id']);
        $ids['merchant_id'] = $merchant_resource->merchant_id;
        $mtrima = new MerchantTaskRetailInfoMapAdapter(getM());
        Resource::createByData($mtrima, array("merchant_id" => $merchant_resource->merchant_id, "location" => 58, "brand_id" => $brand_id,'task_retail_url'=>'https://frdevapi.xchangefusion.com/api/v1/OnlineOrders'));

        $complete_menu = CompleteMenu::getCompleteMenu($menu_id, 'Y', 0, 2, 'pickup');
        $ids['menu'] = $complete_menu;

        $item_id = 306836;
        $size_id = 96738;

        $ids['item_id'] = $item_id;
        $ids['size_id'] = $size_id;

        $sql = "select * From Modifier_Item where modifier_group_id = 337832";
        $options[TONIC_FIND_BY_SQL] = $sql;
        $mia = new ModifierItemAdapter(getM());
        $modifier_items = $mia->getRecords([],$options);
        $modifier_size_map_adapter = new ModifierSizeMapAdapter(getM());
        foreach($modifier_items as $modifier_item) {
            $modifier_item_id = $modifier_item['modifier_item_id'];
            $data = ['modifier_item_id' => $modifier_item_id,'merchant_id'=>0];
            $record = $modifier_size_map_adapter->getRecord($data);
            $ids['modifier_item_size_maps'][] = $record;
            $ids['modifier_item_ids'][] = $record['modifier_item_id'];
        }

        $modifier_item_size_map_hash_by_modifier_item_id = createHashmapFromArrayOfArraysByFieldName($ids['modifier_item_size_maps'],'modifier_item_id');
        $ids['hash_of_mods_sizes'] = $modifier_item_size_map_hash_by_modifier_item_id;


        $_SERVER['log_level'] = 5;
        $_SERVER['unit_test_ids'] = $ids;
    }

    static function tearDownAfterClass()
    {
        //mysqli_query("ROLLBACK");
        date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main()
    {
        $suite = new PHPUnit_Framework_TestSuite(__CLASS__);
        PHPUnit_TextUI_TestRunner::run($suite);
    }

}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    TaskRetailPOSAlternateGroupTest::main();
}

?>