<?php
error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');

//chdir("/Users/radamnyc/code/Environments/smaw");
$_SERVER['ENVIRONMENT'] = isset($_SERVER['XDEBUG_CONFIG']) ? "unit_test_ide" : "unit_test";
$_SERVER['DB_INFO_FILE_PATH'] = "config/smaw_database_unittest.conf";
require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';



class TaskRetailPOSTest extends PHPUnit_Framework_TestCase
{
    var $stamp;
    var $ids;

    function setUp()
    {
        include_once "lib/mocks/doordashcurl.php";
        $_SERVER['HTTP_NO_CC_CALL'] = 'true';
        $_SERVER['DO_NOT_RUN_CC'] = 'true';
        $this->stamp = $_SERVER['STAMP'];
        $_SERVER['STAMP'] = __CLASS__ . '-' . $_SERVER['STAMP'];
        $this->ids = $_SERVER['unit_test_ids'];
        setContext($this->ids['context']);
    }

    function tearDown()
    {
        //delete your instance
        $_SERVER['STAMP'] = $this->stamp;
        unset($this->ids);
    }

//    function testPlaceOrderOldFormat()
//    {
//        $mmm = new MerchantMessageMapAdapter(getM());
//        $mmm_resource = Resource::find($mmm,null,[3=>['merchant_id'=>$this->ids['merchant_id']]]);
//        $mmm_resource->message_format = 'A';
//        $mmm_resource->save();
//
//        $user_resource = createNewUserWithCCNoCVV();
//        $user = logTestUserResourceIn($user_resource);
//        $merchant_id = $this->ids['merchant_id'];
//        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($merchant_id);
//        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,getTomorrowTwelveNoonTimeStampDenver());
//        $this->assertNull($checkout_resource->error);
//        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,0.00);
//        $this->assertNull($order_resource->error);
//        $order_id = $order_resource->order_id;
//
//        $task_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id, 'A');
//        $this->assertNotNull($task_message_resource,"It should have created a task message");
//        $task_message_controller = ControllerFactory::generateFromMessageResource($task_message_resource);
//        $result = $task_message_controller->sendThisMessage($task_message_resource);
//
//    }

    function testDeliveryWithAJTemplate()
    {
        $message_data = array("message_format" => 'AJ', "delivery_addr" => 'TaskRetail');
        $data['message_data'] = $message_data;
        $merchant_resource = createNewTestMerchantDelivery($this->ids['menu_id'], $data);
        $merchant_id = $merchant_resource->merchant_id;

        $data = array("merchant_id" => $merchant_resource->merchant_id);

        // now edit the distance price records.
        $mdpd = new MerchantDeliveryPriceDistanceAdapter(getM());
        $mdpd_resource = $mdpd->getExactResourceFromData($data);
        $mdpd_resource->distance_up_to = 10;
        $mdpd_resource->price = 5.00;
        $mdpd_resource->save();
        $mdpd_resource = $mdpd_resource->getRefreshedResource();


        $mtrima = new MerchantTaskRetailInfoMapAdapter(getM());
        Resource::createByData($mtrima, array("merchant_id" => $merchant_resource->merchant_id, "location" => 2, "brand_id" => getBrandIdFromCurrentContext(),'task_retail_url'=>'https://frdevapi.xchangefusion.com/api/v1/OnlineOrders','electronic_tip_media_id'=>97));

        $user_resource = createNewUserWithCCNoCVV();
        $user = logTestUserResourceIn($user_resource);
        $user_id = $user['user_id'];
        $udla = new UserDeliveryLocationAdapter(getM());
        $data = array("user_id" => $user_id, "address1" => "1633 18th street", "city" => "Boulder", "state" => "CO", "zip" => "80302", "phone_no" => "1234567890", "lat" => 40.016101, "lng" => -105.271900);
        $udla_resource = Resource::createByData($udla, $data);
        $udl_id = $udla_resource->user_addr_id;


        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($merchant_id,'delivery',null,2);
        $cart_data['user_addr_id'] = $udl_id;
        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,time());
        $this->assertNull($checkout_resource->error);
        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,0.00,time());

        $task_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_resource->order_id,'AJ');
        $this->assertNotNull($task_message_resource,"It should have created a task message");
        $task_message_controller = ControllerFactory::generateFromMessageResource($task_message_resource);

        $mr = $task_message_controller->prepMessageForSending($task_message_resource);
        $message_text = $mr->message_text;
        $message_as_array = json_decode($message_text,true);
        $this->assertTrue($message_as_array['IsDelivery']);
        $last_item = array_pop($message_as_array['Items']);
        $this->assertContains('Delivery Fee',$last_item['DisplayName']);
        $special_instructions = $last_item['SpecialInstructions'];
        $this->assertContains('1633 18th street',$special_instructions);
        $this->assertContains('Boulder',$special_instructions);
        $this->assertContains('123-456-7890',$special_instructions);

        $task_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_resource->order_id,'AJ');
        $task_message_controller = ControllerFactory::generateFromMessageResource($task_message_resource);
        $result = $task_message_controller->sendThisMessage($task_message_resource);
        $this->assertTrue($result);
    }

    function testTipWithAJTemplate()
    {
        $merchant_id = $this->ids['merchant_id'];

        $user_resource = createNewUserWithCCNoCVV();
        $user = logTestUserResourceIn($user_resource);
        $user_id = $user['user_id'];
        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($merchant_id,'pickup','the note',2);
        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,time());
        $this->assertNull($checkout_resource->error);
        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,8.88,time());
        $this->assertNull($order_resource->error);
        $this->assertEquals(8.88,$order_resource->tip_amt);

        $task_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_resource->order_id,'AJ');
        $this->assertNotNull($task_message_resource,"It should have created a task message");
        $task_message_controller = ControllerFactory::generateFromMessageResource($task_message_resource);

        $result = $task_message_controller->sendThisMessage($task_message_resource);

        $message_text = $task_message_controller->message_resource->message_text;
        $message_as_array = json_decode($message_text,true);
        $medias = $message_as_array['Medias'];
        $medias_hashmap = createHashmapFromArrayOfArraysByFieldName($medias,'MediaDescription');
        $tip_node = $medias_hashmap['Electronic Tips'];
        $this->assertNotNull($tip_node,"it should have the electronic tip node");
        $this->assertEquals(8.88,$tip_node['Value']);
        $this->assertTrue($result);


    }

    function testCurbSidePickupWithAJTemplate()
    {
        $merchant_id = $this->ids['merchant_id'];
        $mmma = new MerchantMenuMapAdapter(getM());
        $mmm_resource = Resource::find($mmma,null,[3=>['merchant_id'=>$merchant_id]]);
        $mmm_resource->allows_curbside_pickup = true;
        $mmm_resource->save();
        $user_resource = createNewUserWithCCNoCVV();
        $user = logTestUserResourceIn($user_resource);
        $user_id = $user['user_id'];
        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($merchant_id,'pickup','the note',2);
        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,time());
        $this->assertNull($checkout_resource->error);
        $checkout_resource->curbside_pickup = true;
        $checkout_resource->car_make = 'Delorian';
        $checkout_resource->car_color = 'Steel';
        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,0.00,time());
        $note = $order_resource->note;
        $this->assertContains('Curbside Pickup',$note);
        $this->assertContains('Steel Delorian',$note);
        $this->assertNull($order_resource->error);

        $task_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_resource->order_id,'AJ');
        $this->assertNotNull($task_message_resource,"It should have created a task message");
        $task_message_controller = ControllerFactory::generateFromMessageResource($task_message_resource);

        $result = $task_message_controller->sendThisMessage($task_message_resource);

        $message_text = $task_message_controller->message_resource->message_text;
        $message_as_array = json_decode($message_text,true);
        $special_instructions = $message_as_array['Items'][6]['SpecialInstructions'];
        $this->assertContains('Curbside Pickup',$special_instructions);
        $this->assertContains('Steel Delorian',$special_instructions);

        $this->assertTrue($result);



    }

    function testDoorDashWithAJTemplate()
    {
        include_once "lib/mocks/doordashcurl.php";
        $user_resource = createNewUserWithCCNoCVV();
        $user = logTestUserResourceIn($user_resource);
        $user_id = $user['user_id'];

        //outside
        $udla = new UserDeliveryLocationAdapter(getM());
        $data = array("user_id"=>$user_id,"address1"=>"450 main street","city"=>"Lyons","state"=>"CO","zip"=>"80540","phone_no"=>"1234567890","lat"=>40.224877,"lng"=> -105.271122);
        $udla_resource = Resource::createByData($udla, $data);
        $udl_id = $udla_resource->user_addr_id;
        $merchant_id = $this->ids['merchant_id'];

        $request = createRequestObject("/apiv2/merchants/$merchant_id/isindeliveryarea/$udl_id?log_level=5",'GET');
        $merchant_controller = new MerchantController(getM(), $user, $request, 5);
        $resource = $merchant_controller->processV2Request();
        $this->assertTrue($resource->is_in_delivery_range," the is in delivery range should be true");
        $this->assertEquals(DeliveryController::DELIVERY_FULLFILLED_BY_DOORDASH_MESSAGE,$resource->user_message);

        //make sure cache didn't happen
        $mudc_adatper = new UserDeliveryLocationMerchantPriceMapsAdapter(getM());
        $record = $mudc_adatper->getRecord(['user_delivery_location_id'=>$udl_id]);
        $this->assertNull($record,'A record should not have been created');


        $udl_id = $udla_resource->user_addr_id;

        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($merchant_id,'pickup','the note',2);
        $cart_data['user_addr_id'] = $udl_id;
        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,time());
        $this->assertNull($checkout_resource->error);
        //$this->assertEquals(5.60,$checkout_resource->delivery_amt);


        // since less than 5 items, delivery shoudl be the min lead time + 45 min
        $lead_times_array = $checkout_resource->lead_times_array;
        $expected_first_time_stamp = time() + 4200;
        $expected_first_time_string = date('Y-m-d H:i',$expected_first_time_stamp);
        $actual_first_time_string = date('Y-m-d H:i',$lead_times_array[0]);
        $this->assertEquals($expected_first_time_string,$actual_first_time_string,"first time should be 50 minutes after preptime");
        $this->assertCount(1,$lead_times_array);

        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,0.00,time());
        $this->assertNull($order_resource->error);

        $ready_timestamp = $order_resource->ready_timestamp;
        $ready_time_string = date('H:i',$ready_timestamp);
        $expected_ready_time_string = date('H:i',time() + 20*60); // now plus lead time for merchant
        $this->assertEquals($expected_ready_time_string,$ready_time_string);

        $full_ready_time_string = date('Y-m-d H:i:s',$ready_timestamp);
        $this->assertEquals($full_ready_time_string,$order_resource->pickup_dt_tm);

        $task_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_resource->order_id,'AJ');
        $this->assertNotNull($task_message_resource,"It should have created a task message");
        $task_message_controller = ControllerFactory::generateFromMessageResource($task_message_resource);

        $mr = $task_message_controller->prepMessageForSending($task_message_resource);
        $message_text = $mr->message_text;
        $message_as_array = json_decode($message_text,true);
        $this->assertNull($message_as_array['IsDelivery']);

        $task_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_resource->order_id,'AJ');
        $this->assertNotNull($task_message_resource,"It should have created a task message");
        $task_message_controller = ControllerFactory::generateFromMessageResource($task_message_resource);
        $result = $task_message_controller->sendThisMessage($task_message_resource);
        $this->assertTrue($result);
    }

    function testPromoWithTaskRetailJsonMessageFormat()
    {
        $merchant_id = $this->ids['merchant_id'];

        $promo_data = [];
        $promo_data['key_word'] = "The Type1 Promo,type1promo";
        $promo_data['promo_type'] = 1;
        $promo_data['description'] = 'Get 10% off';
        $promo_data['start_date'] = '2010-01-01';
        $promo_data['end_date'] = '2030-01-01';
        $promo_data['max_use'] = 100;
        $promo_data['allow_multiple_use_per_order'] = false;
        $promo_data['valid_on_first_order_only'] = 'N';
        $promo_data['order_type'] = 'pickup';
        $promo_data['merchant_id'] = $merchant_id;
//        $promo_data['message1'] = "Congratulations! You're getting $%%amt%% off your order!";
        $promo_data['qualifying_amt'] = 1.00;
        $promo_data['promo_amt'] = 00.00;
        $promo_data['percent_off'] = 10;
        $promo_data['max_amt_off'] = 50.00;
        $promo_data['brand_id'] = getBrandIdFromCurrentContext();

        $request = createRequestObject("/app2/admin/promo",'POST',json_encode($promo_data));
        $promo_controller = new PromoController(getM(),null,$request,5);
        $response = $promo_controller->createPromo();
        $promo_id = $response->promo_id;


        $user_resource = createNewUserWithCCNoCVV();
        $user = logTestUserResourceIn($user_resource);

        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($merchant_id);
        $cart_data['promo_code'] = 'type1promo';

        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,getTomorrowTwelveNoonTimeStampDenver());
        $this->assertNull($checkout_resource->error, "should not have an error");
        $checkout_resource->dine_in = true;
        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,0.00);
        $this->assertNull($order_resource->error, "should not have gotten an order error");
        $order_id = $order_resource->order_id;
        $this->assertEquals($promo_id,$order_resource->promo_id);
        $promo_amt = -$order_resource->promo_amt;

        $task_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id,'AJ');
        $this->assertNotNull($task_message_resource,"It should have created a task message");
        $task_message_controller = ControllerFactory::generateFromMessageResource($task_message_resource);
        $ready_to_send_message_resource = $task_message_controller->prepMessageForSending($task_message_resource);
        $body = $ready_to_send_message_resource->message_text;
        myerror_log($body);

        $body_as_array = json_decode($body,true);
        $this->assertEquals($promo_amt,$body_as_array['OnlineDiscounts'][0]['Value']);
        $this->assertEquals(1,$body_as_array['OrderTypeId'],"It Should have the orderTypeId as 1 since its a dine in order");
    }

    function testTheShakeFlavorThing()
    {
        $order_adapter = new OrderAdapter(getM());
        $sql = "UPDATE Item SET active = 'Y' WHERE item_id =  304512";
        $r = $order_adapter->_query($sql);
        $sql = "UPDATE Item_Size_Map SET active = 'Y', external_id = null WHERE item_id = 304512 AND size_id = 92319";
        $r = $order_adapter->_query($sql);

        $user_resource = createGuestUser();
        $user_resource->first_name = "Bob";
        $user_resource->flags = "1C200000021";
        $user_resource->last_four = '1234';
        $user_resource->save();
        $user = logTestUserResourceIn($user_resource);
        $user_id = $user['user_id'];


        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($this->ids['merchant_id']);

        $item = $cart_data['items'][0];
        $item['item_id'] = 304512;
        $item['size_id'] = 92319;
        $item['mods'] = array(array('modifier_item_id' => 2306400, "mod_quantity" => 1));
        $cart_data['items'][0] = $item;
        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,getTomorrowTwelveNoonTimeStampDenver());
        $this->assertNull($checkout_resource->error);
        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$this->ids['merchant_id'],0.00);
        $this->assertNull($order_resource->error, "should not have gotten an order error");
        return $order_resource->order_id;
    }

    /**
     * @depends testTheShakeFlavorThing
     */
    function testMessageFormat($order_id)
    {
        $merchant_id = $this->ids['merchant_id'];
        $complete_order = CompleteOrder::staticGetCompleteOrder($order_id, getM());

        $task_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id,'AJ');
        $this->assertNotNull($task_message_resource,"It should have created a task message");
        $task_message_controller = ControllerFactory::generateFromMessageResource($task_message_resource);
        $ready_to_send_message_resource = $task_message_controller->prepMessageForSending($task_message_resource);
        $body = $ready_to_send_message_resource->message_text;
        myerror_log($body);

        $body_as_array = json_decode($body,true);

        $this->assertCount(1,$body_as_array['Items']);
        $item = $body_as_array['Items'][0];

        $vanilla_shake_modifier_size_map_record = ModifierSizeMapAdapter::staticGetRecord(array('modifier_item_id' => 2306400, "size_id" => 92319, "merchant_id" => $this->ids['merchant_id']), 'ModifierSizeMapAdapter');
        $plu = $vanilla_shake_modifier_size_map_record['external_id'];
        $item_size_id = $complete_order['order_details'][0]['item_size_id'];
        $vanilla_shake_price_record = ItemSizeAdapter::staticGetRecordByPrimaryKey($item_size_id, 'ItemSizeAdapter');
        $vanilla_shake_price = $vanilla_shake_price_record['price'];

        $this->assertEquals($plu,$item['PLU'],"It should have the PLU of the modifier");
        $this->assertEquals($vanilla_shake_price,$item['Value'],"it should have the price of the shake item");
    }


    function testPlaceOrder()
    {
        $user_resource = createNewUserWithCCNoCVV();
        $user = logTestUserResourceIn($user_resource);
        $merchant_id = $this->ids['merchant_id'];
        $order_json = '{"user_id":"' . $user_resource->uuid . '","merchant_id":"' . $merchant_id . '","user_addr_id":null,"items":[{"item_id":"285100","quantity":"1","mods":{"0":{"modifier_item_id":"2306191","mod_quantity":"1","name":"Fresh White"}},"size_id":"92740","points_used":null,"brand_points_id":null,"note":null},{"item_id":"285113","quantity":"1","mods":{"0":{"modifier_item_id":"2307204","mod_quantity":"1","name":"Grilled"}},"size_id":"92314","points_used":null,"brand_points_id":null,"note":null}],"total_points_used":0}';

        $request = new Request();
        $request->url = '/app2/apiv2/cart/checkout';
        $request->method = "post";
        $request->mimetype = 'application/json';
        $request->body = $order_json;
        $place_order_controller = new PlaceOrderController(getM(), $user, $request);
        $place_order_controller->setCurrentTime(getTomorrowTwelveNoonTimeStampDenver());
        $checkout_resource = $place_order_controller->processV2Request();
        $this->assertNull($checkout_resource->error, "should not have an error");

        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,0.00);
        $this->assertNull($order_resource->error, "should not have gotten an order error");
        $order_id = $order_resource->order_id;
        return $order_id;
    }

    /**
     * @depends testPlaceOrder
     */
    function testSendOrderWithTaskAPIV2($order_id)
    {
        $task_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id,'AJ');
        $this->assertNotNull($task_message_resource,"It should have created a task message");
        $complete_order = CompleteOrder::staticGetCompleteOrder($order_id, getM());
        $task_message_controller = ControllerFactory::generateFromMessageResource($task_message_resource);
        $result = $task_message_controller->sendThisMessage($task_message_resource);

        $sent_task_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id,'AJ');
        $this->assertEquals('S',$sent_task_message_resource->locked,"It should have send the message");
        $base_order_data = CompleteOrder::getBaseOrderData($order_id);
        return $base_order_data['user_id'];
    }

    /**
     * @depends testSendOrderWithTaskAPIV2
     */
    function testTemplateWithExistingUser($user_id)
    {
        $user = logTestUserIn($user_id);
        $merchant_id = $this->ids['merchant_id'];
        $order_json = '{"user_id":"' . $user['uuid'] . '","merchant_id":"' . $merchant_id . '","user_addr_id":null,"items":[{"item_id":"285100","quantity":"1","mods":{"0":{"modifier_item_id":"2306191","mod_quantity":"1","name":"Fresh White"}},"size_id":"92740","points_used":null,"brand_points_id":null,"note":null},{"item_id":"285113","quantity":"1","mods":{"0":{"modifier_item_id":"2307204","mod_quantity":"1","name":"Grilled"}},"size_id":"92314","points_used":null,"brand_points_id":null,"note":null}],"total_points_used":0}';

        $request = new Request();
        $request->url = '/app2/apiv2/cart/checkout';
        $request->method = "post";
        $request->mimetype = 'application/json';
        $request->body = $order_json;
        $place_order_controller = new PlaceOrderController(getM(), $user, $request);
        $place_order_controller->setCurrentTime(getTomorrowTwelveNoonTimeStampDenver());
        $checkout_resource = $place_order_controller->processV2Request();
        $this->assertNull($checkout_resource->error, "should not have an error");

        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,0.00);
        $this->assertNull($order_resource->error, "should not have gotten an order error");
        $order_id = $order_resource->order_id;

        $task_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id,'AJ');
        $this->assertNotNull($task_message_resource,"It should have created a task message");
        $task_message_controller = ControllerFactory::generateFromMessageResource($task_message_resource);
        $ready_to_send_message_resource = $task_message_controller->prepMessageForSending($task_message_resource);
        $body = $ready_to_send_message_resource->message_text;
        myerror_log($body);

        $body_as_array = json_decode($body,true);
        $this->assertNotNull($body_as_array['MemberId'],'It should have added the memeber ID');
        $this->assertNull($body_as_array['PartialMember'],'It should not have the partial member node');
        $task_message_controller = ControllerFactory::generateFromMessageResource($task_message_resource);
        $result = $task_message_controller->sendThisMessage($task_message_resource);
        $this->assertTrue($result);

        $sent_task_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id,'AJ');
        $this->assertEquals('S',$sent_task_message_resource->locked,"It should have send the message");



    }

    /**
     * @expectedException NoMerchantTaskRetailLocationException
     */
    function testNoTaskRetailLocationException()
    {
        $menu_id = createTestMenuWithNnumberOfItems(1);
        $message_data = array("message_format" => 'AJ', "delivery_addr" => 'TaskRetail');
        $data['message_data'] = $message_data;
        $merchant_resource = createNewTestMerchant($menu_id, $data);
        $merchant_id = $merchant_resource->merchant_id;

        $user_resource = createNewUserWithCCNoCVV();
        $user = logTestUserResourceIn($user_resource);

        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($merchant_resource->merchant_id);
        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,getTomorrowTwelveNoonTimeStampDenver());
        $this->assertNull($checkout_resource->error, "should not have an error");

        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,0.00);
        $this->assertNull($order_resource->error, "should not have gotten an order error");
        $order_id = $order_resource->order_id;

        $task_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id,'AJ');
        $this->assertNotNull($task_message_resource,"It should have created a task message");
        $task_message_controller = ControllerFactory::generateFromMessageResource($task_message_resource);
        $result = $task_message_controller->sendThisMessage($task_message_resource);

    }

    static function setUpBeforeClass()
    {
        include_once "lib/mocks/doordashcurl.php";
        $_SERVER['request_time1'] = microtime(true);
        $_SERVER['NO_MOCKS'] = true;
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));

        $menu_id = 102547;
        $brand_id = 372;
        $menu_adapter = new MenuAdapter(getM());
        if ($menu_adapter->getRecord(array("menu_id" => $menu_id))) {
            ; // do nothing
        } else {
            //create menu
            $menu_adapter->importMenu($menu_id, 'prod', 'local', $brand_id);
        }


        //mysql_query("BEGIN");

        $skin_id = 114;
        $name = "Fuddruckers";
        $skin_resource = getOrCreateSkinAndBrandIfNecessaryWithLoyalty($name, $name, $skin_id, $brand_id);
        $skin_resource->show_notes_field = 0;
        $skin_resource->save();
        setContext('com.splickit.fuddruckers');
        $ids['context'] = "com.splickit.$name";
        $ids['brand_id'] = $brand_id;
        $ids['skin_id'] = $skin_id;

        //map it to a menu
        $ids['menu_id'] = $menu_id;

        $message_data = array("message_format" => 'AJ', "delivery_addr" => 'TaskRetail');
        $data['message_data'] = $message_data;
        $merchant_resource = createNewTestMerchant($menu_id, $data);
        $merchant_resource->delivery = 'Y';
        $merchant_resource->save();
        MerchantMenuMapAdapter::createMerchantMenuMap($merchant_resource->merchant_id, $ids['menu_id'], 'delivery');

        // set merchant delivery info
        $data = array("merchant_id" => $merchant_resource->merchant_id);
        $mdia = new MerchantDeliveryInfoAdapter(getM());
        $mdia_resource = $mdia->getExactResourceFromData($data);
        $mdia_resource->minimum_order = 0.01;
        $mdia_resource->delivery_price_type = 'Doordash';
        $mdia_resource->delivery_cost = 1.00;
        $mdia_resource->delivery_increment = 15;
        $mdia_resource->max_days_out = 3;
        $mdia_resource->save();

// now edit the distance price records.
        $mdpd = new MerchantDeliveryPriceDistanceAdapter(getM());
        $mdpd_resource = $mdpd->getExactResourceFromData($data);
        $mdpd_resource->name = 'Doordash';
        $mdpd_resource->distance_up_to = 100;
        $mdpd_resource->price = 5.00;
        $mdpd_resource->notes = 'external_business_name=sumdumbiz';
        $mdpd_resource->save();


        attachMerchantToSkin($merchant_resource->merchant_id, $ids['skin_id']);
        $ids['merchant_id'] = $merchant_resource->merchant_id;
        $mtrima = new MerchantTaskRetailInfoMapAdapter(getM());
        Resource::createByData($mtrima, array("merchant_id" => $merchant_resource->merchant_id, "location" => 2, "brand_id" => $brand_id,'task_retail_url'=>'https://frdevapi.xchangefusion.com/api/v1/OnlineOrders','electronic_tip_media_id'=>97));


        $user_resource = createNewUser(array("flags" => "1C20000001"));
        $ids['user_id'] = $user_resource->user_id;

        $complete_menu = CompleteMenu::getCompleteMenu($menu_id, 'Y', 0, 2, 'pickup');
        $complete_menu_menu_type_hash = createHashmapFromArrayOfArraysByFieldName($complete_menu['menu_types'], 'menu_type_name');
        $ids['menu'] = $complete_menu_menu_type_hash;

        $_SERVER['log_level'] = 5;
        $_SERVER['unit_test_ids'] = $ids;
    }

  static function tearDownAfterClass()
  {
    //mysqli_query("ROLLBACK");
    date_default_timezone_set($_SERVER['starting_tz']);
  }

    /* mail method for testing */
    static function main()
    {
        $suite = new PHPUnit_Framework_TestSuite(__CLASS__);
        PHPUnit_TextUI_TestRunner::run($suite);
    }

}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    TaskRetailPOSTest::main();
}

?>