<?php
error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');
$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;

require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';


class VivonetDiscountOrderTest extends PHPUnit_Framework_TestCase
{
    var $stamp;
    var $ids;

    function setUp()
    {
        $_SERVER['HTTP_NO_CC_CALL'] = 'true';
        $_SERVER['DO_NOT_RUN_CC'] = 'true';
        $this->stamp = $_SERVER['STAMP'];
        $_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
        $this->ids = $_SERVER['unit_test_ids'];
        setContext('com.splickit.vivoskin');

    }

    function testVariablePromo()
    {
        $merchant_id = $this->ids['merchant_id'];

        $promo_data = [];
        $promo_data['key_word'] = 'variable';
        $promo_data['promo_type'] = 6;
        $promo_data['description'] = 'LU discount';
        $promo_data['start_date'] = '2010-01-01';
        $promo_data['end_date'] = '2030-01-01';
        $promo_data['max_use'] = 1000;
        $promo_data['brand_id'] = getBrandIdFromCurrentContext();
        $request = createRequestObject("/app2/admin/promo",'POST',json_encode($promo_data));
        $promo_controller = new PromoController(getM(),null,$request,5);
        $promo_resource = $promo_controller->createPromo();
        $key_word = $promo_resource->promo_key_words[0]->promo_key_word;

        $user_resource = createNewUserWithCCNoCVV();
        $user_resource->flags = '1000000001';
        $user_resource->save();
        $user = logTestUserResourceIn($user_resource);
        $order_data = OrderAdapter::getSimpleCartArrayByMerchantId($merchant_id,'pickup','the note',5);
//        $order_data['promo_code'] = $key_word;
//        $order_data['variable_promo_amt'] = 2.88;

        $pre_checkout_resource = getCheckoutResourceFromOrderData($order_data,getTomorrowTwelveNoonTimeStampDenver());
        $cart_ucid = $pre_checkout_resource->ucid;
        $this->assertNull($pre_checkout_resource->error);
        $pre_tax_amt = $pre_checkout_resource->total_tax_amt;
        $this->assertEquals(0.00,$pre_checkout_resource->promo_tax_amt);
        $this->assertEquals(0.00,$pre_checkout_resource->promo_amt);

        $order_data_promo['promo_code'] = $key_word;
        $order_data_promo['variable_promo_amt'] = 2.88;

        $request = createRequestObject("/app2/apiv2/cart/$cart_ucid/checkout", 'post', json_encode($order_data_promo), 'application/json');
        $place_order_controller = new PlaceOrderController(getM(), $user, $request);
        $place_order_controller->setCurrentTime(getTomorrowTwelveNoonTimeStampDenver());

        $promo_checkout_resource = makeMockRequest($place_order_controller);
        //$promo_checkout_resource = $place_order_controller->processV2Request();
        $this->assertNull($promo_checkout_resource->error);
        $this->assertNull($promo_checkout_resource->error);
        $this->assertEquals(-2.88,$promo_checkout_resource->promo_amt);
        $post_tax_amt = $promo_checkout_resource->total_tax_amt;
        $promo_tax_amt = $promo_checkout_resource->promo_tax_amt;
        $this->assertEquals(-.29,$promo_tax_amt);
        $this->assertEquals($pre_tax_amt+$promo_tax_amt, $post_tax_amt);


        $order_data2 = OrderAdapter::getSimpleCartArrayByMerchantId($merchant_id);
//        $order_data2['promo_code'] = $key_word;
//        $order_data2['variable_promo_amt'] = 2.88;
        $request = createRequestObject("/app2/apiv2/cart/$cart_ucid/checkout", 'post', json_encode($order_data2), 'application/json');
        $place_order_controller = new PlaceOrderController(getM(), $user, $request);
        $place_order_controller->setCurrentTime(getTomorrowTwelveNoonTimeStampDenver());
        $new_checkout_resource = $place_order_controller->processV2Request();
        $this->assertNull($new_checkout_resource->error);
        $this->assertEquals(0.00,$new_checkout_resource->promo_amt);
        $this->assertNull($new_checkout_resource->promo_code);

        // now hit it back in again
        $order_data3['promo_code'] = $key_word;
        $order_data3['variable_promo_amt'] = 2.88;
        $request = createRequestObject("/app2/apiv2/cart/$cart_ucid/checkout", 'post', json_encode($order_data3), 'application/json');
        $place_order_controller = new PlaceOrderController(getM(), $user, $request);
        $place_order_controller->setCurrentTime(getTomorrowTwelveNoonTimeStampDenver());
        $final_checkout_resource = $place_order_controller->processV2Request();
        $this->assertNull($final_checkout_resource->error);

        $this->assertEquals(-2.88,$final_checkout_resource->promo_amt);

        $order_resource = placeOrderFromCheckoutResource($final_checkout_resource);
        $this->assertNull($order_resource->error);

        $this->assertEquals(-2.88,$order_resource->promo_amt);
        $this->assertEquals($promo_resource->promo_id,$order_resource->promo_id);
        $this->assertEquals('variable',$order_resource->promo_code);

        return $promo_resource;

    }

    function testGetCheckoutWithoutPromo()
    {
        $message_format = 'V2';
        $merchant_id = $this->ids['merchant_id'];

        $user_resource = createNewUserWithCCNoCVV();
        $user = logTestUserResourceIn($user_resource);
        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($merchant_id,'pickup','the note',2);
        $request = createRequestObject('app2/apiv2/cart/checkout','post',json_encode($cart_data),'application/json');
        $place_order_controller = new PlaceOrderController(getM(),$user,$request,5);
        $checkout_resource = $place_order_controller->processV2Request();
        $this->assertNull($checkout_resource->error,"It should not throw an error");
        $tax = $checkout_resource->total_tax_amt;

        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$this->ids['merchant_id'],1.00,time());
        $this->assertNull($order_resource->error);
        $order_id = $order_resource->order_id;

        $vivonet_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id, "$message_format");
        $this->assertNotNull($vivonet_message_resource);

        $vivonet_controller = ControllerFactory::generateFromMessageResource($vivonet_message_resource);
        $ready_to_send_message_resource = $vivonet_controller->prepMessageForSending($vivonet_message_resource);
        $message_text = $ready_to_send_message_resource->message_text;
        myerror_log("vivonet message text: ".$message_text);

        $this->assertContains('"charges":[{"amount":1,"chargeId":12345,"name":"SERVICETIP"}]',$message_text);
        return $tax;
    }

    /**
     * @depends testGetCheckoutWithoutPromo
     */
    function testGetPromoChargeBrokenUp($tax)
    {
        $message_format = 'V2';
        $merchant_id = $this->ids['merchant_id'];

        $promo_type1_amt_map_adapter = new PromoType1AmtMapAdapter(getM());
        $promo_amount_map_resource = Resource::find( $promo_type1_amt_map_adapter,$this->ids['promo_amount_map_resource_id']);
        $promo_amt = 1.27;
        $promo_amount_map_resource->promo_amt = $promo_amt;
        $promo_amount_map_resource->save();
        $user_resource = createNewUserWithCCNoCVV();
        $user = logTestUserResourceIn($user_resource);
        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($merchant_id,'pickup','the note',2);
        $cart_data['promo_code'] = 'type1promo';
        $request = createRequestObject('app2/apiv2/cart/checkout','post',json_encode($cart_data),'application/json');
        $place_order_controller = new PlaceOrderController(getM(),$user,$request,5);
        $checkout_resource = $place_order_controller->processV2Request();
        $this->assertNull($checkout_resource->error,"It should not throw an error");
        $this->assertEquals("type1promo",$checkout_resource->promo_code);
        $this->assertTrue($checkout_resource->promo_amt < 0.00,"It should have a negative promo amt");
        $post_promo_amt = $checkout_resource->promo_amt;
        $this->assertEquals(-$promo_amt,$post_promo_amt);

        $post_order_amt = $checkout_resource->order_amt;
        $expected_taxable_subtotal = $post_order_amt - $promo_amt;
        $post_tax_total = $checkout_resource->total_tax_amt;

        $this->assertTrue($tax > ($post_tax_total+.02));


        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$this->ids['merchant_id'],1.00,time());
        $this->assertNull($order_resource->error);
        $order_id = $order_resource->order_id;
        $this->assertTrue($order_id > 1000);
        $this->assertNull($order_resource->error);

        $vivonet_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id, "$message_format");
        $this->assertNotNull($vivonet_message_resource);

        $vivonet_controller = ControllerFactory::generateFromMessageResource($vivonet_message_resource);
        $ready_to_send_message_resource = $vivonet_controller->prepMessageForSending($vivonet_message_resource);
        $message_text = $ready_to_send_message_resource->message_text;
        myerror_log("vivonet message text: ".$message_text);

        $this->assertContains('"charges":[{"amount":1,"chargeId":12345,"name":"SERVICETIP"}]',$message_text);
        $this->assertContains('"discountId":38244,"value":1',$message_text);
        $this->assertContains('"discountId":38245,"value":0.25',$message_text);
        $this->assertContains('"discountId":38248,"value":0.01',$message_text);


        $this->assertContains('"discounts":[{"discountName":"LevelUp Promo","discountType":"amount","price":-1,"discountId":38244,"value":1},{"discountName":"LevelUp Promo","discountType":"amount","price":-0.25,"discountId":38245,"value":0.25},{"discountName":"LevelUp Promo","discountType":"amount","price":-0.01,"discountId":38248,"value":0.01},{"discountName":"LevelUp Promo","discountType":"amount","price":-0.01,"discountId":38248,"value":0.01}]',$message_text);
        $this->assertNotContains('"discountName":"type1promo"',$message_text);

    }

    function testNoTaxForFullDiscount()
    {
        $message_format = 'V2';
        $merchant_id = $this->ids['merchant_id'];

        $promo_type1_amt_map_adapter = new PromoType1AmtMapAdapter(getM());
        $promo_amount_map_resource = Resource::find( $promo_type1_amt_map_adapter,$this->ids['promo_amount_map_resource_id']);
        $promo_amt = 5.00;
        $promo_amount_map_resource->promo_amt = $promo_amt;
        $promo_amount_map_resource->save();
        $user_resource = createNewUserWithCCNoCVV();
        $user = logTestUserResourceIn($user_resource);
        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($merchant_id,'pickup','the note',1);
        $cart_data['promo_code'] = 'type1promo';
        $request = createRequestObject('app2/apiv2/cart/checkout','post',json_encode($cart_data),'application/json');
        $place_order_controller = new PlaceOrderController(getM(),$user,$request,5);
        $checkout_resource = $place_order_controller->processV2Request();
        $this->assertNull($checkout_resource->error,"It should not throw an error");
        $this->assertEquals("type1promo",$checkout_resource->promo_code);
        $this->assertEquals(-3.00,$checkout_resource->promo_amt,"It should be a promo amount equal to the price of the item");
        $this->assertEquals(0.00,$checkout_resource->total_tax_amt);

        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$this->ids['merchant_id'],1.25,time());
        $this->assertNull($order_resource->error);
        $order_id = $order_resource->order_id;
        $this->assertTrue($order_id > 1000);

        $vivonet_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id, "$message_format");
        $this->assertNotNull($vivonet_message_resource);

        $vivonet_controller = ControllerFactory::generateFromMessageResource($vivonet_message_resource);
        $ready_to_send_message_resource = $vivonet_controller->prepMessageForSending($vivonet_message_resource);
        $message_text = $ready_to_send_message_resource->message_text;
        myerror_log("vivonet message text: ".$message_text);

        $this->assertContains('"charges":[{"amount":1.25,"chargeId":12345,"name":"SERVICETIP"}]',$message_text);
        $this->assertContains('"discountId":38244,"value":1',$message_text);


        $this->assertContains('"discounts":[{"discountName":"LevelUp Promo","discountType":"amount","price":-1,"discountId":38244,"value":1},{"discountName":"LevelUp Promo","discountType":"amount","price":-1,"discountId":38244,"value":1},{"discountName":"LevelUp Promo","discountType":"amount","price":-1,"discountId":38244,"value":1}]',$message_text);
        $this->assertNotContains('"discountName":"type1promo"',$message_text);

    }
    function tearDown()
    {
        //delete your instance
        $_SERVER['STAMP'] = $this->stamp;
        unset($this->ids);
    }

    function assignThirdPartyValues($vivonet_data)
    {
        $tpppa = new ThirdPartyProviderParametersAdapter(getM());
        $parameters = $tpppa->getParametersFromProviderId(1003);
        $tpppmma = new ThirdPartyProviderParameterMerchantMapsAdapter(getM());
        foreach ($parameters as $parameter_row) {
            $data = [];
            $data['third_party_provider_parameter_id'] = $parameter_row['third_party_provider_parameter_id'];
            $data['merchant_id'] = $vivonet_data['merchant_id'];
            $parameter_name = $parameter_row['name'];
            switch ($parameter_name) {
                case "store_id":
                    $data['value'] =  $vivonet_data['store_id'];
                    Resource::createByData($tpppmma,$data);
                    break;
                case "merchant_key":
                    $data['value'] = '736de47f4cdee9e8fe9ab8a0bc0eb37e';
                    Resource::createByData($tpppmma,$data);
                    break;
                case "promo_charge_id_001":
                    $data['value'] = '38248';
                    Resource::createByData($tpppmma,$data);
                    break;
                case "promo_charge_id_005":
                    $data['value'] = '38247';
                    Resource::createByData($tpppmma,$data);
                    break;
                case "promo_charge_id_010":
                    $data['value'] = '38246';
                    Resource::createByData($tpppmma,$data);
                    break;
                case "promo_charge_id_025":
                    $data['value'] = '38245';
                    Resource::createByData($tpppmma,$data);
                    break;
                case "promo_charge_id_100":
                    $data['value'] = '38244';
                    Resource::createByData($tpppmma,$data);
                    break;
                default:
                    if ($value = $vivonet_data[$parameter_name]) {
                        $data['value'] = $value;
                        Resource::createByData($tpppmma,$data);
                    }
            }
        }
    }

    static function setUpBeforeClass()
    {
        $code = setNewStamp();

        $_SERVER['request_time1'] = microtime(true);
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));
        ini_set('max_execution_time', 300);

        $skin_resource = getOrCreateSkinAndBrandIfNecessary('vivoskin','vivobrand',null,null);
        $skin_id = $skin_resource->skin_id;
        $brand_id = $skin_resource->brand_id;
        setContext('com.splickit.vivoskin');
        $ids['skin_id'] = getSkinIdForContext();
        $ids['brand_id'] = $brand_id;
        //map it to a menu
        $menu_id = createTestMenuWithNnumberOfItems(1);
        $ids['menu_id'] = $menu_id;

        $item_sizes = CompleteMenu::getAllItemSizesAsResources($menu_id,0);
        $item_size = $item_sizes[0];
        $item_size->external_id = '8357880';
        $item_size->price = '3.0';
        $item_size->save();


        $item_resource = Resource::find(new ItemAdapter(getM()),$item_size->item_id);
        $item_resource->item_name = "Banana Muffin";
        $item_resource->item_print_name = "Banana Muffin";
        $item_resource->save();

        $merchant_resource = createNewTestMerchant($menu_id);
        $mvima_data = ['merchant_id'=>$merchant_resource->merchant_id,'store_id'=>161668,'promo_charge_id'=>88888,'tender_id'=>436,'service_tip_id'=>12345];
        VivonetDiscountOrderTest::assignThirdPartyValues($mvima_data);

        attachMerchantToSkin($merchant_resource->merchant_id, $ids['skin_id']);
        $ids['merchant_id'] = $merchant_resource->merchant_id;
        $map_resource = MerchantMessageMapAdapter::createMerchantMessageMap($merchant_resource->merchant_id, 'V2', 'vivonet', 'X');


        $promo_adapter = new PromoAdapter(getM());
        $promo_id = 111;
        $ids['promo_id'] = $promo_id;
        if ($promo_resource = Resource::find($promo_adapter,$promo_id)) {
            $pmm_resource = Resource::createByData(new PromoMerchantMapAdapter(getM()), array("merchant_id"=>$merchant_resource->merchant_id,"promo_id"=>$promo_id));
        } else {
            $ids['promo_id_type_1'] = $promo_id;
            $sql = "INSERT INTO `Promo` VALUES($promo_id, 'The Type1 Promo', 'Get Up to $5 off', 1, 'Y', 'N', 0, 2, 'N', 'N','all', '2010-01-01', '2030-01-01', 100000,FALSE, 0, 0.00, 0, 0.00, 'Y', 'N', 0,$brand_id, NOW(), NOW(), 'N')";
            $promo_adapter->_query($sql);
            $pmm_resource = Resource::createByData(new PromoMerchantMapAdapter(getM()), array("merchant_id"=>$merchant_resource->merchant_id,"promo_id"=>$promo_id));
            $ids['promo_merchant_map_id_type_1'] = $pmm_resource->map_id;
            $sql = "INSERT INTO `Promo_Message_Map` VALUES(null, $promo_id, 'Congratulations! You''re getting %%amt%% off your order!', NULL, NULL, NULL, NULL, now())";
            $promo_adapter->_query($sql);
            $sql = "INSERT INTO `Promo_Type1_Amt_Map` VALUES(null, $promo_id, 1.00, 1.27, 0,50.00, NOW())";
            $promo_adapter->_query($sql);
            $pkwm_adapter = new PromoKeyWordMapAdapter($m);
            Resource::createByData($pkwm_adapter, array("promo_id"=>$promo_id,"promo_key_word"=>"type1promo","brand_id"=>getBrandIdFromCurrentContext()));
            $promo_resource = Resource::find($promo_adapter,$promo_id);
        }
        $ids['promo_resource'] = $promo_resource;

        $promo_type1_amt_map_adapter = new PromoType1AmtMapAdapter(getM());
        $promo_amount_map_resource = Resource::find( $promo_type1_amt_map_adapter,null,[3=>['promo_id'=>$promo_id]]);
        $ids['promo_amount_map_resource_id'] = $promo_amount_map_resource->map_id;

        $user_resource = createNewUser(array("flags" => "1C20000001"));
        $ids['user_id'] = $user_resource->user_id;

        $_SERVER['log_level'] = 5;
        $_SERVER['unit_test_ids'] = $ids;

    }

    static function tearDownAfterClass()
    {
        date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main() {
        $suite = new PHPUnit_Framework_TestSuite( __CLASS__);
        PHPUnit_TextUI_TestRunner::run( $suite);
    }

}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    VivonetDiscountOrderTest::main();
}

?>