<?php
error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');
$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;

require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';


class VivonetOrderTest extends PHPUnit_Framework_TestCase
{
    var $stamp;
    var $ids;

    function setUp()
    {
        $_SERVER['HTTP_NO_CC_CALL'] = 'true';
        $_SERVER['DO_NOT_RUN_CC'] = 'true';
        $this->stamp = $_SERVER['STAMP'];
        $_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
        $this->ids = $_SERVER['unit_test_ids'];

    }

    function tearDown()
    {
        //delete your instance
        $_SERVER['STAMP'] = $this->stamp;
        unset($this->ids);
    }

//    function testStageImportForAllVivonetMerchants()
//    {
//
//
//        $doit_ts = time()-2;
//        $alphanumeric = $this->ids['merchant_resource']->alphanumeric_id;
//        $info = "object=VivonetImporter;method=importEntireSystem";
//        $activity_history_adapter = new ActivityHistoryAdapter(getM());
//        $activity_history_resource = $activity_history_adapter->createActivityReturnActivityResource('VivonetImport', $doit_ts, $info, '',60*60*24);
//        $this->assertNotNull($activity_history_resource);
//
//        removeContext();
//
//        $activity_history_resource->locked = 'Y';
//        $activity_history_resource->save();
//        $activity = SplickitActivity::getActivity($activity_history_resource);
//        $result = $activity->doit();
//        $this->assertCount(1,$result,"There should have been one imported merchant");
//
//        // now test the import
//        $activity_id = $result[0];
//        $activity_history_resource = Resource::find($activity_history_adapter,"$activity_id");
//        $this->assertNotNull($activity_history_resource);
//        $activity_history_resource->locked = 'Y';
//        $activity_history_resource->save();
//        $activity = SplickitActivity::getActivity($activity_history_resource);
//        $result = $activity->doit();
//
//    }

    function testDiscountWithTax()
    {

    }

    function testGetLevelUpDiscountId()
    {
        $vivonet_service = new VivonetService(array("merchant_id"=>$this->ids['merchant_id']));
        $levelup_discount_id = $vivonet_service->getLevelUpDiscount();
        $this->assertNotNull($levelup_discount_id,"It should have returned a levelup_discount_id");
        $this->assertTrue(is_numeric($levelup_discount_id),"It should have returned the tender id for the store");
        $this->assertEquals(11237997,$levelup_discount_id);
    }

    function testGetTipDiscountId()
    {
        $vivonet_service = new VivonetService(array("merchant_id"=>$this->ids['merchant_id']));
        $service_tip_id = $vivonet_service->getServiceTipIdForStore();
        $this->assertNotNull($service_tip_id,"It should have returned a tender id");
        $this->assertTrue(is_numeric($service_tip_id),"It should have returned the tender id for the store");
    }



    function testGetProductIds()
    {
        $vivonet_controller = new VivonetController(getM(),null,$r,5);
        $ids = $vivonet_controller->getProductIdsForMerchant($this->ids['merchant_id']);
    }

    function testGetTenderIds()
    {
        $vivonet_controller = new VivonetController(getM(),null,$r,5);
        $tender_id = $vivonet_controller->getTenderIdForMerchant($this->ids['merchant_id']);
        $this->assertNotNull($tender_id,"It should have returned a tender id");
        $this->assertTrue(is_numeric($tender_id),"It should have returned the tender id for the store");
    }

//    function testStageImport()
//    {
//
//
//            $doit_ts = time()-2;
//            $alphanumeric = $this->ids['merchant_resource']->alphanumeric_id;
//            $info = "object=VivonetImporter;method=import;thefunctiondatastring=pos/import/vivonet/$alphanumeric";
//            $activity_history_adapter = new ActivityHistoryAdapter(getM());
//            $activity_history_resource = $activity_history_adapter->createActivityReturnActivityResource('ExecuteObjectFunction', $doit_ts, $info, '',60*60*24);
//            $this->assertNotNull($activity_history_resource);
//
//            removeContext();
//
//            $activity_history_resource->locked = 'Y';
//            $activity_history_resource->save();
//            $activity = SplickitActivity::getActivity($activity_history_resource);
//            $result = $activity->doit();
//
//    }

    function testLoadImporter()
    {
        $mr = $this->ids['merchant_resource']->getDataFieldsReally();
        unset($mr['_adapter']);
        $alphanumeric = $this->ids['merchant_resource']->alphanumeric_id;
        removeContext();
        $vivonet_importer = ImporterFactory::getImporterFromUrl("http://localhost/app2/apiv2/pos/import/vivonet/$alphanumeric");
        $this->assertEquals('VivonetImporter',get_class($vivonet_importer),"It should have returned a vivonet importer");
        $imr = $vivonet_importer->getLoadedMerchantResource()->getDataFieldsReally();
        unset($imr['_adapter']);
        $this->assertEquals($mr,$imr,"it should have loaded the merchant resource");
        $this->assertEquals($this->ids['menu_id'],$vivonet_importer->getMenuId(),"It should have the menu_id of the loaded merchant");
    }
    
    function testGetRemoteData()
    {
        removeContext();
        $alphanumeric = $this->ids['merchant_resource']->alphanumeric_id;
        $vivonet_importer = ImporterFactory::getImporterFromUrl("http://localhost/app2/apiv2/pos/import/vivonet/$alphanumeric");
        $response = $vivonet_importer->callServiceForRemoteData($this->ids['merchant_resource']);
        $this->assertTrue(is_array($response),"Should have returned an array of the imported price records");
        $this->assertTrue(count($response) > 100,"It should have a LOT of prices");
    }

    function testLoadPricesForMerchant()
    {
        removeContext();
        $ids = $this->ids;
        $menu_id = $ids['menu_id'];
        $alphanumeric = $this->ids['merchant_resource']->alphanumeric_id;
        $vivonet_importer = ImporterFactory::getImporterFromUrl("http://localhost/app2/apiv2/pos/import/vivonet/$alphanumeric");
        $this->assertTrue($vivonet_importer->importRemoteMerchantMetaDataForLoadedMerchant());

        //$menu = CompleteMenu::getCompleteMenu($this->ids['menu_id'],'Y',$this->ids['merchant_id'],2,'pickup');
        $complete_menu = new CompleteMenu($menu_id);
        $item_sizes = $complete_menu->getAllMenuItemSizePrices($menu_id,'Y',$ids['merchant_id'],$m);
        $count = sizeof($item_sizes);
        $this->assertTrue($count>10,"It shoudl have imported a bunch of prices for the merchant but it only imported: $count");

//        CompleteMenu::getAllMenuItemsAsArray($menu_id, 'Y', E$);
    }


    function testPromoWithVivonetOrder()
    {
        $user = logTestUserResourceIn($this->ids['user_resource']);
        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($this->ids['merchant_id']);
        $cart_data['items'][0]['mods'] = [$cart_data['items'][0]['mods'][0]];
        $request = createRequestObject('app2/apiv2/cart/checkout','post',json_encode($cart_data),'application/json');
        $place_order_controller = new PlaceOrderController(getM(),$user,$request,5);
        $no_promo_checkout_resource = $place_order_controller->processV2Request();
        $this->assertNull($no_promo_checkout_resource->error);
        $pre_grand_total = $no_promo_checkout_resource->grand_total;
        $pre_tax_total = $no_promo_checkout_resource->total_tax_amt;
        $complete_order = CompleteOrder::staticGetCompleteOrder($no_promo_checkout_resource->oid_test_only,getM());
        $splickit_sub_total = $complete_order['order_details'][0]['item_total_w_mods'];
        $ucid = $no_promo_checkout_resource->ucid;
        $request = createRequestObject("app2/apiv2/cart/$ucid/checkout?promo_code=type1promo","GET");
        $place_order_controller = new PlaceOrderController(getM(),$user,$request,5);
        $place_order_controller->setCurrentTime(getTomorrowTwelveNoonTimeStampDenver());
        $checkout_resource = $place_order_controller->processV2Request();
        $this->assertNull($checkout_resource->error,"It should not throw an error");
        $this->assertEquals("type1promo",$checkout_resource->promo_code);
        $this->assertTrue($checkout_resource->promo_amt < 0.00,"It should have a negative promo amt");
        $post_grand_total = $checkout_resource->grand_total;
        $post_tax_total = $checkout_resource->total_tax_amt;
        $post_order_amt = $checkout_resource->order_amt;
        $post_promo_amt = $checkout_resource->promo_amt;
        $order_sum = $post_order_amt+$post_promo_amt+$post_tax_total;
        $this->assertEquals($post_grand_total,$order_sum,"the grand total should replect the amounts");

        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$this->ids['merchant_id'],1.00,time());
        $this->assertNull($order_resource->error);
        $order_id = $order_resource->order_id;
        $this->assertTrue($order_id > 1000);
        $this->assertNull($order_resource->error);

        $vivonet_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id, 'V');
        $this->assertNotNull($vivonet_message_resource);

        $vivonet_controller = ControllerFactory::generateFromMessageResource($vivonet_message_resource);
        $ready_to_send_message_resource = $vivonet_controller->prepMessageForSending($vivonet_message_resource);
        $message_text = $ready_to_send_message_resource->message_text;
        myerror_log("vivonet message text: ".$message_text);

        $this->assertContains('"charges":[{"amount":1,"chargeId":8984323,"name":"SERVICETIP"},{"amount":-0.8,"chargeId":10698157,"name":"SERVICETIP"}]',$message_text);
        $this->assertNotContains('"discountName":"type1promo"',$message_text);

        $this->assertTrue($vivonet_controller->sendThisMessage($vivonet_message_resource));
        $this->assertFalse($vivonet_controller->hasMessagingError(),'It should not have a messaging error: '.$vivonet_controller->getErrorMessage());

        $message_history_record = MerchantMessageHistoryAdapter::staticGetRecordByPrimaryKey($vivonet_message_resource->map_id,'MerchantMessageHistoryAdapter');
        $this->assertNotNull($message_history_record['message_text'],"should have recorded the sent payload");
        $this->assertNotNull($message_history_record['response'],"should have recorded the response payload");


    }

    function testVariablePromoWithVivonetOrder()
    {
        $promo_data = [];
        $promo_data['key_word'] = 'variable';
        $promo_data['promo_type'] = 6;
        $promo_data['description'] = 'LU discount';
        $promo_data['start_date'] = '2010-01-01';
        $promo_data['end_date'] = '2020-01-01';
        $promo_data['max_use'] = 1000;
        $promo_data['brand_id'] = getBrandIdFromCurrentContext();
        $request = createRequestObject("/app2/admin/promo",'POST',json_encode($promo_data));
        $promo_controller = new PromoController(getM(),null,$request,5);
        $promo_resource = $promo_controller->createPromo();
        $key_word = $promo_resource->promo_key_words[0]->promo_key_word;


        $user = logTestUserResourceIn($this->ids['user_resource']);
        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($this->ids['merchant_id']);
        $cart_data['items'][0]['mods'] = [$cart_data['items'][0]['mods'][0]];
        $cart_data['promo_code'] = $key_word;
        $cart_data['variable_promo_amt'] = 1.00;

        $request = createRequestObject('app2/apiv2/cart/checkout','post',json_encode($cart_data),'application/json');
        $place_order_controller = new PlaceOrderController(getM(),$user,$request,5);
        $place_order_controller->setCurrentTime(getTomorrowTwelveNoonTimeStampDenver());


//        $no_promo_checkout_resource = $place_order_controller->processV2Request();
//        $this->assertNull($no_promo_checkout_resource->error);
//        $pre_grand_total = $no_promo_checkout_resource->grand_total;
//        $pre_tax_total = $no_promo_checkout_resource->total_tax_amt;
//        $complete_order = CompleteOrder::staticGetCompleteOrder($no_promo_checkout_resource->oid_test_only,getM());
//        $splickit_sub_total = $complete_order['order_details'][0]['item_total_w_mods'];
//        $ucid = $no_promo_checkout_resource->ucid;
//        $request = createRequestObject("app2/apiv2/cart/$ucid/checkout?promo_code=type1promo","GET");
//        $place_order_controller = new PlaceOrderController(getM(),$user,$request,5);
//        $place_order_controller->setCurrentTime(getTomorrowTwelveNoonTimeStampDenver());


        $checkout_resource = $place_order_controller->processV2Request();
        $this->assertNull($checkout_resource->error,"It should not throw an error");
        $this->assertEquals("variable",$checkout_resource->promo_code);
        $this->assertTrue($checkout_resource->promo_amt < 0.00,"It should have a negative promo amt");
        $post_grand_total = $checkout_resource->grand_total;
        $post_tax_total = $checkout_resource->total_tax_amt;
        $post_order_amt = $checkout_resource->order_amt;
        $post_promo_amt = $checkout_resource->promo_amt;
        $order_sum = $post_order_amt+$post_promo_amt+$post_tax_total;
        $this->assertEquals($post_grand_total,$order_sum,"the grand total should replect the amounts");

        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$this->ids['merchant_id'],1.00,time());
        $this->assertNull($order_resource->error);
        $order_id = $order_resource->order_id;
        $this->assertTrue($order_id > 1000);
        $this->assertNull($order_resource->error);

        $vivonet_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id, 'V');
        $this->assertNotNull($vivonet_message_resource);

        $vivonet_controller = ControllerFactory::generateFromMessageResource($vivonet_message_resource);
        $ready_to_send_message_resource = $vivonet_controller->prepMessageForSending($vivonet_message_resource);
        $message_text = $ready_to_send_message_resource->message_text;
        myerror_log("vivonet message text: ".$message_text);

        $this->assertContains('"charges":[{"amount":1,"chargeId":8984323,"name":"SERVICETIP"},{"amount":-0.8,"chargeId":10698157,"name":"SERVICETIP"}]',$message_text);
        $this->assertNotContains('"discountName":"type1promo"',$message_text);

        $this->assertTrue($vivonet_controller->sendThisMessage($vivonet_message_resource));
        $this->assertFalse($vivonet_controller->hasMessagingError(),'It should not have a messaging error: '.$vivonet_controller->getErrorMessage());

        $message_history_record = MerchantMessageHistoryAdapter::staticGetRecordByPrimaryKey($vivonet_message_resource->map_id,'MerchantMessageHistoryAdapter');
        $this->assertNotNull($message_history_record['message_text'],"should have recorded the sent payload");
        $this->assertNotNull($message_history_record['response'],"should have recorded the response payload");
    }

    function testCreateVivonetMessageFromOrder()
    {
        $user = logTestUserResourceIn($this->ids['user_resource']);
//        $menu = CompleteMenu::getCompleteMenu($this->ids['menu_id'],'Y',$this->ids['merchant_id'],2,'pickup');
        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($this->ids['merchant_id']);
        $cart_data['items'][0]['mods'] = [$cart_data['items'][0]['mods'][0]];
        //$cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($this->ids['merchant_id']);
        $checkout_resource = getCheckoutResourceFromOrderData($cart_data);
        $this->assertNull($checkout_resource->error);
        // see if tax was set by remote call
        $this->assertTrue($checkout_resource->total_tax_amt > 0.00,"It should get the tax values from Vivonet");
        $this->assertEquals($checkout_resource->grand_total,$checkout_resource->total_tax_amt + $checkout_resource->order_amt,"It should have calculated the grand total from subtotal and tax");
        $retrieved_tax = $checkout_resource->total_tax_amt;
        $calculated_grand_total = $checkout_resource->grand_total;

        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$this->ids['merchant_id'],0.00,time());
        $this->assertNull($order_resource->error);
        $order_id = $order_resource->order_id;
        $this->assertTrue($order_id > 1000);
        $this->assertNull($order_resource->error);
        $this->assertEquals($retrieved_tax,$order_resource->total_tax_amt);
        $this->assertEquals($calculated_grand_total,$order_resource->grand_total);

        $vivonet_message_resource = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order_id, 'V');
        $this->assertNotNull($vivonet_message_resource);

        $vivonet_controller = ControllerFactory::generateFromMessageResource($vivonet_message_resource);
        $ready_to_send_message_resource = $vivonet_controller->prepMessageForSending($vivonet_message_resource);
        $message_text = $ready_to_send_message_resource->message_text;
        myerror_log("vivonet message text: ".$message_text);
        $this->assertTrue($vivonet_controller->sendThisMessage($vivonet_message_resource));
        $this->assertFalse($vivonet_controller->hasMessagingError(),'It should not have a messaging error: '.$vivonet_controller->getErrorMessage());

        $message_history_record = MerchantMessageHistoryAdapter::staticGetRecordByPrimaryKey($vivonet_message_resource->map_id,'MerchantMessageHistoryAdapter');
        $this->assertNotNull($message_history_record['message_text'],"should have recorded the sent payload");
        $this->assertNotNull($message_history_record['response'],"should have recorded the response payload");

    }

    static function setUpBeforeClass()
    {
        $_SERVER['request_time1'] = microtime(true);
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));
        ini_set('max_execution_time',300);

        $menu_id = 102713;
//        $brand_id = 198;
//        $skin_id = 26;
        $skin_resource = getOrCreateSkinAndBrandIfNecessary("vivotest","vivotest",null,null);
        $brand_id = $skin_resource->brand_id;
        $menu_adapter = new MenuAdapter(getM());
        if ($menu_resource = Resource::find($menu_adapter,"$menu_id")){
//            $menu_resource->version = 2.0;
//            $menu_resource->save();
        } else {
            //create menu
            $menu_adapter->importMenu($menu_id,'prod','local',$brand_id);
//            $menu_resource = Resource::find($menu_adapter,"$menu_id");
//            $menu_resource->version = 2.0;
//            $menu_resource->save();
        }


        setContext('com.splickit.vivotest');
        $merchant_resource = getOrCreateNewTestMerchantBasedOnExternalId('merch1234');
        $merchant_id = $merchant_resource->merchant_id;
        //$merchant_resource = getOrCreateNewTestMerchantBasedOnExternalId('163284');

        SplickitCache::flushAll();
        $db = DataBase::getInstance();
        $mysqli = $db->getConnection();
        $mysqli->begin_transaction();

        // so we need to set the internal tax to 0%
        $tax_adapter = new TaxAdapter(getM());
        $options[TONIC_FIND_BY_METADATA]['merchant_id'] = $merchant_resource->merchant_id;
        $tax_resource = Resource::find($tax_adapter,null,$options);
        $tax_resource->rate = 0;
        $tax_resource->save();

        Resource::createByData(new MerchantMenuMapAdapter(getM()),array("merchant_id"=>$merchant_resource->merchant_id,"menu_id"=>$menu_id));
        $ids['merchant_resource'] = $merchant_resource;
        $ids['merchant_id'] = $merchant_resource->merchant_id;

        $ids['menu_id'] = $menu_id;

        $store_id = 161668;
        //$mvima_data = ['merchant_id'=>$merchant_resource->merchant_id,'store_id'=>$store_id,'merchant_key'=>'736de47f4cdee9e8fe9ab8a0bc0eb37e','promo_charge_id'=>10698157];
        $tpppa = new ThirdPartyProviderParametersAdapter(getM());
        $parameters = $tpppa->getParametersFromProviderId(1003);
        $tpppmma = new ThirdPartyProviderParameterMerchantMapsAdapter(getM());
        foreach ($parameters as $parameter_row) {
            $data = [];
            $data['third_party_provider_parameter_id'] = $parameter_row['third_party_provider_parameter_id'];
            $data['merchant_id'] = $merchant_id;
            $parameter_name = $parameter_row['name'];
            switch ($parameter_name) {
                case "store_id":
                    $data['value'] = $store_id;
                    Resource::createByData($tpppmma,$data);
                    break;
                case "merchant_key":
                    $data['value'] = '736de47f4cdee9e8fe9ab8a0bc0eb37e';
                    Resource::createByData($tpppmma,$data);
                    break;
                case "promo_charge_id":
                    $data['value'] = '10698157';
                    Resource::createByData($tpppmma,$data);
                    break;
            }
        }


        //        $mvima = new MerchantVivonetInfoMapsAdapter(getM());
//        $mvim_resource = Resource::createByData($mvima,$mvima_data);

//        //$tender_id = '77140003';
//        $tender_id = null;
//        $ids['tender_id'] = $tender_id;
//        $vivonet_info_data = ['merchant_id'=>$merchant_resource->merchant_id,'tender_id'=>$tender_id];
//        Resource::createByData(new MerchantVivonetInfoMapsAdapter(getM()),$vivonet_info_data);


        $map_resource = Resource::createByData(new MerchantMessageMapAdapter(getM()),array("merchant_id"=>$merchant_resource->merchant_id,"message_format"=>'V',"delivery_addr"=>"Vivonet","message_type"=>"X"));

        $user_resource = createNewUser(array("flags"=>"1C20000001"));
        $ids['user_resource'] = $user_resource;
        $ids['user_id'] = $user_resource->user_id;

        $promo_adapter = new PromoAdapter(getM());
        $promo_id = 111;
        if ($promo_record = $promo_adapter->getRecordFromPrimaryKey($promo_id)) {
            ;
        } else {
            $ids['promo_id_type_1'] = $promo_id;
            $sql = "INSERT INTO `Promo` VALUES($promo_id, 'The Type1 Promo', 'Get Up to $5 off', 1, 'Y', 'N', 0, 2, 'N', 'N','all', '2010-01-01', '2020-01-01', 100000,FALSE, 0, 0.00, 0, 0.00, 'Y', 'N', NOW(), NOW(), 'N')";
            $promo_adapter->_query($sql);
            $pmm_resource = Resource::createByData(new PromoMerchantMapAdapter(getM()), array("merchant_id"=>$merchant_resource->merchant_id,"promo_id"=>$promo_id));
            $ids['promo_merchant_map_id_type_1'] = $pmm_resource->map_id;
            $sql = "INSERT INTO `Promo_Message_Map` VALUES(null, $promo_id, 'Congratulations! You''re getting %%amt%% off your order!', NULL, NULL, NULL, NULL, now())";
            $promo_adapter->_query($sql);
            $sql = "INSERT INTO `Promo_Type1_Amt_Map` VALUES(null, $promo_id, 1.00, 0, 50,50.00, NOW())";
            $promo_adapter->_query($sql);
            $pkwm_adapter = new PromoKeyWordMapAdapter($m);
            Resource::createByData($pkwm_adapter, array("promo_id"=>$promo_id,"promo_key_word"=>"type1promo","brand_id"=>$brand_id));

        }

        $_SERVER['log_level'] = 5;
        $_SERVER['unit_test_ids'] = $ids;
    }


    static function tearDownAfterClass()
    {
        SplickitCache::flushAll();
        $db = DataBase::getInstance();
        $mysqli = $db->getConnection();
        $mysqli->rollback();
        date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main() {
        $suite = new PHPUnit_Framework_TestSuite( __CLASS__);
        PHPUnit_TextUI_TestRunner::run( $suite);
    }

}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    VivonetOrderTest::main();
}

?>