<?php

$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');

require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';

class ShorePointsLoyaltyTest extends PHPUnit_Framework_TestCase
{
	var $stamp;
	var $ids;

	function setUp()
	{
		setContext('com.splickit.jerseymikes');
		$_SERVER['HTTP_NO_CC_CALL'] = 'true';
		$this->stamp = $_SERVER['STAMP'];
		$_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
		$this->ids = $_SERVER['unit_test_ids'];
	}
	
	function tearDown() 
	{
		//delete your instance
		$_SERVER['STAMP'] = $this->stamp;
		unset($this->ids);
    }
    
/*

    function testLoyaltyForStoreTester()
    {
    	$loyalty_number = "3036677493";
    	//$response = JerseyMikesController::getShorePointsData($loyalty_number);
    	$shorepoints_service = new ShorepointsLoyaltyService();
    	$response = $shorepoints_service->getShorePointsAccount($loyalty_number);
    	$this->assertEquals('348070', $response['lpc_id']);
    	$this->assertEquals('123-456-7890', $response['phone_number']);
    	$this->assertEquals('3C154325E7544F', $response['card_number']);
    	$this->assertTrue(isset($response['points']));
    	$this->assertTrue(isset($response['registration_code']));
    	$this->assertTrue(isset($response['store_number']));
    	$this->assertTrue(isset($response['history']));
    	$this->assertTrue(is_array($response['history']));
    	
    }
// */    
    function testShorePointsGetLoyaltyInfoFromJM()
    {
    	//002000967543
    	$loyalty_number = "1234567890";
    	//$response = JerseyMikesController::getShorePointsData($loyalty_number);
    	$shorepoints_service = new ShorepointsLoyaltyService();
    	$response = $shorepoints_service->getShorePointsAccount($loyalty_number);
    	//$this->assertEquals('348070', $response['lpc_id']);
    	$this->assertEquals('123-456-7890', $response['phone_number']);
    	$this->assertTrue(isset($response['card_number']));    	
    	$this->assertTrue(isset($response['points']));
    	$this->assertTrue(isset($response['registration_code']));
    	$this->assertTrue(isset($response['store_number']));
    	$this->assertTrue(isset($response['history']));
    	$this->assertTrue(is_array($response['history']));
    }

    function testShorePointsGetLoyaltyInfoFromJMBadLoyaltyNumber()
    {
    	//002000967543

    	$loyalty_number = "".rand(1111111111,9999999999);
    	//$response = JerseyMikesController::getShorePointsData($loyalty_number);
    	$shorepoints_service = new ShorepointsLoyaltyService();
    	$this->assertNull($shorepoints_service->getShorePointsAccount($loyalty_number));
    	$results = $shorepoints_service->response_fields;
    	$this->assertEquals("failure", $results['status']);
    	$this->assertEquals("Account was Not Found", $results['message']);
    }

    function testShorePointsCreateShorePointsAccount()
    {
    	$phone_number = '1'.rand(111111111, 999999999);
    	
    	//$result = JerseyMikesController::createShorePointsAccount($phone_number);
    	$shore_points_loyalty_service = new ShorepointsLoyaltyService();
    	$result = $shore_points_loyalty_service->createShorePointsAccountFromPhoneNumber($phone_number);
    	$card_number = $result['response'];
    	$this->assertTrue($card_number > 1000000);
    	
    	//$result2 = JerseyMikesController::getShorePointsData($result['response']);
    	//$result3 = JerseyMikesController::getShorePointsData($phone_number);
    	$shorepoints_service = new ShorepointsLoyaltyService();
    	$result3 = $shorepoints_service->getShorePointsAccount($phone_number);
    	
    	$this->assertEquals($card_number, $result3['card_number']);
    	$returned_phone_number = $result3['phone_number'];
    	$clean_phone_number = str_replace('-', '', $returned_phone_number);
    	$this->assertEquals($phone_number, $clean_phone_number);
    }
    
    function testShorePointsCreateShorePointsAccoutBadNumber()
    {
    	//$result = JerseyMikesController::createShorePointsAccount('3456');
    	$shore_points_loyalty_service = new ShorepointsLoyaltyService();
    	$result = $shore_points_loyalty_service->createShorePointsAccountFromPhoneNumber('3456');
    	$this->assertEquals("failure", $result['status']);
    	$this->assertEquals("The number provided was not a valid phone number.", $result['message']);
    }    
// 
    static function setUpBeforeClass()
    {
    	$_SERVER['request_time1'] = microtime(true);
    	$_SERVER['NO_MOCKS'] = true;
    	$tz = date_default_timezone_get();
    	$_SERVER['starting_tz'] = $tz;
    	date_default_timezone_set(getProperty("default_server_timezone"));
    	mysqli_query("BEGIN");
    	$sql = "INSERT INTO Property (name,value) values ('jm_username','splickit')";
    	mysqli_query($sql);
    	$sql = "INSERT INTO Property (name,value) values ('jm_password','Spelunk$5marble')";
    	mysqli_query($sql);
    	$_SERVER['log_level'] = 5; 
		$_SERVER['unit_test_ids'] = $ids;
    }
    
	static function tearDownAfterClass()
    {
    	mysqli_query("ROLLBACK");
    	date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main() {
		$suite = new PHPUnit_Framework_TestSuite( __CLASS__);
  		PHPUnit_TextUI_TestRunner::run( $suite);
 	}
    
}

if (isset($_SERVER['argv'][1]) && $_SERVER['argv'][1] == 'use_main'  && !defined('PHPUnit_MAIN_METHOD')) {
    ShorePointsLoyaltyTest::main();
}

?>