<?php

error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');
$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;

require_once 'lib/utilities/unit_test_functions.inc';
require_once 'lib/utilities/functions.inc';

class APIDispatchTestStaging extends PHPUnit_Framework_TestCase
{
	var $stamp;
	var $ids;
	var $info;
    var $server = 'smawapi.test.rrtusa.net';

    // snarfs = '8242-kj63e-ik345-66m99'
    var $public_client_id = '8242-kj63e-ik345-66m99'; //
    var $client = 'CommandLineTest';


    function setUp()
	{
		$this->stamp = $_SERVER['STAMP'];
		$_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
		$this->ids = $_SERVER['unit_test_ids'];
        setContext($this->client_id);
	}
	
	function tearDown() 
	{
		$_SERVER['STAMP'] = $this->stamp;
		unset($this->ids);
		unset($this->info);
    }

//    function testCreateUserForMailChimpSkin()
//    {
//        $this->public_client_id = '9411-55m9a-473hf-ie29p';
//        $url = "http://".$this->server."/app2/apiv2/users?log_level=5";
//        $new_user_data = createNewUserDataFields();
//        $new_user_data['marketing_email_opt_in'] = 1;
//        $new_user_data['birthday'] = '01/01/2000';
//        $response = $this->makeRequest($url, "admin:welcome","POST",$new_user_data);
//        $response_as_array = json_decode($response,true);
//        $this->assertEquals(200,$response_as_array['http_code']);
//
//    }

    function testGetUserSession()
    {
        $url = "https://".$this->server."/app2/apiv2/usersession?log_level=5";
        $response = $this->makeRequest($url, 'store_tester@order140.com:test','GET');
        $response_as_array = json_decode($response,true);
        $this->assertEquals(200,$response_as_array['http_code']);
    }


    function testGetRRTMerchantList()
    {
        $url = "https://".$this->server."/app2/apiv2/merchants?log_level=5";
        //$this->public_client_id = '1586-53rkm-cn84p-6l5r2';
        $response = $this->makeRequest($url, null,'GET');
        $response_as_array = json_decode($response,true);
        $this->assertEquals(200,$response_as_array['http_code']);
        $count = sizeof($response_as_array['data']['merchants']);
        $m = rand(0,$count);
        $merchant_id = $response_as_array['data']['merchants'][$m]['merchant_id'];
        $this->assertTrue($merchant_id>1000,"it shoudl have a valid merchant id");
        return $merchant_id;
    }

    /**
     * @depends testGetRRTMerchantList
     */
    function testGetRRTMenu($merchant_id)
    {
        $url = "https://" . $this->server . "/app2/apiv2/merchants/$merchant_id?log_level=5";
        $response = $this->makeRequest($url, null, 'GET');
        $response_as_array = json_decode($response, true);
        $this->assertEquals(200, $response_as_array['http_code']);
        $menu = $response_as_array['data']['menu'];
        $this->assertTrue(sizeof($menu['menu_types']) > 4, "It should have lots of menu types, this is snarfs menu");
        $menu['merchant_id'] = $merchant_id;
        return $menu;
    }

    /**
     * @depends testGetRRTMenu
     */
    function testPlaceOrderFromMenu($menu) {
        $merchant_id = $menu['merchant_id'];
        array_shift($menu['menu_types']);
        array_shift($menu['menu_types']);
        $oa = new OrderAdapter(getM());
        $cart_data = $oa->getCartArrayFromFullMenuWithOneModiferPerModifierGroup($menu,$merchant_id,"TEST ORDER DO NOT MAKE",1,0,4);
        $url = "https://".$this->server."/app2/apiv2/carts/checkout?log_level=5";
        $response = $this->makeRequest($url,'store_tester@order140.com:test','POST',$cart_data);
        $response_as_array = json_decode($response,true);
        $this->assertEquals(200,$response_as_array['http_code']);
        $ucid = $response_as_array['data']['ucid'];

        $order_data = array();
        $order_data['tip'] = 0.00;
        $payment_array = $response_as_array['data']['accepted_payment_types'];
        $order_data['merchant_payment_type_map_id'] = $payment_array[0]['merchant_payment_type_map_id'];
        $lead_times_array = $response_as_array['data']['lead_times_array'];
        $order_data['note'] = "TEST ORDER DO NOT MAKE";
        $order_data['actual_pickup_time'] = $lead_times_array[0];
        $order_data['requested_time'] = $lead_times_array[0];

        $url = "https://".$this->server."/app2/apiv2/orders/$ucid?log_level=5";
        $response = $this->makeRequest($url,'store_tester@order140.com:test','POST',$order_data);
        $response_as_array = json_decode($response,true);
        $this->assertEquals(200,$response_as_array['http_code']);
    }


    private function createNewUserDataFields()
    {
        $randomizer_string = rand(11111,99999);
        $user_data['first_name'] = 'first';
        $user_data['last_name'] = 'last';
        $user_data['email'] = 'testuser_' . time() . '_' . $randomizer_string . '@order140.com';
        $user_data['password'] = 'welcome';
        $user_data['contact_no'] = '1234567890';
        $user_data['loyalty_number'];
        $user_data['account_hash'] = time().'_'.$randomizer_string;
        return $user_data;

    }

    private function createNewUser()
    {
        $url = "https://".$this->server."/app2/apiv2/users?log_level=5";
        $new_user_data = $this->createNewUserDataFields();
        unset($new_user_data['account_hash']);
        $response = $this->makeRequest($url, "admin:test1234","POST",$new_user_data);
        $this->assertEquals('200', $this->info['http_code']);
        $new_user_response = json_decode($response,true);
        $this->assertNull($new_user_response['error'],"should NOT have gotten an error");
        $user = $new_user_response['data'];
        return $user;
    }




    function makeRequest($url,$userpassword,$method = 'GET',$data = null)
    {
    	unset($this->info);
    	$method = strtoupper($method);
    	$curl = curl_init($url);
    	if ($userpassword) {
    		curl_setopt($curl, CURLOPT_USERPWD, $userpassword);
    	}
    	if ($external_id = $this->public_client_id) {
    	    $client = $this->client;
        } else if ($external_id = getContext()) {
            $client = getSkinNameForContext();
        } else {
            $external_id = "com.splickit.vtwoapi";
        }


    	$headers = array("X_SPLICKIT_CLIENT_ID:$external_id","X_SPLICKIT_CLIENT_DEVICE:unit_testing","X_SPLICKIT_CLIENT:$client");
    	if ($authentication_token = $data['splickit_authentication_token']) {
    		$headers[] = "splickit_authentication_token:$authentication_token";
    	}
    	if ($method == 'POST') {
    		$json = json_encode($data);
    		curl_setopt($curl, CURLOPT_POST, 1);
			curl_setopt($curl, CURLOPT_POSTFIELDS,$json);
			$headers[] = 'Content-Type: application/json';
			$headers[] = 'Content-Length: ' . strlen($json);
    	} else if ($method == 'DELETE') {
   			curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "DELETE"); 		
    	}
		curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
    	curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        //curl_setopt($curl, CURLOPT_VERBOSE, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        logCurl($url,$method,$userpassword,$headers,$json);
        $result = curl_exec($curl);
        myerror_log("CURL COMMAND RESPONSE: $result");
		$this->info = curl_getinfo($curl);
		curl_close($curl);
    	return $result;
    }

    static function useMakeRequest($url,$userpassword,$method = 'GET',$data = null)
    {
        $apidts = new ApiDispatchTestStaging();
        return $apidts->makeRequest($url,$userpassword,$method,$data);
    }

    static function setUpBeforeClass($merchant_id)
    {
//        setContext("com.splickit.RAADAAR");
//        $merchant_id = 1088;
//        $_SERVER['STAMP'] = rand(1111111111,9999999999);
//        $url = "http://sandbox.splickit-uat.com/app2/apiv2/merchants/$merchant_id?log_level=5";
//        $result = ApiDispatchTestStaging::useMakeRequest($url, $userpassword);
//        $request_result_as_array = json_decode($result,true);
//        $merchant = $request_result_as_array['data'];
//        $menu = $merchant['menu'];
//        $ids['menu'] = $menu;
//    	$ids['merchant_id'] = $merchant_id;
//		$_SERVER['unit_test_ids'] = $ids;
    }
    
	static function tearDownAfterClass()
    {
    	//mysqli_query("ROLLBACK");
    	date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main() {
		$suite = new PHPUnit_Framework_TestSuite( __CLASS__);
  		PHPUnit_TextUI_TestRunner::run( $suite);
 	}
    
}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    APIDispatchTestStaging::main();
}

?>