<?php

error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');
$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;
require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';

use Aws\S3\S3Client;
use Aws\Credentials\Credentials;

class AwsTemplateRetrievalTest extends PHPUnit_Framework_TestCase
{
	var $stamp;
	var $ids;

	function setUp()
	{
		$_SERVER['HTTP_NO_CC_CALL'] = 'true';
		$this->stamp = $_SERVER['STAMP'];
		$_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
		$this->ids = $_SERVER['unit_test_ids'];
		setProperty('do_not_call_out_to_aws','false');
		
	}
	
	function tearDown() 
	{
		//delete your instance
		$_SERVER['STAMP'] = $this->stamp;
		unset($this->ids);
		setProperty('do_not_call_out_to_aws','true');
    }

    function testGetGroupOrderEmailRRT()
    {
//        setProperty('S3_AWS_ACCESS_KEY_ID','AKIAZARGOULSAOWT7BD5');
//        setProperty('S3_AWS_SECRET_ACCESS_KEY','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');
//        setProperty('bucket_prefix','net.rrtusa');

        $key = getProperty('S3_AWS_ACCESS_KEY_ID');
        $secret = getProperty('S3_AWS_SECRET_ACCESS_KEY');
        $credentials = new Credentials($key, $secret);
        $client = new S3Client(array(
            'version' => 'latest',
            'region'  => 'us-east-1',
//            'credentials' => $credentials
            'credentials' => array(
                'key' => $key,
                'secret'  => $secret
            )
        ));

        $key = 'group-order-email/production/group_order_invite_email.html';
        $bucket = getProperty('bucket_prefix').".templates";

        $boo = $client->doesObjectExist($bucket,$key);
        $object = $client->getObject(array(
            'Bucket' => $bucket,
            'Key' => $key
        ));
        $body = $object->get("Body")->getContents();

    }
    
    function testGetTemplateFromAWS()
    {
    	$email_service = new EmailService();
    	$message_text = $email_service->getWelcomeEmail("".getProperty('bucket_prefix').".templates/user-welcome-email","moes");
    	$this->assertTrue(is_string($message_text),"welcome email body should be a string");
    	$this->assertContains('<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">', $message_text);
    	$this->assertContains('<html xmlns="http://www.w3.org/1999/xhtml" xmlns="http://www.w3.org/1999/xhtml">', $message_text);
    }
    
    function testCreationOfCustomWelcomeLetter()
    {
    	setContext('com.splickit.moes');
    	$user_resource = createNewUser();
    	//$user_controller = new UserController($mt, $u, $r, 5);
    	//$map_id = $user_controller->sendWelcomeLetterToUserForContext($user_resource);
    	$mmha = new MerchantMessageHistoryAdapter(getM());
    	$record = $mmha->getRecord(array("message_delivery_addr"=>$user_resource->email,"messagse_format"=>'Ewel',"message_type"=>"I"));
    	$map_id = $record['map_id'];
    	$this->assertTrue($map_id > 1000);
    	$welcome_letter_resource = Resource::find(new MerchantMessageHistoryAdapter(getM()), "$map_id", null);
    	$this->assertTrue(is_a($welcome_letter_resource, 'Resource'));
    	$this->assertEquals("Ewel", $welcome_letter_resource->message_format);
    	$message_text = $welcome_letter_resource->message_text;
    	myerror_log($message_text);
    	$this->assertTrue(is_string($message_text),"welcome email body should be a string");
    	$info_string = $welcome_letter_resource->info;
    	$info_array = MessageController::extractInfoData($info_string);
    	$this->assertEquals("Welcome to Moes mobile/online ordering!", $info_array['subject']);
    	$this->assertStringStartsWith('<!-- Inliner Build Version', $message_text);
    	$this->assertContains("<title>Welcome to Moe's</title>", $message_text);
    }
    
    function testNONCreationOfDefaultWelcomeLetter()
    {
    	setContext('com.splickit.order');
    	$user_resource = createNewUser();
    	$user_controller = new UserController($mt, $u, $r, 5);
    	$this->assertFalse($user_controller->sendWelcomeLetterToUserForContext($user_resource));
    }
    
    function testCreateCustomWelcomeLetterFromTempUserUpdateToRegularUser()
    {
    	setContext("com.splickit.moes");
    	$user_resource2 = createNewUser();
    	$user_resource2->first_name = "SpTemp";
    	$user_resource2->last_name = "User";
    	$email = $user_resource2->email;
    	$e = explode('@', $email);
    	$user_resource2->email = $e[0]."@splickit.dum";
    	$result = $user_resource2->save();
    	$this->assertTrue($result);
    	
    	$user2 = logTestUserIn($user_resource2->user_id);
    	
    	$new_email = 'mynewemail@order140.com';
    	$request = new Request();
    	$request->method = "POST";
    	$_SERVER['REQUEST_METHOD'] = 'POST';
    	$data['email'] = $new_email;
    	$data['password'] = "somdumpassword";
    	$data['first_name'] = "somedumguy";
    	$data['last_name'] = "lastname";
    	$request->data = $data;
    	$user_controller = new UserController(getM(), $user2, $request, 5);
    	$response = $user_controller->updateUser();
    	
    	$mmha = new MerchantMessageHistoryAdapter(getM());
    	$record = $mmha->getRecord(array("message_delivery_addr"=>$new_email,"message_format"=>'Ewel'));
    	$this->assertNotNull($record,"should have found a welcome message in the db");
    	$this->assertNotNull($record['message_text'],"welcome message should have message_text");
    	$this->assertContains("<title>Welcome to Moe's</title>", $record['message_text']);
    }

    static function setUpBeforeClass()
    {
    	$_SERVER['request_time1'] = microtime(true);
    	$_SERVER['NO_MOCKS'] = true;
    	$tz = date_default_timezone_get();
    	$_SERVER['starting_tz'] = $tz;
    	date_default_timezone_set(getProperty("default_server_timezone"));
    	mysqli_query("BEGIN");
    	
    	$skin_resource = createWorldHqSkin();
    	$ids['skin_id'] = $skin_resource->skin_id;
    	
    	$_SERVER['log_level'] = 5; 
		$_SERVER['unit_test_ids'] = $ids;
    }
    
	static function tearDownAfterClass()
    {
    	mysqli_query("ROLLBACK");
    	date_default_timezone_set($_SERVER['starting_tz']);
    	setProperty('do_not_call_out_to_aws','true');
    }

    /* mail method for testing */
    static function main() {
		$suite = new PHPUnit_Framework_TestSuite( __CLASS__);
  		PHPUnit_TextUI_TestRunner::run( $suite);
 	}
    
}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    AwsTemplateRetrievalTest::main();
}

?>