<?php
error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');
$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;
require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';

class DoordashServiceTest extends PHPUnit_Framework_TestCase
{
	var $stamp;
	var $ids;

	function setUp()
	{
	    setContext('com.splickit.worldhq');
		$_SERVER['DO_NOT_RUN_CC'] = 'true';
		$this->stamp = $_SERVER['STAMP'];
		$_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
		$this->ids = $_SERVER['unit_test_ids'];
		
	}
	
	function tearDown() 
	{
		//delete your instance
		$_SERVER['STAMP'] = $this->stamp;
		unset($this->ids);
    }
    
    function testEstimate()
    {
        //$delivery_time = date('Y-m-dTH:i:s.000000Z',time() + 3600); // add 60 minutes
        $tz = new DateTimeZone('GMT');
        $dt = new DateTime();
        $dt->setTimezone($tz);
        $dt->setTimestamp(time()+3600);

        $delivery_time = $dt->format('Y-m-d').'T'.$dt->format('H:i:s').'.000000Z';



        //setProperty('doordash_api_key','2242feb2370658f1415ae86960fc21a0d4a4af51');
        setProperty('doordash_api_key','6e70eefc4fbada08c09bfaa394839f1a4cfde2bc');


        $udl['address1'] = '1881 9th street';
        $udl['city'] = 'Boulder';
        $udl['state'] = 'CO';
        $udl['zip'] = '80302';
        //$udl['requested_delivery_time_stamp'] = getTodayTwelveNoonTimeStampDenver();

        $merchant_resource = createNewTestMerchant();
        $merchant = $merchant_resource->getDataFieldsReally();

        $doordash_service = new DoordashService();
        $result = $doordash_service->getEstimate($udl,$merchant);
        $this->assertEquals(200,$result['http_code']);
    }

    function testEstimateWithDropoffTime()
    {
        setProperty('doordash_api_key','2242feb2370658f1415ae86960fc21a0d4a4af51');

        $udl['address1'] = '1881 9th street';
        $udl['city'] = 'Boulder';
        $udl['state'] = 'CO';
        $udl['zip'] = '80302';

        $merchant_resource = createNewTestMerchant();
        $merchant = $merchant_resource->getDataFieldsReally();

        $doordash_service = new DoordashService();
        $result = $doordash_service->getEstimate($udl,$merchant,1500,time()+3600);
        $this->assertEquals(200,$result['http_code']);
    }

    function testValidateDelivery()
    {
        setProperty('doordash_api_key','2242feb2370658f1415ae86960fc21a0d4a4af51');
        $menu_id = createTestMenuWithNnumberOfItems(1);
        $merchant_resource = createNewTestMerchantDelivery($menu_id);
        $merchant_resource->phone_no = '6505555555';
        $merchant_resource->save();
        $merchant = $merchant_resource->getDataFieldsReally();
        $merchant_id = $merchant_resource->merchant_id;

        $user_resource = createNewUserWithCCNoCVV();
        $user_resource->first_name = 'TestUser';
        $user_resource->last_name = 'TestUser';
        $user_resource->save();
        $user = logTestUserResourceIn($user_resource);
        $json = '{"user_addr_id":null,"user_id":"' . $user['user_id'] . '","name":"","address1":"1045 Pine Street","address2":"","city":"boulder","state":"co","zip":"80302","phone_no":"9709262121","lat":40.0197891,"lng":-105.284703}';
        $request = createRequestObject("/users/" . $user['uuid'] . "/userdeliverylocation",'POST',$json);

        $user_controller = new UserController(getM(), $user, $request, 5);
        $udl_response = $user_controller->processV2Request();

        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($merchant_id);
        $cart_data['delivery'] = 'yes';
        $cart_data['user_addr_id'] = $udl_response->user_addr_id;
        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,getTomorrowTwelveNoonTimeStampDenver());

        $not_complete_order = CompleteOrder::staticGetCompleteOrder($checkout_resource->ucid);
        $doordash_service = new DoordashService();
        $result = $doordash_service->validateDelivery($not_complete_order);
        $expected_payload  = '{"valid":true}';
        $this->assertEquals("$expected_payload",$result['raw_result']);
    }

    function testRequestDelivery()
    {
        setProperty('doordash_api_key','2242feb2370658f1415ae86960fc21a0d4a4af51');
        $menu_id = createTestMenuWithNnumberOfItems(1);
        $merchant_resource = createNewTestMerchantDelivery($menu_id);
        $merchant_resource->phone_no = '6505555555';
        $merchant_resource->save();
        $merchant = $merchant_resource->getDataFieldsReally();
        $merchant_id = $merchant_resource->merchant_id;

        $user_resource = createNewUserWithCCNoCVV();
        $user_resource->first_name = 'TestUser';
        $user_resource->last_name = 'TestUser';
        $user_resource->contact_no = '9709262121';
        $user_resource->save();
        $user = logTestUserResourceIn($user_resource);
        $json = '{"user_addr_id":null,"user_id":"' . $user['user_id'] . '","name":"","address1":"1045 Pine Street","address2":"","city":"boulder","state":"co","zip":"80302","phone_no":"9709262121","lat":40.0197891,"lng":-105.284703}';
        $request = createRequestObject("/users/" . $user['uuid'] . "/userdeliverylocation",'POST',$json);

        $user_controller = new UserController(getM(), $user, $request, 5);
        $udl_response = $user_controller->processV2Request();

        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($merchant_id);
        $cart_data['delivery'] = 'yes';
        $cart_data['user_addr_id'] = $udl_response->user_addr_id;
        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,time());
        $this->assertNull($checkout_resource->error);
        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,5.55);
        $this->assertNull($order_resource->error);

        $complete_order = CompleteOrder::staticGetCompleteOrder($checkout_resource->ucid);
        $doordash_service = new DoordashService();
        $result = $doordash_service->requestDelivery($complete_order);
        $this->assertTrue($result,"It should return true for the request delivery call");
        $doordash_response = $doordash_service->getDoordashResponse();
        $this->assertEquals(201,$doordash_response['http_code']);
        return $doordash_response['id'];
    }

    /**
     * @depends testRequestDelivery
     */
    function testCancelDeliveryRequest($id)
    {
        setProperty('doordash_api_key','2242feb2370658f1415ae86960fc21a0d4a4af51');
        $doordash_service = new DoordashService();
        $result = $doordash_service->cancelDeliveryRequest($id);
        $this->assertTrue($result,"It should return true for canceling the door dash delivery request");
        $response = $doordash_service->getDoordashResponse();
        $this->assertTrue(isset($response['cancelled_at']));
        $this->assertEquals($id,$response['doordash_delivery_id']);

    }

    static function setUpBeforeClass()
    {
    	$_SERVER['request_time1'] = microtime(true);
    	$_SERVER['NO_MOCKS'] = true;
    	$tz = date_default_timezone_get();
    	$_SERVER['starting_tz'] = $tz;
    	date_default_timezone_set(getProperty("default_server_timezone"));
        $tpppbma = new ThirdPartyProviderParameterBrandMapsAdapter(getM());
        setContext('com.splickit.worldhq');
        $external_business_name_tppbma_resource = $tpppbma->setBrandParameterByName('external_business_name',4001,getBrandIdFromCurrentContext(),"Snarf's Sandwiches");


    	$_SERVER['log_level'] = 5; 
		$_SERVER['unit_test_ids'] = $ids;
    }
    
	static function tearDownAfterClass()
    {
    	date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main() {
		$suite = new PHPUnit_Framework_TestSuite( __CLASS__);
  		PHPUnit_TextUI_TestRunner::run( $suite);
 	}
    
}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    DoordashServiceTest::main();
}

?>