<?php

error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');
$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;

require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';

class EmmaServiceTest extends PHPUnit_Framework_TestCase
{
    var $stamp;
    var $ids;

    function setUp()
    {
        $this->stamp = $_SERVER['STAMP'];
        $_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
        $this->ids = $_SERVER['unit_test_ids'];
        setContext('com.splickit.emmaskin');
    }

    function tearDown()
    {
        //delete your instance
        $_SERVER['STAMP'] = $this->stamp;
        unset($this->ids);
    }

    function testJoin()
    {
        $randomizer_string = createCode(3);
        $user_data['first_name'] = 'Bob';
        $user_data['last_name'] = 'Roberts';
        $user_data['email'] = getCreateTestUserEmail($randomizer_string);
        $user_data['contact_no'] = rand(1111111111, 9999999999);
        $user_data['birthday'] = date('m/d/Y');
        $user_data['marketing_email_opt_in'] = 1;
        $emma_service = new EmmaService(getBrandIdFromCurrentContext());
        $user_resource = Resource::dummyfactory($user_data);
        $join_response = $emma_service->join($user_resource);
        $this->assertEquals(200,$join_response['http_code']);
    }

    function testNoJoinWithOutOptInFlag()
    {
        $randomizer_string = createCode(3);
        $user_data['first_name'] = 'Bob';
        $user_data['last_name'] = 'Roberts';
        $user_data['email'] = getCreateTestUserEmail($randomizer_string);
        $user_data['contact_no'] = rand(1111111111, 9999999999);
        $user_data['marketing_email_opt_in'] = 0;
        $emma_service = new EmmaService(getBrandIdFromCurrentContext());
        $user_resource = Resource::dummyfactory($user_data);
        $join_response = $emma_service->join($user_resource);
        $this->assertFalse($join_response,'It should not have a response becuase the flag was not checkked');
    }

    static function setUpBeforeClass()
    {
        $_SERVER['request_time1'] = microtime(true);
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));
        ini_set('max_execution_time',300);
        SplickitCache::flushAll();
        $db = DataBase::getInstance();
        $mysqli = $db->getConnection();
        $mysqli->begin_transaction(); ;

        $skin_resource = getOrCreateSkinAndBrandIfNecessaryWithLoyalty("emmaskin","emmabrand",null, null);
        $ids['skin_id'] = $skin_resource->skin_id;
        setContext('com.splickit.emmaskin');

//        $simple_menu_id = createTestMenuWithOneItem("item_one");
//        $ids['menu_id'] = $simple_menu_id;
//
//        $merchant_resource = createNewTestMerchant($simple_menu_id,['authorize'=>true]);
//        $merchant_resource->save();
//        $ids['merchant_id'] = $merchant_resource->merchant_id;
//
//        $merchant_payment_type_map_resource = MerchantPaymentTypeMapsAdapter::createMerchantPaymentTypeMap($merchant_resource->merchant_id, 12020, null);



        $tpppa = new ThirdPartyProviderParametersAdapter(getM());
        $parameters = $tpppa->getParametersFromProviderId(6003);
        foreach ($parameters as $parameter_row) {
            $data = [];
            if ($parameter_row['name'] == 'active_flag') {
                $data['value'] = 'Y';
            } else if ($parameter_row['name'] == 'account_id') {
                $data['value'] = '1927733';
            } else if ($parameter_row['name'] == 'public_api_key') {
                $data['value'] = '34440ed7a4ecbd759b99';
            } else if ($parameter_row['name'] == 'private_api_key') {
                $data['value'] = 'd66ab91ced918788a19a';
            }
            $data['third_party_provider_parameter_id'] = $parameter_row['third_party_provider_parameter_id'];
            $data['brand_id'] = getBrandIdFromCurrentContext();
            $tpppbma = new ThirdPartyProviderParameterBrandMapsAdapter(getM());
            Resource::createByData($tpppbma,$data);
        }

        $_SERVER['log_level'] = 5;
        $_SERVER['unit_test_ids'] = $ids;
    }

    static function tearDownAfterClass()
    {
        SplickitCache::flushAll();
        $db = DataBase::getInstance();
        $mysqli = $db->getConnection();
        $mysqli->rollback();
        date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main() {
        $suite = new PHPUnit_Framework_TestSuite( __CLASS__);
        PHPUnit_TextUI_TestRunner::run( $suite);
    }

}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    EmmaServiceTest::main();
}
?>