<?php

error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');
$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;

require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';

class GiveXCertificationTest extends PHPUnit_Framework_TestCase
{
	var $stamp;
	var $ids;
    var $api_port = "80";
    var $card_a;
    var $card_b;
    var $card_c;
    var $card_d;
    var $card_e;
    var $card_f;

	function setUp()
	{
		$this->stamp = $_SERVER['STAMP'];
		$_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
		$this->ids = $_SERVER['unit_test_ids'];
        if (isset($_SERVER['XDEBUG_CONFIG'])) {
            $this->api_port = "10080";
        }
        $this->card_a = '60362883818161604012';
        $this->card_b = '60362836362161604023';
        $this->card_c = '60362892344161604030';
        $this->card_d = '60362838179161604046';
        $this->card_e = '60362868414161604056';
        $this->card_f = '60362863413161604066';
        setProperty('givex_url','https://dev-dataconnect.givex.com:50104');

//        $guir = $this->ids['givex_user_id_resource'];
//        $guir->value = 36976;
//        $guir->save();
//
//        $guir = $this->ids['givex_password_resource'];
//        $guir->value = 'zgXN8jE1wPpYy33L';
//        $guir->save();

}
	
	function tearDown() 
	{
		//delete your instance
		$_SERVER['STAMP'] = $this->stamp;
//        $guir = $this->ids['givex_user_id_resource'];
//        $guir->value = 36976;
//        $guir->save();
//
//        $guir = $this->ids['givex_password_resource'];
//        $guir->value = 'zgXN8jE1wPpYy33L';
//        $guir->save();

        unset($this->ids);
    }

//        INSERT INTO Configuration_By_Environment_Variables (`name`,`value`,`environment`) VALUES ('givex_url','https://dev-dataconnect.givex.com:50104','default');
//        INSERT INTO Configuration_By_Environment_Variables (`name`,`value`,`environment`) VALUES ('givex_url','https://dataconnect.givex.com:XXXXX','production');
//        INSERT INTO Third_Party_Providers (id,third_party_provider_type_id,name,description) VALUES (5002,5000,'GiveX','GiveX Stored Value');
//        INSERT INTO Third_Party_Provider_Parameters (third_party_provider_id,name,default_context,required) VALUES (5002,'user_id','skin',1),(5002,'password','skin',1)

//    function testMerchandiseCredit1_b()
//    {
//        // credit account
//        $card_number = $this->card_b;
//        $givex_service = new GivexPaymentService(null);
//
//        $amount = 1.00;
//        $results = $givex_service->addCashValueToCard($card_number,$amount);
//        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['raw_result']);
//        $this->assertEquals('failure', $results['status']);
//        $this->assertEquals('Invalid amt < min',$results['response_text']);
//    }



    function testInitializeCards()
    {
        $cards = [];
        $cards['a'] = $this->card_a;
        $cards['b'] = $this->card_b;
        $cards['c'] = $this->card_c;
        $cards['d'] = $this->card_d;
        $cards['e'] = $this->card_e;
        $cards['f'] = $this->card_f;


        foreach ($cards as $name=>$card_number) {
            $givex_service = new GivexPaymentService(null);
            $results = $givex_service->getRemoteCardInfo($card_number);
            $this->assertEquals('success', $results['status']);
            $balance = $results['balance'];
            myerror_log("$name = $balance'");
            if (100.00 <= floatval($balance)) {
                myerror_log("Balance on $name is $balance");
                continue;
            }
            $amount = 100 - (float)$balance;
            $results = $givex_service->addCashValueToCard($card_number,$amount);
            $ending_balance = $results['balance'];
            myerror_log("Ending blance of $name is $ending_balance");
        }

    }

    function testSecureRedemption1()
    {

        $user_resource = createNewUser();
        $uuid = $user_resource->uuid;
        $user = logTestUserResourceIn($user_resource);
        $card_number = $this->card_a;
//        $url = "http://127.0.0.1:".$this->api_port."/app2/apiv2/users/$uuid/stored_value/12020/create";
//        $data['card_number'] = $card_number;
//        $data['user_id'] = $user_resource->user_id;
//        $request = createRequestObject($url,'POST',json_encode($data));
//        $user_controller = new UserController(getM(),$user,$request,5);
//        $result = makeMockRequest($user_controller);
//        $result_as_array = json_decode($result,true);
//        $message = $result_as_array['data']['user_message'];
//        $this->assertContains('Your card info was saved successfully',$message);

        // redemption with enough balance
        $amount = 49.99;
        $givex_service = new GivexPaymentService($data);
        $givex_service->billing_user_id = $user['user_id'];
        $givex_service->order_id = rand(11111,99999);
        $givex_service->amount = $amount;
        $givex_service->setBillingUsersAccountNumber($card_number);
        $results = $givex_service->processPayment($amount);
        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['raw_result']);
        $this->assertEquals('success', $results['status']);
        $ending_balance = $results['result'][3];
        $this->assertEquals(50.01,$ending_balance);

    }

    function testSecureRedemption2()
    {

        $user_resource = createNewUser();
        $uuid = $user_resource->uuid;
        $user = logTestUserResourceIn($user_resource);
        $card_number = $this->card_a;
//        $url = "http://127.0.0.1:".$this->api_port."/app2/apiv2/users/$uuid/stored_value/12020/create";
//        $data['card_number'] = $card_number;
//        $data['user_id'] = $user_resource->user_id;
//        $request = createRequestObject($url,'POST',json_encode($data));
//        $user_controller = new UserController(getM(),$user,$request,5);
//        $result = makeMockRequest($user_controller);
//        $result_as_array = json_decode($result,true);
//        $message = $result_as_array['data']['user_message'];
//        $this->assertContains('Your card info was saved successfully',$message);

        // redemption with not enough balance
        $amount = 60.09;
        $givex_service = new GivexPaymentService($data);
        $givex_service->billing_user_id = $user['user_id'];
        $givex_service->order_id = rand(11111,99999);
        $givex_service->amount = $amount;
        $givex_service->setBillingUsersAccountNumber($card_number);
        $results = $givex_service->processPayment($amount);
        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['raw_result']);
        $this->assertEquals('failure', $results['status']);
    }

    function testBalanceCheck1()
    {
        // balance check
        $card_number = $this->card_a;
        $givex_service = new GivexPaymentService(null);
        $results = $givex_service->getRemoteCardInfo($card_number);
        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['raw_result']);
        $this->assertEquals('success', $results['status']);
        $balance = $results['balance'];
    }

    function testMerchandiseCredit1()
    {
        // credit account
        $card_number = $this->card_b;
        $givex_service = new GivexPaymentService(null);

        $amount = 1.00;
        $results = $givex_service->addCashValueToCard($card_number,$amount);
        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['raw_result']);
        $this->assertEquals('failure', $results['status']);
        $this->assertEquals('Invalid amt < min',$results['response_text']);
    }

    function testMerchandiseCredit2()
    {
        // credit account
        $card_number = $this->card_b;
        $givex_service = new GivexPaymentService(null);

        $amount = 100.00;
        $results = $givex_service->addCashValueToCard($card_number,$amount);
        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['raw_result']);
        $this->assertEquals('success', $results['status']);
        $ending_balance = $results['balance'];
        $this->assertTrue(100 < floatval($ending_balance));
    }


    function testMerchandiseCredit3()
    {
        // credit account
        $card_number = '6060394521410007321';
        $givex_service = new GivexPaymentService(null);

        $amount = 100.00;
        $results = $givex_service->addCashValueToCard($card_number,$amount);
        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['raw_result']);
        $this->assertEquals('failure', $results['status']);
    }

    function testCancel1()
    {
        // redemption with enough balance
        $amount = 20.00;

        $user_resource = createNewUser();
        $uuid = $user_resource->uuid;
        $user = logTestUserResourceIn($user_resource);
        $url = "http://127.0.0.1:".$this->api_port."/app2/apiv2/users/$uuid/stored_value/12020/create";
        $card_number = $this->card_f;
        $data['card_number'] = $card_number;
        $data['user_id'] = $user_resource->user_id;
        $request = createRequestObject($url,'POST',json_encode($data));
        $user_controller = new UserController(getM(),$user,$request,5);
        $result = makeMockRequest($user_controller);
        $result_as_array = json_decode($result,true);
        $message = $result_as_array['data']['user_message'];
        $this->assertContains('Your card info was saved successfully',$message);

        $givex_service = new GivexPaymentService($data);
        $givex_service->billing_user_id = $user['user_id'];
        $order_id = rand(11111,99999);
        $givex_service->order_id = $order_id;
        $givex_service->amount = $amount;
        $results = $givex_service->processPayment($amount);
        $this->assertEquals('success', $results['status']);

        // now cancel the request
        $givex_service = new GivexPaymentService($data);
        $givex_service->billing_user_id = $user['user_id'];
        $givex_service->order_id = $order_id;
        $givex_service->amount  = $amount;
        $results = $givex_service->voidTransaction(null,$results['transactionid']);
        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['raw_result']);
        $this->assertEquals('success', $results['status']);


    }

    function testCancel2()
    {
        $user_resource = createNewUser();
        $uuid = $user_resource->uuid;
        $user = logTestUserResourceIn($user_resource);
        $card_number = $this->card_f;
//        $url = "http://127.0.0.1:".$this->api_port."/app2/apiv2/users/$uuid/stored_value/12020/create";
//        $data['card_number'] = $card_number;
//        $data['user_id'] = $user_resource->user_id;
//        $request = createRequestObject($url,'POST',json_encode($data));
//        $user_controller = new UserController(getM(),$user,$request,5);
//        $result = makeMockRequest($user_controller);
//        $result_as_array = json_decode($result,true);
//        $message = $result_as_array['data']['user_message'];
//        $this->assertContains('Your card info was saved successfully',$message);

        $givex_service = new GivexPaymentService(null);
        $givex_service->billing_user_id = $user['user_id'];
        $order_id = rand(11111,99999);
        $givex_service->order_id = $order_id;
        $givex_service->amount = 30.00;
        $givex_service->setBillingUsersAccountNumber($card_number);
        $results = $givex_service->processPayment(30.00);
        $this->assertEquals('success', $results['status']);

        // now throw a second charge in
        $givex_service = new GivexPaymentService(null);
        $givex_service->billing_user_id = $user['user_id'];
        $order_id2 = rand(11111,99999);
        $givex_service->order_id = $order_id2;
        $givex_service->amount = 20.00;
        $givex_service->setBillingUsersAccountNumber($card_number);
        $results2 = $givex_service->processPayment(20.00);
        $this->assertEquals('success', $results2['status']);



        // now cancel the first redemption request
        $givex_service = new GivexPaymentService(null);
        $givex_service->billing_user_id = $user['user_id'];
        $givex_service->order_id = $order_id;
        $givex_service->amount  = 30.00;
        $givex_service->setBillingUsersAccountNumber($card_number);
        $results = $givex_service->voidTransaction(null,$results['transactionid']);
        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['raw_result']);
        $this->assertEquals('success', $results['status']);
    }

    function testWritLogs()
    {
        myerror_log("GiveX Certification Cancel Test #3  does not apply");
        myerror_log("GiveX Certification Cancel Test #4  does not apply");
    }

    function testNumber1InvalidNumber()
    {
        $user_resource = createNewUser();
        $uuid = $user_resource->uuid;
        $user = logTestUserResourceIn($user_resource);

        $card_number = '8295310131';
        $givex_service = new GivexPaymentService($data);
        $givex_service->billing_user_id = $user['user_id'];
        $givex_service->setBillingUsersAccountNumber($card_number);
        $givex_service->order_id = rand(11111,99999);
        $givex_service->amount = 50.00;
        $results = $givex_service->processPayment(50.00);
        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['raw_result']);

       // $this->assertEquals('failure', $results['status']);

    }

    function testNumber2NineteenDigits()
    {
        $user_resource = createNewUser();
        $uuid = $user_resource->uuid;
        $user = logTestUserResourceIn($user_resource);

        $card_number = '6036285698895779763';
        $givex_service = new GivexPaymentService(null);
        $givex_service->billing_user_id = $user['user_id'];
        $givex_service->setBillingUsersAccountNumber($card_number);
        $givex_service->order_id = rand(11111,99999);
        $givex_service->amount = 50.00;
        $results = $givex_service->processPayment(50.00);
        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['raw_result']);
        //$this->assertEquals('failure', $results['status']);

    }

    function testNumber3TwentyOneDigits()
    {
        $user_resource = createNewUser();
        $uuid = $user_resource->uuid;
        $user = logTestUserResourceIn($user_resource);

        $card_number = '603628951849999999994';
        $givex_service = new GivexPaymentService(null);
        $givex_service->billing_user_id = $user['user_id'];
        $givex_service->setBillingUsersAccountNumber($card_number);
        $givex_service->order_id = rand(11111,99999);
        $givex_service->amount = 50.00;
        $results = $givex_service->processPayment(50.00);
        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['raw_result']);
        //$this->assertEquals('failure', $results['status']);

    }

    function testNumber4TwentyTwoDigits()
    {
        $user_resource = createNewUser();
        $uuid = $user_resource->uuid;
        $user = logTestUserResourceIn($user_resource);

        $card_number = '6036289518412345678909';
        $givex_service = new GivexPaymentService(null);
        $givex_service->billing_user_id = $user['user_id'];
        $givex_service->setBillingUsersAccountNumber($card_number);
        $givex_service->order_id = rand(11111,99999);
        $givex_service->amount = 50.00;
        $results = $givex_service->processPayment(50.00);
        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['raw_result']);
        //$this->assertEquals('failure', $results['status']);

    }

    function testNumber5BinRange()
    {
        $card_number = '8888881196910438';
        $givex_service = new GivexPaymentService(null);
        $results = $givex_service->getRemoteCardInfo($card_number);
        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['raw_result']);
        //$this->assertEquals('success', $results['status']);
        //$balance = $results['balance'];
        //$this->assertEquals(0.00,$balance);

    }

    function testNumber6Alphanumeric()
    {
        $card_number = 'A234-57Q';
        $givex_service = new GivexPaymentService(null);
        $results = $givex_service->getRemoteCardInfo($card_number);
        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['raw_result']);
        //$this->assertEquals('success', $results['status']);
        //$balance = $results['balance'];
        //$this->assertEquals(80.00,$balance);

    }

    function testSunNumber1()
    {
        $card_number = '088993';
        $givex_service = new GivexPaymentService(null);
        $results = $givex_service->getRemoteCardInfo($card_number);
        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['raw_result']);
        //$this->assertEquals('failure', $results['status']);

    }

    function testLogin1()
    {
        // set user_id = 8888899999

        $user_resource = createNewUser();
        $uuid = $user_resource->uuid;
        $user = logTestUserResourceIn($user_resource);

        $card_number = $this->card_a;
        $givex_service = new GivexPaymentService(null);
        $givex_service->info['user_id'] = "8888899999";
        $givex_service->billing_user_id = $user['user_id'];
        $givex_service->setBillingUsersAccountNumber($card_number);
        $givex_service->order_id = rand(11111,99999);
        $givex_service->amount = 10.00;
        $results = $givex_service->processPayment(10.00);
        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['raw_result']);
        $this->assertEquals('failure', $results['status']);

    }

    function testLogin2()
    {
        // set user_id = '30474'
        // set password =  'gwgUhkg50lNcQxwz'

        $user_resource = createNewUser();
        $uuid = $user_resource->uuid;
        $user = logTestUserResourceIn($user_resource);

        $card_number = $this->card_e;
        $givex_service = new GivexPaymentService(null);
        $givex_service->info['user_id'] = "30474";
        $givex_service->info['password'] = "gwgUhkg50lNcQxwz";
        $givex_service->billing_user_id = $user['user_id'];
        $givex_service->setBillingUsersAccountNumber($card_number);
        $givex_service->order_id = rand(11111,99999);
        $givex_service->amount = 10.00;
        $results = $givex_service->processPayment(10.00);
        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['raw_result']);
        $this->assertEquals('failure', $results['status']);

    }

//Port B: 55104 Timeout test #1
//Port C: 56104 Timeout test #2
//Port D: 55105 Timeout test #3


    function testTimeout1()
    {
        $user_resource = createNewUser();
        $uuid = $user_resource->uuid;
        $user = logTestUserResourceIn($user_resource);
        $url = "http://127.0.0.1:".$this->api_port."/app2/apiv2/users/$uuid/stored_value/12020/create";
        $card_number = $this->card_c;
        $data['card_number'] = $card_number;
        $data['user_id'] = $user_resource->user_id;
        $request = createRequestObject($url,'POST',json_encode($data));
        $user_controller = new UserController(getM(),$user,$request,5);
        $result = makeMockRequest($user_controller);
        $result_as_array = json_decode($result,true);
        $message = $result_as_array['data']['user_message'];
        $this->assertContains('Your card info was saved successfully',$message);

        // gotta hit the B port and set timeout to 15 seconds.  then automatically to a reversal.
        // must use PORT B  55104
        // Send $6.00 Redemption request to the Givex host using card “C"
//        $url_resource = $this->ids['givex_url_resource'];
//        $url_resource->value = 'https://dev-dataconnect.givex.com:55104';
//        $url_resource->save();
        setProperty('givex_url','https://dev-dataconnect.givex.com:55104');


        $card_number = $this->card_c;
        $data = ['user_id'=>$user['user_id'],'skin_id'=>getSkinIdForContext()];
        $givex_service = new GivexPaymentService($data);
        $givex_service->billing_user_id = $user['user_id'];
        $givex_service->setBillingUsersAccountNumber($card_number);
        $givex_service->order_id = rand(11111,99999);
        $givex_service->amount = 6.00;
        $results = $givex_service->processPayment(6.00);
        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['reversal_result']);
        $this->assertNotNull($results['reversal_info'],"it should have the reversal info on the results");

    }


    function testTimeout2()
    {
        // Configure the primary port to use Port C for this test.
        // port C is 56104
        // Set timeout for 15 seconds
        // Send $7.00 Redemption request to the Givex host using card “C”
        $user_resource = createNewUser();
        $uuid = $user_resource->uuid;
        $user = logTestUserResourceIn($user_resource);
        $url = "http://127.0.0.1:".$this->api_port."/app2/apiv2/users/$uuid/stored_value/12020/create";
        $card_number = $this->card_c;
        $data['card_number'] = $card_number;
        $data['user_id'] = $user_resource->user_id;
        $request = createRequestObject($url,'POST',json_encode($data));
        $user_controller = new UserController(getM(),$user,$request,5);
        $result = makeMockRequest($user_controller);
        $result_as_array = json_decode($result,true);
        $message = $result_as_array['data']['user_message'];
        $this->assertContains('Your card info was saved successfully',$message);

        // must use PORT C 56104
        // Send 7.00 Redemption request to the Givex host using card “C"
        setProperty('givex_url','https://dev-dataconnect.givex.com:56104');


        $card_number = $this->card_c;
        $data = ['user_id'=>$user['user_id'],'skin_id'=>getSkinIdForContext()];
        $givex_service = new GivexPaymentService($data);
        $givex_service->billing_user_id = $user['user_id'];
        $givex_service->setBillingUsersAccountNumber($card_number);
        $givex_service->order_id = rand(11111,99999);
        $givex_service->amount = 7.00;
        $results = $givex_service->processPayment(7.00);
        myerror_log("GiveX Certification " . __FUNCTION__ . " the result is: ".$results['reversal_result']);
        $this->assertNotNull($results['reversal_info'],"it should have the reversal info on the results");
    }

    function testWritLogsTwo()
    {
        myerror_log("GiveX Certification Timeout Test #3 does not apply");
        myerror_log("GiveX Certification Failover Test #1 does not apply");
    }


    // test time out 3 with failover is not applicable.  no failover
    // test Failover is not applicable.  no failover



    function makeRequestWithDefaultHeaders($url,$userpassword,$method = 'GET',$data = null,$external_id = null)
    {
        if ($external_id == null) {
            $external_id = getContext();
        }
        $headers = array("X_ORDER140_CLIENT_ID"=>"$external_id","X_ORDER140_CLIENT_DEVICE"=>"unit_testing","HTTP_X_ORDER140_CLIENT_VERSION"=>"10.5.0","X_ORDER140_CLIENT"=>"APIGiveXTest","NO_CC_CALL"=>"true");
        if ($authentication_token = $data['splickit_authentication_token']) {
            $headers['splickit_authentication_token'] = $authentication_token;
            unset($data['splickit_authentication_token']);
        }
        if ($data['headers']) {
            $headers = array_merge($headers,$data['headers']);
            unset($data['headers']);
        }
        $header_array = array();
        foreach ($headers as $key=>$value) {
            $header_array[] = $key.":".$value;
        }
        return $this->makeRequest($url,$userpassword,$method,$header_array,$data);
    }

    function makeRequest($url,$userpassword,$method = 'GET', $headers = array(),$data = null)
    {
        unset($this->info);
        $method = strtoupper($method);
        $curl = curl_init($url);
        if ($userpassword) {
            curl_setopt($curl, CURLOPT_USERPWD, $userpassword);
        }
        if ($method == 'POST') {
            $json = json_encode($data);
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_POSTFIELDS,$json);
            $headers[] = 'Content-Type: application/json';
            $headers[] = 'Content-Length: ' . strlen($json);
        } else if ($method == 'DELETE') {
            curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "DELETE");
        }
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        logCurl($url,$method,$userpassword,$headers,$json);
        $result = curl_exec($curl);
        $this->info = curl_getinfo($curl);
        curl_close($curl);
        return $result;
    }


	static function setUpBeforeClass()
    {
        $_SERVER['request_time1'] = microtime(true);
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));
        ini_set('max_execution_time',300);



        $skin_resource = getOrCreateSkinAndBrandIfNecessaryWithLoyalty("givexskin","givexbrand",null, null);
        $ids['skin_id'] = $skin_resource->skin_id;
        setContext('com.splickit.givexskin');

    	$simple_menu_id = createTestMenuWithOneItem("item_one");
    	$ids['menu_id'] = $simple_menu_id;
    	
    	$merchant_resource = createNewTestMerchant($simple_menu_id,['no_payment'=>true]);
    	$merchant_resource->save();
    	$ids['merchant_id'] = $merchant_resource->merchant_id;

    	$merchant_payment_type_map_resource = MerchantPaymentTypeMapsAdapter::createMerchantPaymentTypeMap($merchant_resource->merchant_id, 12020, null);

        $tpppa = new ThirdPartyProviderParametersAdapter(getM());
        $parameters = $tpppa->getParametersFromProviderId(5002);
        foreach ($parameters as $parameter_row) {
            $data = [];
            $data['third_party_provider_parameter_id'] = $parameter_row['third_party_provider_parameter_id'];
            if ($parameter_row['name'] == 'user_id') {
                $data['value'] = 36976;
                $data['skin_id'] = getSkinIdForContext();
                $tpppsma = new ThirdPartyProviderParameterSkinMapsAdapter(getM());
                $ids['givex_user_id_resource'] = Resource::findOrCreateIfNotExistsByData($tpppsma,$data);
            } else if ($parameter_row['name'] == 'password') {
                $data['value'] = 'zgXN8jE1wPpYy33L';
                $data['skin_id'] = getSkinIdForContext();
                $tpppsma = new ThirdPartyProviderParameterSkinMapsAdapter(getM());
                $ids['givex_password_resource'] = Resource::findOrCreateIfNotExistsByData($tpppsma,$data);
            }
        }
        $cbea = new ConfigurationByEnvironmentVariablesAdapter(getM());


        $url_resource = Resource::find($cbea,null,[3=>['name'=>'givex_url']]);
        $url_resource->value = 'https://dev-dataconnect.givex.com:50104';
        $url_resource->save();
        $ids['givex_url_resource'] = $url_resource;

        $_SERVER['log_level'] = 5;
		$_SERVER['unit_test_ids'] = $ids;
    }

    static function tearDownAfterClass()
    {
        SplickitCache::flushAll();
        date_default_timezone_set($_SERVER['starting_tz']);
    }


    /* mail method for testing */
    static function main() {
		$suite = new PHPUnit_Framework_TestSuite( __CLASS__);
  		PHPUnit_TextUI_TestRunner::run( $suite);
 	}
    
}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    GiveXCertificationTest::main();
}
?>