<?php

error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');
$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;

require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';

class GiveXTest extends PHPUnit_Framework_TestCase
{
	var $stamp;
	var $ids;
    var $api_port = "80";

	function setUp()
	{
		$this->stamp = $_SERVER['STAMP'];
		$_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
		$this->ids = $_SERVER['unit_test_ids'];
        if (isset($_SERVER['XDEBUG_CONFIG'])) {
            $this->api_port = "10080";
        }
	}
	
	function tearDown() 
	{
		//delete your instance
		$_SERVER['STAMP'] = $this->stamp;
		unset($this->ids);
    }

//        INSERT INTO Configuration_By_Environment_Variables (`name`,`value`,`environment`) VALUES ('givex_url','https://dev-dataconnect.givex.com:50104','default');
//        INSERT INTO Configuration_By_Environment_Variables (`name`,`value`,`environment`) VALUES ('givex_url','https://dataconnect.givex.com:XXXXX','production');
//        INSERT INTO Third_Party_Providers (id,third_party_provider_type_id,name,description) VALUES (5002,5000,'GiveX','GiveX Stored Value');
//        INSERT INTO Third_Party_Provider_Parameters (third_party_provider_id,name,default_context,required) VALUES (5002,'user_id','skin',1),(5002,'password','skin',1)

    function testGetBalance()
    {

        $card_number = '60362883818161604012';
        $givex_service = new GivexPaymentService($data);
        $results = $givex_service->getRemoteCardInfo($card_number);
        $this->assertEquals('success', $results['status']);
    }

    function testCreditAccount()
    {
        $card_number = '60362883818161604012';
        $givex_service = new GivexPaymentService($data);

        $balance_results = $givex_service->getRemoteCardInfo($card_number);
        $this->assertEquals('success', $balance_results['status']);
        $starting_balance = $balance_results['balance'];

        $amount = 5.00;
        $results = $givex_service->addCashValueToCard($card_number,$amount);
        $this->assertEquals('success', $results['status']);
        $ending_balance = $results['balance'];
        $this->assertEquals($ending_balance,$starting_balance+$amount);

    }


    function testRedemption()
    {
        $user_resource = createNewUser();
        $uuid = $user_resource->uuid;
        $user = logTestUserResourceIn($user_resource);
        $url = "http://127.0.0.1:".$this->api_port."/app2/apiv2/users/$uuid/stored_value/12020/create";
        $card_number = "60362836362161604023";
        $data['card_number'] = $card_number;
        $data['user_id'] = $user_resource->user_id;
        $request = createRequestObject($url,'POST',json_encode($data));
        $user_controller = new UserController(getM(),$user,$request,5);
        $result = makeMockRequest($user_controller);
        $result_as_array = json_decode($result,true);
        $message = $result_as_array['data']['user_message'];
        $this->assertContains('Your card info was saved successfully',$message);


        $card_number = '60362883818161604012';
        $givex_service = new GivexPaymentService($data);
        $givex_service->billing_user_id = $user['user_id'];
        $givex_service->order_id = rand(11111,99999);
        $givex_service->amount = 1.50;
        $results = $givex_service->processPayment(1.50);
        $this->assertEquals('success', $results['status']);
        $results['user'] = $user;
        $results['order_id'] = $givex_service->order_id;
        return $results;
    }

    /**
     * @depends testRedemption
     */
    function testCancel($results)
    {
        $user = $results['user'];
        $order_id =  $results['order_id'];
        logTestUserIn($user['user_id']);
        $card_number = '60362883818161604012';
        $givex_service = new GivexPaymentService($data);
        $givex_service->billing_user_id = $user['user_id'];
        $givex_service->order_id = $order_id;
        $givex_service->amount  = 1.50;
        $results = $givex_service->voidTransaction(null,$results['transactionid']);
        $this->assertEquals('success', $results['status']);

    }

    //    function testBalanceConnection()
    //    {
    //
    //        $payload = ['en','12345',36976,'zgXN8jE1wPpYy33L','60362883818161604012'];
    //        $data = [];
    //        $data['jsonrpc'] = "2.0";
    //        $id = rand(10,99);
    //        $data['id'] = "$id";
    //        $data['method'] = 'dc_994';
    //        $data['params'] = $payload;
    //        $url = "https://dev-dataconnect.givex.com:50104";
    //        $curl = curl_init($url);
    //        if ($data['headers']) {
    //            $headers = $data['headers'];
    //            unset($data['headers']);
    //        }
    //
    //        curl_setopt($curl, CURLOPT_POST, 1);
    //        if ($data) {
    //            $json = json_encode($data);
    //            curl_setopt($curl, CURLOPT_POSTFIELDS,$json);
    //            //$headers[] = 'Service: 904';
    //            $headers[] = 'Content-Type: application/json';
    //            $headers[] = 'Content-Length: ' . strlen($json);
    //        }
    //        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    //        curl_setopt($curl, CURLOPT_SSL_CIPHER_LIST,'TLSv1.2');
    //        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
    //        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    //        curl_setopt($curl, CURLOPT_VERBOSE,1);
    //        logCurl($url,'POST',null,$headers,$json);
    //        $result = curl_exec($curl);
    //
    //        $this->info = curl_getinfo($curl);
    //        curl_close($curl);
    //        $result_as_array = json_decode($result,true);
    //        $this->assertEquals($id,$result_as_array['id']);
    //        $this->assertEquals(200,$this->info['http_code']);
    //    }



    function testAddCardToUserAccount()
    {
        $user_resource = createNewUser();
        $uuid = $user_resource->uuid;
        $user = logTestUserResourceIn($user_resource);
        $url = "http://127.0.0.1:".$this->api_port."/app2/apiv2/users/$uuid/stored_value/12020/create";
        $card_number = "60362883818161604012";
        $data['card_number'] = $card_number;
        $data['user_id'] = $user_resource->user_id;

//        $request = createRequestObject($url,'POST',json_encode($data));
//        $user_controller = new UserController(getM(),$user,$request,5);
//        $result = makeMockRequest($user_controller);

        $result = $this->makeRequestWithDefaultHeaders($url, $user_resource->email.':welcome','POST',$data);
        $this->assertEquals('200', $this->info['http_code']);
        $result_as_array = json_decode($result,true);
        $message = $result_as_array['data']['user_message'];
        $this->assertContains('Your card info was saved successfully',$message);
        return $user;
    }

    /**
     * @depends testAddCardToUserAccount
     */
    function testEndToEndCharge($user)
    {
        logTestUserIn($user['user_id']);
        $ussvma = new UserSkinStoredValueMapsAdapter(getM());
        $sv_resource = Resource::find($ussvma,null,[3=>['user_id'=>$user['id'],'splickit_accepted_payment_type_id'=>12020]]);
        $sv_resource->balance = 1.09;
        $sv_resource->save();

        $merchant_id = $this->ids['merchant_id'];

        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($merchant_id);

        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,getTomorrowTwelveNoonTimeStampDenver());
        $this->assertNull($checkout_resource->error);

        $sv_resource = Resource::find($ussvma,null,[3=>['user_id'=>$user['id'],'splickit_accepted_payment_type_id'=>12020]]);
        $this->assertNotEquals(1.09,$sv_resource->balance);
//        $givex_payment_type = $checkout_resource->accepted_payment_types[0];
//        $checkout_resource->accepted_payment_types = [$givex_payment_type];
        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,0.00);
        $this->assertNull($order_resource->error);

        $bcr = BalanceChangeAdapter::staticGetRecords(['order_id'=>$order_resource->order_id],'BalanceChangeAdapter');
        $bcr_hash = createHashmapFromArrayOfArraysByFieldName($bcr,'process');
        $stored_value_row = $bcr_hash['StoredValuePayment'];
        $this->assertEquals('GivexPaymentService',$stored_value_row['cc_processor']);
        return $order_resource->order_id;
    }

    function makeRequestWithDefaultHeaders($url,$userpassword,$method = 'GET',$data = null,$external_id = null)
    {
        if ($external_id == null) {
            $external_id = getContext();
        }
        $headers = array("X_ORDER140_CLIENT_ID"=>"$external_id","X_ORDER140_CLIENT_DEVICE"=>"unit_testing","HTTP_X_ORDER140_CLIENT_VERSION"=>"10.5.0","X_ORDER140_CLIENT"=>"APIGiveXTest","NO_CC_CALL"=>"true");
        if ($authentication_token = $data['splickit_authentication_token']) {
            $headers['splickit_authentication_token'] = $authentication_token;
            unset($data['splickit_authentication_token']);
        }
        if ($data['headers']) {
            $headers = array_merge($headers,$data['headers']);
            unset($data['headers']);
        }
        $header_array = array();
        foreach ($headers as $key=>$value) {
            $header_array[] = $key.":".$value;
        }
        return $this->makeRequest($url,$userpassword,$method,$header_array,$data);
    }

    function makeRequest($url,$userpassword,$method = 'GET', $headers = array(),$data = null)
    {
        unset($this->info);
        $method = strtoupper($method);
        $curl = curl_init($url);
        if ($userpassword) {
            curl_setopt($curl, CURLOPT_USERPWD, $userpassword);
        }
        if ($method == 'POST') {
            $json = json_encode($data);
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_POSTFIELDS,$json);
            $headers[] = 'Content-Type: application/json';
            $headers[] = 'Content-Length: ' . strlen($json);
        } else if ($method == 'DELETE') {
            curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "DELETE");
        }
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        logCurl($url,$method,$userpassword,$headers,$json);
        $result = curl_exec($curl);
        $this->info = curl_getinfo($curl);
        curl_close($curl);
        return $result;
    }


	static function setUpBeforeClass()
    {
        $_SERVER['request_time1'] = microtime(true);
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));
        ini_set('max_execution_time',300);

        $skin_resource = getOrCreateSkinAndBrandIfNecessaryWithLoyalty("givexskin","givexbrand",null, null);
        $ids['skin_id'] = $skin_resource->skin_id;
        setContext('com.splickit.givexskin');

    	$simple_menu_id = createTestMenuWithOneItem("item_one");
    	$ids['menu_id'] = $simple_menu_id;
    	
    	$merchant_resource = createNewTestMerchant($simple_menu_id,['no_payment'=>true]);
    	$merchant_resource->save();
    	$ids['merchant_id'] = $merchant_resource->merchant_id;

    	$merchant_payment_type_map_resource = MerchantPaymentTypeMapsAdapter::createMerchantPaymentTypeMap($merchant_resource->merchant_id, 12020, null);

        $tpppa = new ThirdPartyProviderParametersAdapter(getM());
        $parameters = $tpppa->getParametersFromProviderId(5002);
        foreach ($parameters as $parameter_row) {
            $data = [];
            $data['third_party_provider_parameter_id'] = $parameter_row['third_party_provider_parameter_id'];
            if ($parameter_row['name'] == 'user_id') {
                $data['value'] = 36976;
                $data['skin_id'] = getSkinIdForContext();
                $tpppsma = new ThirdPartyProviderParameterSkinMapsAdapter(getM());
                Resource::createByData($tpppsma,$data);
            } else if ($parameter_row['name'] == 'password') {
                $data['value'] = 'zgXN8jE1wPpYy33L';
                $data['skin_id'] = getSkinIdForContext();
                $tpppsma = new ThirdPartyProviderParameterSkinMapsAdapter(getM());
                Resource::createByData($tpppsma,$data);
            }
        }

        $_SERVER['log_level'] = 5;
		$_SERVER['unit_test_ids'] = $ids;
    }

    static function tearDownAfterClass()
    {
        SplickitCache::flushAll();
        date_default_timezone_set($_SERVER['starting_tz']);
    }


    /* mail method for testing */
    static function main() {
		$suite = new PHPUnit_Framework_TestSuite( __CLASS__);
  		PHPUnit_TextUI_TestRunner::run( $suite);
 	}
    
}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    GiveXTest::main();
}
?>