<?php
error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');
$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;
require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';

class GoogleGeoServiceTest extends PHPUnit_Framework_TestCase
{
	var $stamp;
	var $ids;

	function setUp()
	{
		$_SERVER['HTTP_NO_CC_CALL'] = 'true';
		$this->stamp = $_SERVER['STAMP'];
		$_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
		$this->ids = $_SERVER['unit_test_ids'];
		
	}
	
	function tearDown() 
	{
		//delete your instance
		$_SERVER['STAMP'] = $this->stamp;
		unset($this->ids);
    }
    
//    function testGoogleGeo()
//    {
//    	$address = "1600+Amphitheatre+Parkway,+Mountain+View,+CA";
//    	$location = GoogleGeoCoderService::staticGeoCodeAddress($address);
//    	$this->assertNotNull($location['lat']);
//    	$lat = number_format($location['lat'],2);
//    	$this->assertEquals(37.42,$lat);
//    }
//
//    function testGoogleGeoOtherAddress()
//    {
//    	$address = "375+Janik+Drive,Kent,OH+44243";
//    	$location = GoogleGeoCoderService::staticGeoCodeAddress($address);
//    	$this->assertNotNull($location['lat']);
//    	$lat = number_format($location['lat'],6);
//    	$this->assertEquals(41.15,round($lat,2));
//    }
//
//	function testGoogleGeoBadAddress()
//    {
//    	$address = "123+sumdum+street,cnetral+toen,BY";
//    	$location = GoogleGeoCoderService::staticGeoCodeAddress($address);
//    	$this->assertNull($location);
//    }
    
    function testShortestDrivingDistance()
    {
    	// had to do this with successes since dur to construction a distance can change for a little while.
    	$successes = 0;
    	$shortest_distance = GoogleGeoCoderService::getShortestDrivingDistance(46.839382, -100.771373, 46.791115, -100.763650);
    	//$this->assertEquals(4.17, $shortest_distance,"shortest distance should have been 4.17 miles");
    	if (4.17 == number_format($shortest_distance,2)) {
    		$successes++;
    	} else {
    		myerror_log("shortest distance should have been 4.17 miles but was $shortest_distance");
    	}
    	
    	$shortest_distance = GoogleGeoCoderService::getShortestDrivingDistance(40.014726,-105.274479,40.014594,-105.275990 );
    	//$this->assertEquals(0.08, $shortest_distance,"shortest distance should have been .08 miles");
    	if (0.1 == number_format($shortest_distance,1)) {
    		$successes++;
    	} else {
    		myerror_log("shortest distance should have been 0.08 miles but was $shortest_distance");
    	}
    	
        $shortest_distance = GoogleGeoCoderService::getShortestDrivingDistance(40.014726,-105.274479,39.867014,-104.934993);
    	//$this->assertEquals(23.38, $shortest_distance,"shortest distance should have been 23.38 miles");
    	if (23.4 == number_format($shortest_distance,1)) {
    		$successes++;
    	} else {
    		myerror_log("shortest distance should have been 23.38 miles but was $shortest_distance");
    	}
    	
        $shortest_distance = GoogleGeoCoderService::getShortestDrivingDistance(40.014726,-105.274479,40.400445,-104.695179);
    	//$this->assertEquals(49.26, $shortest_distance,"shortest distance should have been 49.26 miles");
   		if (49 == number_format($shortest_distance,0)) {
    		$successes++;
    	} else {
    		myerror_log("shortest distance should have been 49 miles but was $shortest_distance");
    	}
    	$this->assertTrue($successes >= 3,"should have only had a max of 1 failure but had more.");
     	
        $shortest_distance = GoogleGeoCoderService::getShortestDrivingDistance(40.014726,-105.274479,47.673989,-116.786191);
        $this->assertTrue($shortest_distance > 1040 && $shortest_distance < 1062," shortest distance was off: ".$shortest_distance);
    	//$this->assertEquals(1048.08, $shortest_distance,"shortest distance should have been 1048.08 miles");
    	
    }

    static function setUpBeforeClass()
    {
    	$_SERVER['request_time1'] = microtime(true);
    	$_SERVER['NO_MOCKS'] = true;
    	$tz = date_default_timezone_get();
    	$_SERVER['starting_tz'] = $tz;
    	date_default_timezone_set(getProperty("default_server_timezone"));
    	mysqli_query("BEGIN");

    	$_SERVER['log_level'] = 5; 
		$_SERVER['unit_test_ids'] = $ids;
    }
    
	static function tearDownAfterClass()
    {
    	mysqli_query("ROLLBACK");
    	date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main() {
		$suite = new PHPUnit_Framework_TestSuite( __CLASS__);
  		PHPUnit_TextUI_TestRunner::run( $suite);
 	}
    
}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    GoogleGeoServiceTest::main();
}

?>