<?php

$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');

require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';

class SnarfsEmagineServiceTest extends PHPUnit_Framework_TestCase
{
    var $stamp;
    var $ids;

    function setUp()
    {
        $_SERVER['HTTP_NO_CC_CALL'] = 'true';
        $this->stamp = $_SERVER['STAMP'];
        $_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
        $this->ids = $_SERVER['unit_test_ids'];
        setContext('com.splickit.snarfs');

    }

    function tearDown()
    {
        //delete your instance
        $_SERVER['STAMP'] = $this->stamp;
        unset($this->ids);
    }

    function testSendOrderIntoEmaginSystem()
    {
        $order_id = rand(111111,999999);
        $pickup_ts = time()+1200;
        $pickup_time = date('H:i',$pickup_ts);
        $pickup_date = date('m/d/y',$pickup_ts);
        $order_time = date('H:i');
        $order_date = date('m/d/y');
        $json = cleanUpDoubleSpacesCRLFTFromString('{
    "location":"Location168",
  "authToken":"1234567890",
  "order":{  
   "order_id":"'.$order_id.'",
   "order_dt_tm":'.time().',
   "user_id":"20000",
   "pickup_dt_tm":'.(time()+1200).',
   "order_amt":"1.50",
   "total_tax_amt":"0.15",
   "trans_fee_amt":"0.00",
   "grand_total":"1.65",
   "tip_amt":"0.50",
   "customer_donation_amt":"0.00",
   "cash":"N",
   "note":"Here are some order notes",
   "order_qty":"1",
   "full_name":"Bob Roberts",
   "user_email":"testuser_1449247638_y3y@order140.com",
   "user_phone_no":"123 456 7890",
   "pickup_time":"'.$pickup_time.'",
   "pickup_date":"'.$pickup_date.'",
   "order_date":"'.$order_date.'",
   "order_time":"'.$order_time.'",
   "loyalty_number":"splick-C009QDF226",
   "order_details":[  
      {  
         "order_detail_id":"583044",
         "external_id":"d5rmotscp3gvzn5tzq3kojru4i",
         "item_name":"Bottle Water",
         "note":"This is an item level note",
         "quantity":"1",
         "price":"1.50",
         "item_total":"1.50",
         "item_total_w_mods":"1.50",
         "item_tax":"0.15",
         "order_detail_modifiers":[]
      }
   ]
}
}');

        $url = "http://dev.emaginepos.com:9191/splickit";

        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_VERBOSE,1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $json);
        curl_setopt($ch, CURLOPT_SSL_CIPHER_LIST,'TLSv1');
        curl_setopt($ch, CURLOPT_HEADER, 1);
        $headers = array(
            'Content-Type: application/json',
            'Content-Length: ' . strlen($json));
        curl_setopt($ch, CURLOPT_HTTPHEADER,$headers);
        logCurl($url,'POST',$up,$headers,$json);
        $response = curl_exec($ch);
        myerror_log("Emagine Response: ".$response);
        $info = curl_getinfo($ch);
        curl_close($ch);
        $this->assertEquals(200,$info['http_code']);
        $response_array = json_decode($response,true);



    }
    


    static function setUpBeforeClass()
    {
        $_SERVER['request_time1'] = microtime(true);
        $_SERVER['NO_MOCKS'] = true;
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));

        $_SERVER['log_level'] = 5;
        $_SERVER['unit_test_ids'] = $ids;
    }

    static function tearDownAfterClass()
    {
        date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main() {
        $suite = new PHPUnit_Framework_TestSuite( __CLASS__);
        PHPUnit_TextUI_TestRunner::run( $suite);
    }

}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    SnarfsEmagineServiceTest::main();
}

?>