<?php

error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');
$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;

require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';

class VIOReportingTest extends PHPUnit_Framework_TestCase
{
	var $stamp;
	var $ids;

	function setUp()
	{
		$this->stamp = $_SERVER['STAMP'];
		$_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
		$this->ids = $_SERVER['unit_test_ids'];
	}
	
	function tearDown() 
	{
		//delete your instance
		$_SERVER['STAMP'] = $this->stamp;
		unset($this->ids);
    }

//    function testProcessData()
//    {
//        $data = file_get_contents('unit_tests_services/resources/transactiondata.txt');
//        $transactions = json_decode($data,true);
//        $vio_activity = new VioDataImportActivity();
//        $vio_activity->saveDailyTransactionData($transactions,null);
//    }
//
//    function testImportWithActivityNoDate()
//    {
//        $doit_ts = time()-10;
//        $info = "action=daily_deposit";
//        $activity_history_adapter = new ActivityHistoryAdapter(getM());
//        $activity_history_resource = $activity_history_adapter->createActivityReturnActivityResource('VioDataImport', $doit_ts, $info, '');
//
//        $activity = $activity_history_adapter->getActivityFromUnlockedActivityHistoryResource($activity_history_resource);
//        $this->assertNotNull($activity);
//        $activity->executeThisActivity();
//
//    }
//
//
//    function testNoData()
//    {
//        $doit_ts = time()-10;
//        //set a date in the future
//        $info = "action=deposit_detail;date=12/8/2021";
//
//        $activity_history_adapter = new ActivityHistoryAdapter(getM());
//        $activity_history_resource = $activity_history_adapter->createActivityReturnActivityResource('VioDataImport', $doit_ts, $info, '');
//
//        $activity = $activity_history_adapter->getActivityFromUnlockedActivityHistoryResource($activity_history_resource);
//        $this->assertNotNull($activity);
//        $activity->executeThisActivity();
//        $activity_id = $activity_history_resource->activity_id;
//        $failed_resource = Resource::find(new ActivityHistoryAdapter(getM()),$activity_id);
//        $this->assertEquals('F',$failed_resource->locked);
//
//    }

//    function testFile()
//    {
//        $doit_ts = time()-10;
//        $date = date("n/j/Y", time() - (2 * 24 * 3600));
//        //$info = "date=$date;account_number=32878591";
//        $info = "file=file";
//
//        $activity_history_adapter = new ActivityHistoryAdapter(getM());
//        $activity_history_resource = $activity_history_adapter->createActivityReturnActivityResource('VioDataImport', $doit_ts, $info, '');
//
//        $activity = $activity_history_adapter->getActivityFromUnlockedActivityHistoryResource($activity_history_resource);
//        $this->assertNotNull($activity);
//        $activity->executeThisActivity();
//
//    }

    function testDepositDetail()
    {
        $doit_ts = time()-10;
        $date = date("n/j/Y", time() - (2 * 24 * 3600));
        //$info = "date=$date;account_number=32878591";
//        $info = "date=$date";
//        $info = "action=deposit_detail";
//        $info = "action=deposit_detail;date=$date";
        $info = "action=deposit_detail;date=2020-10-10";

        $activity_history_adapter = new ActivityHistoryAdapter(getM());
        $activity_history_resource = $activity_history_adapter->createActivityReturnActivityResource('VioDataImport', $doit_ts, $info, '');

        $activity = $activity_history_adapter->getActivityFromUnlockedActivityHistoryResource($activity_history_resource);
        $this->assertNotNull($activity);
        $activity->executeThisActivity();

    }


    function testImportWithActivityFixedDate()
    {
        $doit_ts = time()-10;
        $date = date("n/j/Y", time() - (2 * 24 * 3600));
        //$info = "date=$date;account_number=32878591";
        $info = "date=$date";
        $info = "action=transactions;date=$date";

        $activity_history_adapter = new ActivityHistoryAdapter(getM());
        $activity_history_resource = $activity_history_adapter->createActivityReturnActivityResource('VioDataImport', $doit_ts, $info, '');

        $activity = $activity_history_adapter->getActivityFromUnlockedActivityHistoryResource($activity_history_resource);
        $this->assertNotNull($activity);
        $activity->executeThisActivity();

    }

	static function setUpBeforeClass()
    {
        $_SERVER['request_time1'] = microtime(true);
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));
        ini_set('max_execution_time',300);

    	$merchant_resource = createNewTestMerchant();
    	$merchant_resource->save();
    	//attachMerchantToSkin($merchant_resource->merchant_id, $ids['skin_id']);
    	$ids['merchant_id'] = $merchant_resource->merchant_id;

      	$_SERVER['log_level'] = 5;
		$_SERVER['unit_test_ids'] = $ids;
    }

    static function tearDownAfterClass()
    {
        SplickitCache::flushAll();
        date_default_timezone_set($_SERVER['starting_tz']);
    }


    /* mail method for testing */
    static function main() {
		$suite = new PHPUnit_Framework_TestSuite( __CLASS__);
  		PHPUnit_TextUI_TestRunner::run( $suite);
 	}
    
}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    VIOReportingTest::main();
}
?>