<?php

error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');
$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;

require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';

class VantiveTest extends PHPUnit_Framework_TestCase
{
	var $stamp;
	var $ids;

	function setUp()
	{
        $_SERVER['HTTP_NO_CC_CALL'] = 'true';
        $this->stamp = $_SERVER['STAMP'];
        $_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
        $this->ids = $_SERVER['unit_test_ids'];
        setContext('com.splickit.vantiveskin');
        $this->api_port = "80";
        if (isset($_SERVER['XDEBUG_CONFIG'])) {
            $this->api_port = "10080";
        }
	}
	
	function tearDown() 
	{
		//delete your instance
		$_SERVER['STAMP'] = $this->stamp;
		unset($this->ids);
    }




    function testVantiveMethods()
    {
        $vantive_payment_service = new VantivePaymentService();
        $card_number = '6050110000000015438';

        $response = $vantive_payment_service->getRemoteCardInfo($card_number);
//        $payload = [];
//        $payload['MerchantID'] = '62589001=TEST';
//        $payload['MerchantID'] = '10101010=sumdumnumber';
        // $payload['MerchantID'] = '';
//        $payload['IpPort'] = 9100;
//        $payload['OperatorID'] = 'test';
//        $payload['TranType'] = 'PrePaid';
//        $payload['RefNo'] = getStamp();
//        $payload['InvoiceNo'] = "1000".time();
//        $payload['Memo'] = "MPS Transact 1.2.0.5";
//        $payload['AcctNo'] = '6050110000000015438';
//        $payload['TranCode'] = 'Balance';
//
//
//        $url = 'https://w1.mercurycert.net/PaymentsAPI/PrePaid/Balance';
//        $response = VantiveCurl::curlIt($url,$payload,'003503902913105:xyz');
        //003503902913105:xyz

//        $method = strtoupper('POST');
//        $curl = curl_init($url);
//
//        $user_password = '003503902913105:xyz';
//        curl_setopt($curl, CURLOPT_USERPWD, $user_password );
//        curl_setopt($curl, CURLOPT_VERBOSE,1);
//        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
//        curl_setopt($curl, CURLOPT_SSL_CIPHER_LIST,'TLSv1.2');
//        curl_setopt($curl, CURLOPT_POST, 1);
//        curl_setopt($curl, CURLOPT_POSTFIELDS,$json_payload);
//        $headers[] = 'Content-Type: application/json';
//        $headers[] = 'Content-Length: ' . strlen($json_payload);
//        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
//        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
//        logCurl($url,$method,$user_password,$headers,$json_payload);
//        $response = curl_exec($curl);
//        $this->info = curl_getinfo($curl);
//        curl_close($curl);
//        myerror_log("RESPONSE: $response");
        $this->assertEquals(200,$response['http_code']);
        $raw_result_as_array = json_decode($response['raw_result'],true);
        $this->assertEquals('Approved',$raw_result_as_array['CmdStatus']);

        $balance = $raw_result_as_array['Balance'];

        // now do a sale
        $sale_amount = 6.66;

        $vantive_payment_service = new VantivePaymentService();
        $vantive_payment_service->merchant_id = $this->ids['merchant_id'];
        $info = $vantive_payment_service->setInfo();
        $card_number = '6050110000000015438';

        $vantive_payment_service->info['MerchantID'] = '62589001=TEST';
        $order_id = rand(11111111,99999999);
        $vantive_payment_service->order_id = $order_id;

        $user_resource = createNewUserWithCCNoCVV();
        $user_id = $user_resource->user_id;
        $ubsvma = new UserSkinStoredValueMapsAdapter(getM());
        $user_skin_stored_value_map_resource = $ubsvma->saveCardNumber($card_number,$user_id,getSkinIdForContext(),12010);
        $user_skin_stored_value_map_resource->balance = '500.00';
        $user_skin_stored_value_map_resource->save();

        $vantive_payment_service->user_skin_stored_value_map_resource = $user_skin_stored_value_map_resource;
        $response = $vantive_payment_service->processPayment($sale_amount);





//        $payload['Purchase'] = $sale_amount;
//        $payload['TranCode'] = 'Sale';
//        $payload['InvoiceNo'] = rand(111111,999999);
//        $json_payload = json_encode($payload);
//        myerror_log($json_payload);
//
//        $url = 'https://w1.mercurycert.net/PaymentsAPI/PrePaid/Sale';
//        $response = VantiveCurl::curlIt($url,$payload);
        $this->assertEquals(200,$response['http_code']);
        $raw_result_as_array = json_decode($response['raw_result'],true);
        $this->assertEquals('Approved',$raw_result_as_array['CmdStatus']);
        $expected_new_balance = $balance-$sale_amount;
        $this->assertEquals($expected_new_balance,$raw_result_as_array['Balance']);
        $auth_code = $raw_result_as_array['AuthCode'];
        $second_balance = $raw_result_as_array['Balance'];

        // now try a void

        $vantive_payment_service = new VantivePaymentService();
        $vantive_payment_service->merchant_id = $this->ids['merchant_id'];
        $info = $vantive_payment_service->setInfo();
        $vantive_payment_service->user_skin_stored_value_map_resource = $user_skin_stored_value_map_resource->refreshResource();
        $card_number = '6050110000000015438';

        $vantive_payment_service->info['MerchantID'] = '62589001=TEST';
        $vantive_payment_service->order_id = $order_id;

        $balance_change_adapter = new BalanceChangeAdapter(getM());
        $vantive_payment_service->balance_change_resource_for_stored_value_payment = $balance_change_adapter->addStoredValueRow($user_id,0.00,$sale_amount,0.00,'Vantive',$order_id,$auth_code,'note');
        $response = $vantive_payment_service->voidTransaction($auth_code,null);


//        $payload['TranCode'] = 'VoidSale';
//        $payload['RefNo'] = $auth_code;
//        $payload['AuthCode'] = $auth_code;
//
//        $url = 'https://w1.mercurycert.net/PaymentsAPI/PrePaid/VoidSale';
//        $response = VantiveCurl::curlIt($url,$payload);
        $this->assertEquals(200,$response['http_code']);
        $this->assertEquals('Approved',$response['CmdStatus']);
        $this->assertEquals('Voided',$response['TextResponse']);

        //now do an NSF sale

        $sale_amount = 8.88;

        $vantive_payment_service = new VantivePaymentService();
        $info = $vantive_payment_service->setInfo();
        $card_number = '6050110000000015438';

        $vantive_payment_service->info['MerchantID'] = '62589001=TEST';
        $order_id = rand(11111111,99999999);
        $vantive_payment_service->order_id = $order_id;

        $user_resource = createNewUserWithCCNoCVV();
        $user_id = $user_resource->user_id;
        $ubsvma = new UserSkinStoredValueMapsAdapter(getM());
        $user_skin_stored_value_map_resource = $ubsvma->saveCardNumber($card_number,$user_id,getSkinIdForContext(),12010);
        $user_skin_stored_value_map_resource->balance = '500.00';
        $user_skin_stored_value_map_resource->save();

        $vantive_payment_service->user_skin_stored_value_map_resource = $user_skin_stored_value_map_resource;
        $vantive_payment_service->setNoNSFSale();
        $response = $vantive_payment_service->processPayment($sale_amount);
        $this->assertEquals(200,$response['http_code']);






        // now do a return
        $return_amount = 10.00;

        $vantive_payment_service = new VantivePaymentService();
        $info = $vantive_payment_service->setInfo();
        $vantive_payment_service->user_skin_stored_value_map_resource = $user_skin_stored_value_map_resource->refreshResource();
        $card_number = '6050110000000015438';

        $vantive_payment_service->info['MerchantID'] = '62589001=TEST';
        $vantive_payment_service->order_id = "1000".time();

        $response = $vantive_payment_service->partialRefund($card_number,$return_amount);


//        unset($payload['Purchase']);
//        $payload['Amount']['Purchase'] = $return_amount;
//        $payload['TranCode'] = 'Return';
//        $payload['InvoiceNo'] = rand(111111,999999);
//        $json_payload = json_encode($payload);
//        myerror_log($json_payload);
//
//        $url = 'https://w1.mercurycert.net/PaymentsAPI/PrePaid/Return';
//        $response = VantiveCurl::curlIt($url,$json_payload);
        $this->assertEquals(200,$response['http_code']);
        $raw_result_as_array = json_decode($response['raw_result'],true);
        $this->assertEquals('Approved',$raw_result_as_array['CmdStatus']);
        myerror_log("Certiification complete");
    }

    function testPartialRefund()
    {
        $skin_resource = getOrCreateSkinAndBrandIfNecessaryWithLoyalty("vantiveskin","vantivebrand",null, null);
        $user_resource = createNewUserWithCCNoCVV();
        $user_id = $user_resource->user_id;
        $user = logTestUserResourceIn($user_resource);
        $ubsvma = new UserSkinStoredValueMapsAdapter(getM());
        $card_number = '6050110000000015438';
        $ubsvma->saveCardNumber($card_number,$user_id,getSkinIdForContext(),12010);

        setContext('com.splickit.vantiveskin');

        $simple_menu_id = createTestMenuWithOneItem("item_one");

        $merchant_resource = createNewTestMerchant($simple_menu_id,['authorize'=>true]);
        $merchant_id = $merchant_resource->merchant_id;
        attachMerchantToSkin($merchant_resource->merchant_id, $skin_resource->skin_id);
        $merchant_payment_type_map_resource = MerchantPaymentTypeMapsAdapter::createMerchantPaymentTypeMap($merchant_id, 12010, null);

        $tpppa = new ThirdPartyProviderParametersAdapter(getM());
        $parameters = $tpppa->getParametersFromProviderId(5001);
        foreach ($parameters as $parameter_row) {
            $data = [];
            $data['third_party_provider_parameter_id'] = $parameter_row['third_party_provider_parameter_id'];
            if ($parameter_row['name'] == 'OperatorID') {
                $data['value'] = 'test';
                $data['skin_id'] = getSkinIdForContext();
                $tpppsma = new ThirdPartyProviderParameterSkinMapsAdapter(getM());
                Resource::createByData($tpppsma,$data);
            } else if ($parameter_row['name'] == 'MerchantID') {
                $data['value'] = '62589001=TEST';
                $data['merchant_id'] = $merchant_resource->merchant_id;
                $tpppmma = new ThirdPartyProviderParameterMerchantMapsAdapter(getM());
                Resource::createByData($tpppmma,$data);
            } else if ($parameter_row['name'] == 'password') {
                $data['value'] = 'xyz';
                $data['skin_id'] = getSkinIdForContext();
                $tpppsma = new ThirdPartyProviderParameterSkinMapsAdapter(getM());
                Resource::createByData($tpppsma,$data);
            }
        }

        $cart_data = OrderAdapter::getSimpleCartArrayByMerchantId($merchant_id,'pickup','sum dum note',3);

        $checkout_resource = getCheckoutResourceFromOrderData($cart_data,getTomorrowTwelveNoonTimeStampDenver());
        $this->assertNull($checkout_resource->error);
        $hash = createHashmapFromArrayOfArraysByFieldName($checkout_resource->accepted_payment_types,'name');
        $this->assertNotNull($hash['Vantive Stored Value'],'It should have stored value payment option');
        //$this->assertNotNull($hash['Stored Value + CC'],'It should have the stored value + cc payment option');

        $vantive_payment_type = $hash['Vantive Stored Value'];
        $checkout_resource->accepted_payment_types = [$vantive_payment_type];
        $order_resource = placeOrderFromCheckoutResource($checkout_resource,$user,$merchant_id,0.00);
        $this->assertNull($order_resource->error);
        $total = $order_resource->grand_total;
        $order_id = $order_resource->order_id;
        $bcr = BalanceChangeAdapter::staticGetRecords(['order_id'=>$order_id],'BalanceChangeAdapter');
        $bcr_hash = createHashmapFromArrayOfArraysByFieldName($bcr,'process');
        $this->assertNotNull($bcr_hash['StoredValuePayment']);
        $bcr_stored_value = $bcr_hash['StoredValuePayment'];
        $this->assertEquals($total,$bcr_stored_value['charge_amt']);

        // now try a partial refund

        $order_controller = new OrderController(getM(), $user, $request, 5);
        $refund_results = $order_controller->issueOrderRefund($order_id, "1.50");
        $this->assertEquals("success", $refund_results['result']," should have gotten a success but: ".$refund_results['message']);


        $bcr = BalanceChangeAdapter::staticGetRecords(['order_id'=>$order_id],'BalanceChangeAdapter');
        $bcr_hash = createHashmapFromArrayOfArraysByFieldName($bcr,'process');
        $this->assertCount(3,$bcr);
        $this->assertEquals('PartialRefund',$bcr_hash['PartialRefund']['process']);
        $this->assertEquals('1.50',$bcr_hash['PartialRefund']['charge_amt']);

        $aora = new AdmOrderReversalAdapter(getM());
        $record = $aora->getRecord(['order_id'=>$order_id]);
        $this->assertEquals('1.50',$record['amount']);


        $request = new Request();
        $request->data['note'] = "Sum dum note again";
        $order_controller = new OrderController(getM(), $user, $request, 5);
        $refund_results = $order_controller->issueOrderRefund($order_id, "1.25");
        $this->assertEquals("failure", $refund_results['result']," should have gotten a failure since you cant do two partials on the same order.");
    }

    function testAddCardToUserAccount()
    {
        $user_resource = createNewUserWithCCNoCVV();
        $uuid = $user_resource->uuid;

        $url = "http://127.0.0.1:".$this->api_port."/app2/apiv2/users/$uuid/stored_value/12010/add";
        $data = ['card_number'=>'6050110000000015438'];
        $response = $this->makeRequestWithDefaultHeaders($url, $user_resource->email.':welcome','POST',$data,'com.splickit.vantiveskin');
        $result_as_array = json_decode($response,true);



    }

    function makeRequestWithDefaultHeaders($url,$userpassword,$method = 'GET',$data = null,$external_id = null)
    {
        if ($external_id == null) {
            $external_id = $this->getExternalId();
        }
        $headers = array("X_ORDER140_CLIENT_ID"=>"$external_id","X_ORDER140_CLIENT_DEVICE"=>"unit_testing","HTTP_X_ORDER140_CLIENT_VERSION"=>"10.5.0","X_ORDER140_CLIENT"=>"APIDispatchTest","NO_CC_CALL"=>"true");
        if ($authentication_token = $data['splickit_authentication_token']) {
            $headers['splickit_authentication_token'] = $authentication_token;
            unset($data['splickit_authentication_token']);
        }
        if ($data['headers']) {
            $headers = array_merge($headers,$data['headers']);
            unset($data['headers']);
        }
        $header_array = array();
        foreach ($headers as $key=>$value) {
            $header_array[] = $key.":".$value;
        }
        return $this->makeRequest($url,$userpassword,$method,$header_array,$data);
    }

    function makeRequest($url,$userpassword,$method = 'GET', $headers = array(),$data = null)
    {
        unset($this->info);
        $method = strtoupper($method);
        $curl = curl_init($url);
        if ($userpassword) {
            curl_setopt($curl, CURLOPT_USERPWD, $userpassword);
        }
        if ($method == 'POST') {
            $json = json_encode($data);
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_POSTFIELDS,$json);
            $headers[] = 'Content-Type: application/json';
            $headers[] = 'Content-Length: ' . strlen($json);
        } else if ($method == 'DELETE') {
            curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "DELETE");
        }
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        logCurl($url,$method,$userpassword,$headers,$json);
        $result = curl_exec($curl);
        $this->info = curl_getinfo($curl);
        curl_close($curl);
        return $result;
    }

    static function setUpBeforeClass()
    {
        $_SERVER['request_time1'] = microtime(true);
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));
        ini_set('max_execution_time',300);

        $skin_resource = getOrCreateSkinAndBrandIfNecessaryWithLoyalty("vantiveskin","vantivebrand",null, null);
        $ids['skin_id'] = $skin_resource->skin_id;
        setContext('com.splickit.vantiveskin');

    	$simple_menu_id = createTestMenuWithOneItem("item_one");
    	$ids['menu_id'] = $simple_menu_id;
    	
    	$merchant_resource = createNewTestMerchant($simple_menu_id);
    	$merchant_resource->save();
    	$ids['merchant_id'] = $merchant_resource->merchant_id;

    	$merchant_payment_type_map_resource = MerchantPaymentTypeMapsAdapter::createMerchantPaymentTypeMap($merchant_resource->merchant_id, 12010, null);

        $tpppa = new ThirdPartyProviderParametersAdapter(getM());
        $parameters = $tpppa->getParametersFromProviderId(5001);
        foreach ($parameters as $parameter_row) {
            $data = [];
            $data['third_party_provider_parameter_id'] = $parameter_row['third_party_provider_parameter_id'];
            if ($parameter_row['name'] == 'OperatorID') {
                $data['value'] = 'online';
                $data['skin_id'] = getSkinIdForContext();
                $tpppsma = new ThirdPartyProviderParameterSkinMapsAdapter(getM());
                Resource::createByData($tpppsma,$data);
            } else if ($parameter_row['name'] == 'MerchantID') {
                $data['value'] = '62589001=TEST';
                $data['merchant_id'] = $merchant_resource->merchant_id;
                $tpppmma = new ThirdPartyProviderParameterMerchantMapsAdapter(getM());
                Resource::createByData($tpppmma,$data);
            } else if ($parameter_row['name'] == 'password') {
                $data['value'] = 'xyz';
                $data['merchant_id'] = $merchant_resource->merchant_id;
                $tpppmma = new ThirdPartyProviderParameterMerchantMapsAdapter(getM());
                Resource::createByData($tpppmma,$data);
            }
        }





        $_SERVER['log_level'] = 5;
		$_SERVER['unit_test_ids'] = $ids;
    }

    static function tearDownAfterClass()
    {
        SplickitCache::flushAll();
        date_default_timezone_set($_SERVER['starting_tz']);
    }


    /* mail method for testing */
    static function main() {
		$suite = new PHPUnit_Framework_TestSuite( __CLASS__);
  		PHPUnit_TextUI_TestRunner::run( $suite);
 	}
    
}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    VantiveTest::main();
}
?>