<?php
error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');
$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;
require_once 'lib/utilities/functions.inc';
require_once 'lib/utilities/unit_test_functions.inc';

class XoikosServiceTest extends PHPUnit_Framework_TestCase
{
    var $stamp;
    var $ids;
    var $store_ids = "1,2,3,4,6,7,10,11,13,14,17,18,19,20,21,22,26,28,29,33,34,35,39,40,41,45,46,50,52,60,68,69,71,72,80,83,84,86,87,89,93,96,103,105,131,134,136,138,149,154,156,166,167,172,174,187,191,206,1005,1008,1009,1012,1013,1020,1021,1023,1025,1026,1027,1028,1030,1031,1033,1034,1035,1036,1037,1040";

    function setUp()
    {
        $_SERVER['HTTP_NO_CC_CALL'] = 'true';
        $this->stamp = $_SERVER['STAMP'];
        $_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
        $this->ids = $_SERVER['unit_test_ids'];
        setContext('com.splickit.goodcentssubs');
        $this->api_port = "80";
        if (isset($_SERVER['XDEBUG_CONFIG'])) {
            $this->api_port = "10080";
        }

    }

    function tearDown()
    {
        //delete your instance
        $_SERVER['STAMP'] = $this->stamp;
        unset($this->ids);
    }

    function testGetActiveStausByStore()
    {

        $menu_id = createTestMenuWithNnumberOfItems(1);
        $merchant_resource = getOrCreateNewTestMerchantBasedOnExternalId('20',$menu_id,['no_payment'=>true]);
        $merchant_resource->ordering_on = 'Y';
        $merchant_resource->save();
        $merchant_id = $merchant_resource->merchant_id;
        $map_resource = Resource::createByData(new MerchantMessageMapAdapter(getM()),array("merchant_id"=>$merchant_resource->merchant_id,"message_format"=>'X',"delivery_addr"=>"Xoikos","message_type"=>"X"));
        $data = ["merchant"=>$merchant_resource->getDataFieldsReally()];
        $xoikos_service = new XoikosService($data);
        $xoikos_service->url = "http://orders.subshop.com/order.asmx";
        $this->assertTrue($xoikos_service->testStoreIsActive());

        $bad_external = rand(111111,999999);
        $xoikos_service->merchant['merchant_external_id'] = "".$bad_external;
        $this->assertFalse($xoikos_service->testStoreIsActive());
    }

    function testGetPlusByStore()
    {
        $xml = '<?xml version="1.0" encoding="utf-8"?>
                    <soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
                      <soap:Body>
                        <getPlusByStore xmlns="http://www.subshop.com/">
                          <store>8500</store>
                        </getPlusByStore>
                      </soap:Body>
                    </soap:Envelope>';
        $xml = cleanUpDoubleSpacesCRLFTFromString($xml);
        $soap_action = "http://www.subshop.com/getPlusByStore";
        $headers[] = 'SOAPAction: "'.$soap_action.'"';
        $response = XoikosCurl::curlIt("http://www.subshop.com/onlineordering/order.asmx",$xml,$headers);
        $this->assertEquals(200,$response['http_code']);
        $raw = $response['raw_result'];

        $start = strpos($raw,"<DocumentElement");
        $end_string = "</DocumentElement>";


        $end = strpos($raw,$end_string) + strlen($end_string);
        $payload = substr($raw,$start,$end-$start);
        $xml=simplexml_load_string($payload) or die("error: cannot create object");
        $hashmap = $this->myBrinkToArray($xml);

        $plu_list = array();
        foreach ($hashmap['OnlinePLUs'] as $plu_node) {
            $plu_list[$plu_node['description']] = $plu_node;
        }
        ksort($plu_list);


//        $file = fopen("xoikos_getPlus_call.csv","w");
//        foreach ($plu_list as $plu_item) {
//            $txt = $plu_item['description'].",".$plu_item['plu']."\n";
//            fwrite($file,$txt);
//        }
//        fclose($file);
        myerror_log("finished");

    }

    function testGetMenu()
    {
        $xoikos_service = new XoikosService();
        $xml = '<?xml version="1.0" encoding="utf-8"?>
                    <soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
                      <soap:Body>
                        <getPlusByStore xmlns="http://www.subshop.com/">
                          <store>21</store>
                        </getPlusByStore>
                      </soap:Body>
                    </soap:Envelope>';
        $xml = cleanUpDoubleSpacesCRLFTFromString($xml);
        $soap_action = "http://www.subshop.com/getPlusByStore";
        $headers[] = 'SOAPAction: "'.$soap_action.'"';
        $response = XoikosCurl::curlIt("http://www.subshop.com/onlineordering/order.asmx",$xml,$headers);
        $this->assertEquals(200,$response['http_code']);
        $raw = $response['raw_result'];
        $menu_array = $this->parseXMLResponseIntoArray($raw,'getPlusByStore');
        $menu_hash_map = array();
        $menu_hash_map_menu = array();
        $menu_hash_map_id = array();
        $fix_map = array();


        foreach ($menu_array as $menu_item) {
            $menu_hash_map[$menu_item['parentId']][$menu_item['description']] = $menu_item;
            if ($menu_item['parentId'] == 'TOP' && $menu_item['type'] == 'MENU') {
                $menu_hash_map_menu[$menu_item['description']] = $menu_item;
                $menu_hash_map_id[$menu_item['id']] = $menu_item;
            }
        }

        foreach ($menu_array as $menu_item) {
            $parent_id = $menu_item['parentId'];
            myerror_log("looking for parent node of $parent_id");
            if (isset($menu_hash_map_id[$parent_id])) {
                $parent_description = $menu_hash_map_id[$parent_id]['description'];
                $menu_hash_map_menu[$parent_description]['items'][$menu_item['description']."-".$menu_item['id']] = $menu_item;
            }
        }
        $plu_list = array();
        $togle_list = array();
        foreach ($menu_array as $menu_item) {
            if ($menu_item['type'] == 'RADIO' || $menu_item['type'] == 'PLU' || $menu_item['type'] == 'TOGGLE') {
                $plu_list[$menu_item['parentId'].'-'.$menu_item['description'].'-'.$menu_item['id']] = $menu_item;
            }
        }
        ksort($plu_list);

        $file = fopen("xoikos_name_plu.csv","w");
        foreach ($plu_list as $menu_item) {
            if (is_numeric($menu_item['stringValue']) && is_numeric($menu_item['id'])) {
                $txt = $menu_hash_map_id[$menu_item['parentId']]['description'].",".$menu_item['description'].",".$menu_item['stringValue']."\n";
                fwrite($file,$txt);
            }
        }
        fclose($file);

        myerror_log("finished");

    }

    function myBrinkToArray($xml) {
        $array = (array)$xml;

        foreach ( array_slice($array, 0) as $key => $value )
        {
            if ( $value instanceof SimpleXMLElement )
            {
                if ($key == "@attributes") {
                    continue;
                }
                $ns = $value->getNamespaces(true);
                if ($ns['b']) {
                    $value = $array[$key]->children($ns['b']);
                }
                $array[$key] = empty($value) ? NULL : $this->myBrinkToArray($value);
            } else if (is_array($value)) {
                foreach ($value as $sub_key => $sub_value) {
                    $array[$key][$sub_key] = $this->myBrinkToArray($sub_value);
                }
            }
        }
        return $array;
    }

    function parseXMLResponseIntoArray($response,$method)
    {
        $start = strpos($response,"<".$method."Result");
        $end_string = "</".$method."Result>";

        $start = strpos($response,"<DocumentElement");
        $end_string = "</DocumentElement>";


        $end = strpos($response,$end_string) + strlen($end_string);
        $payload = substr($response,$start,$end-$start);
        $hash = parseXMLintoHashmap($payload);
        $menu_items = $hash['OnlinePLUs'];
        return $menu_items;
    }

    /****************************/
    function makeRequestWithDefaultHeaders($url,$userpassword,$method = 'GET',$data = null)
    {
        $external_id = getContext();
        $headers = array("X_SPLICKIT_CLIENT_ID"=>"$external_id","X_SPLICKIT_CLIENT_DEVICE"=>"unit_testing","HTTP_X_SPLICKIT_CLIENT_VERSION"=>"10.5.0","X_SPLICKIT_CLIENT"=>"APIDispatchTest","NO_CC_CALL"=>"true");
        if ($authentication_token = $data['splickit_authentication_token']) {
            $headers['splickit_authentication_token'] = $authentication_token;
            unset($data['splickit_authentication_token']);
        }
        if ($data['headers']) {
            $headers = array_merge($headers,$data['headers']);
            unset($data['headers']);
        }
        $header_array = array();
        foreach ($headers as $key=>$value) {
            $header_array[] = $key.":".$value;
        }
        return $this->makeRequest($url,$userpassword,$method,$header_array,$data);
    }

    function makeRequest($url,$userpassword,$method = 'GET', $headers = array(),$data = null)
    {
        unset($this->info);
        $method = strtoupper($method);
        $curl = curl_init($url);
        if ($userpassword) {
            curl_setopt($curl, CURLOPT_USERPWD, $userpassword);
        }
        if ($method == 'POST') {
            $json = json_encode($data);
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_POSTFIELDS,$json);
            $headers[] = 'Content-Type: application/json';
            $headers[] = 'Content-Length: ' . strlen($json);
        } else if ($method == 'DELETE') {
            curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "DELETE");
        }
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        logCurl($url,$method,$userpassword,$headers,$json);
        $result = curl_exec($curl);
        $this->info = curl_getinfo($curl);
        curl_close($curl);
        return $result;
    }
    
    static function setUpBeforeClass()
    {
        $_SERVER['request_time1'] = microtime(true);
        $_SERVER['NO_MOCKS'] = true;
        $tz = date_default_timezone_get();
        $_SERVER['starting_tz'] = $tz;
        date_default_timezone_set(getProperty("default_server_timezone"));

        $_SERVER['log_level'] = 5;
        $_SERVER['unit_test_ids'] = $ids;
    }

    static function tearDownAfterClass()
    {
        date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main() {
        $suite = new PHPUnit_Framework_TestSuite( __CLASS__);
        PHPUnit_TextUI_TestRunner::run( $suite);
    }

}

if (isset($_SERVER['XDEBUG_CONFIG']) && !defined('PHPUnit_MAIN_METHOD')) {
    XoikosServiceTest::main();
}

?>