<?php

error_reporting(E_ERROR | E_COMPILE_ERROR | E_COMPILE_WARNING | E_PARSE);
$filepathParts = pathinfo(__FILE__);
$path = $filepathParts['dirname'];
chdir($path . '/../');
$db_info->database = 'smaw_unittest';
$db_info->username = 'root';
$db_info->password = 'splickit';
if (isset($_SERVER['XDEBUG_CONFIG'])) {
    putenv("SMAW_ENV=unit_test_ide");
    $db_info->hostname = "127.0.0.1";
    $db_info->port = 13306;
} else {
    $db_info->hostname = "db_container";
    $db_info->port = 3306;
}
$_SERVER['DB_INFO'] = $db_info;

require_once 'lib/utilities/unit_test_functions.inc';
require_once 'lib/utilities/functions.inc';

class APIDispatchTestStaging extends PHPUnit_Framework_TestCase
{
	var $stamp;
	var $ids;
	var $info;
    var $server = 'api.order140-test.com';

    //var $public_client_id = '9061-5td55-812fg-9xq9h';
    var $public_client_id = '5946-x5l4o-234u2-0fbo4'; // world pay staging
    var $client = 'Sodexotest';


    function setUp()
	{
		$this->stamp = $_SERVER['STAMP'];
		$_SERVER['STAMP'] = __CLASS__.'-'.$_SERVER['STAMP'];
		$this->ids = $_SERVER['unit_test_ids'];
        setContext($this->client_id);
	}
	
	function tearDown() 
	{
		$_SERVER['STAMP'] = $this->stamp;
		unset($this->ids);
		unset($this->info);
    }

    function testCallBackFromWorldPay()
    {
        $transaction_id = '1629';
        $data = ['purchasecode_id'=>$transaction_id,'success'=>1,'phonesale'=>3038844083,'amount'=>112.53];
        $url = "http://".$this->server."/app2/apiv2/payments";

//        $user = logTestUserIn(1);
//        $request = createRequestObject($url,'POST',json_encode($data));
//        $order_controller = new OrderController(getM(),$user,$request);
//        $response = makeMockRequest($order_controller);

        $headers = array("X_ORDER140_CLIENT_ID"=>"5946-x5l4o-234u2-0fbo4","X_ORDER140_CLIENT_DEVICE"=>"unit_testing","HTTP_X_ORDER140_CLIENT_VERSION"=>"10.5.0","X_ORDER140_CLIENT"=>"WorldPay");
        $header_array = array();
        foreach ($headers as $key=>$value) {
            $header_array[] = $key.":".$value;
        }
        $data['headers'] = $header_array;
        $response = $this->makeRequest($url,"admin:Test1234",'POST',$data);
        //$response = $this->makeRequest($url,"admin:BadPassword",'POST',$header_array,$data);
        $rar = json_decode($response,true);
        $this->assertEquals(422,$rar['http_code']);
        $this->assertContains(OrderController::UNABLE_TO_VALIDATE_P2P_TRANSACTION_ID_ERROR_MESSAGE,$rar['error']['error']);

        clearAuthenticatedUserParametersForSession();
        removeContext();

        $world_pay_skin = $this->ids['worldpay_skin_resource'];
        $wpi = $world_pay_skin->external_identifier;
        setContext($wpi);

//        $user = logTestUserIn(1);
//        $request = createRequestObject($url,'POST',json_encode($data));
//        $order_controller = new OrderController(getM(),$user,$request);
//        $response = makeMockRequest($order_controller);
        $external_id = getPublicClientIdForContext();
        $headers = array("X_ORDER140_CLIENT_ID"=>"$external_id","X_ORDER140_CLIENT_DEVICE"=>"unit_testing","HTTP_X_ORDER140_CLIENT_VERSION"=>"10.5.0","X_ORDER140_CLIENT"=>"APIDispatchTest","NO_CC_CALL"=>"true");
        $header_array = array();
        foreach ($headers as $key=>$value) {
            $header_array[] = $key.":".$value;
        }
        $response = $this->makeRequest($url,"admin:Test1234",'POST',$header_array,$data);

        $rar = json_decode($response,true);
        $this->assertEquals(200,$rar['http_code']);
        $this->assertEquals('success',$rar['data']['result']);

        $response_stamp = $rar['stamp'];
        // now confirm payment row was updated
        $ucid = $rar['data']['order_id'];
        $order = new Order($ucid);
        $bcr = BalanceChangeAdapter::staticGetRecords(['order_id'=>$order->getOrderId()],'BalanceChangeAdapter');
        $bcr_hash = createHashmapFromArrayOfArraysByFieldName($bcr,'process');
        $payment_row = $bcr_hash['P2P'];
        $this->assertEquals('WorldPay',$payment_row['cc_processor']);
        $this->assertEquals("COMPLETED-$response_stamp",$payment_row['notes']);

        // confirm that message were released
        $order_message = MerchantMessageHistoryAdapter::getMessageByOrderIdAndFormat($order->getOrderId(),'E');
        $this->assertEquals('N',$order_message->locked,"It should have un-locked the message");

    }


//    function testGetAvailbleGroupOrderTimes()
//    {
//
//        setContext("com.splickit.pitapit");
//        $merchant_id = 103912;
//        $_SERVER['STAMP'] = rand(1111111111,9999999999);
//        $url = "http://".$this->server."/app2/apiv2/merchants/103912/grouporderavailabletimes/pickup?log_level=5";
//        $result = $this->useMakeRequest($url, $userpassword);
//        $request_result_as_array = json_decode($result,true);
//        $stamp = $request_result_as_array['stamp'];
//
//
//    }

//    function testGetUserAdam()
//    {
//        $url = "https://".$this->server."/app2/apiv2/users?log_level=5";
//        $response = $this->makeRequest($url, 'arosenthal@order140.com:welcome1');
//        $this->assertEquals(200, $this->info['http_code']);
//        $request_result_as_array = json_decode($response,true);
//        $user_session = $request_result_as_array['data'];
//        $this->assertNotNull($user_session['user_id']);
//        $this->assertNotNull($user_session['splickit_authentication_token'],'should have found an authentication token');
//        return $user;
//    }

    function testGetRRTMenu()
    {
        // 108332
        //long horn steak house  1586-53rkm-cn84p-6l5r2   merchant_id = 108332    41671
        $url = "https://smawapi.rrtusa.net/app2/apiv2/merchants/108332/pickup";
        //$headers = ['X_ORDER140_CLIENT_ID:8019-2rgbl-t0ka0-od16x','X_ORDER140_CLIENT_DEVICE:somidata','X_ORDER140_CLIENT_VERSION:10.0.0','X_ORDER140_CLIENT:Somidata'];
        $this->public_client_id = '1586-53rkm-cn84p-6l5r2';
        $response = $this->makeRequest($url, null,'GET');
        $response_as_array = json_decode($response,true);
        $menu = $response_as_array['data']['menu'];
        $menu_types = $menu['menu_types'];
        foreach ($menu_types as $menu_type) {
            $items = $menu_type['menu_items'];
            myerror_log("have the items");
        }
    }

    function testGetLJSMenu()
    {
        //curl -v -H 'X_ORDER140_CLIENT_ID:8019-2rgbl-t0ka0-od16x' -H 'X_ORDER140_CLIENT_DEVICE:somidata' -H 'X_ORDER140_CLIENT_VERSION:10.0.0' -H 'X_ORDER140_CLIENT:Somidata' https://smawapi.rrtusa.net/app2/apiv2/merchants/108501
        $url = "https://smawapi.rrtusa.net/app2/apiv2/merchants/108501/delivery";
        //$headers = ['X_ORDER140_CLIENT_ID:8019-2rgbl-t0ka0-od16x','X_ORDER140_CLIENT_DEVICE:somidata','X_ORDER140_CLIENT_VERSION:10.0.0','X_ORDER140_CLIENT:Somidata'];
        $this->public_client_id = '1427-vkb1s-d2547-b7xkq';
        $response = $this->makeRequest($url, "store_tester@order140.com:test",'GET');
        $response_as_array = json_decode($response,true);
        $menu = $response_as_array['data']['menu'];
        $menu_types = $menu['menu_types'];
        foreach ($menu_types as $menu_type) {
            $items = $menu_type['menu_items'];
            myerror_log("have the items");
        }
    }


    private function createNewUserDataFields()
    {
        $randomizer_string = rand(11111,99999);
        $user_data['first_name'] = 'first';
        $user_data['last_name'] = 'last';
        $user_data['email'] = 'testuser_' . time() . '_' . $randomizer_string . '@order140.com';
        $user_data['password'] = 'welcome';
        $user_data['contact_no'] = '1234567890';
        $user_data['loyalty_number'];
        $user_data['account_hash'] = time().'_'.$randomizer_string;
        return $user_data;

    }

    private function createNewUser()
    {
        $url = "https://".$this->server."/app2/apiv2/users?log_level=5";
        $new_user_data = $this->createNewUserDataFields();
        unset($new_user_data['account_hash']);
        $response = $this->makeRequest($url, "admin:test1234","POST",$new_user_data);
        $this->assertEquals('200', $this->info['http_code']);
        $new_user_response = json_decode($response,true);
        $this->assertNull($new_user_response['error'],"should NOT have gotten an error");
        $user = $new_user_response['data'];
        return $user;
    }



    function testGetCorrectHttpCodeFromBadLogin()
    {
        $url = "https://".$this->server."/app2/apiv2/users";
		$response = $this->makeRequest($url, "someemail:sumpassword");
		$this->assertEquals(401, $this->info['http_code'],"Should have gotten a failed authentication status code");
		
    }

//    function testPublicSkinPasswordCreation()
//    {
//        $url = "https://".$this->server."/app2/apiv2/skins";
//        $admin_password_data = ['password'=>'test1234'];
//        $response = $this->makeRequest($url, null,'POST',$admin_password_data);
//        $data = json_decode($response,true);
//        $this->assertEquals(200,$data['http_code']);
//
//        // delete shouldnt' work without the passowr
//        $url = "https://".$this->server."/app2/apiv2/skins/delete_password";
//        $response = $this->makeRequest($url, null,'DELETE');
//        $data = json_decode($response,true);
//        $this->assertEquals(401,$data['http_code']);
//
//        $response = $this->makeRequest($url, 'admin:test1234','DELETE');
//        $data = json_decode($response,true);
//        $this->assertEquals(200,$data['http_code']);
//
//        $url = "https://".$this->server."/app2/apiv2/skins";
//        $response = $this->makeRequest($url, null,'POST',$admin_password_data);
//        $data = json_decode($response,true);
//        $this->assertEquals(200,$data['http_code']);
//
//    }



    function testCreateNewUser()
    {
        $user = $this->createNewUser();
        $this->assertNotNull($user['user_id']);
        return $user;
    }

    /**
     * @depends testCreateNewUser
     */
    function testGetUser($user)
    {

//    	$user = $this->createNewUser();
        $url = "https://".$this->server."/app2/apiv2/users?log_level=5";
    	$response = $this->makeRequest($url, $user['email'].':welcome');
    	$this->assertEquals(200, $this->info['http_code']);
		$request_result_as_array = json_decode($response,true);
		$user_session = $request_result_as_array['data'];
		$this->assertNotNull($user_session['user_id']);
		$this->assertNotNull($user_session['splickit_authentication_token'],'should have found an authentication token');
        return $user;
    }

    /**
     * @depends testGetUser
     */
    function testUpdateUser($user)
    {
    	$data['first_name'] = "john";
        $url = "https://".$this->server."/app2/apiv2/users?log_level=5";
    	$response = $this->makeRequest($url, 'splickit_authentication_token:'.$user['splickit_authentication_token'],"POST",$data);
		$this->assertEquals('200', $this->info['http_code']);
		$user_response = json_decode($response,true);
		$this->assertNull($user_response['error'],"should NOT have gotten an error");
		$this->assertEquals($user['uuid'], $user_response['data']['user_id']);  	
    	$this->assertEquals('john',$user_response['data']['first_name']);
        return $user;
    }
    
    /**
     * @depends testUpdateUser
     */
    function testSetUserDeliveryAddress($user)
    {
    	$user_id = $user['user_id'];
    	$user_uuid = $user['uuid'];
    	$json = '{"name":"home","address1":"11 Riverside Drive","address2":"","city":"new york","state":"ny","zip":"12345","phone_no":"1234567890","lat":40.796202,"lng":-73.936635}';
    	$data = json_decode($json,true);
        $url = "https://".$this->server."/app2/apiv2/users/$user_uuid/userdeliverylocation?log_level=5";
    	$response = $this->makeRequest($url, 'splickit_authentication_token:'.$user['splickit_authentication_token'],"POST",$data);
		$this->assertEquals('200', $this->info['http_code']);
		$user_response = json_decode($response,true);
		$this->assertNull($user_response['error'],"should NOT have gotten an error");
		$user_delivery_info = $user_response['data'];
		$this->assertNotNull($user_delivery_info['user_addr_id']);
		$this->assertEquals('new york', $user_delivery_info['city']);
        $user['user_addr_id'] = $user_delivery_info['user_addr_id'];
    	return $user;
    }
    
    /**
     * @depends testSetUserDeliveryAddress
     */
    function testDeleteUserAddress($user)
    {
    	$user_address_id = $user['user_addr_id'];
        $user_uuid = $user['uuid'];
        $url = "https://".$this->server."/app2/apiv2/users/$user_uuid/userdeliverylocation/$user_address_id?log_level=5";
    	$response = $this->makeRequest($url, 'splickit_authentication_token:'.$user['splickit_authentication_token'],"DELETE",$data);
		$this->assertEquals('200', $this->info['http_code']);
		$user_response = json_decode($response,true);
		$this->assertNull($user_response['error'],"should NOT have gotten an error");
		$user_delivery_info = $user_response['data'];
		$this->assertEquals('success', $user_delivery_info['result']);
		return $user;
    }

    /**
     * @depends testDeleteUserAddress
     */
    function testForgotPassword($user)
    {
        $url = "https://".$this->server."/app2/apiv2/users/forgotpassword";
        $response = $this->makeRequest($url, "admin:test1234",'Post',array("email"=>$user['email']));
        $this->assertEquals(200, $this->info['http_code']);
        $request_result_as_array = json_decode($response,true);
        $this->assertEquals("We have processed your request. Please check your email for reset instructions.", $request_result_as_array['message']);
    }

    function testForgotPasswordBadEmail()
    {
        $url = "https://".$this->server."/app2/apiv2/users/forgotpassword";
        $response = $this->makeRequest($url, "admin:test1234",'Post',array("email"=>'sumdumemail@email.com'));
        $request_result_as_array = json_decode($response,true);
        $this->assertEquals("Sorry, that email is not registered with us. Please check your entry.", $request_result_as_array['error']['error']);
        $this->assertEquals(404, $this->info['http_code']);
    }

    function testGetMerchants()
    {
        $_SERVER['STAMP'] = rand(1111111111,9999999999);
        $url = "https://".$this->server."/app2/apiv2/merchants";
        $result = $this->makeRequest($url, null);
        $request_result_as_array = json_decode($result,true);
        $data = $request_result_as_array['data'];
        $merchant = $data['merchants'][0];
        $this->assertNotNull($merchant['merchant_id']);
        $merchant_id = $merchant['merchant_id'];
        return $merchant_id;

//        $url = "https://".$this->server."/app2/apiv2/merchants/$merchant_id";
//        $result = $this->makeRequest($url, null);
//        $request_result_as_array = json_decode($result,true);
//        $merchant = $request_result_as_array['data'];
//
//        $this->assertNotNull($merchant['menu']);
//        $this->assertNotNull($merchant['todays_hours']);
//        $this->assertNotNull($merchant['payment_types']);
//        return $merchant['merchant_id'];
    }

    /**
     * @depends testGetMerchants
     */
    function testPlaceOrderForAdam($merchant_id)
    {
        $_SERVER['STAMP'] = rand(1111111111,9999999999);
        $url = "https://".$this->server."/app2/apiv2/merchants/$merchant_id";
        $result = $this->makeRequest($url, null);
        $request_result_as_array = json_decode($result,true);
        $merchant = $request_result_as_array['data'];
        $this->assertNotNull($merchant['menu']);
        $this->assertNotNull($merchant['todays_hours']);
        $this->assertNotNull($merchant['payment_types']);

        $menu = $merchant['menu'];

        // $user = $this->createNewUser();

        $item['mods'] = array();
        $item['quantity'] = 1;
        $item['item_id'] = $menu['menu_types'][1]['menu_items'][0]['size_prices'][0]['item_id'];
        $item['size_id'] = $menu['menu_types'][1]['menu_items'][0]['size_prices'][0]['size_id'];

//        $order_data['user_id'] = $user['uuid'];
//        $order_data['note'] = 'some note';
        $order_data['merchant_id'] = $merchant_id;
        $order_data['items'][] = $item;

        $url = "https://".$this->server."/app2/apiv2/cart/checkout";
        //$response = $this->makeRequest($url, 'splickit_authentication_token:'.$user['splickit_authentication_token'],'POST',$order_data);
        $response = $this->makeRequest($url, "20000:test",'POST',$order_data);
        $this->assertEquals('200', $this->info['http_code']);
        $request_result_as_array = json_decode($response,true);

        $checkout_data = $request_result_as_array['data'];
        $cart_ucid = $checkout_data['ucid'];
        $payment_array = $checkout_data['accepted_payment_types'];
        $lead_times_array = $checkout_data['lead_times_array'];

        $placeorder_data['merchant_payment_type_map_id'] = $payment_array[0]['merchant_payment_type_map_id'];
        $placeorder_data['actual_pickup_time'] = $lead_times_array[0];

        $url = "https://".$this->server."/app2/apiv2/orders/$cart_ucid";
        $response = $this->makeRequest($url, '20000:test','POST',$placeorder_data);
        $this->assertEquals('200', $this->info['http_code']);
    }

    /**
     * @depends testGetMerchants
     */
    function testAddToCart($merchant_id)
    {
        $_SERVER['STAMP'] = rand(1111111111,9999999999);
        $url = "https://".$this->server."/app2/apiv2/merchants/$merchant_id";
        $result = $this->makeRequest($url, null);
        $request_result_as_array = json_decode($result,true);
        $merchant = $request_result_as_array['data'];
        $this->assertNotNull($merchant['menu']);
        $this->assertNotNull($merchant['todays_hours']);
        $this->assertNotNull($merchant['payment_types']);

        $menu = $merchant['menu'];

        $user = $this->createNewUser();
        $item['mods'] = array();
        $item['quantity'] = 1;
        $item['item_id'] = $menu['menu_types'][1]['menu_items'][0]['size_prices'][0]['item_id'];
        $item['size_id'] = $menu['menu_types'][1]['menu_items'][0]['size_prices'][0]['size_id'];

        $order_data['user_id'] = $user['uuid'];
        $order_data['note'] = 'some note';
        $order_data['merchant_id'] = $merchant_id;
        $order_data['items'][] = $item;

        $url = "https://".$this->server."/app2/apiv2/cart";
        $response = $this->makeRequest($url, 'splickit_authentication_token:'.$user['splickit_authentication_token'],'POST',$order_data);
        $this->assertEquals('200', $this->info['http_code']);
        $request_result_as_array = json_decode($response,true);

        $cart_data = $request_result_as_array['data'];
        $this->assertNotNull($cart_data,"should have gotten a cart resource back");
        $this->assertNotNull($cart_data['ucid'],"cart should have a unique identifier");
        $this->assertNotNUll($cart_data['order_summary'],"cart shoudl have an order summarry section");

        // now add somethign else to teh existing cart
        $item2['mods'] = array();
        $item2['quantity'] = 1;
        $item2['item_id'] = $menu['menu_types'][1]['menu_items'][1]['size_prices'][0]['item_id'];
        $item2['size_id'] = $menu['menu_types'][1]['menu_items'][1]['size_prices'][0]['size_id'];

        $cart_ucid = $cart_data['ucid'];
        //$order_data2['ucid'] = $cart_ucid;
        $order_data2['items'][] = $item2;

        $url = "https://".$this->server."/app2/apiv2/cart/$cart_ucid";
        $response = $this->makeRequest($url, 'splickit_authentication_token:'.$user['splickit_authentication_token'],'POST',$order_data2);
        $request_result_as_array = json_decode($response,true);
        $this->assertEquals('200', $this->info['http_code'],"an error was thrown: ".$request_result_as_array['error']['error']);

        // now checkout with the cart
        $url = "https://".$this->server."/app2/apiv2/cart/$cart_ucid/checkout";
        $response = $this->makeRequest($url, 'splickit_authentication_token:'.$user['splickit_authentication_token'],'GET');
        $request_result_as_array = json_decode($response,true);
        $this->assertEquals('200', $this->info['http_code'],"an error was thrown: ".$request_result_as_array['error']['error']);
        $checkout_data = $request_result_as_array['data'];
        $payment_array = $checkout_data['accepted_payment_types'];
        $lead_times_array = $checkout_data['lead_times_array'];

        $placeorder_data['merchant_id'] = $this->ids['merchant_id'];
        $placeorder_data['user_id'] = $user['user_id'];
        $placeorder_data['cart_ucid'] = $cart_ucid;
        $placeorder_data['merchant_payment_type_map_id'] = $payment_array[0]['merchant_payment_type_map_id'];

        $placeorder_data['actual_pickup_time'] = $lead_times_array[0];

        $url = "https://".$this->server."/app2/apiv2/orders";
        $response = $this->makeRequest($url, 'splickit_authentication_token:'.$user['splickit_authentication_token'],'POST',$placeorder_data);
        $request_result_as_array = json_decode($response,true);
        $this->assertEquals('200', $this->info['http_code'],"an error was thrown: ".$request_result_as_array['error']['error']);
        $this->assertNull($request_result_as_array['error'],"an error was thrown: ".$request_result_as_array['error']['error']);

    }



//    function testUploadCreditCard()
//    {
//    	// get new user
//    	$user = $this->createNewUser();
//        $zip = rand(11111,59999);
//    	$json_encoded_data = "{\"cc_exp_date\":\"03/2016\",\"cc_number\":\"4111111111111111\",\"cvv\":\"123\",\"zip\":\"$zip\"}";
//    	$data = json_decode($json_encoded_data,true);
//
//    	$url = "https://tweb03.splickit.com/app2/apiv2/users?log_level=5";
//    	$response = $this->makeRequest($url, 'splickit_authentication_token:'.$user['splickit_authentication_token'],"POST",$data);
//		$this->assertEquals('200', $this->info['http_code']);
//		$user_response = json_decode($response,true);
//		$this->assertNull($user_response['error'],"should NOT have gotten an error");
//		$this->assertEquals($user['uuid'], $user_response['data']['user_id']);
//        return $user;
//
//    }
//


//    function testAddToCartRaadaa()
//    {
//
//        $merchant_id = $this->merchant_id;
//        $_SERVER['STAMP'] = rand(1111111111,9999999999);
//        $url = "https://".$this->server."/app2/apiv2/merchants/$merchant_id";
//        $result = $this->makeRequest($url, $userpassword);
//        $request_result_as_array = json_decode($result,true);
//        $merchant = $request_result_as_array['data'];
//        $menu = $merchant['menu'];
//
//        $user = $this->createNewUser();
//
//        $item['mods'] = array();
//        $item['quantity'] = 1;
//        $item['item_id'] = $menu['menu_types'][1]['menu_items'][0]['size_prices'][0]['item_id'];
//        $item['size_id'] = $menu['menu_types'][1]['menu_items'][0]['size_prices'][0]['size_id'];
//
////        $order_data['user_id'] = $user['uuid'];
////        $order_data['note'] = 'some note';
//        $order_data['merchant_id'] = $merchant_id;
//        $order_data['items'][] = $item;
//
//        $url = "https://".$this->server."/app2/apiv2/cart";
//        $response = $this->makeRequest($url, 'splickit_authentication_token:'.$user['splickit_authentication_token'],'POST',$order_data);
//        $this->assertEquals('200', $this->info['http_code']);
//        $request_result_as_array = json_decode($response,true);
//
//        $cart_data = $request_result_as_array['data'];
//        $this->assertNotNull($cart_data,"should have gotten a cart resource back");
//        $this->assertNotNull($cart_data['ucid'],"cart should have a unique identifier");
//        $this->assertNotNUll($cart_data['order_summary'],"cart shoudl have an order summarry section");
//
////        // now add somethign else to teh existing cart
////        $item2['mods'] = array();
////        $item2['quantity'] = 1;
////        $item2['item_id'] = $menu['menu_types'][1]['menu_items'][1]['size_prices'][0]['item_id'];
////        $item2['size_id'] = $menu['menu_types'][1]['menu_items'][1]['size_prices'][0]['size_id'];
////
//        $cart_ucid = $cart_data['ucid'];
////        //$order_data2['ucid'] = $cart_ucid;
////        $order_data2['items'][] = $item2;
////
////        $url = "https://tweb03.splickit.com/app2/apiv2/cart/$cart_ucid";
////        $response = $this->makeRequest($url, 'splickit_authentication_token:'.$user['splickit_authentication_token'],'POST',$order_data2);
////        $request_result_as_array = json_decode($response,true);
////        $this->assertEquals('200', $this->info['http_code'],"an error was thrown: ".$request_result_as_array['error']['error']);
//
//        // now checkout with the cart
//        $url = "https://".$this->server."/app2/apiv2/cart/$cart_ucid/checkout";
//        $response = $this->makeRequest($url, 'splickit_authentication_token:'.$user['splickit_authentication_token'],'GET');
//        $request_result_as_array = json_decode($response,true);
//        $this->assertEquals('200', $this->info['http_code'],"an error was thrown: ".$request_result_as_array['error']['error']);
//        $checkout_data = $request_result_as_array['data'];
//        $payment_array = $checkout_data['accepted_payment_types'];
//        $lead_times_array = $checkout_data['lead_times_array'];
//
////        $placeorder_data['merchant_id'] = $this->ids['merchant_id'];
////        $placeorder_data['user_id'] = $user['user_id'];
////        $placeorder_data['cart_ucid'] = $cart_ucid;
//        $placeorder_data['merchant_payment_type_map_id'] = $payment_array[0]['merchant_payment_type_map_id'];
//
//        $placeorder_data['actual_pickup_time'] = $lead_times_array[0];
//
//        $url = "https://".$this->server."/app2/apiv2/orders/$cart_ucid";
//        $response = $this->makeRequest($url, 'splickit_authentication_token:'.$user['splickit_authentication_token'],'POST',$placeorder_data);
//        $request_result_as_array = json_decode($response,true);
//        $this->assertEquals('200', $this->info['http_code'],"an error was thrown: ".$request_result_as_array['error']['error']);
//        $this->assertNull($request_result_as_array['error'],"an error was thrown: ".$request_result_as_array['error']['error']);
//
//    }


    function makeRequest($url,$userpassword,$method = 'GET',$data = null)
    {
    	unset($this->info);
    	$method = strtoupper($method);
    	$curl = curl_init($url);
    	if ($userpassword) {
    		curl_setopt($curl, CURLOPT_USERPWD, $userpassword);
    	}
    	if ($data['headers']) {
    	    $headers = $data['headers'];
    	    unset($data['headers']);
        } else {
            if ($external_id = $this->public_client_id) {
                $client = $this->client;
            } else if ($external_id = getContext()) {
                $client = getSkinNameForContext();
            } else {
                $external_id = "com.splickit.vtwoapi";
            }
            $headers = array("X_SPLICKIT_CLIENT_ID:$external_id","X_SPLICKIT_CLIENT_DEVICE:unit_testing","X_SPLICKIT_CLIENT:$client");
        }

    	if ($authentication_token = $data['splickit_authentication_token']) {
    		$headers[] = "splickit_authentication_token:$authentication_token";
    	}
    	if ($method == 'POST') {
    		$json = json_encode($data);
    		curl_setopt($curl, CURLOPT_POST, 1);
			curl_setopt($curl, CURLOPT_POSTFIELDS,$json);
			$headers[] = 'Content-Type: application/json';
			$headers[] = 'Content-Length: ' . strlen($json);
    	} else if ($method == 'DELETE') {
   			curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "DELETE"); 		
    	}
		curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
    	curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_VERBOSE, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        logCurl($url,$method,$userpassword,$headers,$json);
        $result = curl_exec($curl);
        myerror_log("CURL COMMAND RESPONSE: $result");
		$this->info = curl_getinfo($curl);
		curl_close($curl);
    	return $result;
    }

    static function useMakeRequest($url,$userpassword,$method = 'GET',$data = null)
    {
        $apidts = new ApiDispatchTestStaging();
        return $apidts->makeRequest($url,$userpassword,$method,$data);
    }

    static function setUpBeforeClass($merchant_id)
    {
//        setContext("com.splickit.RAADAAR");
//        $merchant_id = 1088;
//        $_SERVER['STAMP'] = rand(1111111111,9999999999);
//        $url = "http://sandbox.splickit-uat.com/app2/apiv2/merchants/$merchant_id?log_level=5";
//        $result = ApiDispatchTestStaging::useMakeRequest($url, $userpassword);
//        $request_result_as_array = json_decode($result,true);
//        $merchant = $request_result_as_array['data'];
//        $menu = $merchant['menu'];
//        $ids['menu'] = $menu;
//    	$ids['merchant_id'] = $merchant_id;
//		$_SERVER['unit_test_ids'] = $ids;
    }
    
	static function tearDownAfterClass()
    {
    	//mysqli_query("ROLLBACK");
    	date_default_timezone_set($_SERVER['starting_tz']);
    }

    /* mail method for testing */
    static function main() {
		$suite = new PHPUnit_Framework_TestSuite( __CLASS__);
  		PHPUnit_TextUI_TestRunner::run( $suite);
 	}
    
}

if (true && !defined('PHPUnit_MAIN_METHOD')) {
    APIDispatchTestStaging::main();
}

?>